function [X,Y] = ell(x, y, a, b, angle, s)
    %# This functions returns points to draw an ellipse
    %#
    %#  @param x     X coordinate
    %#  @param y     Y coordinate
    %#  @param a     Semimajor axis
    %#  @param b     Semiminor axis
    %#  @param angle Angle of the ellipse (in degrees)
    %#

    narginchk(5, 6);
    if nargin<6, s = 36; end

    beta = -angle * (pi / 180);
    sinbeta = sin(beta);
    cosbeta = cos(beta);

    alpha = linspace(0, 360, s)' .* (pi / 180);
    sa = sin(alpha);
    ca = cos(alpha);

    X = x + (a * ca * cosbeta - b * sa * sinbeta);
    Y = y + (a * ca * sinbeta + b * sa * cosbeta);

    if nargout==1, X = [X Y]; end
end