%%INIT
clear;
load('Data rtk piksi');
%%START
figure(1);
clf;
hold on;
title('3D Position for RTK and Pixhawk');
itend = [length(EstimatedState.x),length(RtkFix.n)];
diff = [EstimatedState.x(itend(1))-RtkFix.n(itend(2)), EstimatedState.y(itend(1))-RtkFix.e(itend(2)), EstimatedState.z(itend(1))-RtkFix.d(itend(2))];
plot3(EstimatedState.x - diff(1), EstimatedState.y - diff(2), EstimatedState.z - diff(3));
plot3(RtkFix.n, RtkFix.e, RtkFix.d);
xlabel('N');
ylabel('E');
zlabel('D');


%%START
figure(2);
clf;
hold on;
title('NE Position for RTK and Pixhawk');
plot(EstimatedState.x - diff(1), EstimatedState.y - diff(2));
plot(RtkFix.n, RtkFix.e);
xlabel('N');
ylabel('E');

%%START
figure(3);
clf;
hold on;
title('ND Position for RTK and Pixhawk');
plot(EstimatedState.x - diff(1), EstimatedState.z - diff(3));
plot(RtkFix.n, RtkFix.d);
xlabel('N');
ylabel('D');

measurediff=zeros(3,length(RtkFix.n));
measureerr=zeros(3,length(RtkFix.n));

for i = 1:length(RtkFix.n)
    prevtdiff=10000;
    leastdiff=10000;
    for j = 1:length(EstimatedState.x)
        tdiff = abs(RtkFix.timestamp(i)-EstimatedState.timestamp(j));
        if tdiff<leastdiff
            leastdiff=tdiff;
        elseif tdiff > prevtdiff
            measurediff(1,i) = EstimatedState.x(j) - diff(1)-RtkFix.n(i);
            measureerr(1,i) = abs(EstimatedState.x(j) - diff(1)-RtkFix.n(i));
            measurediff(2,i) = EstimatedState.y(j) - diff(2)-RtkFix.e(i);
            measureerr(2,i) = abs(EstimatedState.y(j) - diff(2)-RtkFix.e(i));
            measurediff(3,i) = EstimatedState.z(j) - diff(3)-RtkFix.d(i);
            measureerr(3,i) = abs(EstimatedState.z(j) - diff(3)-RtkFix.d(i));
            break;
        end
        prevtdiff = tdiff;
    end
end

Mn= mean(measurediff(1,:));
Me= mean(measurediff(2,:));
Md= mean(measurediff(3,:));
Vn= var(measurediff(1,:));
Ve= var(measurediff(2,:));
Vd= var(measurediff(3,:));

Man= mean(measureerr(1,:));
Mae= mean(measureerr(2,:));
Mad= mean(measureerr(3,:));
Van= var(measureerr(1,:));
Vae= var(measureerr(2,:));
Vad= var(measureerr(3,:));

%%SAVE
%saveas(figure(2), 'My Master/Report - Master/figures/rtkpixpos_ne', 'png');
%saveas(figure(3), 'My Master/Report - Master/figures/rtkpixpos_nd', 'png');

%%