clear;
load('Data lots of optimal.mat');
ent = zeros(1,25);
entcount = 1;

for i = 1:length(Distance.value)
    newent = true;
    for j = 1:length(ent)
        if(Distance.src_ent(i) == ent(j))
            newent = false;
        end
    end
    if(newent)
        ent(entcount) = Distance.src_ent(i);
        entcount = entcount +1;
    end
end

if i==500
    x = zeros(entcount,500);
else
    x = zeros(entcount,round(length(Distance.value)/entcount));
end

count = ones(1,entcount);
for i = 1:(entcount*length(x(1,:)))
    for j = 1:entcount
        if Distance.src_ent(i) == ent(j)
            x(j,count(j)) = Distance.value(i);
            count(j) = count(j) +1;
            continue;
        end
    end
end

average=[mean(x(1,:)),mean(x(2,:)),mean(x(3,:))];
[xe, ye, ze] = ellipsoid(average(1),average(2),average(3), sqrt(var(x(1,:))+ var(x(2,:))+ var(x(3,:))),sqrt(var(x(1,:))+ var(x(2,:))+ var(x(3,:))),sqrt(var(x(1,:))+ var(x(2,:))+ var(x(3,:))),30);
[xr, yr, zr] = ellipsoid(0,0,0, .85*2, .85*2, .85*2 ,30);

figure(1);
clf;
hold on;
title('Optimal path release accuracy plot in body frame')
xlabel('x');
ylabel('y');
zlabel('z');
scatter3(x(1,:),x(2,:),x(3,:), 'Fill');
scatter3(average(1),average(2),average(3), 'Fill')
scatter3(0,0,0, 'Fill')
surf(xe,ye,ze, 'FaceAlpha', 0.2)
surf(xr,yr,zr, 'FaceAlpha', 0.2)
legend('Release point','Average','CARP', 'MRSE', 'CARP release distance')

figure(2);
clf;
hold on;
title('Optimal path release accuracy XY-plot in body frame')
xlabel('x');
ylabel('y');
scatter(x(1,:),x(2,:), 20, 'Fill');
scatter(average(1),average(2), 'Fill')
scatter(0,0, 'Fill')
[X,Y]=ell(average(1),average(2),sqrt(var(x(1,:))+ var(x(2,:))), sqrt(var(x(1,:))+ var(x(2,:))),0,100);
plot(X,Y);
alpha(0)
legend('Release point','Average','CARP', 'DRMS')

figure(3);
clf;
hold on;
title('Optimal path release accuracy XZ-plot in body frame')
xlabel('x');
ylabel('z');
scatter(x(1,:),x(3,:),20, 'Fill');
scatter(average(1),average(3), 'Fill')
scatter(0,0, 'Fill')
[X,Y]=ell(average(1),average(3),sqrt(var(x(1,:))+ var(x(3,:))),sqrt(var(x(1,:))+ var(x(3,:))),0,100);
plot(X,Y);
alpha(0)
legend('Release point','Average','CARP', 'DRMS')


mx= average(1);
my= average(2);
mz= average(3);
vx= var(x(1,:));
vy=var(x(2,:));
vz=var(x(3,:));

max= mean(abs(x(1,:)));
may= mean(abs(x(2,:)));
maz= mean(abs(x(3,:)));
vax= var(abs(x(1,:)));
vay=var(abs(x(2,:)));
vaz=var(abs(x(3,:)));

mvx= mean(x(4,:));
mvy= mean(x(5,:));
mvz= mean(x(6,:));
vvx= var(x(4,:));
vvy=var(x(5,:));
vvz=var(x(6,:));

mavx= mean(abs(x(4,:)));
mavy= mean(abs(x(5,:)));
mavz= mean(abs(x(6,:)));
vavx= var(abs(x(4,:)));
vavy=var(abs(x(5,:)));
vavz=var(abs(x(6,:)));

saveas(figure(2), 'Report - Master/figures/optimal_xy','png')
saveas(figure(3), 'Report - Master/figures/optimal_xz','png')