//***************************************************************************
// Copyright 2007-2015 Universidade do Porto - Faculdade de Engenharia      *
// Laboratório de Sistemas e Tecnologia Subaquática (LSTS)                  *
//***************************************************************************
// This file is part of DUNE: Unified Navigation Environment.               *
//                                                                          *
// Commercial Licence Usage                                                 *
// Licencees holding valid commercial DUNE licences may use this file in    *
// accordance with the commercial licence agreement provided with the       *
// Software or, alternatively, in accordance with the terms contained in a  *
// written agreement between you and Universidade do Porto. For licensing   *
// terms, conditions, and further information contact lsts@fe.up.pt.        *
//                                                                          *
// European Union Public Licence - EUPL v.1.1 Usage                         *
// Alternatively, this file may be used under the terms of the EUPL,        *
// Version 1.1 only (the "Licence"), appearing in the file LICENCE.md       *
// included in the packaging of this file. You may not use this work        *
// except in compliance with the Licence. Unless required by applicable     *
// law or agreed to in writing, software distributed under the Licence is   *
// distributed on an "AS IS" basis, WITHOUT WARRANTIES OR CONDITIONS OF     *
// ANY KIND, either express or implied. See the Licence for the specific    *
// language governing permissions and limitations at                        *
// http://ec.europa.eu/idabc/eupl.html.                                     *
//***************************************************************************
// Author: Ricardo Martins                                                  *
//***************************************************************************
// Automatically generated.                                                 *
//***************************************************************************
// IMC XML MD5: f6f5adb5d6ef31881d40b0811697f34f                            *
//***************************************************************************

// DUNE headers.
#include <DUNE/DUNE.hpp>

using DUNE_NAMESPACES;

#include "Test.hpp"

int
main(void)
{
  Test test("IMC Serialization/Deserialization");

  {
    IMC::EntityState msg;
    msg.setTimeStamp(0.75360993874);
    msg.setSource(57955U);
    msg.setSourceEntity(210U);
    msg.setDestination(38522U);
    msg.setDestinationEntity(67U);
    msg.state = 161U;
    msg.flags = 1U;
    msg.description.assign("AUOFDHVGKFVZDEIXRAQFGUXFXZUADTVSYDTFOBWNR");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityState msg;
    msg.setTimeStamp(0.919844371888);
    msg.setSource(8622U);
    msg.setSourceEntity(185U);
    msg.setDestination(26029U);
    msg.setDestinationEntity(59U);
    msg.state = 158U;
    msg.flags = 110U;
    msg.description.assign("GDQZVUTXCCQYOGSTVBQJYTNLKQJVZIAPJTXKJUSAROLXRQMIPNDCWKKMHNTVGODZNESMFSWLWKTHVXOTBWVDORFFEUWSHMWYHISQWRYXBQXVUBJARKMFJXOYRQWBFNUPHANIMACEMLHNSK");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityState msg;
    msg.setTimeStamp(0.463368878093);
    msg.setSource(34211U);
    msg.setSourceEntity(145U);
    msg.setDestination(2160U);
    msg.setDestinationEntity(162U);
    msg.state = 151U;
    msg.flags = 187U;
    msg.description.assign("WTVEXSJIZHJCPSUFWUHEBBNKPFJKEGVEQRYWURDXDTAGIXLWBOHOZDNQDUZLXSYIFCNKMMWYRBETZAVHOZVXKJCPYZPTNEUAGFUZULODFAFFOZTPCQARHUKMDKNIINVEIBLHLUQLDJCPSWKXSSEJUJAYDQMPRGLPCGQPSCWIFDJKONVWTXCGSAAMIKFXMVRRNOPBSYYFBIAGJZXYYSBHTKMYQDQZCNOL");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityState msg;
    msg.setTimeStamp(0.0856018370597);
    msg.setSource(60273U);
    msg.setSourceEntity(130U);
    msg.setDestination(36991U);
    msg.setDestinationEntity(74U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityState msg;
    msg.setTimeStamp(0.908485341393);
    msg.setSource(4204U);
    msg.setSourceEntity(23U);
    msg.setDestination(37445U);
    msg.setDestinationEntity(72U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityState msg;
    msg.setTimeStamp(0.445855419184);
    msg.setSource(46335U);
    msg.setSourceEntity(158U);
    msg.setDestination(58599U);
    msg.setDestinationEntity(219U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityInfo msg;
    msg.setTimeStamp(0.708435632651);
    msg.setSource(22634U);
    msg.setSourceEntity(193U);
    msg.setDestination(2335U);
    msg.setDestinationEntity(177U);
    msg.id = 167U;
    msg.label.assign("WNLPKZQIBCHCIBEEHBGNYHRPXMDFYAQJPMBTGKSGJESLFGLSBDUCAVVEDYQUOTBZAHCTWVKSVOTBAMDNGKEFLOBEKLACWUXZEVMZFHQTKYIUGXNXCSRWZZSURKYMZXRFFLKVNZOMPQSZYQJHTDNYHIIPUGNXFZJNFPLARBGRRWSPXNTOQTAYPGHHIOCCIJOJWJAVSKJNDHFAEUVMXQWQDMEPTSRID");
    msg.component.assign("YTKRZYZYEOTFGGXZIFIWUOLEWFETOYWWXIZRQLUKNKUWMAIITTODLSNJNXLYBFVMBHOCANORUPVGMQBCJUECNCKGYSFSBQREPZKLFODBGHJDHSIUJBBVPMEASOPYMEQSVPNV");
    msg.act_time = 56445U;
    msg.deact_time = 11973U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityInfo #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityInfo msg;
    msg.setTimeStamp(0.378731937244);
    msg.setSource(24040U);
    msg.setSourceEntity(69U);
    msg.setDestination(28200U);
    msg.setDestinationEntity(186U);
    msg.id = 25U;
    msg.label.assign("LNRJQLKPJMUIVXYJNGKTUNREQIYCWCUXDHSJNDPTEMGZPAVHATDJ");
    msg.component.assign("WWSVVMPFBFZCCRXZQYZCRWSNTSSNZTHKUZODZXSIOLIYTCJNVAXZISCWNOHYOOIQBJMDLXXKLEJQSHWUHYAQVXJCTWUEKFMMEPBJYMUMKNADLRXTBHSGLNPNVFLPUFCMTAJZFQUYQKAOVKIFLHRGPMXAGDLBESQHFACYFGUNTQDKDHNCIDQ");
    msg.act_time = 31047U;
    msg.deact_time = 40089U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityInfo #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityInfo msg;
    msg.setTimeStamp(0.703216582265);
    msg.setSource(30745U);
    msg.setSourceEntity(64U);
    msg.setDestination(7109U);
    msg.setDestinationEntity(28U);
    msg.id = 128U;
    msg.label.assign("KLSBHVCZPAZBRLMJVYOTKNGQJWDDAYRNSFLKRMWQZMYOCNCOGSOPTXKOGCRNVZLIAKUSRBIFDMQHUAYSFFUSPLWJPJIDXHBKEXOVEDZDJHBEMWQKIGAMXWAVGNVYMUCSNNTMZQKMJYDLFEEKHPHIAREFLFYFHWPDSWTUAHITUPBNQQYWIJTTIYKDUNOALUCIRFVRCFBUTCPGEIBUXBJXONMGDWOQHGTSSWJEOXCBZTECZGZ");
    msg.component.assign("QZJYGPEKVCUBZWERCGYRMJFXNNGVWTNBLKQZMFZIAKJAMLHQXSQGHWIPOFUVNQXWMNCNTVAWEEFLJCCRSRMIPCGJIYMAZGOQIXHBRDLEUOHSKYUMVSAOPBYNAUHYGXWDD");
    msg.act_time = 23385U;
    msg.deact_time = 53978U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityInfo #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityInfo msg;
    msg.setTimeStamp(0.53197896542);
    msg.setSource(24424U);
    msg.setSourceEntity(2U);
    msg.setDestination(57229U);
    msg.setDestinationEntity(18U);
    msg.id = 7U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityInfo #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityInfo msg;
    msg.setTimeStamp(0.159260858221);
    msg.setSource(30160U);
    msg.setSourceEntity(10U);
    msg.setDestination(44265U);
    msg.setDestinationEntity(73U);
    msg.id = 253U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityInfo #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityInfo msg;
    msg.setTimeStamp(0.56257350879);
    msg.setSource(4663U);
    msg.setSourceEntity(132U);
    msg.setDestination(56345U);
    msg.setDestinationEntity(57U);
    msg.id = 112U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityInfo #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityList msg;
    msg.setTimeStamp(0.590490658423);
    msg.setSource(51851U);
    msg.setSourceEntity(43U);
    msg.setDestination(37723U);
    msg.setDestinationEntity(173U);
    msg.op = 69U;
    msg.list.assign("CJDYBSOSMTDBPVQPCRXVXIVRNPCMAKLHTNWYAYVHOCTOOXLSOGXKTHWGCKDGYNIFFNPCDRMPFXBKEQPAPPZGWMANMTEEBHOXIIMUBZOWUDEAUGURFLOAFSMHTHOSNAIVSGYGJWGBRBNJWLTJRUTWUKTRHFCZIYHZADFXXLEQEXZGDAHCIJSXTRJLRUEMVULJNGKQEHKUCDDNKZBWZIPEQKSIIFPSZQQLJQSYQZDVVYUNBOJYFW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityList #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityList msg;
    msg.setTimeStamp(0.8998052324);
    msg.setSource(45554U);
    msg.setSourceEntity(204U);
    msg.setDestination(880U);
    msg.setDestinationEntity(12U);
    msg.op = 18U;
    msg.list.assign("NMWFLOIOZCLULYSMKSWKIQGBIYSLUDVLJBVMAIFKOBBQCMJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityList #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityList msg;
    msg.setTimeStamp(0.220529208441);
    msg.setSource(45007U);
    msg.setSourceEntity(246U);
    msg.setDestination(17730U);
    msg.setDestinationEntity(122U);
    msg.op = 210U;
    msg.list.assign("INDFDFLWVQRDRICNDKCXVTOLNZLELKCOOMXPCHXLJEBDWUSYGVJISZGAPGQWEWQRYQLOYEIMVXTUXAKPRBVMEBJTLKFSPGWEKSXZBMATVZGRFPAMTUZBIBQZAPQIJDCUSSTANOEFRQXNEGNUDIWZZPMWAEPLBQWCQSOOHZPTBHUSA");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityList #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CpuUsage msg;
    msg.setTimeStamp(0.221482036137);
    msg.setSource(19094U);
    msg.setSourceEntity(185U);
    msg.setDestination(10650U);
    msg.setDestinationEntity(211U);
    msg.value = 155U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CpuUsage #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CpuUsage msg;
    msg.setTimeStamp(0.468568978714);
    msg.setSource(11680U);
    msg.setSourceEntity(150U);
    msg.setDestination(31246U);
    msg.setDestinationEntity(134U);
    msg.value = 120U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CpuUsage #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CpuUsage msg;
    msg.setTimeStamp(0.455988070635);
    msg.setSource(45879U);
    msg.setSourceEntity(220U);
    msg.setDestination(8589U);
    msg.setDestinationEntity(30U);
    msg.value = 143U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CpuUsage #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TransportBindings msg;
    msg.setTimeStamp(0.47331458203);
    msg.setSource(8107U);
    msg.setSourceEntity(163U);
    msg.setDestination(54737U);
    msg.setDestinationEntity(39U);
    msg.consumer.assign("MUIUGEOWETET");
    msg.message_id = 26972U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TransportBindings #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TransportBindings msg;
    msg.setTimeStamp(0.256425123746);
    msg.setSource(4060U);
    msg.setSourceEntity(33U);
    msg.setDestination(43976U);
    msg.setDestinationEntity(17U);
    msg.consumer.assign("OBDFIYATZWSVCWNOQEXHRTFLMZGZJEESEQUTMLUKAKMBNFJBZWDLYERIQKAKCJQFTDKDNHIGAFLSIAZVUXJMDHFUSXUTLXGVLOQBBFXRLETKMOPEQSNZZDPCYIBIBXFSEUWJWGTQUCMAYECGAQJ");
    msg.message_id = 10963U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TransportBindings #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TransportBindings msg;
    msg.setTimeStamp(0.766373434827);
    msg.setSource(13196U);
    msg.setSourceEntity(236U);
    msg.setDestination(51823U);
    msg.setDestinationEntity(2U);
    msg.consumer.assign("QKCIZMCXGRRNVRWTIPCQYQHILYGXILIBUFNNXCGJHTLHESSQOGPFJBKWEEBXYIMKJPHVUFHJAAQXTKYRUSWBMOGD");
    msg.message_id = 35440U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TransportBindings #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RestartSystem msg;
    msg.setTimeStamp(0.547407419947);
    msg.setSource(7939U);
    msg.setSourceEntity(230U);
    msg.setDestination(25273U);
    msg.setDestinationEntity(103U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RestartSystem #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RestartSystem msg;
    msg.setTimeStamp(0.337006515569);
    msg.setSource(15615U);
    msg.setSourceEntity(199U);
    msg.setDestination(30097U);
    msg.setDestinationEntity(27U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RestartSystem #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RestartSystem msg;
    msg.setTimeStamp(0.356023562413);
    msg.setSource(53836U);
    msg.setSourceEntity(94U);
    msg.setDestination(18117U);
    msg.setDestinationEntity(41U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RestartSystem #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevCalibrationControl msg;
    msg.setTimeStamp(0.144756914828);
    msg.setSource(26747U);
    msg.setSourceEntity(13U);
    msg.setDestination(62456U);
    msg.setDestinationEntity(156U);
    msg.op = 11U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevCalibrationControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevCalibrationControl msg;
    msg.setTimeStamp(0.34394348505);
    msg.setSource(53420U);
    msg.setSourceEntity(158U);
    msg.setDestination(313U);
    msg.setDestinationEntity(155U);
    msg.op = 251U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevCalibrationControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevCalibrationControl msg;
    msg.setTimeStamp(0.464394492018);
    msg.setSource(59685U);
    msg.setSourceEntity(177U);
    msg.setDestination(45235U);
    msg.setDestinationEntity(154U);
    msg.op = 204U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevCalibrationControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevCalibrationState msg;
    msg.setTimeStamp(0.46911645199);
    msg.setSource(1412U);
    msg.setSourceEntity(126U);
    msg.setDestination(39558U);
    msg.setDestinationEntity(216U);
    msg.total_steps = 77U;
    msg.step_number = 139U;
    msg.step.assign("IRUHRPUVNRZBLEPTXDOQJPFLXLEWUEZDBSSTAFV");
    msg.flags = 65U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevCalibrationState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevCalibrationState msg;
    msg.setTimeStamp(0.297819046606);
    msg.setSource(18731U);
    msg.setSourceEntity(45U);
    msg.setDestination(8458U);
    msg.setDestinationEntity(28U);
    msg.total_steps = 103U;
    msg.step_number = 182U;
    msg.step.assign("SKNJQQDPEOCOBNDDTWLRJXTVNVUOGCSUGBVGJENJXYXAGCGVMMNXZUDSIGWSRFQUMNEPOYRFOPVHZMTWYFSEEKGKJTWBDBLQFIPRMANSYPJZUKFHRGQAPZBNXYSBYZIYIWOLFUUBOHBCFHLRHEAUWXIRKFERCZLQWXHQYAKCRLULDACDAJNZBJHILWXLFPVDHHTZPEHIJPXITSTDJSAGQTOTEBZKOAWQEXVRVOSGLMVPWQMIVYKFKCMA");
    msg.flags = 156U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevCalibrationState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevCalibrationState msg;
    msg.setTimeStamp(0.250816807247);
    msg.setSource(11106U);
    msg.setSourceEntity(235U);
    msg.setDestination(30296U);
    msg.setDestinationEntity(139U);
    msg.total_steps = 246U;
    msg.step_number = 35U;
    msg.step.assign("XHVMHRJYWMRFEFVEAWTDBPZCEEHIOFTMBTHYFASQAFAQTOUDQVIRGWQUAWHZXYMNTPXJPPCZYLDXSNKPYIRUVLQCHNMJETANCFJWLKSXCGCKXDMWIUWZBOGZVVCBDTSRMCKJLSTQODJYSBZNEVKHKTOPELNEAWHIPFGDUXBIABJPKVIFQQOKFIBJZGYATUUNMLNDQRYXCLPIOAGJWNBSSOZLDOSGUDOIQPMLGZMNLKKWJHRVYSURHFVRCBXGZG");
    msg.flags = 253U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevCalibrationState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityActivationState msg;
    msg.setTimeStamp(0.104202223231);
    msg.setSource(1215U);
    msg.setSourceEntity(49U);
    msg.setDestination(50369U);
    msg.setDestinationEntity(174U);
    msg.state = 199U;
    msg.error.assign("ZHLOIATOWRBLWUFOIJNGCGTUWADDFZRWNIZCXHSGQNVYKLXITLAMOKOXZIRKCQWDZQSSKRHIGBWPQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityActivationState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityActivationState msg;
    msg.setTimeStamp(0.283648382013);
    msg.setSource(57531U);
    msg.setSourceEntity(194U);
    msg.setDestination(54879U);
    msg.setDestinationEntity(238U);
    msg.state = 206U;
    msg.error.assign("OZOSNHRORMYEZHFGNFVCJTCFDYRQMLHXALSQQXWBQRAHBFQFMVSDNSURHABCPDCQMEDQIZZPNAXIOIVNHKJRVZLWTKJGGZEIMNFNZXPNXJNYUEYWYASHTRJBEVWGIFNRLCBWREGLOTCLUIETHWQGBJAFYWOLOJRSQKUVFBTXIPKDLXAJVUQPKEMBMTTDOPTSMOJIP");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityActivationState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityActivationState msg;
    msg.setTimeStamp(0.0492803663826);
    msg.setSource(27937U);
    msg.setSourceEntity(59U);
    msg.setDestination(7264U);
    msg.setDestinationEntity(98U);
    msg.state = 153U;
    msg.error.assign("IIFEZMZUYQIBGZUBRYNDUFRHMZCBMVIBGUOUPJCXVJYDRBHXRCKQGWUMQAXOVPCFSYNMFDJKIBSUXJUOODRGPBWMKDNPTAHLXYNFRBLXFXQESHOVWMWKPVQNLKDHPLHLKYDGFEWGRZXZQXZOAOLAESSHPWEYOFWNSAVMUIYCPONHMQNKWEZBDKLYPJSAEEHQBZCATGZRNRJFAAITKSWSINLJGTTKXQIQTETPLCVE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityActivationState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityActivationState msg;
    msg.setTimeStamp(0.869153753735);
    msg.setSource(47704U);
    msg.setSourceEntity(171U);
    msg.setDestination(8054U);
    msg.setDestinationEntity(86U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityActivationState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityActivationState msg;
    msg.setTimeStamp(0.425728434804);
    msg.setSource(46307U);
    msg.setSourceEntity(48U);
    msg.setDestination(36415U);
    msg.setDestinationEntity(195U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityActivationState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityActivationState msg;
    msg.setTimeStamp(0.76617746904);
    msg.setSource(62547U);
    msg.setSourceEntity(136U);
    msg.setDestination(2846U);
    msg.setDestinationEntity(81U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityActivationState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleOperationalLimits msg;
    msg.setTimeStamp(0.587362107962);
    msg.setSource(17844U);
    msg.setSourceEntity(7U);
    msg.setDestination(34645U);
    msg.setDestinationEntity(51U);
    msg.op = 99U;
    msg.speed_min = 0.0017602343804;
    msg.speed_max = 0.5024843981;
    msg.long_accel = 0.599925324595;
    msg.alt_max_msl = 0.153350674733;
    msg.dive_fraction_max = 0.17276749449;
    msg.climb_fraction_max = 0.665759265342;
    msg.bank_max = 0.382600065683;
    msg.p_max = 0.894703203048;
    msg.pitch_min = 0.459897153763;
    msg.pitch_max = 0.145666397862;
    msg.q_max = 0.128772936721;
    msg.g_min = 0.737608018914;
    msg.g_max = 0.364720392814;
    msg.g_lat_max = 0.505502568887;
    msg.rpm_min = 0.526812511084;
    msg.rpm_max = 0.0786016369976;
    msg.rpm_rate_max = 0.373305912594;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleOperationalLimits #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleOperationalLimits msg;
    msg.setTimeStamp(0.997651292991);
    msg.setSource(24989U);
    msg.setSourceEntity(253U);
    msg.setDestination(29537U);
    msg.setDestinationEntity(53U);
    msg.op = 93U;
    msg.speed_min = 0.366498297103;
    msg.speed_max = 0.82479792474;
    msg.long_accel = 0.33900042999;
    msg.alt_max_msl = 0.805262325981;
    msg.dive_fraction_max = 0.389154513912;
    msg.climb_fraction_max = 0.889860102132;
    msg.bank_max = 0.874363193037;
    msg.p_max = 0.816308685414;
    msg.pitch_min = 0.57936949093;
    msg.pitch_max = 0.447385902042;
    msg.q_max = 0.36214473106;
    msg.g_min = 0.635720902683;
    msg.g_max = 0.439406724083;
    msg.g_lat_max = 0.885309239412;
    msg.rpm_min = 0.689785735104;
    msg.rpm_max = 0.483726590665;
    msg.rpm_rate_max = 0.0245084639408;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleOperationalLimits #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleOperationalLimits msg;
    msg.setTimeStamp(0.357276845676);
    msg.setSource(21653U);
    msg.setSourceEntity(18U);
    msg.setDestination(48773U);
    msg.setDestinationEntity(190U);
    msg.op = 20U;
    msg.speed_min = 0.444402186188;
    msg.speed_max = 0.553520113589;
    msg.long_accel = 0.79684173385;
    msg.alt_max_msl = 0.666165547414;
    msg.dive_fraction_max = 0.677182558347;
    msg.climb_fraction_max = 0.646889408287;
    msg.bank_max = 0.650649498544;
    msg.p_max = 0.64887593919;
    msg.pitch_min = 0.563556863872;
    msg.pitch_max = 0.207618714424;
    msg.q_max = 0.246270194133;
    msg.g_min = 0.479250106018;
    msg.g_max = 0.149539213258;
    msg.g_lat_max = 0.997813246575;
    msg.rpm_min = 0.0732402092827;
    msg.rpm_max = 0.773490485023;
    msg.rpm_rate_max = 0.958814272886;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleOperationalLimits #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MsgList msg;
    msg.setTimeStamp(0.727381599497);
    msg.setSource(52479U);
    msg.setSourceEntity(75U);
    msg.setDestination(60764U);
    msg.setDestinationEntity(143U);
    IMC::ManeuverControlState tmp_msg_0;
    tmp_msg_0.state = 178U;
    tmp_msg_0.eta = 42760U;
    tmp_msg_0.info.assign("KQACRTYWAWXNWXLVLJDLYXCIMUAQVDTGRPDRTUAAIMAUMEIJNMOPISKOEBMKZTFHXPOGZWCFZDFTBKRVOQPTDWGLDMIGEHLVFWZAPDFNEUV");
    msg.msgs.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MsgList #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MsgList msg;
    msg.setTimeStamp(0.756491933874);
    msg.setSource(50525U);
    msg.setSourceEntity(183U);
    msg.setDestination(21277U);
    msg.setDestinationEntity(175U);
    IMC::TrexObservation tmp_msg_0;
    tmp_msg_0.timeline.assign("URCRTLLNAHSLPUQRMNGVHEYCRNIIIYWSDEBFWOPMSBUADRDPAUXUZYOCBVCQXWDKMVKWEYCJAUXSQVFUQFVIFGLMOTGDRSXZOQFGVBLDYBLBFSOHWEGRMLHZCNIXTCFTAXYSHAEIHDBFTJAVGIOTTZOKONXCXRJBUQFTQRMQNJPEMCTHGTMWQJKPBJOFXPAVPIJHIVCZHGEYLZDDWU");
    tmp_msg_0.predicate.assign("ZBOPPWRXKVKWLNEYFJCDSNRULSSAHSGAXLWRMCBLUNJODFIVBKGAVIWSOJCKXGONMGOPCGMWLRANPF");
    tmp_msg_0.attributes.assign("IGUJMPSACETWGIJJIKXGKHCPQIZFYYTQYOCPQPGUDKNHFEUSEYUORZINLELBHOQXICWIMBHXPVBWYWEPDBXCBMBZAWVHAUKPMPNRJVADOKKZDFJPFJNWIFMHXZLDOACVGDSZLGZBWLKRCENPBMKQXQKQLNNICQLNVSCUJMLSVZJYHFYTVRZATRAWEMDMFUDGHEERLAJUQTNTKXAESCSFOBGOROOTHTYYFRLHUXWOJTDQVBST");
    msg.msgs.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MsgList #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MsgList msg;
    msg.setTimeStamp(0.0458680848543);
    msg.setSource(17081U);
    msg.setSourceEntity(100U);
    msg.setDestination(54164U);
    msg.setDestinationEntity(204U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MsgList #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SimulatedState msg;
    msg.setTimeStamp(0.750489486078);
    msg.setSource(38061U);
    msg.setSourceEntity(226U);
    msg.setDestination(46677U);
    msg.setDestinationEntity(141U);
    msg.lat = 0.849252583591;
    msg.lon = 0.676718928145;
    msg.height = 0.251249893377;
    msg.x = 0.828044860739;
    msg.y = 0.712518709932;
    msg.z = 0.438481117691;
    msg.phi = 0.40822487507;
    msg.theta = 0.441494935665;
    msg.psi = 0.0828536853798;
    msg.u = 0.748689395801;
    msg.v = 0.59481206591;
    msg.w = 0.586799688618;
    msg.p = 0.604824436177;
    msg.q = 0.0608611060722;
    msg.r = 0.110435897433;
    msg.svx = 0.41774416655;
    msg.svy = 0.906883464997;
    msg.svz = 0.939289966237;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SimulatedState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SimulatedState msg;
    msg.setTimeStamp(0.975286008827);
    msg.setSource(51401U);
    msg.setSourceEntity(62U);
    msg.setDestination(26580U);
    msg.setDestinationEntity(79U);
    msg.lat = 0.59828460198;
    msg.lon = 0.229191786897;
    msg.height = 0.0793595264708;
    msg.x = 0.270131719528;
    msg.y = 0.295688327569;
    msg.z = 0.700328530169;
    msg.phi = 0.206181638849;
    msg.theta = 0.875878793803;
    msg.psi = 0.405714545364;
    msg.u = 0.506877528169;
    msg.v = 0.859563051068;
    msg.w = 0.643729770138;
    msg.p = 0.348010298148;
    msg.q = 0.21825348626;
    msg.r = 0.891563877095;
    msg.svx = 0.141878851427;
    msg.svy = 0.0574094663875;
    msg.svz = 0.327438677316;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SimulatedState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SimulatedState msg;
    msg.setTimeStamp(0.773583573605);
    msg.setSource(56413U);
    msg.setSourceEntity(175U);
    msg.setDestination(51459U);
    msg.setDestinationEntity(100U);
    msg.lat = 0.188518787716;
    msg.lon = 0.278319883816;
    msg.height = 0.850157944475;
    msg.x = 0.993705709398;
    msg.y = 0.619469792803;
    msg.z = 0.96722126441;
    msg.phi = 0.0962446622616;
    msg.theta = 0.723555888472;
    msg.psi = 0.653088349841;
    msg.u = 0.166729902852;
    msg.v = 0.820096427786;
    msg.w = 0.0471569852931;
    msg.p = 0.297855834342;
    msg.q = 0.951899929469;
    msg.r = 0.0275558672579;
    msg.svx = 0.726942450711;
    msg.svy = 0.124407033476;
    msg.svz = 0.108594140506;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SimulatedState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LeakSimulation msg;
    msg.setTimeStamp(0.495872565512);
    msg.setSource(15427U);
    msg.setSourceEntity(140U);
    msg.setDestination(17305U);
    msg.setDestinationEntity(202U);
    msg.op = 71U;
    msg.entities.assign("BDLDBGXHPJKDHEMGYJDEREKHJACCCFOQMNIZFBWMFNAPPJUWHPIJOQUXPGABRZQKYXBYYBTOLPIGRUAEMTGGQAWRJCHMYZXRTEWNZOOERPFAXENAQIPWZDYXKVUDHDRZELEDCIONHWTEJPVAHBCBRSQKT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LeakSimulation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LeakSimulation msg;
    msg.setTimeStamp(0.285163833867);
    msg.setSource(11469U);
    msg.setSourceEntity(190U);
    msg.setDestination(53814U);
    msg.setDestinationEntity(248U);
    msg.op = 9U;
    msg.entities.assign("AALBXXUOCKBTBDCDTJRGIVFKIBJQMLJSMVLMINHGTWVMRXEGCBWKOKBIIERROLBDAMXLUSWXVYXCPJODTFBYWWBEAIVDZYHTNEQHWEUGFOPEPKZQHKGHLCMFD");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LeakSimulation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LeakSimulation msg;
    msg.setTimeStamp(0.866884078909);
    msg.setSource(33647U);
    msg.setSourceEntity(34U);
    msg.setDestination(64503U);
    msg.setDestinationEntity(183U);
    msg.op = 148U;
    msg.entities.assign("GJLQPGUVBIRJVTZKAQJGHOBICTXZIPLFQCPCFFATMKNMPDJNOSTDNFOOFBCJNHAJOAUVMBYGKUMPYVLBHRZDYGKJFGMWKRWVLLWVTHGHCAFUTKSJEPEVSLTIREKGSBASUSVSWDYYGKBDLXHXPRIUOUHHWXITZYYQUIEUNBRZWYRIAXEQVGWQFVMDXRBPESPECRXLXJACDCHTOLSAZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LeakSimulation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UASimulation msg;
    msg.setTimeStamp(0.0994460835895);
    msg.setSource(32172U);
    msg.setSourceEntity(238U);
    msg.setDestination(44058U);
    msg.setDestinationEntity(106U);
    msg.type = 195U;
    msg.speed = 24739U;
    const char tmp_msg_0[] = {19, 101, 54, 101, 25, -82, -48, -123, -42, -19, 104, 121, 91, -42, -93, 2, -71, 77, -108, 81, -127, 33, -7, -92, 96, 61, -44, 118, 34, -96, -124, -12, 61, -11, 111, 119, 51, 79, -26, -73, 96, -13, -123, 38, 17, 84, -48, -77, 101, -2, -61, -84, -30, 47, 90, 4, 13, -88, 104, -42, 72, 29, -71, -47, 103, -95, -12, -6, -42, -63, 9, 101, 104, 72, -75, -1, -58, 28, -74, 75, 82, 57, 126, 10, 28, -39, 8, 21, 24, -18, -25, -17, -98, -108, 85, -13, -52, 89, -55, -112, -45, -20, -61, 40, -28, 69, -92, -22, -44, 73, 56, -75, 35, 22, 45};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UASimulation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UASimulation msg;
    msg.setTimeStamp(0.55912157027);
    msg.setSource(5845U);
    msg.setSourceEntity(91U);
    msg.setDestination(50129U);
    msg.setDestinationEntity(207U);
    msg.type = 192U;
    msg.speed = 19667U;
    const char tmp_msg_0[] = {54, 99, -33, 57, -96, -3, 25, -90, -86, 41, -49, -74, 33, -100, 98, 98, 76, 12, 33, -43, -127, 120, -50, -45, -51, -13, -55, 104};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UASimulation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UASimulation msg;
    msg.setTimeStamp(0.332886019071);
    msg.setSource(62195U);
    msg.setSourceEntity(218U);
    msg.setDestination(53584U);
    msg.setDestinationEntity(205U);
    msg.type = 246U;
    msg.speed = 40609U;
    const char tmp_msg_0[] = {-75, 57, 23, -99, -111, -83, 64, 116, 36, -66, 82, -76, -38, -57, 31, -35, -36, -14, -31, -46, -121, 104, 26, -26, 92, 116, 99, -119, -2, 79, -59, -17, -19, -127, -76, -97, 91, 70, -56, -24, 72, -84, 23, 2, -111, 93, 86, -52, 76, -28, -49, 69, -18, -83, -95, 70, 27, 89, -63, -105, 101, 102, -93, 68, -92, 126, -100, 7, -82, 11, 104, 90, -69, -119, 34, 30, -116, 6, -27, 40, 77, 61, -98, 8, 20, -98, 98, 31, 13, 59, 6, -26, -80, -124, -95, 99, 98, -107, -68, -8, -41, 35, 100, -106, -22, -55, -105, 108, -55, 98, -114, -7, -50, -72, -15, -116, 124, -82, 1, 13, -49, -94, 102, 70, 27, -69, -68, -23, 3, 77, 5, -110, 109, -126, 54, 49, -112, 25, -120, -123, 73, -80, 92, 80, -38, 83, -81, 57, 29, -55, 29, 118, -44, -17, 4, 18, -44, -86, -122, 69, -40, 42, 32, 40, 19, -22, 103, 81, -70, -107, -15, -53, 90, -104, 121, 105, -44, 78, -23, -17, 80, 125, 32, -60, 124, -83, -4, -2, 23, -14, -60, -3, 60, 11, 34};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UASimulation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DynamicsSimParam msg;
    msg.setTimeStamp(0.729595935588);
    msg.setSource(47845U);
    msg.setSourceEntity(205U);
    msg.setDestination(13954U);
    msg.setDestinationEntity(217U);
    msg.op = 71U;
    msg.tas2acc_pgain = 0.587850654595;
    msg.bank2p_pgain = 0.137294140814;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DynamicsSimParam #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DynamicsSimParam msg;
    msg.setTimeStamp(0.836741297059);
    msg.setSource(34204U);
    msg.setSourceEntity(147U);
    msg.setDestination(37671U);
    msg.setDestinationEntity(152U);
    msg.op = 185U;
    msg.tas2acc_pgain = 0.563235051042;
    msg.bank2p_pgain = 0.0696057488472;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DynamicsSimParam #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DynamicsSimParam msg;
    msg.setTimeStamp(0.729036287284);
    msg.setSource(37488U);
    msg.setSourceEntity(165U);
    msg.setDestination(37304U);
    msg.setDestinationEntity(100U);
    msg.op = 68U;
    msg.tas2acc_pgain = 0.289519255467;
    msg.bank2p_pgain = 0.476395603275;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DynamicsSimParam #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StorageUsage msg;
    msg.setTimeStamp(0.120593461136);
    msg.setSource(10285U);
    msg.setSourceEntity(251U);
    msg.setDestination(36272U);
    msg.setDestinationEntity(111U);
    msg.available = 2315720220U;
    msg.value = 1U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StorageUsage #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StorageUsage msg;
    msg.setTimeStamp(0.107977618144);
    msg.setSource(4320U);
    msg.setSourceEntity(109U);
    msg.setDestination(25046U);
    msg.setDestinationEntity(7U);
    msg.available = 2376432026U;
    msg.value = 64U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StorageUsage #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StorageUsage msg;
    msg.setTimeStamp(0.842722485377);
    msg.setSource(31808U);
    msg.setSourceEntity(143U);
    msg.setDestination(50290U);
    msg.setDestinationEntity(19U);
    msg.available = 1506384107U;
    msg.value = 59U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StorageUsage #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CacheControl msg;
    msg.setTimeStamp(0.0757853836977);
    msg.setSource(6879U);
    msg.setSourceEntity(93U);
    msg.setDestination(26089U);
    msg.setDestinationEntity(162U);
    msg.op = 125U;
    msg.snapshot.assign("SPYABPSKDYTWMTVZVZLKYMUECSRHUZDLAWLVRWQNEYDIECJBAXGIFFVRDLYMWSYOHUGTHIUOATRQOJIMXCMOFKFGCFSSZLQZQXVNHTPOPHXQJQUZABMWDQWJNMAEOHUZLZVJQCOGLYYPIJCNXPDBPESJYKARGMWO");
    IMC::FormationMonitor tmp_msg_0;
    tmp_msg_0.ax_cmd = 0.936398879622;
    tmp_msg_0.ay_cmd = 0.118203685188;
    tmp_msg_0.az_cmd = 0.669633053988;
    tmp_msg_0.ax_des = 0.479756999312;
    tmp_msg_0.ay_des = 0.964452781391;
    tmp_msg_0.az_des = 0.677408834276;
    tmp_msg_0.virt_err_x = 0.774722203941;
    tmp_msg_0.virt_err_y = 0.798937987183;
    tmp_msg_0.virt_err_z = 0.730323317911;
    tmp_msg_0.surf_fdbk_x = 0.873985447695;
    tmp_msg_0.surf_fdbk_y = 0.193281837389;
    tmp_msg_0.surf_fdbk_z = 0.878199176959;
    tmp_msg_0.surf_unkn_x = 0.415517113323;
    tmp_msg_0.surf_unkn_y = 0.859882673615;
    tmp_msg_0.surf_unkn_z = 0.56997401107;
    tmp_msg_0.ss_x = 0.873724259569;
    tmp_msg_0.ss_y = 0.717765702797;
    tmp_msg_0.ss_z = 0.0825552365905;
    IMC::RelativeState tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.s_id.assign("ZWKHYDDGSLMZMCFRBXODMOGISMFKJIYINYUJVLQNYEKVTGMHHHQYZIJCEOXMXPHWWECPVOGAYLYLUNHWQNKBCTLHGJYZWAAWCUXIDSLKLFTDSJRYTHRWZAOBLFRONRMCCFOYKXGGPTCOMBQAXUQSEXUXERVBPHZBUTQRIBNIQZVZIDNVTJFSEHJMRBDOEKEUPLPCVVGKGDDONBCDEZAQI");
    tmp_tmp_msg_0_0.dist = 0.341706700997;
    tmp_tmp_msg_0_0.err = 0.927208544733;
    tmp_tmp_msg_0_0.ctrl_imp = 0.728654604668;
    tmp_tmp_msg_0_0.rel_dir_x = 0.51700781085;
    tmp_tmp_msg_0_0.rel_dir_y = 0.737572204348;
    tmp_tmp_msg_0_0.rel_dir_z = 0.814512287517;
    tmp_tmp_msg_0_0.err_x = 0.510315995955;
    tmp_tmp_msg_0_0.err_y = 0.24773120365;
    tmp_tmp_msg_0_0.err_z = 0.931758647241;
    tmp_tmp_msg_0_0.rf_err_x = 0.80954466196;
    tmp_tmp_msg_0_0.rf_err_y = 0.543447844086;
    tmp_tmp_msg_0_0.rf_err_z = 0.715630782826;
    tmp_tmp_msg_0_0.rf_err_vx = 0.247130278297;
    tmp_tmp_msg_0_0.rf_err_vy = 0.300422762176;
    tmp_tmp_msg_0_0.rf_err_vz = 0.796030560463;
    tmp_tmp_msg_0_0.ss_x = 0.0832638836786;
    tmp_tmp_msg_0_0.ss_y = 0.0948938732689;
    tmp_tmp_msg_0_0.ss_z = 0.697934359334;
    tmp_tmp_msg_0_0.virt_err_x = 0.172953141309;
    tmp_tmp_msg_0_0.virt_err_y = 0.248771023966;
    tmp_tmp_msg_0_0.virt_err_z = 0.498318932273;
    tmp_msg_0.rel_state.push_back(tmp_tmp_msg_0_0);
    msg.message.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CacheControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CacheControl msg;
    msg.setTimeStamp(0.0956097099068);
    msg.setSource(18106U);
    msg.setSourceEntity(18U);
    msg.setDestination(10097U);
    msg.setDestinationEntity(145U);
    msg.op = 72U;
    msg.snapshot.assign("BHYRSCQNQULTMRBSGEPCXKVFRVBQOAQHAHDBZITGOMPJZVVJJFKGZEMODLRYYWTPUUULDERIUEJOSBDACSSCCUNHYXXB");
    IMC::AlignmentState tmp_msg_0;
    tmp_msg_0.state = 193U;
    msg.message.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CacheControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CacheControl msg;
    msg.setTimeStamp(0.214130669691);
    msg.setSource(28680U);
    msg.setSourceEntity(113U);
    msg.setDestination(54773U);
    msg.setDestinationEntity(181U);
    msg.op = 116U;
    msg.snapshot.assign("LQVNNLJAHDBIIYQGHXENYMJTYOFVCQYDBWBIFHFSKTFUWCRFQRAOHQTSGWOAMTXAIUGHHYPIUULZNSKBCTQIZK");
    IMC::IoEvent tmp_msg_0;
    tmp_msg_0.type = 52U;
    tmp_msg_0.error.assign("BLIRGTTXJRLAUQHBSGAINSSDWMEFNRSKCCKAIZWPUBFCUJBAOPERDZUMZTSVNZFLNENIBRUOSFXUIHRLVQYKTMCZWEJPDRQGOKRWSXYVZEYHBGYMHNGQPMFPVWBXDBFJZSXYOKKDWJAROCUHNXVCSGMMXLBQUQCASUTGLKDMAWOW");
    msg.message.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CacheControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LoggingControl msg;
    msg.setTimeStamp(0.72304449445);
    msg.setSource(54076U);
    msg.setSourceEntity(113U);
    msg.setDestination(23622U);
    msg.setDestinationEntity(225U);
    msg.op = 77U;
    msg.name.assign("CSYJSXKGUMNEELOUSHOVAREGECKUMZNM");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LoggingControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LoggingControl msg;
    msg.setTimeStamp(0.351403494965);
    msg.setSource(18893U);
    msg.setSourceEntity(156U);
    msg.setDestination(57209U);
    msg.setDestinationEntity(28U);
    msg.op = 192U;
    msg.name.assign("DINYBMNJHPGIQBWLXRRHBWQYJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LoggingControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LoggingControl msg;
    msg.setTimeStamp(0.690654148627);
    msg.setSource(52592U);
    msg.setSourceEntity(202U);
    msg.setDestination(34844U);
    msg.setDestinationEntity(212U);
    msg.op = 133U;
    msg.name.assign("TCFGQGXYJWIEFMANXRVTZMHABAJUDLVADHNKNNEBUQPXSOYTHBJEOUZPUZCQELSVPWBXFRTCOXTXVJVWKSFKDMLBZMGOYXIXIJIGDTJDQQNPGVLKTCOYJVLXCGRFCTHRUACGHKWYRBHVNDIHAIAWSMXRACGQWBYLSICSFPVRUKCMQPNPSUZQGYIFMAPYFJZNFUORUEEPYOBVHEBRLWZDSIFHRBQMILQKAUKGOZJDT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LoggingControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LogBookEntry msg;
    msg.setTimeStamp(0.755252307363);
    msg.setSource(54559U);
    msg.setSourceEntity(14U);
    msg.setDestination(26213U);
    msg.setDestinationEntity(210U);
    msg.type = 29U;
    msg.htime = 0.223853234099;
    msg.context.assign("HFROFQNYIQUFQVJDABDEGJUXVNTEMUGAYWBQHXBWGMTBXYDXKZYJGELUMTSCPYXBMVJHHYCQPKFIWAKCVSFRKUERUSVTDKSXWMVJOOTKYRLHOARTDACZPOEDTWUZZABGZOICAHOQZBGXPNZNIGFNNWMDELIYKQCNYPLXLPQJIUCBROAMLGWUFSNDLW");
    msg.text.assign("OEHONKHFOVPSDJWFAASATFCFUWFARNNLQWSTSJXVIWMJHFQJAEQJOGFWIVDCPBTEWGXTYBNEGYNKZBZASCZEDYUZXDLQQMYCDACXBVPTMLUETUURRXNJQTPZOEECHEPNSLGLMITDXTMGMOKUMBJXXUHPKZOUQCBRLORYVVVHPRKQKAIHYZOFSGLGCJRVBSDUGPLHBKFAIIRMWIWTAFCCPJWRYUXYIHINKHXIGGKKYZMQSME");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LogBookEntry #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LogBookEntry msg;
    msg.setTimeStamp(0.934797386276);
    msg.setSource(39586U);
    msg.setSourceEntity(201U);
    msg.setDestination(14645U);
    msg.setDestinationEntity(54U);
    msg.type = 223U;
    msg.htime = 0.436427224997;
    msg.context.assign("CSFBIGYKHAGQPRFUMLEFCLAIJAVVOEKAZXFPWPOWBOWIKFNSKSLSUBCKIUIABJTTMNVBHIZCQZEGTEPMYKMCFQJZJXQUIWWTQOSJZALCXPYHGEDIFNRXHPXXGRAPEDRGFHZYCKHODGSMUEBTPPYQTAVDFWXWTXWPKHMUU");
    msg.text.assign("IKGLJNSADJXAYSFQIQUMCFXOZJFMXLSF");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LogBookEntry #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LogBookEntry msg;
    msg.setTimeStamp(0.294215213406);
    msg.setSource(35163U);
    msg.setSourceEntity(249U);
    msg.setDestination(64345U);
    msg.setDestinationEntity(193U);
    msg.type = 153U;
    msg.htime = 0.0218268892064;
    msg.context.assign("KPTCTAVSLPABVKNXIZMQMYDCEXEVCYFJNLGNZBXVOVENWWZSPUFCXIHWNVUERVUMANXMUBTABVQWROTQCRHLXHTUJRKHGWBMOYLPWQKPKSEOZAFLHIAWSJUREJYFEPMLBYGLSGCHXOGQOZPRSBNYDYQMREJLUAKBDOJPVDIACCKWSQNGWDNYFDGFFCIMKSFXSIJZSAXTNVHQCOKYRZTPBYRZHDOIWELGFGUIZJMPADLHDRJGUXDTJFMKTOZ");
    msg.text.assign("XHISSUPSZVMSFAMPIKDUTVZEXRGQVULFCLKKUQPANJORCXNPWLBGNJANQNEEXACFYDRKMIVEYRMMHEUZWYTWTCPBYASXHBYNJNRGGJSHOOTFESPVCMHWRUTOZJDCQEDOHXABEPKIQZQWWRJXRKPBHAWMITULJOUPDHKCBJDIIHICJUUZNGGOMFLZYIDJSMMNTLDFIAXWKYKFSBQFFZGVQCDKQOCYHWYEZTSRXOVPTAY");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LogBookEntry #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LogBookControl msg;
    msg.setTimeStamp(0.610491736144);
    msg.setSource(15789U);
    msg.setSourceEntity(40U);
    msg.setDestination(52641U);
    msg.setDestinationEntity(94U);
    msg.command = 217U;
    msg.htime = 0.239730315912;
    IMC::LogBookEntry tmp_msg_0;
    tmp_msg_0.type = 164U;
    tmp_msg_0.htime = 0.419925337911;
    tmp_msg_0.context.assign("TLPZVVKKTBNYATTIGMDFYMVIDNSMSYABMZOYEXPDIEQLAGUUGGFTPIRFFCHHZEAEMQHVTHODBCWBHLXRYCOWKMSXHXIBHFTXAJDSINTDXKRGKWLKUGFZMEGUGQOTUXSWELWFGMVFOSDNHOYMCPQPYSROQJZNRDPKWLIAJZLCWENQVACPRKJSU");
    tmp_msg_0.text.assign("RRMRDKPXSNIKECSOJCWBHJWPEENAQBCFRRFOPBZLEQWETDCTVXJDVGVZTFDFCMKXIHMZQQJYTGXIGQPHWZOHRZNACOXJOHQKDIXTBDIVPQNYSKREDVNHFKNVMLAHHGLEWZDUMIOLXARHSFVYACZXMISOJJAOGNJYUGRJYTTSYYPSSBUVIZETBMPGAAUOMPUFZGIMUXSLRUPFBCWAGGKPDFXEBCKJQHBDNLUMLNAKST");
    msg.msg.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LogBookControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LogBookControl msg;
    msg.setTimeStamp(0.543245799784);
    msg.setSource(32592U);
    msg.setSourceEntity(208U);
    msg.setDestination(28441U);
    msg.setDestinationEntity(200U);
    msg.command = 242U;
    msg.htime = 0.298748687745;
    IMC::LogBookEntry tmp_msg_0;
    tmp_msg_0.type = 7U;
    tmp_msg_0.htime = 0.613463469327;
    tmp_msg_0.context.assign("RWQSCIEADBGPUPSJAZHULMIWKLNXZVRBDTSGTXWGSJNUDNCKIZTGAOILQXADGQGLHHVZFWRYQIAQLNASYKSXZYWQPIEMRIURBUWYEWQB");
    tmp_msg_0.text.assign("YCUELIKBBDTWDKFXAWQHHAZRGNHFIFREZTJIJDXQWRWTDPSHNDYIJFCPJBGNYVUOZRKFNWQDGAZQLYTZUSAMRYOPAPWNTJWMGJJBVUFJMEWGRPNVITIXDCLDBIQXGZCEQZHDBKDVSLPMYKKMHECVBQAHHSOLMPSUCPO");
    msg.msg.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LogBookControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LogBookControl msg;
    msg.setTimeStamp(0.535646744683);
    msg.setSource(59643U);
    msg.setSourceEntity(15U);
    msg.setDestination(48757U);
    msg.setDestinationEntity(169U);
    msg.command = 130U;
    msg.htime = 0.533035420561;
    IMC::LogBookEntry tmp_msg_0;
    tmp_msg_0.type = 15U;
    tmp_msg_0.htime = 0.49104784761;
    tmp_msg_0.context.assign("OGKACDYBTEWNNJ");
    tmp_msg_0.text.assign("SYSSAZCRPNBENVFCIAOQIBLIBDDLOAIPPGWDTSWTZIZBXSIKZCGEGTFKOIPEFFZAGFTW");
    msg.msg.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LogBookControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ReplayControl msg;
    msg.setTimeStamp(0.697097455286);
    msg.setSource(26549U);
    msg.setSourceEntity(216U);
    msg.setDestination(5873U);
    msg.setDestinationEntity(19U);
    msg.op = 103U;
    msg.file.assign("WUGRMYYQBWTXCRBESBBYVYWHTZMIPNVRBSEUXMGLAJFWYJRCERGFDUSLWETRGPJWQJACHPDZKAHATILBQLD");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ReplayControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ReplayControl msg;
    msg.setTimeStamp(0.000856704545066);
    msg.setSource(3708U);
    msg.setSourceEntity(158U);
    msg.setDestination(48796U);
    msg.setDestinationEntity(238U);
    msg.op = 40U;
    msg.file.assign("HCCSNCALFVQGYQKMROEHGMPWUQMPJHFKWPCDUMGSZNHGORNMIFYZZAKXYFHVLJOCOAJWNMNPSBRJWJWEPGHMELZYSKBTQKHVNDUTTQBGWDYDSRMOJVXVACAJAVPUXTDDSIFTENRZJZLOKWSNVZLEIWSBLCSXCBIDCIEEQZEGPAWLMPQQUXCQJTBVU");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ReplayControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ReplayControl msg;
    msg.setTimeStamp(0.69973096361);
    msg.setSource(46413U);
    msg.setSourceEntity(90U);
    msg.setDestination(30528U);
    msg.setDestinationEntity(139U);
    msg.op = 73U;
    msg.file.assign("QDSBITLPOGYUTFCWKBXLX");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ReplayControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ClockControl msg;
    msg.setTimeStamp(0.633627114857);
    msg.setSource(6324U);
    msg.setSourceEntity(124U);
    msg.setDestination(52181U);
    msg.setDestinationEntity(201U);
    msg.op = 46U;
    msg.clock = 0.144960941564;
    msg.tz = -12;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ClockControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ClockControl msg;
    msg.setTimeStamp(0.113999183699);
    msg.setSource(10453U);
    msg.setSourceEntity(36U);
    msg.setDestination(34492U);
    msg.setDestinationEntity(113U);
    msg.op = 178U;
    msg.clock = 0.913250725025;
    msg.tz = -29;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ClockControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ClockControl msg;
    msg.setTimeStamp(0.65788643974);
    msg.setSource(62432U);
    msg.setSourceEntity(51U);
    msg.setDestination(19121U);
    msg.setDestinationEntity(17U);
    msg.op = 173U;
    msg.clock = 0.0271954538412;
    msg.tz = 23;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ClockControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Heartbeat msg;
    msg.setTimeStamp(0.699657246097);
    msg.setSource(1261U);
    msg.setSourceEntity(137U);
    msg.setDestination(45724U);
    msg.setDestinationEntity(0U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Heartbeat #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Heartbeat msg;
    msg.setTimeStamp(0.33164433426);
    msg.setSource(46866U);
    msg.setSourceEntity(219U);
    msg.setDestination(17886U);
    msg.setDestinationEntity(34U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Heartbeat #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Heartbeat msg;
    msg.setTimeStamp(0.930172462253);
    msg.setSource(8303U);
    msg.setSourceEntity(97U);
    msg.setDestination(58921U);
    msg.setDestinationEntity(35U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Heartbeat #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Announce msg;
    msg.setTimeStamp(0.468278668266);
    msg.setSource(42091U);
    msg.setSourceEntity(211U);
    msg.setDestination(3917U);
    msg.setDestinationEntity(29U);
    msg.sys_name.assign("SOYRTQXDFQWGBZARPQPOIEMEGBOYILUPVXWPXTVCBLSNFKZALZKNGDJOVJOPVUUSJUJHOBDVMCLZWIEMKCEUQHUCCHDITYNRIWZNTNIWMENWGAQTPSWITFSSKSDVDQDFOWBGIHRGRPAGZ");
    msg.sys_type = 220U;
    msg.owner = 41708U;
    msg.lat = 0.843967216012;
    msg.lon = 0.688780798434;
    msg.height = 0.306357640007;
    msg.services.assign("KEIVRGZHHLANKCFDMGWNAZMYVGVWXKMXPOCAZEEFFMVPMOZGOBEGTAIQQWTWBZSSZYWPRSQQIIFXRBNOTQVVRUOBVEPSAKJCGWLUTIWCX");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Announce #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Announce msg;
    msg.setTimeStamp(0.796391037985);
    msg.setSource(48985U);
    msg.setSourceEntity(85U);
    msg.setDestination(26180U);
    msg.setDestinationEntity(81U);
    msg.sys_name.assign("TTHKLRCPYRNJUODESATADXEUHKNHLJTYYAOQIENNZZFVQDXMMGATVPSJCXVQBULEOUWUPXGSGBFZLQJBBJRNDRZDYZIQLQWCWGVWNHFBPDHBIXTZVWZUQGYHWEGUFHEGFHIMIUIOYFVSMABEMJXBMJUSVKWTNLBLSVDRLLRACVNWUCCJARIMRCZEDOQIKRXPXCXARLKPDBCPTSQOSPYMGEKKAOSOVFYQJI");
    msg.sys_type = 211U;
    msg.owner = 27763U;
    msg.lat = 0.953403342814;
    msg.lon = 0.289284838151;
    msg.height = 0.410063000003;
    msg.services.assign("CXDGYFDEKDTDQAEKXJIHWSMEWIMNUZNVLYUZHNBGTATAIEYCUJZGHRVHXWFBJYSMERFDHQKUBMFKLOFVSVLMZRTQGDFMJKQKFSPQNHBOGEYAVOBMYVSFLPGOWURSWKETZBTIRYCFZXVVCYXXYAOXCZRLLDNTOOUFKZBHASBOXWMAGENSXKPOLRJMJZBWQPIULLHJPUPCYDNQOIWGSMV");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Announce #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Announce msg;
    msg.setTimeStamp(0.629703848087);
    msg.setSource(7639U);
    msg.setSourceEntity(245U);
    msg.setDestination(19265U);
    msg.setDestinationEntity(220U);
    msg.sys_name.assign("KFYMILEBHAEURIDIBHIEGUU");
    msg.sys_type = 166U;
    msg.owner = 13759U;
    msg.lat = 0.386728237048;
    msg.lon = 0.392208846628;
    msg.height = 0.512778898106;
    msg.services.assign("UHIKPPHCUJXSKENQHCRBKQW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Announce #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AnnounceService msg;
    msg.setTimeStamp(0.084881154912);
    msg.setSource(46791U);
    msg.setSourceEntity(131U);
    msg.setDestination(56229U);
    msg.setDestinationEntity(2U);
    msg.service.assign("YYAWXGFCCXMDZKDVFWURIZELXUNBARJKDXSDYHQZTMXSXLWONSRABEGUHSWTBGQJJUVDTPUYZRDFTXCRNZLQECKVZBISOTINNHVIKLGRLMONMZAFHLWKAADCYGYXHWFSMFEHHLVCBAOXFOUGBRSWGMDRRPDSEGWEWEJCQI");
    msg.service_type = 1U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AnnounceService #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AnnounceService msg;
    msg.setTimeStamp(0.274408595525);
    msg.setSource(63209U);
    msg.setSourceEntity(109U);
    msg.setDestination(35648U);
    msg.setDestinationEntity(40U);
    msg.service.assign("EXFOOGPRUKVQU");
    msg.service_type = 84U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AnnounceService #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AnnounceService msg;
    msg.setTimeStamp(0.762561738004);
    msg.setSource(52013U);
    msg.setSourceEntity(245U);
    msg.setDestination(64637U);
    msg.setDestinationEntity(194U);
    msg.service.assign("CIFMHGJTOGVGSVKFXOTLEFTLIGBPARNDYUWHHYNDDVRNSOKCQIACRLXTKDEPVLLVHG");
    msg.service_type = 133U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AnnounceService #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RSSI msg;
    msg.setTimeStamp(0.0282645686902);
    msg.setSource(16574U);
    msg.setSourceEntity(243U);
    msg.setDestination(53878U);
    msg.setDestinationEntity(8U);
    msg.value = 0.693485066285;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RSSI #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RSSI msg;
    msg.setTimeStamp(0.521402249308);
    msg.setSource(33751U);
    msg.setSourceEntity(26U);
    msg.setDestination(9220U);
    msg.setDestinationEntity(147U);
    msg.value = 0.457546211493;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RSSI #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RSSI msg;
    msg.setTimeStamp(0.459418495935);
    msg.setSource(44026U);
    msg.setSourceEntity(31U);
    msg.setDestination(29809U);
    msg.setDestinationEntity(112U);
    msg.value = 0.1960683897;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RSSI #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VSWR msg;
    msg.setTimeStamp(0.400435257678);
    msg.setSource(58288U);
    msg.setSourceEntity(114U);
    msg.setDestination(56421U);
    msg.setDestinationEntity(243U);
    msg.value = 0.510804792234;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VSWR #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VSWR msg;
    msg.setTimeStamp(0.0662567192726);
    msg.setSource(62205U);
    msg.setSourceEntity(253U);
    msg.setDestination(20878U);
    msg.setDestinationEntity(161U);
    msg.value = 0.713495361702;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VSWR #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VSWR msg;
    msg.setTimeStamp(0.931026241716);
    msg.setSource(19163U);
    msg.setSourceEntity(155U);
    msg.setDestination(6087U);
    msg.setDestinationEntity(183U);
    msg.value = 0.488298749401;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VSWR #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LinkLevel msg;
    msg.setTimeStamp(0.201459524937);
    msg.setSource(62174U);
    msg.setSourceEntity(83U);
    msg.setDestination(33757U);
    msg.setDestinationEntity(119U);
    msg.value = 0.654780792935;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LinkLevel #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LinkLevel msg;
    msg.setTimeStamp(0.0839054547088);
    msg.setSource(4146U);
    msg.setSourceEntity(253U);
    msg.setDestination(19588U);
    msg.setDestinationEntity(190U);
    msg.value = 0.529874483097;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LinkLevel #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LinkLevel msg;
    msg.setTimeStamp(0.824384120131);
    msg.setSource(44034U);
    msg.setSourceEntity(197U);
    msg.setDestination(4925U);
    msg.setDestinationEntity(199U);
    msg.value = 0.247746554747;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LinkLevel #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Sms msg;
    msg.setTimeStamp(0.958228915134);
    msg.setSource(31573U);
    msg.setSourceEntity(10U);
    msg.setDestination(29250U);
    msg.setDestinationEntity(23U);
    msg.number.assign("CKTOMXRQHYLTCPPDOCONLXFHDUURLQSGVITHFGNBOGQZJSZHLXYSPHDAXQYUOJWVRVKIFIJMPVPCSDSKUEIGCOSTBBITUAGQVUVZCIGTSXR");
    msg.timeout = 49909U;
    msg.contents.assign("FBTAQAQMWIYRTSEGWSKMCVUTVBRYXELEXZLDGJUUWCXSPQHOYQVPASFEJXOQGYCUFNOAGZZVMEGJZZXRHNPWPZNKELDIUGSZKEJCHFRPMTSCXURUGQZBWXHVCXAHGNSFLDOKFHMYACSUJDBTITVIKIODJRLINWFDJROBW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Sms #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Sms msg;
    msg.setTimeStamp(0.905993076919);
    msg.setSource(53807U);
    msg.setSourceEntity(242U);
    msg.setDestination(29821U);
    msg.setDestinationEntity(10U);
    msg.number.assign("DYOVEEWCGGTHMWTMZKRKUJKBKURMAEFNNJLCDXSCSKFHHZHUXJMZUSFAPDQTVOIYLVEFAEOUEHGDAGLAFCVRYMKQHHQIYVFWFBGLUBEQGDYLPWFTCLGCLNVOAZQNOBRPSQINJXYNHRLZXJSWDWDUUOTXPZYFPXJMJQWSVGHQRAJEAJIABQUUZPYRNICLTCYTNERVWWRZBPBIOJFOESCNXOXPSTPDIKDTHKMBQMTVPSICKMXOGNSGALZIVD");
    msg.timeout = 60331U;
    msg.contents.assign("JEGJEDFFWQHCKJJSENRHCCEEGXINJOEKZPGJTBABMCRFIEQVGVKTIYTHSUPUFYCGYBYMZAXAQAFRSOQYVMALLPLHVZWBRTAQAAVT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Sms #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Sms msg;
    msg.setTimeStamp(0.387636100033);
    msg.setSource(12416U);
    msg.setSourceEntity(180U);
    msg.setDestination(54839U);
    msg.setDestinationEntity(218U);
    msg.number.assign("DJPPVDRNIMXFXMSLVVRUWQMMYMJCZOOSVVWHPGBTEJCXJEJUNPGWFZSELTYPOJLCRXHEIIHJKSEZVKTDUOKPKHBBHJUQZGMCFUPFBLHAEAEDTQTQMYYXCTODBKKJCAQ");
    msg.timeout = 56842U;
    msg.contents.assign("DIBSPOXRIMDCGBTZJFQLWPLWNRMNVELOBHSCDQLPXFSONJARFOGODNKIXEPWUVPHIRHKNLCLUDNAVIYWVTBGPQAGFJPTEFRBJSYKAZLRDOMHPSQWTEZDVMITFKJNZGQKVJZTTVEVEKXSTMUXMCQXWAYOCZSJXRQCCMHDVZGSAPWAUJIJCMRGSHULXMXFYFHWZUNBZALYYHOOYUYGFDKUSLBYGHCIEGIQCIAARXY");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Sms #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsTx msg;
    msg.setTimeStamp(0.468305365359);
    msg.setSource(38954U);
    msg.setSourceEntity(86U);
    msg.setDestination(53883U);
    msg.setDestinationEntity(250U);
    msg.seq = 3677227447U;
    msg.destination.assign("IALFFTHYLNJEFXNFGITQCJFIMSAYGSTEDEGCFRGYZBAQMJHFDORMLWCFOPOGDJYXYSBVEMZPDTVOVUINBWAQMKOXEVMASCICUNULUGHBYHPRQPJMKZPZOJFDRRKDIRGUNPEVHZZSOPVVIHTCMTIYZHQSBKSLRSTGKYOANAWLLZFWNUZNWQQVPJMEHWXE");
    msg.timeout = 51212U;
    const char tmp_msg_0[] = {97, 95, 101, -11, 74, -113, 0, -71, -60, 64, -100, 37, -121, 39, -7, -75, 108, -43, 126, -15, 50, -13, -69, -73, 0, 82, -25, 38, 47, -21, -110, 62, -108, 66, -47, -76, -39, -33, -123, 101, -111, 100, 103, 61, -117, 25, 46, -74, -60, 52, 67, 113, 27, -76, -1, -94, 30, 88, 15, 33, 94, -22, -41, -86, -26, -9, 97, -128, 41, -42, -35, -45, 20, 24};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsTx #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsTx msg;
    msg.setTimeStamp(0.513764302206);
    msg.setSource(35763U);
    msg.setSourceEntity(106U);
    msg.setDestination(5304U);
    msg.setDestinationEntity(42U);
    msg.seq = 1618945726U;
    msg.destination.assign("WDIKYQARQIGUAHPEMBKDCZIAFEREZSMAYUUSHDWLLNNQOWVKLVSOBOTEYIHENKOXQMNBHCIZXOJMKAGQXUSNHRVDKOUWGFBDNYRIDWOFYIGSBSHKWXUYLTFTLTCPWLLSCBJYZJUZLFCFUQDVXGSPNGECHXIKZIQCBWTCJTRPNBYFNSFFDAMVGJTWOJVZHKHMPVPZQZNCGUBGRPPHRXTYWMZEEJTRYPSK");
    msg.timeout = 63442U;
    const char tmp_msg_0[] = {45, -69, 85, -56, 79, 126, -114, 7, 85, 20, -1, 21, 23, 126, 21, 72, 22, -115, 61, -18, -98, -71, 56, -51, 82, -84, -45, -59, 87, -54, -110, -4, -93, 55, -98, -3, -9, 60, 26, 97, 91, -79, -29, -34, 19, -106, 92, 59, 79, 66, -77, -9, 100, 97, 20, 97, -7, -62, 43, 118, -67, 112, 3, 69, 114, 125, 20, 101, 108, -108, 95, 75, -44, -13, 93, -120, 97, 15, -47, -65, 108, -8, -47, 82, -55, 20, -1, -117, -20, -86, 6, -47, -98, -25, -127, -28, 51, -91, 17, -52, -8, 19, 123, 25, -102, -70, -69, -128, -7, 17, -8, 47, 83, -13, -93, 106, 61, -55, 121, -120, 81, 116, 96, -83, -104, 45, 119, -70, -128, -57, -59, -39, -20, 0, -93, -1, 32, -22, 114, -23, -83, -51, 43, 95, 77, -14, 85, -94, -114, 85, 32, 7, 10, 99, 15, 29, -37, 64, -15, -54, -63, 120, 28, -38, 87, 126, 116, -69, 79, 89, -16, 118, 107, -106, -74, -31, -48, -40};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsTx #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsTx msg;
    msg.setTimeStamp(0.0273317190455);
    msg.setSource(13291U);
    msg.setSourceEntity(45U);
    msg.setDestination(404U);
    msg.setDestinationEntity(121U);
    msg.seq = 3483619233U;
    msg.destination.assign("ZKAZDQUZMVNKMLRJQXOCCFDHRZLXYMMPJRFLECXSCKLOCWWEVNZUERVBXACHIKUKRZNLWQUSLIOWMSXWGGSGRJXLWHTSEBIVUAFIZKDYCDYNRBUMDSFUZFDTQYGCKLTRFOTOMPSVPVYEOTANDFNPTCHUITVAQFCAKXWVAJQMHYEUJYHBNEDJGJFQBHIWFIJGOALXEDABMBVBGPXWHXPQKANM");
    msg.timeout = 39279U;
    const char tmp_msg_0[] = {-124, 5, 76, -116, -96, 35, 14, -73, 36, 98, 96, 106, -108, -11, -114, 71, 22, 55, -106, 24, -39, -31, 72, 80, 30, 18, -89, -13, 111, -81, -20, -26, -124, -40, 34, -25, -105, 9, -81, 36, 43, -51, -22, 26, 35, 39, 59, 91, 66, -47, 4, 45, 33, -67, 117, -112, 73, 17, -28, -51, -37, -125, 100, -12, 94, 80, 58, 78, -71, 51, 105, -115, 96, -105, -14, 115, -106, -89, 86, -99, 25, 43, -39, -18, 13, 9, -56, 12, 122, 52, -35, 6, -30, -46, -27, -78, 102, 67, 35, -90, 107, 50, -32, -5, -98, -94, 50, 73, -45, 12, -31, -62, 79, -59, -87, -103, 72, -21, -1, -24, -52, -55, -36, -22, -1, 68, 47, -88, -115, -84, 62, -39, 46, -31, -58, 96, -114, 101, 97, 9, 35, -79, -50, -126, 48, -2, 5, 16, 44, -32, 68, 39, 46, 8, 5, 85, -65, 21, 10, 13, -19, 113, -24, -22, -13, 88, -77, 29, -118, -12, 97, -62, 109, 29, -99, -126, -43, -39, 78, 58, -59, 96, 57, -109, 61, -29, 109, 57, 85, 71, -22, 20, 35, -116, -39, -28, 65, 11, -63, -115, -22, -4};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsTx #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsRx msg;
    msg.setTimeStamp(0.939018908896);
    msg.setSource(52752U);
    msg.setSourceEntity(148U);
    msg.setDestination(41131U);
    msg.setDestinationEntity(251U);
    msg.source.assign("XUXHNVSYBCSJQKSTHEYFFUBOQVKWWFOXGZWAGMOSMVYELQFSCVGJXBFAGGEUXOJMHULULUVIOIRNWIQOZHJRHPXUEYDUDVTIOPGPCRMVLQADJTQGATLBZOPVLOGYTIVJWKEFDWKCFIPTWQDEAZXDFMHLKSDBWNOKYNQLTHNCRTRYCSAJBEYFBEZZTRNCDNYRUNXSHWMRCQBCPXMBGLIDNUMPRKPKJ");
    const char tmp_msg_0[] = {-77, -54, -21, -26, -89, -120, 17, -33, 120, -14, -91, -82, -53, -1, 29, -15, -114, -34, 89, 37, 35, 87, -49, -64, 5, -21, -46, 61, 7, -40, 46, -44, -37, 67, 108, -18, -86, 58, 66, -54, -51, 60, 119, -101, -114, -25, 57, 22, -17, 106, -74, 83, 113, 124, 51, -7, -119, -30, -53, -33, 49, 71, 64, -93, 96, -9, 69, -93, -102, 63, -47, 115, 120, -117, -118, 88, 81, -109, -6, 85, -9, 110, -97, 60, -12, 110, -46, -60, 84, -44, -123, 25, 78, 117, -92, 121, -84, -83, -99, -115, 54, 56, 97, -109, 61, -39, 92, 67, -112, 111, -61, 34, 64, 3, -79, 70, -87, 105, 76, -25, -49, 55, 40, 62, 50, -85, -68, -41, 55, -28, 100, -87, -116, 22, 6, 47, -57, 112, 120, 23, 84, -85, 96, 19, 61, 42, 44, -10, 52, -26, 27, 109, -23, -44, 79, 114, 25, -51, 117, -15, -32, -34, -79, 118, 37, 109, -54, -9, -75, 8, -46, -71, -88, -85, -124, -70, -86, 87, -65, -124, -27, 7, 26, 14, 4, 18, -34, -24, -44, 13, -109, -127, -56, -77, -86, 78};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsRx #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsRx msg;
    msg.setTimeStamp(0.873571945992);
    msg.setSource(13426U);
    msg.setSourceEntity(131U);
    msg.setDestination(64876U);
    msg.setDestinationEntity(119U);
    msg.source.assign("FDNIYSHMPNEIULMQBCHK");
    const char tmp_msg_0[] = {-27, 24, 34, 124, 34, 31, 110, -25, 84, -49, 27, 83, 101, 19, 7, -17, 78, 71, 49, 22, 31, -36, -8, 42, 71, 76, -92, -27, -10, 99, 75, -42, 13, -127, 65, -18, 11, 43};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsRx #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsRx msg;
    msg.setTimeStamp(0.664793112517);
    msg.setSource(42827U);
    msg.setSourceEntity(200U);
    msg.setDestination(45478U);
    msg.setDestinationEntity(4U);
    msg.source.assign("ZRDBYLKRAAUWPBLFGJLYGMTDVMHKMYWZWPIYYMZPLUMXCUUEVTEKSSNVKGGESWRSLXIITSZDEPEAJPUKLZSOGRDXEFNLVUDNICVFBOJIXATAZNNEYKGTVCOGKRFOCNXMYALXNWCPDGTGZPQONTUMBVRBNJCQLTYAHFOHEUHRMFXPRKSE");
    const char tmp_msg_0[] = {-9, -2, 74, 85, 32, 100, 126, 23, -13, 96, 77, -85, -35, -51, -52, -39, 87, 41, -29, -100, 77, 84, 85, 101, -15, -53, 112, 0, -74, 117, -103, -4, -27, -100, 15, 105, 93, -41, 46, 123, 90, -102, 115, 103, -79, -106, 6, 76, 116, -6, 63, -114, 81, -23, -128, 19, 71, -50, 121, 15, 41, 25, 119, -19, -64, 57, 115, -110, -99, -123, -23, -1, 32, 62, -21, 119, -90, 105, 23, -32, 120, 88, -106, 119, -39, -124, -24, 35, 115, 22, -3, -86, -59, 87, -2, -57, -62, -2, 40, 31, 75, 10, -75, -33, -90, 58, -55, 1, 1, -97, -80, -34, 62, -128, -96, -37, 46, -20, 124, 18, -117, -109, -111, 24, -59, -93, 106, -83, 103, -52, 65, 88, -125, -115, -127, -95, -10, 10, 125, 104, 97, 111, 43, 116, -127, -19, -119, 71, -3, -67, -73, -75, -34, 43, -36, 119, 114, -16, -71, 14, -128, 98, 121, 103, 43, 17, 41, 113, 111, 24, 14, 46, -34, 58, -117, 13, 119, 38, -5, 77, -104, 26, -43, -53, 10, 31, -7, -69, 8, 17, 42, 79, -16, -78, -101, -102, -42, 101, -53, 67, -111, 82, 56, -114, -112, -71, 31, 64, 121, -19, -101, -20, 119, 55, -17, 46, 79, -45, -128, -99, -71, 9, -7, -50, -41, -42, -102};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsRx #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsState msg;
    msg.setTimeStamp(0.338481752276);
    msg.setSource(27647U);
    msg.setSourceEntity(192U);
    msg.setDestination(50196U);
    msg.setDestinationEntity(96U);
    msg.seq = 1253503585U;
    msg.state = 79U;
    msg.error.assign("CNPMXGPXGRNZCYYAIAVQVGPFWDIUQWSEUDBGLZTANOXUPEQMHQLYVYDWSZDCOHCNNAEHZPBPUSLVJNJRQOVHCLSUFFHTXQJLXCWUVBHVEYSCJERLMQQNOJEFKUGIWGAMJAVPKOZKZLXPHOLLIBHFTYMIGYEWZZXBUTIRTKOIBSDFDKQBXVEYJOVMABKRZDTRBNXJMUJMTAJWKOFDRZLGIRQI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsState msg;
    msg.setTimeStamp(0.341604534697);
    msg.setSource(24026U);
    msg.setSourceEntity(202U);
    msg.setDestination(12727U);
    msg.setDestinationEntity(88U);
    msg.seq = 2332499573U;
    msg.state = 225U;
    msg.error.assign("XIRXOUYFZZJXWDBDREILUQASKWJCNCKSSRHKJTEPMFAWNZSOXUUPECCXDJQKINKXSVXLHQIURNCGBLBVFEDCISNTTORLZFZXMRDNTOTDQSGJEVKEKVHVMUFUHMOPUAGAWGHRQHZZNGAAROAYDFGYVQGAITMFBCMLMNBOGNSUTBOJTEHQA");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SmsState msg;
    msg.setTimeStamp(0.657774894189);
    msg.setSource(60956U);
    msg.setSourceEntity(192U);
    msg.setDestination(34414U);
    msg.setDestinationEntity(187U);
    msg.seq = 1225536871U;
    msg.state = 50U;
    msg.error.assign("RAAZGIWHBSKKQSHJTBLYOFUEUBKDNAWNMSTSCFZHXUVXDQFVNJAFSEIUVIWLGPVJPTASMGCZIQNMSKA");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SmsState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TextMessage msg;
    msg.setTimeStamp(0.689573178338);
    msg.setSource(47689U);
    msg.setSourceEntity(157U);
    msg.setDestination(37094U);
    msg.setDestinationEntity(128U);
    msg.origin.assign("NXSNFPFEWDNNXKWVVNZUAFSUBVIGLVHQGPCKYGYSWQJIZZIUSUQOAMEOJWETATUYRHMXAZPELXDZJKWWGHCNNIWLOBLIGJLSKMGYAVIGFVZEHLTVZCMORCQOYXGBYHIFMTUXPLFDDTEDWTNURSCERKISLJHAGKEQPQVKQXBAYYTWNJSOUBDZJPOCJTYIMVPXBWFSMDHOEXPFCCPGRMOFRSXJCRHAFACPANULHZTQID");
    msg.text.assign("JCJIFAHRFNTOTEZYTZMTUQVOTZDIEXHAVSWYIPJAMNJRPLDCUUOLFYZSBRPNBKUKWZKIKSAYKDQDOMLDPAHUFPLRAQOZSVNFIXWRNSLBYIBJPGRSEUQCJEIXIRLSHOGNHXVOKGMUZTFXEJRFLNKEGVIMEYLQDIFAQXTVXBWXHWGBCDAUAWYRETN");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TextMessage #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TextMessage msg;
    msg.setTimeStamp(0.995010323657);
    msg.setSource(28285U);
    msg.setSourceEntity(99U);
    msg.setDestination(47848U);
    msg.setDestinationEntity(191U);
    msg.origin.assign("PEOIBDQPHAPRQBCWSKYEHJIVGVLPFRRJULOFVVGTGZLXSALWEEPMGIBQJALJUQQFESJQMNNFHXCHELYHPOBXXRUDDXXEWFODDUGNRUNMCIQYMBZUZYGKJCUZDGWBDTHXRKCALSPVFSHKGWWVZBPODZYONAMLWHUVQMUGTATMRBIKFRA");
    msg.text.assign("MYWCKTIXZQWMDUJWWRLHSSQNFDXWAIQSXRBAHZQLULOHOYYFBTOBDKLGMUMIHEAKBMJXFIZACHOLSPCFBNYJFSZSCPBAETVIRFELKLEBMOGKHEJOVUKWNG");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TextMessage #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TextMessage msg;
    msg.setTimeStamp(0.100549926097);
    msg.setSource(53578U);
    msg.setSourceEntity(155U);
    msg.setDestination(37357U);
    msg.setDestinationEntity(178U);
    msg.origin.assign("IZEDWDEZJLFQWDVGBJMPXYOKUTVLWJGQYDAVON");
    msg.text.assign("YPJLENUVKDWJTQROSGIGYQVMUJMLVIZSVZXFANMDZQBNULEGHJE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TextMessage #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumMsgRx msg;
    msg.setTimeStamp(0.848632640591);
    msg.setSource(10784U);
    msg.setSourceEntity(190U);
    msg.setDestination(52008U);
    msg.setDestinationEntity(73U);
    msg.origin.assign("LGBHVNPMGPSVNCGSTNOMCCMUCTHWPCXFQVSHQYWPUHQRAGTFMOBUBPMJXCXCOQTMQTCDAVIQSKNZTIKJDBLULIHUXZFKFWFSVLGG");
    msg.htime = 0.716475482234;
    msg.lat = 0.0676527280563;
    msg.lon = 0.545355604956;
    const char tmp_msg_0[] = {96, -6, 68, 12, 8, 103, 95, -23, -61, -82, 97, 7, 14, 51, 110, -41, 81, -108, -50, -25, -93, 109, 113, 80, 121, -86, -112, -126, 119, -120, 29, -1, 34, 68, 113, -109, 81, 31, 69, -40, -126, 41, 83, 44, -24, -70, -119, -102, -2, -100, -49, 49, 55, 103, -63, -48, 38, 30, -31, -79, -91, -77, -1, -10, -128, 56, 60, 27, 75, -105, -104, -19, 12, 42, -117, -83, -6, 120, -128, -1, -41, -79, -99, -83, -103, -25, -66, 36, 111, 52, 110, -33, -99, -102, 126, 12, 26, 48, 72, -33, 13, -72, 61, -42, -10, 112, 126, 98, 109, -82, -94, 109, -84, -118, 114, -109, -70, 82, -12, -116, 122, 76, 42, -24, 31, -32, -27, -59, 39, -17, 83, 22, 5, -54, -122, 27, -123, -55, 53, -97, -119, -87, 62, -25, 97, 44, -34, -40, -76};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumMsgRx #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumMsgRx msg;
    msg.setTimeStamp(0.24722312099);
    msg.setSource(2980U);
    msg.setSourceEntity(173U);
    msg.setDestination(27835U);
    msg.setDestinationEntity(99U);
    msg.origin.assign("XLJRHLFADVFZJSYFQKEQZGEPRIMGNOUXMMWXAORCHYHWSLEIUYDUROIAZOBUPQAFKEMNRDYLXEWVJVIGLKNWDKWGZSENASMTQGPHKKWXIJNPRPMCXOVCBBVYWTBAZBZNORTMFPTVBSTUHHGZOYLINMENQLODLQUCBCGQYIJPGURXAKKC");
    msg.htime = 0.318934869492;
    msg.lat = 0.876054615142;
    msg.lon = 0.209911210244;
    const char tmp_msg_0[] = {36, -11, 94, -57, 95, -17, 109, -45, -110, -124, 65, 64, -12, 101, -90, 92, -64, -113};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumMsgRx #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumMsgRx msg;
    msg.setTimeStamp(0.556211565447);
    msg.setSource(9326U);
    msg.setSourceEntity(208U);
    msg.setDestination(16910U);
    msg.setDestinationEntity(80U);
    msg.origin.assign("SIKNMZHDSYHLLVDGSAJDXTGVFPCKNESZPOQUYYKOPMDFIRHFQORFZUQMVELUSWCSNEGXQHUSKJCCUGZLYKJXZYPFAKUBBTVBDJSEDWAQBZMFTLOIWLZGJLHJUFHDHYRBVGQGTFRNWROEAJUJJSXXBTIMGRUNVLCVYCDEPIDCRSMWTTTXPOQOKJNNIOACZIYEEWANXX");
    msg.htime = 0.510168596651;
    msg.lat = 0.784479547704;
    msg.lon = 0.8488196651;
    const char tmp_msg_0[] = {60, -48, -85, 17, -110, -28, 58, 56, -54, 25, 46, 14, -98, 95, -111, -113, -98, -48, 13, -43, -98, -19, 3, 32, 109, 124, 89, -67, -17, 19, -21, 14, 12, 38, 51, 39, 60, 45, -50};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumMsgRx #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumMsgTx msg;
    msg.setTimeStamp(0.862431846862);
    msg.setSource(47412U);
    msg.setSourceEntity(220U);
    msg.setDestination(29594U);
    msg.setDestinationEntity(87U);
    msg.req_id = 60842U;
    msg.ttl = 44731U;
    msg.destination.assign("UFIESXSVBRQUYKRQDWZWCZLIOMYMSOTBQBZHSFVRPGHBWKVNKEAXPGRRVRILAKTYOWGGQCXMCEZNOBLTKSNEQHNHFHWKSSDIIQUOIIX");
    const char tmp_msg_0[] = {25, -61, -50, 12, 74, 78, 35, -79, -6, 45, -127, 76, 70, -18, 87, -16, -6, -3, -94, 34, -29, -4, 84, -106, -115, -86, 78, 26, 3, -18, 112, 64, 20, 90, 103, -29, 14, 63, 84, 57, -116, -63, 6, -29, -41, -104, 104, -21, 25, -99, 66, 9, 122, -84, 9, -49, -117, -123, -86, 78, -90, -98, 89, -124, 120, -6, 65, 67, -26, -68, -18, -82, -34, -107, 108, -97, -75, 74, -9, -46, 40, 63, 7, 122, -124, 122, 68, 21, 64, 40, -65};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumMsgTx #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumMsgTx msg;
    msg.setTimeStamp(0.715551233661);
    msg.setSource(64321U);
    msg.setSourceEntity(135U);
    msg.setDestination(1298U);
    msg.setDestinationEntity(159U);
    msg.req_id = 42682U;
    msg.ttl = 48134U;
    msg.destination.assign("SWHKRRJSSFZOFEPXTTTYLKGIYOSURKICVSNMPWTKNPIDYJGBRUUOBQIKOFIGJCNYTMAIXLOQDPCQKCBZXFEHXLZVZVHURTWEHNBAQWWZNQXQNAMRAEGYLNWIBPVN");
    const char tmp_msg_0[] = {-13, -53, -76, 23, -84, -92, -34, -66, 68, -67, 51, -53, 110, -34, -91};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumMsgTx #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumMsgTx msg;
    msg.setTimeStamp(0.133120663358);
    msg.setSource(8934U);
    msg.setSourceEntity(66U);
    msg.setDestination(54710U);
    msg.setDestinationEntity(82U);
    msg.req_id = 32713U;
    msg.ttl = 61830U;
    msg.destination.assign("BQCZFVSBTDKKKCZIESHGPPXMSAMEHQYVQSAJHMRBJNRLFCFLUIBZNGLVBIBAQECEOLAFXXOUJURRDZBBBJHCVKGVPVLXOTXFAVEECWCIXRDSPKVAUWFURNYKDMPQTNZAXRCWZXBDTT");
    const char tmp_msg_0[] = {0, 120, 99, 109, -124, 96, 7, -34, -50, -45, 79, -41, -46, -99, 52, -99, 62, 101, -109, -89, 22, 10, -122, -74, 124, -55, -102, -29, 43, 93, 111, 46, -37, 95, 84, -62, 75, 63, 45, 34, -26, 70, -126, -98, 14, -86, 108, -93, -109, 115, -46, 91, -126, -106, -86, 86, -30, -86, -60, -35, -24, 67, 33, 62, -3, 66, 85, 9, -16, 25, -30, 85, -23, 81, -63, 89, 73, 86, 36, -86, -106, -17, 45, 4, 64, 19, 1, -104, 91, 33, 88, -109, 80, 76, 57, 80, -76, 112, 119, -86, 11, -64, -113, 62, 113, -30, -84, 59, -3, -76, 122, 93, 16, -94, -38, 48, 49, 84, -103, -75, -115, 76, -50, 123, -65, -106, -47, 92, 23, -99, 20, 2, 12};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumMsgTx #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumTxStatus msg;
    msg.setTimeStamp(0.407763551824);
    msg.setSource(24222U);
    msg.setSourceEntity(215U);
    msg.setDestination(61670U);
    msg.setDestinationEntity(235U);
    msg.req_id = 779U;
    msg.status = 164U;
    msg.text.assign("FHBQFLTVXDHPJKBWCKBTTJXMJEYIRFOANEPASUZFPUFGMBZVBKRPRXYVHYPTTOUPYIPUKNNZGIOIUPWASOPSB");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumTxStatus #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumTxStatus msg;
    msg.setTimeStamp(0.551710594253);
    msg.setSource(16254U);
    msg.setSourceEntity(235U);
    msg.setDestination(2110U);
    msg.setDestinationEntity(155U);
    msg.req_id = 41881U;
    msg.status = 203U;
    msg.text.assign("GVRPEIUOPNLIKWIJTUBAAHIKEQCGSMGMUVNLCGAQL");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumTxStatus #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IridiumTxStatus msg;
    msg.setTimeStamp(0.845731217752);
    msg.setSource(58345U);
    msg.setSourceEntity(227U);
    msg.setDestination(15081U);
    msg.setDestinationEntity(97U);
    msg.req_id = 40095U;
    msg.status = 60U;
    msg.text.assign("LGMOLTSUJHXBRPWWUEDNXDNKEKYVTAPWFHGRXCYXSGAKQQAEFQPFPVNOQBBOEHLPYMWUJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IridiumTxStatus #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroupMembershipState msg;
    msg.setTimeStamp(0.901936017857);
    msg.setSource(53849U);
    msg.setSourceEntity(74U);
    msg.setDestination(55606U);
    msg.setDestinationEntity(227U);
    msg.group_name.assign("QSOPJIPTJUMUBGAKVVJGYITQZKGABDICXBSDKFHVTDPCSEVSMHOCJPCOMRNWELBELUNDXYFRYXAJWVNMJ");
    msg.links = 291221329U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroupMembershipState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroupMembershipState msg;
    msg.setTimeStamp(0.633234499276);
    msg.setSource(52568U);
    msg.setSourceEntity(205U);
    msg.setDestination(27823U);
    msg.setDestinationEntity(221U);
    msg.group_name.assign("GTJJSLTGCRCAAZKDVMHBSXABGDUYMDJCWYAOIYYISQSVRMLXCKEWDNIZEUDAWMWWBEZLXTTOFOXUPQCHVPHARJTCTZYBVNMKBZRVDWZPFIGFWZOPUNURVLQMCRLIYSPHYFYUJLEKXTTCEXBDZUMULEY");
    msg.links = 412877131U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroupMembershipState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroupMembershipState msg;
    msg.setTimeStamp(0.633293900091);
    msg.setSource(1684U);
    msg.setSourceEntity(152U);
    msg.setDestination(25934U);
    msg.setDestinationEntity(22U);
    msg.group_name.assign("AAWEEKOQFURBGXJIPOKAOLSSNFYZCHRZOZADZIRWTUBXRIZPHKZVFVJBWVKSZCLKALTTYPJDJJVOYYBHMOUDYNNGXBMDQODPWPXQDMVEOCGIWMXFVKYZVSMWUSGCBRIGMR");
    msg.links = 2941864502U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroupMembershipState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SystemGroup msg;
    msg.setTimeStamp(0.142592623121);
    msg.setSource(39066U);
    msg.setSourceEntity(89U);
    msg.setDestination(43017U);
    msg.setDestinationEntity(169U);
    msg.groupname.assign("KOLRWXIXHMTUNFGKDZXDSJXKKYAWIQWKRLLZRWNPEHMTLSPXLQYBVQTHAXPZDTHLDBSWNNKRGATKDIXAOIOYPSHJHNNJAGCGRLVPIDXVAZUEYL");
    msg.action = 85U;
    msg.grouplist.assign("MEZOWXIKMOPRNSXOYZBQRJSSHDJWATQMWTVQGWIMFCLTT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SystemGroup #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SystemGroup msg;
    msg.setTimeStamp(0.393209757213);
    msg.setSource(21802U);
    msg.setSourceEntity(29U);
    msg.setDestination(51057U);
    msg.setDestinationEntity(166U);
    msg.groupname.assign("ERCADAWYIUCLMNUEWLPTUQECIZHOZAZRBTUXLDDIRMAXEMVJZOPSXETHHBCKSNMRHQGDYQIISWPDBEGGETIXPJRRNFMLCWYNXQGKSIHCMCZMRQKPVTEYHFGFQVSTMNCKGOZHCLOUDSNBZKJPGDQLPQPYJMYLLIFBAZOVHJXBAZCWRSOSEFXIVJFZTFXAYEKKUYIGKHOJBVOLLWYYKUTSBFWFJNNNGUKUXDNRVVBGOWRQTDPUSFQWBM");
    msg.action = 47U;
    msg.grouplist.assign("UJTLTBAZHIFQRKQM");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SystemGroup #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SystemGroup msg;
    msg.setTimeStamp(0.378501542302);
    msg.setSource(52271U);
    msg.setSourceEntity(14U);
    msg.setDestination(30651U);
    msg.setDestinationEntity(106U);
    msg.groupname.assign("YANRLRHDSBMGMHSFVICNTSFHAAMWKWWGFGLQSXTRUMNGVRUXUBFQONGYKDCOPWSCLTIANEYQBCUBPQRXCTEIUNHQHCETTWBQOJINOSKUJMVVXOJZZAQHHTEALETLOEOPVEJDZD");
    msg.action = 142U;
    msg.grouplist.assign("FRNEPVQDWKUXPAGETDVGZHUACCUFXJCCZOFXTIROPYBNSWXANEMVBLIZQETDGWFKJOGMVSYULIXHOTUXMCQREJPLSUB");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SystemGroup #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblRange msg;
    msg.setTimeStamp(0.397940186693);
    msg.setSource(58229U);
    msg.setSourceEntity(71U);
    msg.setDestination(3703U);
    msg.setDestinationEntity(37U);
    msg.id = 147U;
    msg.range = 0.864865530483;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblRange #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblRange msg;
    msg.setTimeStamp(0.382834348879);
    msg.setSource(28781U);
    msg.setSourceEntity(184U);
    msg.setDestination(20389U);
    msg.setDestinationEntity(229U);
    msg.id = 36U;
    msg.range = 0.522389756461;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblRange #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblRange msg;
    msg.setTimeStamp(0.999838341972);
    msg.setSource(13552U);
    msg.setSourceEntity(96U);
    msg.setDestination(1417U);
    msg.setDestinationEntity(178U);
    msg.id = 239U;
    msg.range = 0.992924284293;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblRange #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblBeacon msg;
    msg.setTimeStamp(0.874719661671);
    msg.setSource(13949U);
    msg.setSourceEntity(156U);
    msg.setDestination(53441U);
    msg.setDestinationEntity(55U);
    msg.beacon.assign("MDPOAMNACQNZGLYZKHKORIWSDOOFUWZUCG");
    msg.lat = 0.504680074046;
    msg.lon = 0.691461295171;
    msg.depth = 0.683085893146;
    msg.query_channel = 229U;
    msg.reply_channel = 80U;
    msg.transponder_delay = 185U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblBeacon #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblBeacon msg;
    msg.setTimeStamp(0.298049514995);
    msg.setSource(34486U);
    msg.setSourceEntity(17U);
    msg.setDestination(19519U);
    msg.setDestinationEntity(161U);
    msg.beacon.assign("IOFENXXKZFUZRIXCYIGEKPBQUKWFKNDVLHRXJNSSIFWXNCSRDJMWXAPYTSOBSWLATNEWSZJQCZAWFFBTOVFDUYQHYIGCZQYEELTTMUWOMKE");
    msg.lat = 0.464771556331;
    msg.lon = 0.894226218462;
    msg.depth = 0.546296115517;
    msg.query_channel = 112U;
    msg.reply_channel = 167U;
    msg.transponder_delay = 118U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblBeacon #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblBeacon msg;
    msg.setTimeStamp(0.164092379957);
    msg.setSource(45110U);
    msg.setSourceEntity(56U);
    msg.setDestination(6422U);
    msg.setDestinationEntity(174U);
    msg.beacon.assign("UFVOIGDFYLMASCADMRPNJUALPRGXRDWZXYWWLHKXNXJWJQZKTOOMHWTEHJMEXOCIVIQYWHJZBQDIWJSUEQUTQXQLYACYIYXKIJXAJBZZGMYRVSPTCWAOGNAUZVFRDWSOCUUEDKNLKFKEFBJSCDLBFTYNAGEKQPAPEHBSZE");
    msg.lat = 0.729645467293;
    msg.lon = 0.193212555889;
    msg.depth = 0.631298863162;
    msg.query_channel = 69U;
    msg.reply_channel = 98U;
    msg.transponder_delay = 98U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblBeacon #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblConfig msg;
    msg.setTimeStamp(0.215243893742);
    msg.setSource(61100U);
    msg.setSourceEntity(171U);
    msg.setDestination(46949U);
    msg.setDestinationEntity(77U);
    msg.op = 161U;
    IMC::LblBeacon tmp_msg_0;
    tmp_msg_0.beacon.assign("VEYOSWGMRRYNJZZEWBYWQVKLKQNHYGDRWYXPPLNNZDKWUSFFSMYGITKLJIQGDQTLAUHBRDSHSIUTXILFCU");
    tmp_msg_0.lat = 0.00430209199139;
    tmp_msg_0.lon = 0.377315182293;
    tmp_msg_0.depth = 0.391646759383;
    tmp_msg_0.query_channel = 208U;
    tmp_msg_0.reply_channel = 106U;
    tmp_msg_0.transponder_delay = 96U;
    msg.beacons.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblConfig #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblConfig msg;
    msg.setTimeStamp(0.768050957348);
    msg.setSource(37847U);
    msg.setSourceEntity(165U);
    msg.setDestination(15488U);
    msg.setDestinationEntity(232U);
    msg.op = 249U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblConfig #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblConfig msg;
    msg.setTimeStamp(0.308571086952);
    msg.setSource(553U);
    msg.setSourceEntity(157U);
    msg.setDestination(9773U);
    msg.setDestinationEntity(224U);
    msg.op = 233U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblConfig #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticMessage msg;
    msg.setTimeStamp(0.702973891947);
    msg.setSource(62260U);
    msg.setSourceEntity(99U);
    msg.setDestination(7415U);
    msg.setDestinationEntity(26U);
    IMC::TeleoperationDone tmp_msg_0;
    msg.message.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticMessage #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticMessage msg;
    msg.setTimeStamp(0.0283394438005);
    msg.setSource(29049U);
    msg.setSourceEntity(155U);
    msg.setDestination(59140U);
    msg.setDestinationEntity(94U);
    IMC::RemoteSensorInfo tmp_msg_0;
    tmp_msg_0.id.assign("ODOPIYQDPJFUSDEZURLAHGXXWANMXDVCALEBSDBYMMADSRIKHCLDPPQMBRSHOHZYVINXTHUAMTPUGWILCAHEXFXWFYYJKOHVNQKZRQVXWVCXIWUVCULQISMTSYVKZJTEOHZJGHEMCTKSKRSR");
    tmp_msg_0.sensor_class.assign("WXDIZFDEDJIQOKIDQZYIKHRPEUQXVCAMOMBPKJDWNGRCNSBQJQHEMWHACIGCSLGGA");
    tmp_msg_0.lat = 0.69973827893;
    tmp_msg_0.lon = 0.0158396285667;
    tmp_msg_0.alt = 0.858215190663;
    tmp_msg_0.heading = 0.0142570927246;
    tmp_msg_0.data.assign("GXABUBGVSLBYDOERKEYWNKLWQLFKKDQJIMDWDDUPKZWIVGUAOFNXQNZAUHMTAYPVNUQGGFFCWDZESTZBZNHAMDZXPTIPNCSJTWBIPLBRKRVPJSTPFEHREMAUQBCGIVHCFZNCIQAYBXJOTLJDHSLRTOSJSHDLSPEKGYMXYIMQATKWAYGFCMZHJWXJNRCCDVLJVHHURYLWOLOFTKETFGEXQUIXYSZAGVBKSCJXM");
    msg.message.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticMessage #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticMessage msg;
    msg.setTimeStamp(0.92614697757);
    msg.setSource(27983U);
    msg.setSourceEntity(173U);
    msg.setDestination(56123U);
    msg.setDestinationEntity(194U);
    IMC::PlanVariable tmp_msg_0;
    tmp_msg_0.name.assign("TXCMUEKSDDVXCCGIQOCIJWEFPHNFJXNWCFAPMRYJSBBRRFYPQYAXCOZGVCRFGKUUQ");
    tmp_msg_0.value.assign("XETYICUYTOWQZIMLDUIAVIHCFYQZXZSVZAUTIJIKTLVKPPRZTYHPIWRMSYMGHKSMURUYEBONONCHPVSVIDXWQJUZEWNXQCMQVUTLGMCBKUSBQFCMAGBSESETHRUDFZPDXQQWGVKFTHEHXOHVKRMZCPVSUFDBSWZRDQXJYJLZJCFBGXMNOPFBAEFGWKKNSIOBNTNGNREDAINGDFOHJFROYPBWAAPXLYKVDM");
    tmp_msg_0.type = 165U;
    tmp_msg_0.access = 10U;
    msg.message.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticMessage #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticOperation msg;
    msg.setTimeStamp(0.647217757454);
    msg.setSource(36079U);
    msg.setSourceEntity(6U);
    msg.setDestination(63620U);
    msg.setDestinationEntity(89U);
    msg.op = 218U;
    msg.system.assign("TWXKXXAHHWUPJLLHEPMSDRAQYNQRLIOASGAJUSWVRCEHTOVZONKXFHJNDVSCLFRTYKGIEJDGDSVOLHSQBMPEUTUYKLEMWDJBCUUXJGMCRNBGEARZKKKIFKAGBWNFWLKKFSTIYTCJEBVMZMCFTYXOVMFWXZIVIPOUQNEBVVCOPDPGHNQQQNDEXTDAOBUYQSZTI");
    msg.range = 0.445184577184;
    IMC::SetPWM tmp_msg_0;
    tmp_msg_0.id = 144U;
    tmp_msg_0.period = 3391000359U;
    tmp_msg_0.duty_cycle = 1161846904U;
    msg.msg.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticOperation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticOperation msg;
    msg.setTimeStamp(0.552128376482);
    msg.setSource(64912U);
    msg.setSourceEntity(189U);
    msg.setDestination(20269U);
    msg.setDestinationEntity(235U);
    msg.op = 236U;
    msg.system.assign("CMWARYHBQMYXUQGJQDFEBZJGNCENISWDJIOLLEARIHYTJDMGATIHMDXLSDGYNXIVHAKDBHOMTFAUELBYLPPVGCTCFXKXRRZCFGKBWPJWSMRPTARADHSBKAEVNMTWRPGUYAJPDBCUJWYHHYGVKUWYUNKRSBFQVFKVQSCQOVJTSOLANMFISUEQZBRNUZDLHEGOPWUFEEZKK");
    msg.range = 0.702015335455;
    IMC::DynamicsSimParam tmp_msg_0;
    tmp_msg_0.op = 24U;
    tmp_msg_0.tas2acc_pgain = 0.789457765008;
    tmp_msg_0.bank2p_pgain = 0.695427161546;
    msg.msg.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticOperation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticOperation msg;
    msg.setTimeStamp(0.35860251232);
    msg.setSource(60256U);
    msg.setSourceEntity(139U);
    msg.setDestination(43537U);
    msg.setDestinationEntity(27U);
    msg.op = 226U;
    msg.system.assign("RKVDLAIMJPMWSDDQQSMORCHJFACODKEEUCOPNDWARSBPGGZZGNODMHPAUVTIIJRRKJBPWSALDOTXPFTAVAUVVRBEZ");
    msg.range = 0.638740216046;
    IMC::LeaderState tmp_msg_0;
    tmp_msg_0.group_name.assign("DPBJXOGRIDQINEZYKRZRONMJWXAVCEAIPEJDMBMSIQUCFKRWKXBAPAPXUHDFNNWDLHFZTIKYCNXZVVANOPLQDVPTHHWTGUJGFBMUX");
    tmp_msg_0.op = 206U;
    tmp_msg_0.lat = 0.544153954469;
    tmp_msg_0.lon = 0.540195574416;
    tmp_msg_0.height = 0.867493434354;
    tmp_msg_0.x = 0.658176128258;
    tmp_msg_0.y = 0.385969922808;
    tmp_msg_0.z = 0.522046392066;
    tmp_msg_0.phi = 0.433511653732;
    tmp_msg_0.theta = 0.546340779885;
    tmp_msg_0.psi = 0.235151850811;
    tmp_msg_0.vx = 0.25621814151;
    tmp_msg_0.vy = 0.632023216811;
    tmp_msg_0.vz = 0.168868359342;
    tmp_msg_0.p = 0.906612777212;
    tmp_msg_0.q = 0.196479562329;
    tmp_msg_0.r = 0.525255678483;
    tmp_msg_0.svx = 0.207696782385;
    tmp_msg_0.svy = 0.206712302014;
    tmp_msg_0.svz = 0.917641493906;
    msg.msg.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticOperation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticSystemsQuery msg;
    msg.setTimeStamp(0.593195373818);
    msg.setSource(51424U);
    msg.setSourceEntity(164U);
    msg.setDestination(59830U);
    msg.setDestinationEntity(95U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticSystemsQuery #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticSystemsQuery msg;
    msg.setTimeStamp(0.519198141769);
    msg.setSource(46196U);
    msg.setSourceEntity(132U);
    msg.setDestination(53785U);
    msg.setDestinationEntity(175U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticSystemsQuery #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticSystemsQuery msg;
    msg.setTimeStamp(0.516732065561);
    msg.setSource(23994U);
    msg.setSourceEntity(177U);
    msg.setDestination(13892U);
    msg.setDestinationEntity(46U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticSystemsQuery #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticSystems msg;
    msg.setTimeStamp(0.517147021055);
    msg.setSource(37881U);
    msg.setSourceEntity(187U);
    msg.setDestination(10902U);
    msg.setDestinationEntity(76U);
    msg.list.assign("WXNPUIZXIDUQZCURYBKNDXRYUTXWKHORYVQZHHIIZVAZMJLEGULSDOSRYFCFOXYEXFBQV");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticSystems #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticSystems msg;
    msg.setTimeStamp(0.334256574599);
    msg.setSource(55023U);
    msg.setSourceEntity(27U);
    msg.setDestination(38241U);
    msg.setDestinationEntity(211U);
    msg.list.assign("YSNIKYYFJUOFPVPAEROQKLEDCYTNJHUCWVCEYLBGQSSETGYMDCMURXERZGOKUVSFIGKOFBPYZIPLIXPXDQSKLUPEFNBTQYCXBSWRVMUANCRKWBQLBAVLHZKOVEHJCLYNRVBWXJDCUCJXHUTUMIUVRTBNDEXGGDMPFBHABHJIAZGSYSQXQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticSystems #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AcousticSystems msg;
    msg.setTimeStamp(0.052160492864);
    msg.setSource(53508U);
    msg.setSourceEntity(91U);
    msg.setDestination(63633U);
    msg.setDestinationEntity(106U);
    msg.list.assign("DVTGHLVUTJPEMTXHTIDUMXIDQZYRKIVJBQSGHAMMNFJWTFKYJKLUBCEEFINMBCWMNEGNIYPBFWQNMYIVEDOEZUAIGWQJZPYAFJRVAULZHCNLBGXGZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AcousticSystems #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Rpm msg;
    msg.setTimeStamp(0.158134734225);
    msg.setSource(28983U);
    msg.setSourceEntity(61U);
    msg.setDestination(15599U);
    msg.setDestinationEntity(209U);
    msg.value = 4278;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Rpm #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Rpm msg;
    msg.setTimeStamp(0.443472021689);
    msg.setSource(40082U);
    msg.setSourceEntity(215U);
    msg.setDestination(45148U);
    msg.setDestinationEntity(200U);
    msg.value = -31035;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Rpm #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Rpm msg;
    msg.setTimeStamp(0.69021987916);
    msg.setSource(14905U);
    msg.setSourceEntity(153U);
    msg.setDestination(33173U);
    msg.setDestinationEntity(45U);
    msg.value = 29506;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Rpm #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Voltage msg;
    msg.setTimeStamp(0.90730440858);
    msg.setSource(8970U);
    msg.setSourceEntity(180U);
    msg.setDestination(27815U);
    msg.setDestinationEntity(118U);
    msg.value = 0.576682114703;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Voltage #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Voltage msg;
    msg.setTimeStamp(0.876887868828);
    msg.setSource(17503U);
    msg.setSourceEntity(26U);
    msg.setDestination(60101U);
    msg.setDestinationEntity(211U);
    msg.value = 0.72057495475;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Voltage #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Voltage msg;
    msg.setTimeStamp(0.650308443058);
    msg.setSource(9927U);
    msg.setSourceEntity(43U);
    msg.setDestination(26724U);
    msg.setDestinationEntity(143U);
    msg.value = 0.934632165744;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Voltage #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Current msg;
    msg.setTimeStamp(0.595107202295);
    msg.setSource(40057U);
    msg.setSourceEntity(181U);
    msg.setDestination(16402U);
    msg.setDestinationEntity(91U);
    msg.value = 0.900571390644;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Current #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Current msg;
    msg.setTimeStamp(0.206306376479);
    msg.setSource(1660U);
    msg.setSourceEntity(148U);
    msg.setDestination(3183U);
    msg.setDestinationEntity(26U);
    msg.value = 0.864863766436;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Current #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Current msg;
    msg.setTimeStamp(0.806575965512);
    msg.setSource(37795U);
    msg.setSourceEntity(188U);
    msg.setDestination(5199U);
    msg.setDestinationEntity(154U);
    msg.value = 0.0395470587179;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Current #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsFix msg;
    msg.setTimeStamp(0.935187605747);
    msg.setSource(21393U);
    msg.setSourceEntity(249U);
    msg.setDestination(64945U);
    msg.setDestinationEntity(188U);
    msg.validity = 62310U;
    msg.type = 77U;
    msg.utc_year = 11207U;
    msg.utc_month = 138U;
    msg.utc_day = 67U;
    msg.utc_time = 0.228811475461;
    msg.lat = 0.736571212357;
    msg.lon = 0.797069602684;
    msg.height = 0.113242884854;
    msg.satellites = 30U;
    msg.cog = 0.37122133683;
    msg.sog = 0.269449373007;
    msg.hdop = 0.533482038719;
    msg.vdop = 0.591306548459;
    msg.hacc = 0.818503504275;
    msg.vacc = 0.674985142574;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsFix #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsFix msg;
    msg.setTimeStamp(0.203521218511);
    msg.setSource(3887U);
    msg.setSourceEntity(164U);
    msg.setDestination(22250U);
    msg.setDestinationEntity(107U);
    msg.validity = 63852U;
    msg.type = 212U;
    msg.utc_year = 32517U;
    msg.utc_month = 173U;
    msg.utc_day = 246U;
    msg.utc_time = 0.258168606333;
    msg.lat = 0.869749396291;
    msg.lon = 0.825020955179;
    msg.height = 0.878685061344;
    msg.satellites = 90U;
    msg.cog = 0.85743222941;
    msg.sog = 0.972694049168;
    msg.hdop = 0.613755962493;
    msg.vdop = 0.754765572204;
    msg.hacc = 0.861664725218;
    msg.vacc = 0.493991234784;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsFix #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsFix msg;
    msg.setTimeStamp(0.415524462647);
    msg.setSource(47297U);
    msg.setSourceEntity(172U);
    msg.setDestination(19878U);
    msg.setDestinationEntity(251U);
    msg.validity = 49060U;
    msg.type = 65U;
    msg.utc_year = 42261U;
    msg.utc_month = 129U;
    msg.utc_day = 253U;
    msg.utc_time = 0.717054667087;
    msg.lat = 0.199971132885;
    msg.lon = 0.434576231408;
    msg.height = 0.230952928712;
    msg.satellites = 70U;
    msg.cog = 0.619880634978;
    msg.sog = 0.748967506454;
    msg.hdop = 0.254249495168;
    msg.vdop = 0.0899968088915;
    msg.hacc = 0.415011523024;
    msg.vacc = 0.435552911929;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsFix #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EulerAngles msg;
    msg.setTimeStamp(0.0719001116543);
    msg.setSource(8219U);
    msg.setSourceEntity(129U);
    msg.setDestination(16709U);
    msg.setDestinationEntity(107U);
    msg.time = 0.383051471838;
    msg.phi = 0.00956433013599;
    msg.theta = 0.501744980675;
    msg.psi = 0.724238011961;
    msg.psi_magnetic = 0.998206711151;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EulerAngles #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EulerAngles msg;
    msg.setTimeStamp(0.159243233565);
    msg.setSource(10212U);
    msg.setSourceEntity(213U);
    msg.setDestination(13204U);
    msg.setDestinationEntity(10U);
    msg.time = 0.66446116166;
    msg.phi = 0.452538583298;
    msg.theta = 0.480956718962;
    msg.psi = 0.0137464122046;
    msg.psi_magnetic = 0.481949460708;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EulerAngles #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EulerAngles msg;
    msg.setTimeStamp(0.927275060479);
    msg.setSource(41120U);
    msg.setSourceEntity(35U);
    msg.setDestination(42918U);
    msg.setDestinationEntity(27U);
    msg.time = 0.310145282241;
    msg.phi = 0.935158525124;
    msg.theta = 0.154281694001;
    msg.psi = 0.21192908623;
    msg.psi_magnetic = 0.219431940578;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EulerAngles #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EulerAnglesDelta msg;
    msg.setTimeStamp(0.834420663222);
    msg.setSource(12543U);
    msg.setSourceEntity(39U);
    msg.setDestination(11657U);
    msg.setDestinationEntity(32U);
    msg.time = 0.436221541127;
    msg.x = 0.38858278951;
    msg.y = 0.0895307707778;
    msg.z = 0.948244394126;
    msg.timestep = 0.544935135441;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EulerAnglesDelta #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EulerAnglesDelta msg;
    msg.setTimeStamp(0.730390294406);
    msg.setSource(12303U);
    msg.setSourceEntity(240U);
    msg.setDestination(14007U);
    msg.setDestinationEntity(123U);
    msg.time = 0.753809292574;
    msg.x = 0.412055342355;
    msg.y = 0.568632666042;
    msg.z = 0.682043255595;
    msg.timestep = 0.788201261076;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EulerAnglesDelta #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EulerAnglesDelta msg;
    msg.setTimeStamp(0.954869405473);
    msg.setSource(11073U);
    msg.setSourceEntity(203U);
    msg.setDestination(47559U);
    msg.setDestinationEntity(25U);
    msg.time = 0.144651747677;
    msg.x = 0.625535625325;
    msg.y = 0.763221347221;
    msg.z = 0.402141541147;
    msg.timestep = 0.826548295619;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EulerAnglesDelta #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AngularVelocity msg;
    msg.setTimeStamp(0.955850118919);
    msg.setSource(39440U);
    msg.setSourceEntity(118U);
    msg.setDestination(55829U);
    msg.setDestinationEntity(175U);
    msg.time = 0.027094535655;
    msg.x = 0.664317669625;
    msg.y = 0.964574443038;
    msg.z = 0.292964128625;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AngularVelocity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AngularVelocity msg;
    msg.setTimeStamp(0.646074911998);
    msg.setSource(50375U);
    msg.setSourceEntity(249U);
    msg.setDestination(16767U);
    msg.setDestinationEntity(64U);
    msg.time = 0.897738229901;
    msg.x = 0.206897038614;
    msg.y = 0.524962562737;
    msg.z = 0.508331739215;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AngularVelocity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AngularVelocity msg;
    msg.setTimeStamp(0.389155873208);
    msg.setSource(42701U);
    msg.setSourceEntity(111U);
    msg.setDestination(37587U);
    msg.setDestinationEntity(199U);
    msg.time = 0.0335743461762;
    msg.x = 0.462408179765;
    msg.y = 0.776470686451;
    msg.z = 0.863828748276;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AngularVelocity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Acceleration msg;
    msg.setTimeStamp(0.349399431187);
    msg.setSource(2536U);
    msg.setSourceEntity(3U);
    msg.setDestination(59928U);
    msg.setDestinationEntity(6U);
    msg.time = 0.665059052578;
    msg.x = 0.567864089351;
    msg.y = 0.131344081783;
    msg.z = 0.763191340114;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Acceleration #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Acceleration msg;
    msg.setTimeStamp(0.971759553011);
    msg.setSource(9074U);
    msg.setSourceEntity(52U);
    msg.setDestination(38639U);
    msg.setDestinationEntity(198U);
    msg.time = 0.938708302255;
    msg.x = 0.241031593807;
    msg.y = 0.466372004239;
    msg.z = 0.93036681164;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Acceleration #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Acceleration msg;
    msg.setTimeStamp(0.0202431257797);
    msg.setSource(4239U);
    msg.setSourceEntity(26U);
    msg.setDestination(6314U);
    msg.setDestinationEntity(19U);
    msg.time = 0.863105272101;
    msg.x = 0.0181506406041;
    msg.y = 0.670424815258;
    msg.z = 0.353753828023;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Acceleration #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MagneticField msg;
    msg.setTimeStamp(0.673330054433);
    msg.setSource(33619U);
    msg.setSourceEntity(205U);
    msg.setDestination(62043U);
    msg.setDestinationEntity(237U);
    msg.time = 0.951576792126;
    msg.x = 0.795269287262;
    msg.y = 0.776474192303;
    msg.z = 0.607947736285;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MagneticField #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MagneticField msg;
    msg.setTimeStamp(0.082509763228);
    msg.setSource(33060U);
    msg.setSourceEntity(48U);
    msg.setDestination(65190U);
    msg.setDestinationEntity(106U);
    msg.time = 0.125591908382;
    msg.x = 0.854797613463;
    msg.y = 0.535857711477;
    msg.z = 0.221648874029;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MagneticField #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MagneticField msg;
    msg.setTimeStamp(0.55962018985);
    msg.setSource(42818U);
    msg.setSourceEntity(214U);
    msg.setDestination(10213U);
    msg.setDestinationEntity(54U);
    msg.time = 0.284393238056;
    msg.x = 0.620933828355;
    msg.y = 0.467284453195;
    msg.z = 0.325316149002;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MagneticField #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroundVelocity msg;
    msg.setTimeStamp(0.119653719791);
    msg.setSource(42059U);
    msg.setSourceEntity(2U);
    msg.setDestination(62199U);
    msg.setDestinationEntity(233U);
    msg.validity = 148U;
    msg.x = 0.540733933952;
    msg.y = 0.612092472846;
    msg.z = 0.577153653976;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroundVelocity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroundVelocity msg;
    msg.setTimeStamp(0.0831864700735);
    msg.setSource(51620U);
    msg.setSourceEntity(157U);
    msg.setDestination(40446U);
    msg.setDestinationEntity(130U);
    msg.validity = 131U;
    msg.x = 0.822079028175;
    msg.y = 0.0549117092619;
    msg.z = 0.863148502677;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroundVelocity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroundVelocity msg;
    msg.setTimeStamp(0.795361576642);
    msg.setSource(64108U);
    msg.setSourceEntity(221U);
    msg.setDestination(37133U);
    msg.setDestinationEntity(51U);
    msg.validity = 75U;
    msg.x = 0.718253072244;
    msg.y = 0.581739300023;
    msg.z = 0.624647654167;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroundVelocity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WaterVelocity msg;
    msg.setTimeStamp(0.203438194617);
    msg.setSource(46790U);
    msg.setSourceEntity(160U);
    msg.setDestination(58473U);
    msg.setDestinationEntity(22U);
    msg.validity = 250U;
    msg.x = 0.427355867056;
    msg.y = 0.516191989478;
    msg.z = 0.00667154172373;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WaterVelocity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WaterVelocity msg;
    msg.setTimeStamp(0.163107879007);
    msg.setSource(43040U);
    msg.setSourceEntity(155U);
    msg.setDestination(37080U);
    msg.setDestinationEntity(72U);
    msg.validity = 150U;
    msg.x = 0.367541711974;
    msg.y = 0.609201357037;
    msg.z = 0.661031678366;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WaterVelocity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WaterVelocity msg;
    msg.setTimeStamp(0.797293320808);
    msg.setSource(39486U);
    msg.setSourceEntity(21U);
    msg.setDestination(11335U);
    msg.setDestinationEntity(177U);
    msg.validity = 240U;
    msg.x = 0.835513593387;
    msg.y = 0.564514948964;
    msg.z = 0.1209363938;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WaterVelocity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VelocityDelta msg;
    msg.setTimeStamp(0.373378730087);
    msg.setSource(20435U);
    msg.setSourceEntity(230U);
    msg.setDestination(59331U);
    msg.setDestinationEntity(12U);
    msg.time = 0.291064420988;
    msg.x = 0.193874682176;
    msg.y = 0.16513060584;
    msg.z = 0.898745968645;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VelocityDelta #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VelocityDelta msg;
    msg.setTimeStamp(0.465543034452);
    msg.setSource(32307U);
    msg.setSourceEntity(203U);
    msg.setDestination(44040U);
    msg.setDestinationEntity(65U);
    msg.time = 0.558380897199;
    msg.x = 0.834949788449;
    msg.y = 0.447002527933;
    msg.z = 0.814063699787;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VelocityDelta #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VelocityDelta msg;
    msg.setTimeStamp(0.761334018605);
    msg.setSource(38315U);
    msg.setSourceEntity(55U);
    msg.setDestination(47050U);
    msg.setDestinationEntity(74U);
    msg.time = 0.143892232435;
    msg.x = 0.338210762579;
    msg.y = 0.183320360056;
    msg.z = 0.202087957254;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VelocityDelta #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Distance msg;
    msg.setTimeStamp(0.2294085354);
    msg.setSource(12030U);
    msg.setSourceEntity(47U);
    msg.setDestination(47331U);
    msg.setDestinationEntity(205U);
    msg.validity = 28U;
    IMC::DeviceState tmp_msg_0;
    tmp_msg_0.x = 0.678943879825;
    tmp_msg_0.y = 0.462749909033;
    tmp_msg_0.z = 0.815188467426;
    tmp_msg_0.phi = 0.925146337715;
    tmp_msg_0.theta = 0.453001128458;
    tmp_msg_0.psi = 0.34870395387;
    msg.location.push_back(tmp_msg_0);
    IMC::BeamConfig tmp_msg_1;
    tmp_msg_1.beam_width = 0.59334023982;
    tmp_msg_1.beam_height = 0.11453035702;
    msg.beam_config.push_back(tmp_msg_1);
    msg.value = 0.904314755698;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Distance #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Distance msg;
    msg.setTimeStamp(0.829747572939);
    msg.setSource(61154U);
    msg.setSourceEntity(158U);
    msg.setDestination(61017U);
    msg.setDestinationEntity(75U);
    msg.validity = 68U;
    IMC::BeamConfig tmp_msg_0;
    tmp_msg_0.beam_width = 0.409061839271;
    tmp_msg_0.beam_height = 0.919234599125;
    msg.beam_config.push_back(tmp_msg_0);
    msg.value = 0.411545830814;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Distance #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Distance msg;
    msg.setTimeStamp(0.0713516235372);
    msg.setSource(54462U);
    msg.setSourceEntity(37U);
    msg.setDestination(25864U);
    msg.setDestinationEntity(57U);
    msg.validity = 35U;
    IMC::BeamConfig tmp_msg_0;
    tmp_msg_0.beam_width = 0.0170383011565;
    tmp_msg_0.beam_height = 0.887062402246;
    msg.beam_config.push_back(tmp_msg_0);
    msg.value = 0.714171469915;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Distance #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Temperature msg;
    msg.setTimeStamp(0.887110403336);
    msg.setSource(50582U);
    msg.setSourceEntity(102U);
    msg.setDestination(2004U);
    msg.setDestinationEntity(95U);
    msg.value = 0.411163020646;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Temperature #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Temperature msg;
    msg.setTimeStamp(0.679677620877);
    msg.setSource(5956U);
    msg.setSourceEntity(204U);
    msg.setDestination(65011U);
    msg.setDestinationEntity(96U);
    msg.value = 0.0075746395425;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Temperature #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Temperature msg;
    msg.setTimeStamp(0.786599784272);
    msg.setSource(15563U);
    msg.setSourceEntity(203U);
    msg.setDestination(53244U);
    msg.setDestinationEntity(37U);
    msg.value = 0.493789999028;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Temperature #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Pressure msg;
    msg.setTimeStamp(0.151498393289);
    msg.setSource(57473U);
    msg.setSourceEntity(106U);
    msg.setDestination(18842U);
    msg.setDestinationEntity(196U);
    msg.value = 0.429675855702;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Pressure #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Pressure msg;
    msg.setTimeStamp(0.279618513583);
    msg.setSource(61575U);
    msg.setSourceEntity(41U);
    msg.setDestination(16140U);
    msg.setDestinationEntity(6U);
    msg.value = 0.475946807685;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Pressure #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Pressure msg;
    msg.setTimeStamp(0.247897248137);
    msg.setSource(46575U);
    msg.setSourceEntity(254U);
    msg.setDestination(40483U);
    msg.setDestinationEntity(97U);
    msg.value = 0.727703326882;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Pressure #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Depth msg;
    msg.setTimeStamp(0.882546379177);
    msg.setSource(7206U);
    msg.setSourceEntity(221U);
    msg.setDestination(9724U);
    msg.setDestinationEntity(117U);
    msg.value = 0.106309265694;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Depth #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Depth msg;
    msg.setTimeStamp(0.958938797778);
    msg.setSource(35822U);
    msg.setSourceEntity(217U);
    msg.setDestination(64157U);
    msg.setDestinationEntity(26U);
    msg.value = 0.450105457321;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Depth #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Depth msg;
    msg.setTimeStamp(0.675861319183);
    msg.setSource(1965U);
    msg.setSourceEntity(232U);
    msg.setDestination(57256U);
    msg.setDestinationEntity(101U);
    msg.value = 0.30963398479;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Depth #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DepthOffset msg;
    msg.setTimeStamp(0.283858015917);
    msg.setSource(33353U);
    msg.setSourceEntity(81U);
    msg.setDestination(10353U);
    msg.setDestinationEntity(233U);
    msg.value = 0.576650365127;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DepthOffset #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DepthOffset msg;
    msg.setTimeStamp(0.565534729155);
    msg.setSource(1368U);
    msg.setSourceEntity(96U);
    msg.setDestination(17755U);
    msg.setDestinationEntity(205U);
    msg.value = 0.426060684235;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DepthOffset #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DepthOffset msg;
    msg.setTimeStamp(0.817093031517);
    msg.setSource(32941U);
    msg.setSourceEntity(39U);
    msg.setDestination(48709U);
    msg.setDestinationEntity(160U);
    msg.value = 0.122919476687;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DepthOffset #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SoundSpeed msg;
    msg.setTimeStamp(0.875798777231);
    msg.setSource(23155U);
    msg.setSourceEntity(157U);
    msg.setDestination(48750U);
    msg.setDestinationEntity(61U);
    msg.value = 0.140888836179;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SoundSpeed #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SoundSpeed msg;
    msg.setTimeStamp(0.53853095317);
    msg.setSource(57501U);
    msg.setSourceEntity(7U);
    msg.setDestination(19995U);
    msg.setDestinationEntity(148U);
    msg.value = 0.748774762914;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SoundSpeed #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SoundSpeed msg;
    msg.setTimeStamp(0.617539747773);
    msg.setSource(3543U);
    msg.setSourceEntity(251U);
    msg.setDestination(59487U);
    msg.setDestinationEntity(254U);
    msg.value = 0.420509822954;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SoundSpeed #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WaterDensity msg;
    msg.setTimeStamp(0.345960020138);
    msg.setSource(58969U);
    msg.setSourceEntity(83U);
    msg.setDestination(17191U);
    msg.setDestinationEntity(12U);
    msg.value = 0.98690909326;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WaterDensity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WaterDensity msg;
    msg.setTimeStamp(0.720266663519);
    msg.setSource(65393U);
    msg.setSourceEntity(92U);
    msg.setDestination(28139U);
    msg.setDestinationEntity(136U);
    msg.value = 0.258643850671;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WaterDensity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WaterDensity msg;
    msg.setTimeStamp(0.0510684158631);
    msg.setSource(40181U);
    msg.setSourceEntity(127U);
    msg.setDestination(64770U);
    msg.setDestinationEntity(217U);
    msg.value = 0.489700242447;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WaterDensity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Conductivity msg;
    msg.setTimeStamp(0.260273680173);
    msg.setSource(280U);
    msg.setSourceEntity(91U);
    msg.setDestination(25823U);
    msg.setDestinationEntity(72U);
    msg.value = 0.0642793096824;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Conductivity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Conductivity msg;
    msg.setTimeStamp(0.664028628882);
    msg.setSource(12256U);
    msg.setSourceEntity(211U);
    msg.setDestination(57140U);
    msg.setDestinationEntity(3U);
    msg.value = 0.956738834501;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Conductivity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Conductivity msg;
    msg.setTimeStamp(0.529133117953);
    msg.setSource(7245U);
    msg.setSourceEntity(33U);
    msg.setDestination(48852U);
    msg.setDestinationEntity(250U);
    msg.value = 0.0620019071286;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Conductivity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Salinity msg;
    msg.setTimeStamp(0.590648947656);
    msg.setSource(24873U);
    msg.setSourceEntity(24U);
    msg.setDestination(61541U);
    msg.setDestinationEntity(135U);
    msg.value = 0.346209967173;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Salinity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Salinity msg;
    msg.setTimeStamp(0.337084294141);
    msg.setSource(7556U);
    msg.setSourceEntity(195U);
    msg.setDestination(31022U);
    msg.setDestinationEntity(252U);
    msg.value = 0.247077254286;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Salinity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Salinity msg;
    msg.setTimeStamp(0.107686001255);
    msg.setSource(63315U);
    msg.setSourceEntity(124U);
    msg.setDestination(9239U);
    msg.setDestinationEntity(179U);
    msg.value = 0.633421395526;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Salinity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WindSpeed msg;
    msg.setTimeStamp(0.254602429623);
    msg.setSource(63331U);
    msg.setSourceEntity(126U);
    msg.setDestination(2763U);
    msg.setDestinationEntity(251U);
    msg.direction = 0.950993854518;
    msg.speed = 0.839163383142;
    msg.turbulence = 0.0741626028934;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WindSpeed #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WindSpeed msg;
    msg.setTimeStamp(0.112536815258);
    msg.setSource(26337U);
    msg.setSourceEntity(114U);
    msg.setDestination(51081U);
    msg.setDestinationEntity(205U);
    msg.direction = 0.0147746622142;
    msg.speed = 0.836849020056;
    msg.turbulence = 0.267062167352;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WindSpeed #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::WindSpeed msg;
    msg.setTimeStamp(0.0748858169241);
    msg.setSource(60104U);
    msg.setSourceEntity(35U);
    msg.setDestination(43146U);
    msg.setDestinationEntity(76U);
    msg.direction = 0.989825007304;
    msg.speed = 0.15325388302;
    msg.turbulence = 0.359208726235;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("WindSpeed #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RelativeHumidity msg;
    msg.setTimeStamp(0.861825234778);
    msg.setSource(30706U);
    msg.setSourceEntity(73U);
    msg.setDestination(7838U);
    msg.setDestinationEntity(137U);
    msg.value = 0.512805304357;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RelativeHumidity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RelativeHumidity msg;
    msg.setTimeStamp(0.521983946975);
    msg.setSource(48959U);
    msg.setSourceEntity(110U);
    msg.setDestination(34447U);
    msg.setDestinationEntity(181U);
    msg.value = 0.451504327503;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RelativeHumidity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RelativeHumidity msg;
    msg.setTimeStamp(0.6231529724);
    msg.setSource(38836U);
    msg.setSourceEntity(99U);
    msg.setDestination(2158U);
    msg.setDestinationEntity(129U);
    msg.value = 0.414995729725;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RelativeHumidity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevDataText msg;
    msg.setTimeStamp(0.337389644469);
    msg.setSource(60924U);
    msg.setSourceEntity(226U);
    msg.setDestination(29225U);
    msg.setDestinationEntity(226U);
    msg.value.assign("XLYYLWVOVOTAMFDIFGWABNRTPHHTSMMHQDZCFRZVKXRYRRIEMJYZKWVMGZBVGMDSDSPEDGKXOZNMOKCQUONSIPEYULQAVUVEEXCBPITPRHVNUFBAAXKRYYSMCPNTHOISTUIOZHPBGWKNFVUWNADQMGJQBAADJPOQJFW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevDataText #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevDataText msg;
    msg.setTimeStamp(0.236864325741);
    msg.setSource(47206U);
    msg.setSourceEntity(94U);
    msg.setDestination(64456U);
    msg.setDestinationEntity(163U);
    msg.value.assign("ANXHNYJKLOWUULOZVKLSKBRIUJKXVYJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevDataText #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevDataText msg;
    msg.setTimeStamp(0.170275080754);
    msg.setSource(39769U);
    msg.setSourceEntity(43U);
    msg.setDestination(29402U);
    msg.setDestinationEntity(205U);
    msg.value.assign("ROJQWBHDSUTQVITLFTZZOECVJKFJUPHBAUUXLXXJEPAGMXYPPEJLACZRQMIOSWPRKOCPBPDTYDWEAOLMVNQEMMAOFXVQJKKALPQQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevDataText #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevDataBinary msg;
    msg.setTimeStamp(0.193625601648);
    msg.setSource(17105U);
    msg.setSourceEntity(252U);
    msg.setDestination(63664U);
    msg.setDestinationEntity(145U);
    const char tmp_msg_0[] = {30, 122, -112, 25, 56, 111, 63, 34, 121, -116, -1, -115, -86, -31, -35, -84, -74, -45, 124, 69, -46, -78, 114, -7, 57, 64, -31, 90, -28, -26, 83, -44, 88, 100, -81, -9, -50, 104, 34, -116, 42, 36, -108, -88, -112, -33, -93, 0, -10, 123, -105, 116, 81, -66, -127, -65, 17, 75, 22, 44, 20, -40, 20, -26, 126, 48, -55, 64, 32, 4, -23, 68, 86, 95, -14, -17, -90, 74, 109, -50, 8, -40, 51, 40, 5, -2, 59, -88, -80, 81, -23, -68, 115, 91, -108, -3, 68, 54, -57, -49, 1, 89, -111, 98, 55, 15, 124, 54, -128, 38, 104, -61, 82, 66, 124, 107, 35, -13, -3, -69, 58, -99, -9, 74, 43, -99, -15, -52, -101, -83, -121, 120, -30, -71, -34, 13, 88, -116, -8, -111, 25, -99, -55, 22, -109, -20, 53, -116, -74, 77, -31, 79, 54, -85, 105, 13, 55, -79, 118, 10, 86, 109, -105, -74, -62, 3, -57, 52, 6, -116, -70, 62, -54, 56, -60, 47, 52, -71, -120, -119, 114, -13, -7, -72, 103};
    msg.value.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevDataBinary #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevDataBinary msg;
    msg.setTimeStamp(0.354340304111);
    msg.setSource(15835U);
    msg.setSourceEntity(111U);
    msg.setDestination(30855U);
    msg.setDestinationEntity(139U);
    const char tmp_msg_0[] = {-2, 55, -30, 65, 105, -92, -20, -25, 111, -62, -64, 8, 108, 64, 25, -120, 39, 50, 74, 102, 32, 104, 49, -120, -82, 60, 123, -110, -20, 70, 75, 3, 99, -98, -128, -77, -11, -2, 15, 119, -1, -85, -94, 111, -97, 0, 71, -56, -86, 105, 14, 2, 46, 1, -101, 15, 102, -40, -43, 45, -41, 76, 59, 10, -33, 34, -66, 116, -122, 1, 106, -13, 40, -35, -86, -70, 79, 46, 86, -39, -128, -36, 55, -28, -72, -51, -113, 60, -85, -121, 119, -82, -1, -88, -65, -20, -56, -65, 35, -121, -97, -1, -80, 12, 1, -91, 108, -48, -14, 74, 102, -114, -50, 109, -33, -107, -16, -7, 70, -14, 89, -98, 61, 92, 1, -119, 73, 112, -87, 23, -40, -66, 61, -111, -123, -31, 106, -51, 16, -10, 85, 125};
    msg.value.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevDataBinary #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DevDataBinary msg;
    msg.setTimeStamp(0.976168223543);
    msg.setSource(45224U);
    msg.setSourceEntity(73U);
    msg.setDestination(21700U);
    msg.setDestinationEntity(141U);
    const char tmp_msg_0[] = {103, 52, -30, -13, 19, -102, 5, 41, 14, 107, -14, 26, 118, -104, 44, 6, -41, 54, 15, -79, -16, 5, 69, -82, -7, 81, -14, 36, 79, 22, 9, -18, -43, -108, 124, 84, -3, 12, -26, -35, 28, -46, -124, 30, 87, 13, 21, 71, -59, -46, 0, -83, 57, -104, -66, -84, -96, 58, -18, -102, -63, -75, -19, -102, 87, -46, -109, 7, 24, 99};
    msg.value.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DevDataBinary #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SonarData msg;
    msg.setTimeStamp(0.602742035979);
    msg.setSource(56222U);
    msg.setSourceEntity(202U);
    msg.setDestination(56544U);
    msg.setDestinationEntity(141U);
    msg.type = 205U;
    msg.frequency = 794406562U;
    msg.min_range = 16322U;
    msg.max_range = 61406U;
    msg.bits_per_point = 26U;
    msg.scale_factor = 0.861264744096;
    IMC::BeamConfig tmp_msg_0;
    tmp_msg_0.beam_width = 0.708353038979;
    tmp_msg_0.beam_height = 0.100160625838;
    msg.beam_config.push_back(tmp_msg_0);
    const char tmp_msg_1[] = {42, 49, -97, -80, -71, 90, 120, -25, 54, -86, 63, 60, -22, 76, 54, -72, -69, 30, 87, 79, 120, -116, -105, 54};
    msg.data.assign(tmp_msg_1, tmp_msg_1 + sizeof(tmp_msg_1));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SonarData #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SonarData msg;
    msg.setTimeStamp(0.539487063427);
    msg.setSource(9676U);
    msg.setSourceEntity(164U);
    msg.setDestination(53149U);
    msg.setDestinationEntity(145U);
    msg.type = 184U;
    msg.frequency = 493292074U;
    msg.min_range = 27951U;
    msg.max_range = 39369U;
    msg.bits_per_point = 225U;
    msg.scale_factor = 0.397421102819;
    const char tmp_msg_0[] = {-65, -50, 105, 124, 92, 99, 37, -31, -35, 74, -125, 57, -12, 100, 107, 42, 0, -68, -77, 109, -7, 108, 39, 74, -40, -56, 67, -22, 120, 70, -119, 50, 9, -3, 5, -58, 40, 100, 54, -88, 121, 56, 23, 40, 117, 49, 25, -104, -122, 64, -101, 27, -68, 125, 80, -79, 116, -104, 110, -76, 2, 107, 19, 63, 57, 93, -34, -68, 109, -127, -53, 86, -12, -59, 103, -99, -117, 72, 63, -21, -100, 72, -9, -60, 92, -57, -113, 113, 63, -27, 116, 17, -96, -86, 97, 125, -12, 20, 63, -80, -10, -76, 98, 6, 39, -104, -89, 106, -32, -47, -74, -109, 91, 79, -87, -47, 69, 16, -82, 96, 26, 9, -24, 51, 31, 118, -1, 102, -17, 62, 123, 8, 13, -19, -59, 6, 102, -90, 120, -61, -16, -16, 29, -14, -125, -46, 31, -38, 23, -10, 56, 103, 42, -80, -84, 66, -107, -96, 65, 56};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SonarData #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SonarData msg;
    msg.setTimeStamp(0.891128650294);
    msg.setSource(3718U);
    msg.setSourceEntity(45U);
    msg.setDestination(13289U);
    msg.setDestinationEntity(57U);
    msg.type = 215U;
    msg.frequency = 3957629318U;
    msg.min_range = 35640U;
    msg.max_range = 25824U;
    msg.bits_per_point = 40U;
    msg.scale_factor = 0.863725980058;
    IMC::BeamConfig tmp_msg_0;
    tmp_msg_0.beam_width = 0.704609812319;
    tmp_msg_0.beam_height = 0.190014078179;
    msg.beam_config.push_back(tmp_msg_0);
    const char tmp_msg_1[] = {77, -102, -108, -83, -119, -56, 37, -15, 54, -41, 72, 13, -16, -31, -66, -24, -14, 93, 63, -11, -20, 116, 20, 38, -61, 46, 8, -84, -101, 54, -70, 97, 72, -22, -84, -40, -121, -70, -35, -71, -40, -3, -59, 69, 7, 2, -44, -49, 23, 67, 72, 32, -80, -9, -49, 15, 43, -97, -124, -73, 18, -34, 121, 36, 100, -92, 34, -56, -49, -28, 109, 39, 93, -62, -18, -78, -119, 104, 96, 34, 44, 97, 90, -66, 75, -85, 105, -72, -2, -117, -55, -42, 40, 1, 31, 47, -57, 122, 26, 16, -92, 112, -106, 8, 90, -9, -111, 74, 4, 70, -117, -73, 106, -66, -100, -114, -34, -54, 50, 87, 77, -89, -118, -38, 32, -103, 49, -121, -116, -29, -103, -69, 15, -4, -74, 68, -51, -124, 49, 66, 103, 60, 56, 45, 83, 7, 87, 112, -13, 117, -55, 78, 60, -85, 82, 26, 21, -6, 21, -16, -28, 81, 59, -10, 119, 112, -69, 90, 36, 114, 80, -62, 41, 44, -64, -75, -41, -74, -61, -30, -87, 16, 73, -15, -11, 109, -113, -7, -18, 48, 70, 43, -80, -64, 104, 112, 59, 90, -37, 77, -102, -118};
    msg.data.assign(tmp_msg_1, tmp_msg_1 + sizeof(tmp_msg_1));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SonarData #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Pulse msg;
    msg.setTimeStamp(0.607419896003);
    msg.setSource(61203U);
    msg.setSourceEntity(17U);
    msg.setDestination(34243U);
    msg.setDestinationEntity(199U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Pulse #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Pulse msg;
    msg.setTimeStamp(0.933714878193);
    msg.setSource(8267U);
    msg.setSourceEntity(149U);
    msg.setDestination(39911U);
    msg.setDestinationEntity(218U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Pulse #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Pulse msg;
    msg.setTimeStamp(0.216552607735);
    msg.setSource(22906U);
    msg.setSourceEntity(10U);
    msg.setDestination(7373U);
    msg.setDestinationEntity(7U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Pulse #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PulseDetectionControl msg;
    msg.setTimeStamp(0.45039885444);
    msg.setSource(19630U);
    msg.setSourceEntity(71U);
    msg.setDestination(51706U);
    msg.setDestinationEntity(18U);
    msg.op = 113U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PulseDetectionControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PulseDetectionControl msg;
    msg.setTimeStamp(0.131934017881);
    msg.setSource(6884U);
    msg.setSourceEntity(63U);
    msg.setDestination(20443U);
    msg.setDestinationEntity(127U);
    msg.op = 13U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PulseDetectionControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PulseDetectionControl msg;
    msg.setTimeStamp(0.394223840791);
    msg.setSource(29432U);
    msg.setSourceEntity(90U);
    msg.setDestination(9672U);
    msg.setDestinationEntity(4U);
    msg.op = 227U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PulseDetectionControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FuelLevel msg;
    msg.setTimeStamp(0.427646564391);
    msg.setSource(3642U);
    msg.setSourceEntity(206U);
    msg.setDestination(62198U);
    msg.setDestinationEntity(77U);
    msg.value = 0.732917155349;
    msg.confidence = 0.507038480694;
    msg.opmodes.assign("IQFULLLZIRBBRKUGXTRLIQVZWJMPXQIEEIMXHJFCEVIQNBIKKMR");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FuelLevel #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FuelLevel msg;
    msg.setTimeStamp(0.104039562796);
    msg.setSource(10569U);
    msg.setSourceEntity(158U);
    msg.setDestination(35618U);
    msg.setDestinationEntity(68U);
    msg.value = 0.154102256005;
    msg.confidence = 0.651169136958;
    msg.opmodes.assign("LTRSGQAVJQGKGYRWGUBIBWZMIIGNCPMHUTXZOUFKRLHZIBSFYSFBECDWETDTKKGOCQULCMXJNVARZWJGASJHOBPCDFNNLQPRMZDSFSJHDHYYTBHDZBPCOXKLENWMOPFRNTUDQXIXSAGYMWJA");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FuelLevel #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FuelLevel msg;
    msg.setTimeStamp(0.0533774165762);
    msg.setSource(64174U);
    msg.setSourceEntity(192U);
    msg.setDestination(49855U);
    msg.setDestinationEntity(40U);
    msg.value = 0.247681451726;
    msg.confidence = 0.349445457161;
    msg.opmodes.assign("RDCFYSIAVVMEQZXO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FuelLevel #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsNavData msg;
    msg.setTimeStamp(0.329933151789);
    msg.setSource(37551U);
    msg.setSourceEntity(1U);
    msg.setDestination(49509U);
    msg.setDestinationEntity(192U);
    msg.itow = 2334845432U;
    msg.lat = 0.159474547731;
    msg.lon = 0.693271264316;
    msg.height_ell = 0.476096625499;
    msg.height_sea = 0.309538550683;
    msg.hacc = 0.722210632111;
    msg.vacc = 0.0284916914082;
    msg.vel_n = 0.577974056318;
    msg.vel_e = 0.020544800388;
    msg.vel_d = 0.368746542027;
    msg.speed = 0.505674149554;
    msg.gspeed = 0.839627076059;
    msg.heading = 0.503242947433;
    msg.sacc = 0.570832236593;
    msg.cacc = 0.0981344965254;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsNavData #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsNavData msg;
    msg.setTimeStamp(0.633454588424);
    msg.setSource(64637U);
    msg.setSourceEntity(59U);
    msg.setDestination(7651U);
    msg.setDestinationEntity(119U);
    msg.itow = 1010066410U;
    msg.lat = 0.899298406178;
    msg.lon = 0.154769855419;
    msg.height_ell = 0.521297235027;
    msg.height_sea = 0.335539720301;
    msg.hacc = 0.896442311353;
    msg.vacc = 0.248732338627;
    msg.vel_n = 0.0691225243874;
    msg.vel_e = 0.692105421349;
    msg.vel_d = 0.616085172301;
    msg.speed = 0.749126154311;
    msg.gspeed = 0.533352696367;
    msg.heading = 0.682543056998;
    msg.sacc = 0.464241142906;
    msg.cacc = 0.487361473061;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsNavData #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsNavData msg;
    msg.setTimeStamp(0.245287621341);
    msg.setSource(34299U);
    msg.setSourceEntity(0U);
    msg.setDestination(56445U);
    msg.setDestinationEntity(149U);
    msg.itow = 1986397029U;
    msg.lat = 0.320121740185;
    msg.lon = 0.474856222061;
    msg.height_ell = 0.538708896767;
    msg.height_sea = 0.696741538383;
    msg.hacc = 0.216353347299;
    msg.vacc = 0.210520408926;
    msg.vel_n = 0.267429260067;
    msg.vel_e = 0.527339680711;
    msg.vel_d = 0.974272596684;
    msg.speed = 0.990923157439;
    msg.gspeed = 0.535946166812;
    msg.heading = 0.147378785929;
    msg.sacc = 0.560059738931;
    msg.cacc = 0.919047111302;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsNavData #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ServoPosition msg;
    msg.setTimeStamp(0.0193703060021);
    msg.setSource(22753U);
    msg.setSourceEntity(60U);
    msg.setDestination(8069U);
    msg.setDestinationEntity(164U);
    msg.id = 103U;
    msg.value = 0.896985429439;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ServoPosition #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ServoPosition msg;
    msg.setTimeStamp(0.996713501393);
    msg.setSource(3564U);
    msg.setSourceEntity(211U);
    msg.setDestination(3911U);
    msg.setDestinationEntity(93U);
    msg.id = 226U;
    msg.value = 0.325904011551;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ServoPosition #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ServoPosition msg;
    msg.setTimeStamp(0.209785218896);
    msg.setSource(38027U);
    msg.setSourceEntity(174U);
    msg.setDestination(44380U);
    msg.setDestinationEntity(247U);
    msg.id = 191U;
    msg.value = 0.181221714652;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ServoPosition #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DeviceState msg;
    msg.setTimeStamp(0.830458331353);
    msg.setSource(46748U);
    msg.setSourceEntity(248U);
    msg.setDestination(12389U);
    msg.setDestinationEntity(200U);
    msg.x = 0.920109366402;
    msg.y = 0.416771759071;
    msg.z = 0.640061710229;
    msg.phi = 0.288068378122;
    msg.theta = 0.178893586732;
    msg.psi = 0.980629260314;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DeviceState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DeviceState msg;
    msg.setTimeStamp(0.228296027467);
    msg.setSource(20970U);
    msg.setSourceEntity(195U);
    msg.setDestination(31133U);
    msg.setDestinationEntity(202U);
    msg.x = 0.259495256107;
    msg.y = 0.434795361008;
    msg.z = 0.596439138836;
    msg.phi = 0.11095507745;
    msg.theta = 0.0288695516461;
    msg.psi = 0.376686240728;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DeviceState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DeviceState msg;
    msg.setTimeStamp(0.0848843751268);
    msg.setSource(44113U);
    msg.setSourceEntity(138U);
    msg.setDestination(54169U);
    msg.setDestinationEntity(25U);
    msg.x = 0.980385249537;
    msg.y = 0.173970878151;
    msg.z = 0.54020943246;
    msg.phi = 0.370772649597;
    msg.theta = 0.128350646283;
    msg.psi = 0.222229972311;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DeviceState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::BeamConfig msg;
    msg.setTimeStamp(0.587900614182);
    msg.setSource(56872U);
    msg.setSourceEntity(135U);
    msg.setDestination(23558U);
    msg.setDestinationEntity(172U);
    msg.beam_width = 0.139545152463;
    msg.beam_height = 0.0842811992837;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("BeamConfig #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::BeamConfig msg;
    msg.setTimeStamp(0.389293908732);
    msg.setSource(2901U);
    msg.setSourceEntity(18U);
    msg.setDestination(13094U);
    msg.setDestinationEntity(106U);
    msg.beam_width = 0.0128805156662;
    msg.beam_height = 0.274910563031;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("BeamConfig #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::BeamConfig msg;
    msg.setTimeStamp(0.722115183309);
    msg.setSource(19571U);
    msg.setSourceEntity(135U);
    msg.setDestination(26372U);
    msg.setDestinationEntity(215U);
    msg.beam_width = 0.00305652280112;
    msg.beam_height = 0.463241579965;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("BeamConfig #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DataSanity msg;
    msg.setTimeStamp(0.403108746106);
    msg.setSource(62813U);
    msg.setSourceEntity(142U);
    msg.setDestination(57784U);
    msg.setDestinationEntity(188U);
    msg.sane = 66U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DataSanity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DataSanity msg;
    msg.setTimeStamp(0.229210557557);
    msg.setSource(28730U);
    msg.setSourceEntity(47U);
    msg.setDestination(17681U);
    msg.setDestinationEntity(9U);
    msg.sane = 128U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DataSanity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DataSanity msg;
    msg.setTimeStamp(0.421200030866);
    msg.setSource(27258U);
    msg.setSourceEntity(120U);
    msg.setDestination(12505U);
    msg.setDestinationEntity(176U);
    msg.sane = 123U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DataSanity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RhodamineDye msg;
    msg.setTimeStamp(0.265781267019);
    msg.setSource(50653U);
    msg.setSourceEntity(113U);
    msg.setDestination(983U);
    msg.setDestinationEntity(97U);
    msg.value = 0.842185937341;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RhodamineDye #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RhodamineDye msg;
    msg.setTimeStamp(0.782333638093);
    msg.setSource(12624U);
    msg.setSourceEntity(213U);
    msg.setDestination(2507U);
    msg.setDestinationEntity(173U);
    msg.value = 0.600935594236;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RhodamineDye #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RhodamineDye msg;
    msg.setTimeStamp(0.971012993632);
    msg.setSource(8755U);
    msg.setSourceEntity(200U);
    msg.setDestination(41800U);
    msg.setDestinationEntity(149U);
    msg.value = 0.349238167034;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RhodamineDye #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CrudeOil msg;
    msg.setTimeStamp(0.0696925523121);
    msg.setSource(24999U);
    msg.setSourceEntity(124U);
    msg.setDestination(3834U);
    msg.setDestinationEntity(212U);
    msg.value = 0.0754940998274;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CrudeOil #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CrudeOil msg;
    msg.setTimeStamp(0.187532412876);
    msg.setSource(51233U);
    msg.setSourceEntity(176U);
    msg.setDestination(28023U);
    msg.setDestinationEntity(92U);
    msg.value = 0.348361803528;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CrudeOil #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CrudeOil msg;
    msg.setTimeStamp(0.711412676301);
    msg.setSource(17397U);
    msg.setSourceEntity(33U);
    msg.setDestination(50069U);
    msg.setDestinationEntity(10U);
    msg.value = 0.358272708556;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CrudeOil #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FineOil msg;
    msg.setTimeStamp(0.297311457546);
    msg.setSource(28523U);
    msg.setSourceEntity(12U);
    msg.setDestination(38851U);
    msg.setDestinationEntity(20U);
    msg.value = 0.493606172115;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FineOil #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FineOil msg;
    msg.setTimeStamp(0.553386960981);
    msg.setSource(45245U);
    msg.setSourceEntity(240U);
    msg.setDestination(41519U);
    msg.setDestinationEntity(223U);
    msg.value = 0.852050472677;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FineOil #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FineOil msg;
    msg.setTimeStamp(0.326956675376);
    msg.setSource(47397U);
    msg.setSourceEntity(147U);
    msg.setDestination(20799U);
    msg.setDestinationEntity(26U);
    msg.value = 0.638662488744;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FineOil #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CameraZoom msg;
    msg.setTimeStamp(0.204837538264);
    msg.setSource(10797U);
    msg.setSourceEntity(250U);
    msg.setDestination(39864U);
    msg.setDestinationEntity(127U);
    msg.id = 188U;
    msg.zoom = 5U;
    msg.action = 113U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CameraZoom #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CameraZoom msg;
    msg.setTimeStamp(0.624474400996);
    msg.setSource(45923U);
    msg.setSourceEntity(81U);
    msg.setDestination(16225U);
    msg.setDestinationEntity(50U);
    msg.id = 183U;
    msg.zoom = 246U;
    msg.action = 201U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CameraZoom #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CameraZoom msg;
    msg.setTimeStamp(0.655051274576);
    msg.setSource(10862U);
    msg.setSourceEntity(91U);
    msg.setDestination(21187U);
    msg.setDestinationEntity(143U);
    msg.id = 122U;
    msg.zoom = 9U;
    msg.action = 97U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CameraZoom #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetThrusterActuation msg;
    msg.setTimeStamp(0.421867659789);
    msg.setSource(50113U);
    msg.setSourceEntity(40U);
    msg.setDestination(4384U);
    msg.setDestinationEntity(35U);
    msg.id = 217U;
    msg.value = 0.948101111992;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetThrusterActuation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetThrusterActuation msg;
    msg.setTimeStamp(0.0101039695107);
    msg.setSource(38276U);
    msg.setSourceEntity(170U);
    msg.setDestination(29003U);
    msg.setDestinationEntity(238U);
    msg.id = 230U;
    msg.value = 0.268841153563;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetThrusterActuation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetThrusterActuation msg;
    msg.setTimeStamp(0.356005014159);
    msg.setSource(61837U);
    msg.setSourceEntity(104U);
    msg.setDestination(5529U);
    msg.setDestinationEntity(218U);
    msg.id = 138U;
    msg.value = 0.629544561156;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetThrusterActuation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetServoPosition msg;
    msg.setTimeStamp(0.585479676754);
    msg.setSource(43516U);
    msg.setSourceEntity(182U);
    msg.setDestination(35427U);
    msg.setDestinationEntity(214U);
    msg.id = 102U;
    msg.value = 0.971451918511;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetServoPosition #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetServoPosition msg;
    msg.setTimeStamp(0.80029851125);
    msg.setSource(40957U);
    msg.setSourceEntity(150U);
    msg.setDestination(58928U);
    msg.setDestinationEntity(60U);
    msg.id = 134U;
    msg.value = 0.715979821939;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetServoPosition #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetServoPosition msg;
    msg.setTimeStamp(0.565918612023);
    msg.setSource(42045U);
    msg.setSourceEntity(173U);
    msg.setDestination(54069U);
    msg.setDestinationEntity(153U);
    msg.id = 135U;
    msg.value = 0.453130679472;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetServoPosition #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetControlSurfaceDeflection msg;
    msg.setTimeStamp(0.775818405817);
    msg.setSource(5781U);
    msg.setSourceEntity(227U);
    msg.setDestination(48904U);
    msg.setDestinationEntity(173U);
    msg.id = 197U;
    msg.angle = 0.831655667319;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetControlSurfaceDeflection #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetControlSurfaceDeflection msg;
    msg.setTimeStamp(0.426399710461);
    msg.setSource(53839U);
    msg.setSourceEntity(145U);
    msg.setDestination(41633U);
    msg.setDestinationEntity(182U);
    msg.id = 205U;
    msg.angle = 0.285584770055;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetControlSurfaceDeflection #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetControlSurfaceDeflection msg;
    msg.setTimeStamp(0.560449498753);
    msg.setSource(56169U);
    msg.setSourceEntity(228U);
    msg.setDestination(12437U);
    msg.setDestinationEntity(191U);
    msg.id = 28U;
    msg.angle = 0.319662292005;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetControlSurfaceDeflection #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteActionsRequest msg;
    msg.setTimeStamp(0.405918800067);
    msg.setSource(33093U);
    msg.setSourceEntity(32U);
    msg.setDestination(59034U);
    msg.setDestinationEntity(87U);
    msg.op = 225U;
    msg.actions.assign("CKYMIHSQKODGIXILLVCANRPGNJJEPOEKFBEYXJIZFRWAYJTHVPZVQQDDSKCBZVBJAEYRNXMYXZCBVNBJTAXTUFSPEDWBLTADMKANKBOOLODZETUWZLVNXVQQOPUFRBZJPRMBWJWMBCJGXWHQRMIPSIRNPCODUQIEQLSYHGKWRAHUVDCONFGPILKXWHFLSFNSIGRCTXKDEGAYMMCLTWEUSAFYNSUGVGKQQAYTTMIUOZSTLHFZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteActionsRequest #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteActionsRequest msg;
    msg.setTimeStamp(0.283000954224);
    msg.setSource(53105U);
    msg.setSourceEntity(55U);
    msg.setDestination(58389U);
    msg.setDestinationEntity(13U);
    msg.op = 105U;
    msg.actions.assign("VUSXXEFJQLKEPCNNDWQTJRPGJMPNOUVSQTIWYSMSCWRLPADDDWPZJULUICLBEUHNX");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteActionsRequest #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteActionsRequest msg;
    msg.setTimeStamp(0.685262455207);
    msg.setSource(43249U);
    msg.setSourceEntity(216U);
    msg.setDestination(51122U);
    msg.setDestinationEntity(61U);
    msg.op = 224U;
    msg.actions.assign("DOVJCVNACFHEIFIEQHQTFXBXKTLAVMDCJLAZOKYKVEEZHRNXLFSYZGFMVSGGYZWTCDIECZGZJUUSJBUPBIYLPUKBIQK");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteActionsRequest #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteActions msg;
    msg.setTimeStamp(0.111543012459);
    msg.setSource(2809U);
    msg.setSourceEntity(115U);
    msg.setDestination(22784U);
    msg.setDestinationEntity(59U);
    msg.actions.assign("XOKLQCRAUEIGCUQSYDDKTVVCRKVIQJIPTYEDNUEBJRLBMHDIASBNWGAKFIFZZPCVNRSYTXNAOOYXTRHKGBYSMTSWQGNVOTIYOWPT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteActions #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteActions msg;
    msg.setTimeStamp(0.470873043925);
    msg.setSource(17710U);
    msg.setSourceEntity(12U);
    msg.setDestination(60845U);
    msg.setDestinationEntity(14U);
    msg.actions.assign("HMXUEHWMMGJLMPWQFCQBEZEBOKC");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteActions #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteActions msg;
    msg.setTimeStamp(0.0344132666719);
    msg.setSource(48038U);
    msg.setSourceEntity(219U);
    msg.setDestination(49364U);
    msg.setDestinationEntity(179U);
    msg.actions.assign("WVGDJXDKABDFNKNTRZUQODQPGPIWMRMMRVIGVLJYILJZSLBAGNGABZCEUPZCGAQZIRQFYUTYBJNBUJFIKGZCUKREFBXQYCBRZYQQDKPWPUEHTMSEGPWRTSFWXTOMSVQWPOXUEZCWFYPAKCHONWOLGOAEMJSTXALNYTUACWAHBHFTJOOTSEPDVAXUQILILLEONZEMKFQVNOHCRDRJSCX");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteActions #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ButtonEvent msg;
    msg.setTimeStamp(0.135728654887);
    msg.setSource(53985U);
    msg.setSourceEntity(6U);
    msg.setDestination(60895U);
    msg.setDestinationEntity(141U);
    msg.button = 80U;
    msg.value = 60U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ButtonEvent #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ButtonEvent msg;
    msg.setTimeStamp(0.588998512992);
    msg.setSource(59022U);
    msg.setSourceEntity(163U);
    msg.setDestination(4038U);
    msg.setDestinationEntity(247U);
    msg.button = 153U;
    msg.value = 183U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ButtonEvent #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ButtonEvent msg;
    msg.setTimeStamp(0.973781030616);
    msg.setSource(8809U);
    msg.setSourceEntity(117U);
    msg.setDestination(37290U);
    msg.setDestinationEntity(35U);
    msg.button = 136U;
    msg.value = 220U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ButtonEvent #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LcdControl msg;
    msg.setTimeStamp(0.16292118385);
    msg.setSource(23933U);
    msg.setSourceEntity(137U);
    msg.setDestination(13768U);
    msg.setDestinationEntity(42U);
    msg.op = 40U;
    msg.text.assign("NCFFLNDTIHKGDAFNGJRHEBSQJBZLSWGVLKMJCORYMCVJBNKTOHXIFFRRONTZIKJQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LcdControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LcdControl msg;
    msg.setTimeStamp(0.293120022628);
    msg.setSource(39718U);
    msg.setSourceEntity(102U);
    msg.setDestination(48350U);
    msg.setDestinationEntity(202U);
    msg.op = 106U;
    msg.text.assign("BTUGEOJNCMGQUMPXRZGXSZYVCBALBELASWDRHSE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LcdControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LcdControl msg;
    msg.setTimeStamp(0.574571311719);
    msg.setSource(31359U);
    msg.setSourceEntity(200U);
    msg.setDestination(23393U);
    msg.setDestinationEntity(61U);
    msg.op = 137U;
    msg.text.assign("ZEVSPWIGPYRMRZDEFFXQGWUAVMJTOHNMBHIIIJZXJUGSBEWKHMJRTALPRDNUJBADKTLJICAWTGKLVADWLBWHQNPEVBAFFKTILIEYHXLODVMMTPK");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LcdControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerOperation msg;
    msg.setTimeStamp(0.343996653397);
    msg.setSource(7543U);
    msg.setSourceEntity(155U);
    msg.setDestination(12027U);
    msg.setDestinationEntity(39U);
    msg.op = 216U;
    msg.time_remain = 0.697378721519;
    msg.sched_time = 0.504105816664;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerOperation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerOperation msg;
    msg.setTimeStamp(0.302119376168);
    msg.setSource(37643U);
    msg.setSourceEntity(123U);
    msg.setDestination(38229U);
    msg.setDestinationEntity(160U);
    msg.op = 214U;
    msg.time_remain = 0.692263371702;
    msg.sched_time = 0.400318624771;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerOperation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerOperation msg;
    msg.setTimeStamp(0.607620661381);
    msg.setSource(55324U);
    msg.setSourceEntity(124U);
    msg.setDestination(7350U);
    msg.setDestinationEntity(62U);
    msg.op = 192U;
    msg.time_remain = 0.463968861502;
    msg.sched_time = 0.0389075431932;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerOperation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerChannelControl msg;
    msg.setTimeStamp(0.725280402085);
    msg.setSource(46448U);
    msg.setSourceEntity(169U);
    msg.setDestination(30639U);
    msg.setDestinationEntity(108U);
    msg.name.assign("YYEUYBVWBLOHWYSEKKKJZRAZUGTSNBGOBHUJKBSMQPVINADTFEODMTUPPVUESFUQXYOQNGGXFXJPFHCLHZVIDOEAXIUWYEKWVQPFQSZFNTCLRJZVXHCJZZLPRVVRSRSCGBWODQSXLMCRHTICYALFUHMQDDCNPADPSWKNFLBQNYBKBXJOAFYELMNLJUINKTRDYUCSHV");
    msg.op = 63U;
    msg.sched_time = 0.955899970518;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerChannelControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerChannelControl msg;
    msg.setTimeStamp(0.118887754983);
    msg.setSource(41156U);
    msg.setSourceEntity(178U);
    msg.setDestination(34498U);
    msg.setDestinationEntity(126U);
    msg.name.assign("GDQJEZDPYLLPXRQICGTVIBJCNFGSHCMBHMSOTNOLNKAMGXTMFFUPXGWAZXUZEMQBCIRUWCBAIPLWQFVBJSTSWHNVUOYZJEWUIKJQUGDACUHO");
    msg.op = 128U;
    msg.sched_time = 0.664419202101;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerChannelControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerChannelControl msg;
    msg.setTimeStamp(0.919194562949);
    msg.setSource(39696U);
    msg.setSourceEntity(37U);
    msg.setDestination(36975U);
    msg.setDestinationEntity(165U);
    msg.name.assign("MNVFKBVLTYVJXFJHAIHAAUUQUFUNCJVEKZXOCDISHFWQDKERDPRZYESUWWXPOKTWFYYOABXIZBPIMCDRAVQSZOPNVPWSKDTQMXCDTGRGGRNJKOLBIMLJWCFBVGLGPRDTWBKOEKMQABAXXJHTVOJWYKSIBLSACKXLQOSEQAPRNIQNHYMBNNLSTUYZCMGHFHSODGWQVTXZNECCEZEUMSGGPFTAYPTRYLJUHJ");
    msg.op = 87U;
    msg.sched_time = 0.616012923357;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerChannelControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryPowerChannelState msg;
    msg.setTimeStamp(0.759884250018);
    msg.setSource(53532U);
    msg.setSourceEntity(36U);
    msg.setDestination(12919U);
    msg.setDestinationEntity(108U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryPowerChannelState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryPowerChannelState msg;
    msg.setTimeStamp(0.934883438933);
    msg.setSource(4053U);
    msg.setSourceEntity(253U);
    msg.setDestination(42492U);
    msg.setDestinationEntity(133U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryPowerChannelState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryPowerChannelState msg;
    msg.setTimeStamp(0.187704579688);
    msg.setSource(59201U);
    msg.setSourceEntity(28U);
    msg.setDestination(1240U);
    msg.setDestinationEntity(224U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryPowerChannelState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerChannelState msg;
    msg.setTimeStamp(0.481268785772);
    msg.setSource(35352U);
    msg.setSourceEntity(251U);
    msg.setDestination(19380U);
    msg.setDestinationEntity(90U);
    msg.name.assign("EUFDFKCSSWYCNBIZVJQQFBNRCWYAJBIXRFPBWFCFPNXIOSKSMNVTVWTKOOAVMGUNULAKJQZEWDTESVOTCPPYBLSMKQPYHHHEMLGGHRTKPXBNYI");
    msg.state = 91U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerChannelState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerChannelState msg;
    msg.setTimeStamp(0.653558556276);
    msg.setSource(27066U);
    msg.setSourceEntity(127U);
    msg.setDestination(19878U);
    msg.setDestinationEntity(117U);
    msg.name.assign("OUDOYFYTRVPVMWIV");
    msg.state = 86U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerChannelState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PowerChannelState msg;
    msg.setTimeStamp(0.450127552544);
    msg.setSource(34005U);
    msg.setSourceEntity(131U);
    msg.setDestination(32678U);
    msg.setDestinationEntity(233U);
    msg.name.assign("SZVMILFXXKHMKVGJSNTERIQ");
    msg.state = 5U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PowerChannelState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LedBrightness msg;
    msg.setTimeStamp(0.990279063864);
    msg.setSource(38064U);
    msg.setSourceEntity(7U);
    msg.setDestination(57294U);
    msg.setDestinationEntity(58U);
    msg.name.assign("CXRFXCOCSJHIRGNCXWUOZXXPQFYXZSEDSFGMVFALTZVRENACEUMKYZYDDFVGKLPXIQDHZLWLQWVMTABTQEAWIGNIOGZANBVITCVWWBKZWRPRGEJECKRDBYZFSOABKAUYUNCMHSPQQKRTXLUCUCEIBAZWJOOPLSTDHMJGAVVJVLYTPXJXBKMJHYDQIISHNDFHMORPULYRPQMEKKWUNMDFHOTJEASOBLVFIPQZWYUNKTFNGQTBHIUSDJPJNMGB");
    msg.value = 93U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LedBrightness #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LedBrightness msg;
    msg.setTimeStamp(0.5397969428);
    msg.setSource(23121U);
    msg.setSourceEntity(201U);
    msg.setDestination(24504U);
    msg.setDestinationEntity(170U);
    msg.name.assign("JVNNEJOSRHVSYBLBURWULRXTACJTJSMDSVJLOAMQKDORVQTGVOWCAKQYQCFTEATGGKNDCCQHVIHVVDXYSYWGNTWMYEMMDRCRMEOHLZFARGCUHIPZWKBXXHMNHWTROXWW");
    msg.value = 178U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LedBrightness #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LedBrightness msg;
    msg.setTimeStamp(0.00885285867698);
    msg.setSource(26894U);
    msg.setSourceEntity(141U);
    msg.setDestination(4105U);
    msg.setDestinationEntity(17U);
    msg.name.assign("TVHVTKLIKXYBIXFRNVUIYZVQRPASJVGDROBIZRYGBTOCFXMEMABZFAKWNQGGPDABSKYKLOYNTZEUQDOPYAJXSHPWAKVQMUTUQJBCLAOTAEFLNZJHJYKQSBGMHDTXNPOWSXXNZJMIIKDCCRWN");
    msg.value = 39U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LedBrightness #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryLedBrightness msg;
    msg.setTimeStamp(0.275535679624);
    msg.setSource(12964U);
    msg.setSourceEntity(178U);
    msg.setDestination(65182U);
    msg.setDestinationEntity(48U);
    msg.name.assign("DSPAQVTOEVSQUDXFIDIVTOJISASXLJXYZUVLBMFNZEHQSMZJCQAKGSACRYFATXWXQJMJQCUGSHIVQJFYNNMFWQOTAWUKVZUXXJHMVKNJPINEOLZOPLMBKLLFIETYRDDPZDHDPPKNYTRDRHKGXBKRECBMALCWFYAMNPSWKLEUKZHEXWCUS");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryLedBrightness #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryLedBrightness msg;
    msg.setTimeStamp(0.185223954261);
    msg.setSource(15616U);
    msg.setSourceEntity(102U);
    msg.setDestination(35415U);
    msg.setDestinationEntity(76U);
    msg.name.assign("KQAHFCWPAHVOYLGJDTVVCWHQHMMUVUZMPRYGAWMPBOSCTTZJNBEWZWRTGJTMBGOXWYDNFLEYVDZVJQHHMTDIQHUKBAKALNQXSFIZNGGIBSUTAICEUQHXKJNGYEGEFFAXCRRITOKWLDZONAQVN");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryLedBrightness #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryLedBrightness msg;
    msg.setTimeStamp(0.803986670436);
    msg.setSource(46250U);
    msg.setSourceEntity(61U);
    msg.setDestination(60481U);
    msg.setDestinationEntity(107U);
    msg.name.assign("QWWZOIQOGDMVORVIYSGYGJJDEJNMKIHUYUWGKPRTXAMCLOULGSSQNUJBYZEZBACYHNPXAAZMXOTRPJQKCIJSFSHPNVMTFCBYRNNIWLEYVGTFHKFFSFVCEDNTGTQYRLFSUJKUQBHIMDSMYXXQACRTOEWIJZUPZCBVWBWPHGOVLXVEKWK");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryLedBrightness #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetLedBrightness msg;
    msg.setTimeStamp(0.699516027849);
    msg.setSource(50234U);
    msg.setSourceEntity(185U);
    msg.setDestination(37301U);
    msg.setDestinationEntity(173U);
    msg.name.assign("AJLGZUXBZDSOREJQRDOGEEYQIWUTJETANLSHGIRGAHQEJEDLKNYNWKRDVJILEKFFOYRICCOYNWKWNFQNIQCFGXKOHDSXEVPKUMTTNFLCDQIATWWQRSFPTGPRHDZVCIBOUMHIPZLFCPATJMJPMAMULBRSSXCKCMVSXHDDGBKYBZUYZVPBGOAOLOOYWSNBALJFHYJMHCFXBIZPIQAPHUZMERQVXTSWXRZWFBYBZSMJTHVGV");
    msg.value = 16U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetLedBrightness #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetLedBrightness msg;
    msg.setTimeStamp(0.56248568264);
    msg.setSource(61858U);
    msg.setSourceEntity(55U);
    msg.setDestination(16796U);
    msg.setDestinationEntity(20U);
    msg.name.assign("NMEVNHCCBPXYUSJBHGJOGHAHOHFDRZJZRYUGLCTXMLLOHXAKRUOQYVADEFXTGZCADQPDMJZLSGKHXFADLULFBSJWRMNULDDIFVENRVIMZEXPOMGBWPIIKYMNABGBTYWADDVWTNOFEUMKZNPPLUZLIBNQKECXMCKUKIQXOGBPCSVVSJJWN");
    msg.value = 189U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetLedBrightness #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetLedBrightness msg;
    msg.setTimeStamp(0.041786437655);
    msg.setSource(40249U);
    msg.setSourceEntity(237U);
    msg.setDestination(5228U);
    msg.setDestinationEntity(112U);
    msg.name.assign("QMFEDSGUXNWDSSKFHTUUHABYDIWXERBCTOPCCAYZLUQOTGJFGZSCWKWZUBRLBOGNJPHLCKQNBADFNUNMFLJVWOOCTDLIBERVLIZRKDNKTHYXLRZUFWGHUMIIAKTQIIJGZQDOXVBXXAGQTGODNESCNYVPEVVLMJANIMNUSQLQYTJMROUPVPXPTEYYPKRKEVOFVHE");
    msg.value = 166U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetLedBrightness #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetPWM msg;
    msg.setTimeStamp(0.50127795772);
    msg.setSource(52843U);
    msg.setSourceEntity(107U);
    msg.setDestination(3058U);
    msg.setDestinationEntity(84U);
    msg.id = 74U;
    msg.period = 946344505U;
    msg.duty_cycle = 3680621123U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetPWM #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetPWM msg;
    msg.setTimeStamp(0.107617098109);
    msg.setSource(34662U);
    msg.setSourceEntity(177U);
    msg.setDestination(29351U);
    msg.setDestinationEntity(204U);
    msg.id = 210U;
    msg.period = 1199782839U;
    msg.duty_cycle = 3122319154U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetPWM #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetPWM msg;
    msg.setTimeStamp(0.475780808334);
    msg.setSource(17780U);
    msg.setSourceEntity(247U);
    msg.setDestination(34391U);
    msg.setDestinationEntity(104U);
    msg.id = 57U;
    msg.period = 577217314U;
    msg.duty_cycle = 1665838554U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetPWM #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PWM msg;
    msg.setTimeStamp(0.532085930472);
    msg.setSource(4642U);
    msg.setSourceEntity(74U);
    msg.setDestination(61061U);
    msg.setDestinationEntity(11U);
    msg.id = 185U;
    msg.period = 3479044564U;
    msg.duty_cycle = 2811364606U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PWM #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PWM msg;
    msg.setTimeStamp(0.325712908898);
    msg.setSource(63893U);
    msg.setSourceEntity(223U);
    msg.setDestination(44804U);
    msg.setDestinationEntity(209U);
    msg.id = 239U;
    msg.period = 1027399638U;
    msg.duty_cycle = 93068561U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PWM #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PWM msg;
    msg.setTimeStamp(0.0280790175118);
    msg.setSource(14640U);
    msg.setSourceEntity(82U);
    msg.setDestination(54960U);
    msg.setDestinationEntity(195U);
    msg.id = 67U;
    msg.period = 1995985871U;
    msg.duty_cycle = 1342237007U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PWM #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EstimatedState msg;
    msg.setTimeStamp(0.651622901466);
    msg.setSource(1731U);
    msg.setSourceEntity(85U);
    msg.setDestination(30722U);
    msg.setDestinationEntity(13U);
    msg.lat = 0.286554632965;
    msg.lon = 0.471821252827;
    msg.height = 0.284612153672;
    msg.x = 0.984375237995;
    msg.y = 0.490935316103;
    msg.z = 0.0985103784361;
    msg.phi = 0.0998085515367;
    msg.theta = 0.1624705093;
    msg.psi = 0.227479714719;
    msg.u = 0.932914838126;
    msg.v = 0.430698064873;
    msg.w = 0.347394966491;
    msg.vx = 0.882609266415;
    msg.vy = 0.763203749734;
    msg.vz = 0.172762066328;
    msg.p = 0.975450281845;
    msg.q = 0.491611530869;
    msg.r = 0.310067868328;
    msg.depth = 0.746886939769;
    msg.alt = 0.231358627939;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EstimatedState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EstimatedState msg;
    msg.setTimeStamp(0.0988136613556);
    msg.setSource(32680U);
    msg.setSourceEntity(195U);
    msg.setDestination(359U);
    msg.setDestinationEntity(2U);
    msg.lat = 0.949195006734;
    msg.lon = 0.355172176197;
    msg.height = 0.335924303946;
    msg.x = 0.0928225660609;
    msg.y = 0.198973594126;
    msg.z = 0.732448256137;
    msg.phi = 0.558102089191;
    msg.theta = 0.294568569321;
    msg.psi = 0.331824902182;
    msg.u = 0.0582689811062;
    msg.v = 0.18688920706;
    msg.w = 0.328138750389;
    msg.vx = 0.516544390149;
    msg.vy = 0.401249114794;
    msg.vz = 0.113797754651;
    msg.p = 0.183733715449;
    msg.q = 0.489156605462;
    msg.r = 0.0825083980127;
    msg.depth = 0.625305217583;
    msg.alt = 0.322363249877;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EstimatedState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EstimatedState msg;
    msg.setTimeStamp(0.518832902957);
    msg.setSource(48928U);
    msg.setSourceEntity(45U);
    msg.setDestination(19820U);
    msg.setDestinationEntity(40U);
    msg.lat = 0.07400712858;
    msg.lon = 0.968448818768;
    msg.height = 0.197322969732;
    msg.x = 0.994750242378;
    msg.y = 0.169019703968;
    msg.z = 0.461054739443;
    msg.phi = 0.0675198701386;
    msg.theta = 0.107088553827;
    msg.psi = 0.344404819486;
    msg.u = 0.505636828952;
    msg.v = 0.0276535214328;
    msg.w = 0.489847323074;
    msg.vx = 0.15394079873;
    msg.vy = 0.254865503524;
    msg.vz = 0.101317286964;
    msg.p = 0.975256735443;
    msg.q = 0.0421683053182;
    msg.r = 0.390471680102;
    msg.depth = 0.688399978076;
    msg.alt = 0.633002227822;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EstimatedState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EstimatedStreamVelocity msg;
    msg.setTimeStamp(0.0978249998053);
    msg.setSource(48180U);
    msg.setSourceEntity(137U);
    msg.setDestination(63190U);
    msg.setDestinationEntity(152U);
    msg.x = 0.863928799178;
    msg.y = 0.691076537178;
    msg.z = 0.552232506219;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EstimatedStreamVelocity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EstimatedStreamVelocity msg;
    msg.setTimeStamp(0.0160018112266);
    msg.setSource(65036U);
    msg.setSourceEntity(131U);
    msg.setDestination(10777U);
    msg.setDestinationEntity(109U);
    msg.x = 0.379937844345;
    msg.y = 0.973839109647;
    msg.z = 0.023013140963;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EstimatedStreamVelocity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EstimatedStreamVelocity msg;
    msg.setTimeStamp(0.697945885794);
    msg.setSource(45552U);
    msg.setSourceEntity(130U);
    msg.setDestination(11218U);
    msg.setDestinationEntity(114U);
    msg.x = 0.174085526247;
    msg.y = 0.0874925681639;
    msg.z = 0.760205319818;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EstimatedStreamVelocity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IndicatedSpeed msg;
    msg.setTimeStamp(0.577580484122);
    msg.setSource(47648U);
    msg.setSourceEntity(105U);
    msg.setDestination(56513U);
    msg.setDestinationEntity(34U);
    msg.value = 0.760063032931;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IndicatedSpeed #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IndicatedSpeed msg;
    msg.setTimeStamp(0.845288966319);
    msg.setSource(23804U);
    msg.setSourceEntity(99U);
    msg.setDestination(31437U);
    msg.setDestinationEntity(0U);
    msg.value = 0.26334081442;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IndicatedSpeed #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IndicatedSpeed msg;
    msg.setTimeStamp(0.480724395985);
    msg.setSource(49930U);
    msg.setSourceEntity(47U);
    msg.setDestination(25192U);
    msg.setDestinationEntity(22U);
    msg.value = 0.960959051743;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IndicatedSpeed #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrueSpeed msg;
    msg.setTimeStamp(0.235592558295);
    msg.setSource(55574U);
    msg.setSourceEntity(82U);
    msg.setDestination(19140U);
    msg.setDestinationEntity(71U);
    msg.value = 0.260804150521;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrueSpeed #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrueSpeed msg;
    msg.setTimeStamp(0.860331099231);
    msg.setSource(5535U);
    msg.setSourceEntity(240U);
    msg.setDestination(60178U);
    msg.setDestinationEntity(159U);
    msg.value = 0.292816047792;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrueSpeed #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrueSpeed msg;
    msg.setTimeStamp(0.639453852061);
    msg.setSource(6365U);
    msg.setSourceEntity(50U);
    msg.setDestination(51588U);
    msg.setDestinationEntity(147U);
    msg.value = 0.834174887399;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrueSpeed #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NavigationUncertainty msg;
    msg.setTimeStamp(0.930046090003);
    msg.setSource(23847U);
    msg.setSourceEntity(46U);
    msg.setDestination(39388U);
    msg.setDestinationEntity(207U);
    msg.x = 0.157607669165;
    msg.y = 0.818832838185;
    msg.z = 0.780080069732;
    msg.phi = 0.664194221061;
    msg.theta = 0.321625918608;
    msg.psi = 0.799861401064;
    msg.p = 0.649329151834;
    msg.q = 0.808343321678;
    msg.r = 0.569814471709;
    msg.u = 0.11477872024;
    msg.v = 0.88955706309;
    msg.w = 0.428771517603;
    msg.bias_psi = 0.659051575067;
    msg.bias_r = 0.718442917561;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NavigationUncertainty #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NavigationUncertainty msg;
    msg.setTimeStamp(0.0521442109255);
    msg.setSource(45715U);
    msg.setSourceEntity(148U);
    msg.setDestination(19285U);
    msg.setDestinationEntity(129U);
    msg.x = 0.603478085592;
    msg.y = 0.0124078320519;
    msg.z = 0.31788675493;
    msg.phi = 0.585603795192;
    msg.theta = 0.944996318285;
    msg.psi = 0.196958453877;
    msg.p = 0.339297276584;
    msg.q = 0.935707768863;
    msg.r = 0.539708487883;
    msg.u = 0.568346834641;
    msg.v = 0.341230017056;
    msg.w = 0.532259827905;
    msg.bias_psi = 0.405433278737;
    msg.bias_r = 0.52779676667;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NavigationUncertainty #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NavigationUncertainty msg;
    msg.setTimeStamp(0.880107187969);
    msg.setSource(22789U);
    msg.setSourceEntity(217U);
    msg.setDestination(6266U);
    msg.setDestinationEntity(169U);
    msg.x = 0.602088474015;
    msg.y = 0.322401428475;
    msg.z = 0.216880850137;
    msg.phi = 0.823789606308;
    msg.theta = 0.98073431873;
    msg.psi = 0.694991580097;
    msg.p = 0.750991971632;
    msg.q = 0.478599503279;
    msg.r = 0.760223944331;
    msg.u = 0.94291817416;
    msg.v = 0.941411528754;
    msg.w = 0.458520479889;
    msg.bias_psi = 0.916580189297;
    msg.bias_r = 0.446450489538;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NavigationUncertainty #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NavigationData msg;
    msg.setTimeStamp(0.421509826923);
    msg.setSource(27196U);
    msg.setSourceEntity(120U);
    msg.setDestination(27711U);
    msg.setDestinationEntity(116U);
    msg.bias_psi = 0.483902565691;
    msg.bias_r = 0.965622223432;
    msg.cog = 0.946359927188;
    msg.cyaw = 0.327961460811;
    msg.lbl_rej_level = 0.585455401967;
    msg.gps_rej_level = 0.0412837300499;
    msg.custom_x = 0.0641656729036;
    msg.custom_y = 0.0198406124091;
    msg.custom_z = 0.543700023767;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NavigationData #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NavigationData msg;
    msg.setTimeStamp(0.578908889346);
    msg.setSource(3685U);
    msg.setSourceEntity(109U);
    msg.setDestination(62653U);
    msg.setDestinationEntity(24U);
    msg.bias_psi = 0.833032035698;
    msg.bias_r = 0.696431400875;
    msg.cog = 0.692305845917;
    msg.cyaw = 0.630113473394;
    msg.lbl_rej_level = 0.409671084986;
    msg.gps_rej_level = 0.201365714336;
    msg.custom_x = 0.26602250054;
    msg.custom_y = 0.792597972652;
    msg.custom_z = 0.252143046518;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NavigationData #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NavigationData msg;
    msg.setTimeStamp(0.746322628373);
    msg.setSource(60412U);
    msg.setSourceEntity(134U);
    msg.setDestination(47529U);
    msg.setDestinationEntity(238U);
    msg.bias_psi = 0.54874305255;
    msg.bias_r = 0.423686621084;
    msg.cog = 0.021880674243;
    msg.cyaw = 0.418362942636;
    msg.lbl_rej_level = 0.950255134473;
    msg.gps_rej_level = 0.649468044003;
    msg.custom_x = 0.68931236054;
    msg.custom_y = 0.0577192114546;
    msg.custom_z = 0.747997104366;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NavigationData #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsFixRejection msg;
    msg.setTimeStamp(0.75348222571);
    msg.setSource(41154U);
    msg.setSourceEntity(55U);
    msg.setDestination(21618U);
    msg.setDestinationEntity(188U);
    msg.utc_time = 0.939026889884;
    msg.reason = 129U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsFixRejection #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsFixRejection msg;
    msg.setTimeStamp(0.941369898373);
    msg.setSource(32690U);
    msg.setSourceEntity(59U);
    msg.setDestination(33369U);
    msg.setDestinationEntity(192U);
    msg.utc_time = 0.818697934173;
    msg.reason = 32U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsFixRejection #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GpsFixRejection msg;
    msg.setTimeStamp(0.163910047674);
    msg.setSource(57439U);
    msg.setSourceEntity(38U);
    msg.setDestination(50751U);
    msg.setDestinationEntity(243U);
    msg.utc_time = 0.186982770934;
    msg.reason = 147U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GpsFixRejection #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblRangeAcceptance msg;
    msg.setTimeStamp(0.129431332762);
    msg.setSource(61260U);
    msg.setSourceEntity(10U);
    msg.setDestination(17035U);
    msg.setDestinationEntity(103U);
    msg.id = 87U;
    msg.range = 0.0376149769284;
    msg.acceptance = 210U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblRangeAcceptance #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblRangeAcceptance msg;
    msg.setTimeStamp(0.605209894553);
    msg.setSource(51148U);
    msg.setSourceEntity(194U);
    msg.setDestination(54748U);
    msg.setDestinationEntity(52U);
    msg.id = 245U;
    msg.range = 0.129887157067;
    msg.acceptance = 130U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblRangeAcceptance #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblRangeAcceptance msg;
    msg.setTimeStamp(0.515836147015);
    msg.setSource(34361U);
    msg.setSourceEntity(208U);
    msg.setDestination(30954U);
    msg.setDestinationEntity(177U);
    msg.id = 28U;
    msg.range = 0.571693050244;
    msg.acceptance = 124U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblRangeAcceptance #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DvlRejection msg;
    msg.setTimeStamp(0.560179682793);
    msg.setSource(16581U);
    msg.setSourceEntity(214U);
    msg.setDestination(4026U);
    msg.setDestinationEntity(38U);
    msg.type = 142U;
    msg.reason = 103U;
    msg.value = 0.696475886292;
    msg.timestep = 0.907278706649;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DvlRejection #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DvlRejection msg;
    msg.setTimeStamp(0.96980190976);
    msg.setSource(64227U);
    msg.setSourceEntity(31U);
    msg.setDestination(58291U);
    msg.setDestinationEntity(135U);
    msg.type = 202U;
    msg.reason = 26U;
    msg.value = 0.616511641029;
    msg.timestep = 0.464374974824;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DvlRejection #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DvlRejection msg;
    msg.setTimeStamp(0.815297095313);
    msg.setSource(30535U);
    msg.setSourceEntity(233U);
    msg.setDestination(25370U);
    msg.setDestinationEntity(200U);
    msg.type = 214U;
    msg.reason = 114U;
    msg.value = 0.0908662728025;
    msg.timestep = 0.740150215218;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DvlRejection #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblEstimate msg;
    msg.setTimeStamp(0.22091508458);
    msg.setSource(27614U);
    msg.setSourceEntity(152U);
    msg.setDestination(11229U);
    msg.setDestinationEntity(136U);
    IMC::LblBeacon tmp_msg_0;
    tmp_msg_0.beacon.assign("YTWRMZSLIMIKCKOLAFZKJSZTCBRFHAPPNDKVQJBUQSLTDTKDNMCFHNCHVMIPJDWPJRSTEBZRGTOXCAOFCOLQXXGRGFLDEOBORJJICSQIMNXPYJMBHCIWPUVKOSIVAMNGLHSZYNWXHKUNHFYHGXWJDYSTNGRQAOUVAOKLEUBLYZAPPWQI");
    tmp_msg_0.lat = 0.342056808276;
    tmp_msg_0.lon = 0.445383820503;
    tmp_msg_0.depth = 0.351643358374;
    tmp_msg_0.query_channel = 35U;
    tmp_msg_0.reply_channel = 98U;
    tmp_msg_0.transponder_delay = 34U;
    msg.beacon.set(tmp_msg_0);
    msg.x = 0.308285240083;
    msg.y = 0.506262645905;
    msg.var_x = 0.98310317435;
    msg.var_y = 0.845815538451;
    msg.distance = 0.57080135358;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblEstimate #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblEstimate msg;
    msg.setTimeStamp(0.251548916142);
    msg.setSource(9844U);
    msg.setSourceEntity(139U);
    msg.setDestination(58425U);
    msg.setDestinationEntity(54U);
    IMC::LblBeacon tmp_msg_0;
    tmp_msg_0.beacon.assign("IUTCOBNKBYAVUXCVJQDKNPHNSVYTZFYSNARSZZVXRUWTMWQHQUYAROUYWOXHMBEHOTPTNMWGPTASYJAMPXZBGGXGSPBTZDPIQCV");
    tmp_msg_0.lat = 0.697909800072;
    tmp_msg_0.lon = 0.872943499903;
    tmp_msg_0.depth = 0.339578652251;
    tmp_msg_0.query_channel = 33U;
    tmp_msg_0.reply_channel = 179U;
    tmp_msg_0.transponder_delay = 76U;
    msg.beacon.set(tmp_msg_0);
    msg.x = 0.537968287411;
    msg.y = 0.24703030179;
    msg.var_x = 0.0493552574053;
    msg.var_y = 0.954011336232;
    msg.distance = 0.39069391467;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblEstimate #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LblEstimate msg;
    msg.setTimeStamp(0.776739141395);
    msg.setSource(19803U);
    msg.setSourceEntity(165U);
    msg.setDestination(43668U);
    msg.setDestinationEntity(214U);
    IMC::LblBeacon tmp_msg_0;
    tmp_msg_0.beacon.assign("DFGYKIVVGGMKAXIPUFYTTDZPGKSSQUBRJAGABJHXWYNTBNVYHKKHPMROTBBLZOZERCUDWBQZGLCBQJXENXUFIGYBQ");
    tmp_msg_0.lat = 0.355191072686;
    tmp_msg_0.lon = 0.466891875679;
    tmp_msg_0.depth = 0.798783816419;
    tmp_msg_0.query_channel = 111U;
    tmp_msg_0.reply_channel = 151U;
    tmp_msg_0.transponder_delay = 169U;
    msg.beacon.set(tmp_msg_0);
    msg.x = 0.606490437768;
    msg.y = 0.756760480533;
    msg.var_x = 0.808116319699;
    msg.var_y = 0.442658950587;
    msg.distance = 0.35474605471;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LblEstimate #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AlignmentState msg;
    msg.setTimeStamp(0.692046195806);
    msg.setSource(23458U);
    msg.setSourceEntity(79U);
    msg.setDestination(18681U);
    msg.setDestinationEntity(116U);
    msg.state = 9U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AlignmentState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AlignmentState msg;
    msg.setTimeStamp(0.0375087234269);
    msg.setSource(20892U);
    msg.setSourceEntity(174U);
    msg.setDestination(2972U);
    msg.setDestinationEntity(47U);
    msg.state = 173U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AlignmentState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AlignmentState msg;
    msg.setTimeStamp(0.804835760541);
    msg.setSource(57822U);
    msg.setSourceEntity(153U);
    msg.setDestination(55869U);
    msg.setDestinationEntity(129U);
    msg.state = 151U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AlignmentState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroupStreamVelocity msg;
    msg.setTimeStamp(0.0149237726294);
    msg.setSource(62961U);
    msg.setSourceEntity(49U);
    msg.setDestination(42788U);
    msg.setDestinationEntity(118U);
    msg.x = 0.388594647456;
    msg.y = 0.00966496992673;
    msg.z = 0.389513322529;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroupStreamVelocity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroupStreamVelocity msg;
    msg.setTimeStamp(0.418036440527);
    msg.setSource(44956U);
    msg.setSourceEntity(209U);
    msg.setDestination(3460U);
    msg.setDestinationEntity(70U);
    msg.x = 0.0307769423183;
    msg.y = 0.778696129884;
    msg.z = 0.799252973566;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroupStreamVelocity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GroupStreamVelocity msg;
    msg.setTimeStamp(0.651832251278);
    msg.setSource(13486U);
    msg.setSourceEntity(34U);
    msg.setDestination(16558U);
    msg.setDestinationEntity(76U);
    msg.x = 0.000176612517521;
    msg.y = 0.712548968426;
    msg.z = 0.827546585566;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GroupStreamVelocity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredHeading msg;
    msg.setTimeStamp(0.0338643373311);
    msg.setSource(4142U);
    msg.setSourceEntity(245U);
    msg.setDestination(30192U);
    msg.setDestinationEntity(45U);
    msg.value = 0.563435045672;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredHeading #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredHeading msg;
    msg.setTimeStamp(0.377014493864);
    msg.setSource(39938U);
    msg.setSourceEntity(141U);
    msg.setDestination(29403U);
    msg.setDestinationEntity(16U);
    msg.value = 0.892161355445;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredHeading #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredHeading msg;
    msg.setTimeStamp(0.13700326132);
    msg.setSource(24854U);
    msg.setSourceEntity(209U);
    msg.setDestination(16859U);
    msg.setDestinationEntity(7U);
    msg.value = 0.968463314332;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredHeading #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredZ msg;
    msg.setTimeStamp(0.809104974116);
    msg.setSource(55724U);
    msg.setSourceEntity(223U);
    msg.setDestination(47121U);
    msg.setDestinationEntity(233U);
    msg.value = 0.695928736046;
    msg.z_units = 54U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredZ #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredZ msg;
    msg.setTimeStamp(0.889933825722);
    msg.setSource(61164U);
    msg.setSourceEntity(60U);
    msg.setDestination(35885U);
    msg.setDestinationEntity(22U);
    msg.value = 0.457742711403;
    msg.z_units = 135U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredZ #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredZ msg;
    msg.setTimeStamp(0.712840366966);
    msg.setSource(43434U);
    msg.setSourceEntity(161U);
    msg.setDestination(53635U);
    msg.setDestinationEntity(248U);
    msg.value = 0.934270238786;
    msg.z_units = 112U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredZ #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredSpeed msg;
    msg.setTimeStamp(0.0044828252843);
    msg.setSource(38844U);
    msg.setSourceEntity(220U);
    msg.setDestination(57082U);
    msg.setDestinationEntity(72U);
    msg.value = 0.484567594149;
    msg.speed_units = 177U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredSpeed #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredSpeed msg;
    msg.setTimeStamp(0.750671073314);
    msg.setSource(20593U);
    msg.setSourceEntity(7U);
    msg.setDestination(38010U);
    msg.setDestinationEntity(139U);
    msg.value = 0.345327398286;
    msg.speed_units = 73U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredSpeed #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredSpeed msg;
    msg.setTimeStamp(0.272250922403);
    msg.setSource(28670U);
    msg.setSourceEntity(32U);
    msg.setDestination(57534U);
    msg.setDestinationEntity(224U);
    msg.value = 0.575438780984;
    msg.speed_units = 236U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredSpeed #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredRoll msg;
    msg.setTimeStamp(0.712510667472);
    msg.setSource(21374U);
    msg.setSourceEntity(73U);
    msg.setDestination(31589U);
    msg.setDestinationEntity(12U);
    msg.value = 0.259458421381;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredRoll #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredRoll msg;
    msg.setTimeStamp(0.471960537432);
    msg.setSource(55511U);
    msg.setSourceEntity(247U);
    msg.setDestination(64161U);
    msg.setDestinationEntity(178U);
    msg.value = 0.799827670695;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredRoll #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredRoll msg;
    msg.setTimeStamp(0.81301693826);
    msg.setSource(29362U);
    msg.setSourceEntity(48U);
    msg.setDestination(51714U);
    msg.setDestinationEntity(16U);
    msg.value = 0.768365359243;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredRoll #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredPitch msg;
    msg.setTimeStamp(0.515238039784);
    msg.setSource(37796U);
    msg.setSourceEntity(228U);
    msg.setDestination(56619U);
    msg.setDestinationEntity(229U);
    msg.value = 0.41268946316;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredPitch #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredPitch msg;
    msg.setTimeStamp(0.823389922973);
    msg.setSource(63646U);
    msg.setSourceEntity(137U);
    msg.setDestination(54954U);
    msg.setDestinationEntity(25U);
    msg.value = 0.152740536235;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredPitch #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredPitch msg;
    msg.setTimeStamp(0.782517977861);
    msg.setSource(14584U);
    msg.setSourceEntity(16U);
    msg.setDestination(15876U);
    msg.setDestinationEntity(64U);
    msg.value = 0.503163297807;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredPitch #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredVerticalRate msg;
    msg.setTimeStamp(0.765576880021);
    msg.setSource(29361U);
    msg.setSourceEntity(45U);
    msg.setDestination(5744U);
    msg.setDestinationEntity(63U);
    msg.value = 0.0028353083331;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredVerticalRate #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredVerticalRate msg;
    msg.setTimeStamp(0.422810644192);
    msg.setSource(57688U);
    msg.setSourceEntity(194U);
    msg.setDestination(25212U);
    msg.setDestinationEntity(33U);
    msg.value = 0.690554900276;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredVerticalRate #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredVerticalRate msg;
    msg.setTimeStamp(0.709964027589);
    msg.setSource(37545U);
    msg.setSourceEntity(49U);
    msg.setDestination(8763U);
    msg.setDestinationEntity(209U);
    msg.value = 0.954291751891;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredVerticalRate #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredPath msg;
    msg.setTimeStamp(0.624298654886);
    msg.setSource(19476U);
    msg.setSourceEntity(134U);
    msg.setDestination(62345U);
    msg.setDestinationEntity(179U);
    msg.path_ref = 1616544415U;
    msg.start_lat = 0.332584513724;
    msg.start_lon = 0.646306407647;
    msg.start_z = 0.796415081594;
    msg.start_z_units = 123U;
    msg.end_lat = 0.376750480787;
    msg.end_lon = 0.745653438747;
    msg.end_z = 0.337581108045;
    msg.end_z_units = 52U;
    msg.speed = 0.784926316;
    msg.speed_units = 237U;
    msg.lradius = 0.486289001558;
    msg.flags = 113U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredPath #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredPath msg;
    msg.setTimeStamp(0.58276241566);
    msg.setSource(20670U);
    msg.setSourceEntity(137U);
    msg.setDestination(32303U);
    msg.setDestinationEntity(200U);
    msg.path_ref = 1211263424U;
    msg.start_lat = 0.860561194818;
    msg.start_lon = 0.493071330464;
    msg.start_z = 0.399936322579;
    msg.start_z_units = 11U;
    msg.end_lat = 0.748910850072;
    msg.end_lon = 0.16124328938;
    msg.end_z = 0.435561090216;
    msg.end_z_units = 57U;
    msg.speed = 0.381123023143;
    msg.speed_units = 231U;
    msg.lradius = 0.459949627787;
    msg.flags = 9U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredPath #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredPath msg;
    msg.setTimeStamp(0.337362059495);
    msg.setSource(20140U);
    msg.setSourceEntity(227U);
    msg.setDestination(6782U);
    msg.setDestinationEntity(61U);
    msg.path_ref = 2136252889U;
    msg.start_lat = 0.600889311127;
    msg.start_lon = 0.67203473909;
    msg.start_z = 0.803217741844;
    msg.start_z_units = 227U;
    msg.end_lat = 0.391973822944;
    msg.end_lon = 0.915962689312;
    msg.end_z = 0.762872298851;
    msg.end_z_units = 64U;
    msg.speed = 0.506283961418;
    msg.speed_units = 195U;
    msg.lradius = 0.951599449966;
    msg.flags = 240U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredPath #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredControl msg;
    msg.setTimeStamp(0.839432243697);
    msg.setSource(8879U);
    msg.setSourceEntity(125U);
    msg.setDestination(36326U);
    msg.setDestinationEntity(217U);
    msg.x = 0.408449272121;
    msg.y = 0.53660758526;
    msg.z = 0.996034321495;
    msg.k = 0.254213292626;
    msg.m = 0.308881893377;
    msg.n = 0.515549474035;
    msg.flags = 137U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredControl msg;
    msg.setTimeStamp(0.180104686506);
    msg.setSource(24711U);
    msg.setSourceEntity(212U);
    msg.setDestination(49902U);
    msg.setDestinationEntity(200U);
    msg.x = 0.038949895494;
    msg.y = 0.276395176686;
    msg.z = 0.808071506898;
    msg.k = 0.818438250778;
    msg.m = 0.993840364916;
    msg.n = 0.510796566083;
    msg.flags = 139U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredControl msg;
    msg.setTimeStamp(0.612163944886);
    msg.setSource(11793U);
    msg.setSourceEntity(84U);
    msg.setDestination(10808U);
    msg.setDestinationEntity(213U);
    msg.x = 0.447384654341;
    msg.y = 0.736523426588;
    msg.z = 0.5020882272;
    msg.k = 0.382809529476;
    msg.m = 0.194724805655;
    msg.n = 0.879351713817;
    msg.flags = 247U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredHeadingRate msg;
    msg.setTimeStamp(0.420415518116);
    msg.setSource(34912U);
    msg.setSourceEntity(192U);
    msg.setDestination(60952U);
    msg.setDestinationEntity(165U);
    msg.value = 0.316157998406;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredHeadingRate #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredHeadingRate msg;
    msg.setTimeStamp(0.867016553739);
    msg.setSource(61257U);
    msg.setSourceEntity(220U);
    msg.setDestination(34516U);
    msg.setDestinationEntity(33U);
    msg.value = 0.396789446964;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredHeadingRate #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredHeadingRate msg;
    msg.setTimeStamp(0.60685100555);
    msg.setSource(33991U);
    msg.setSourceEntity(134U);
    msg.setDestination(45672U);
    msg.setDestinationEntity(40U);
    msg.value = 0.347120814564;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredHeadingRate #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredVelocity msg;
    msg.setTimeStamp(0.879319993467);
    msg.setSource(45186U);
    msg.setSourceEntity(85U);
    msg.setDestination(32816U);
    msg.setDestinationEntity(128U);
    msg.u = 0.0908192793464;
    msg.v = 0.594059957233;
    msg.w = 0.580986665548;
    msg.p = 0.131052600687;
    msg.q = 0.671789601084;
    msg.r = 0.815429484146;
    msg.flags = 124U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredVelocity #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredVelocity msg;
    msg.setTimeStamp(0.518442535021);
    msg.setSource(21674U);
    msg.setSourceEntity(8U);
    msg.setDestination(19552U);
    msg.setDestinationEntity(145U);
    msg.u = 0.576622427287;
    msg.v = 0.283653789924;
    msg.w = 0.190535565315;
    msg.p = 0.429554544677;
    msg.q = 0.0165136153436;
    msg.r = 0.792936827868;
    msg.flags = 206U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredVelocity #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::DesiredVelocity msg;
    msg.setTimeStamp(0.273014574576);
    msg.setSource(15064U);
    msg.setSourceEntity(68U);
    msg.setDestination(50527U);
    msg.setDestinationEntity(170U);
    msg.u = 0.920105600905;
    msg.v = 0.832677748621;
    msg.w = 0.60519410566;
    msg.p = 0.448147378762;
    msg.q = 0.804678989585;
    msg.r = 0.228321259064;
    msg.flags = 181U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("DesiredVelocity #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PathControlState msg;
    msg.setTimeStamp(0.989016128175);
    msg.setSource(14878U);
    msg.setSourceEntity(61U);
    msg.setDestination(59062U);
    msg.setDestinationEntity(185U);
    msg.path_ref = 1165371660U;
    msg.start_lat = 0.780203210395;
    msg.start_lon = 0.574209172492;
    msg.start_z = 0.887116788838;
    msg.start_z_units = 26U;
    msg.end_lat = 0.28019930772;
    msg.end_lon = 0.67110408428;
    msg.end_z = 0.820530333532;
    msg.end_z_units = 133U;
    msg.lradius = 0.271394842428;
    msg.flags = 131U;
    msg.x = 0.898720233936;
    msg.y = 0.0705114639273;
    msg.z = 0.260993905933;
    msg.vx = 0.292776316557;
    msg.vy = 0.0258608066572;
    msg.vz = 0.661156758218;
    msg.course_error = 0.777912494883;
    msg.eta = 40750U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PathControlState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PathControlState msg;
    msg.setTimeStamp(0.102057441669);
    msg.setSource(2310U);
    msg.setSourceEntity(15U);
    msg.setDestination(22216U);
    msg.setDestinationEntity(83U);
    msg.path_ref = 478827749U;
    msg.start_lat = 0.242728021396;
    msg.start_lon = 0.460751667885;
    msg.start_z = 0.548531663994;
    msg.start_z_units = 40U;
    msg.end_lat = 0.471687168999;
    msg.end_lon = 0.876846003239;
    msg.end_z = 0.833027777063;
    msg.end_z_units = 152U;
    msg.lradius = 0.244905530745;
    msg.flags = 55U;
    msg.x = 0.205307049406;
    msg.y = 0.417857406632;
    msg.z = 0.346129075288;
    msg.vx = 0.821310546205;
    msg.vy = 0.259192065379;
    msg.vz = 0.71988491212;
    msg.course_error = 0.256816961846;
    msg.eta = 14308U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PathControlState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PathControlState msg;
    msg.setTimeStamp(0.00628691129465);
    msg.setSource(47429U);
    msg.setSourceEntity(248U);
    msg.setDestination(41258U);
    msg.setDestinationEntity(60U);
    msg.path_ref = 1670751071U;
    msg.start_lat = 0.658909338655;
    msg.start_lon = 0.158948276969;
    msg.start_z = 0.0250801160267;
    msg.start_z_units = 27U;
    msg.end_lat = 0.381088400113;
    msg.end_lon = 0.895579248188;
    msg.end_z = 0.224904712075;
    msg.end_z_units = 156U;
    msg.lradius = 0.937588129263;
    msg.flags = 21U;
    msg.x = 0.598400682802;
    msg.y = 0.306079595893;
    msg.z = 0.355865815485;
    msg.vx = 0.11716469209;
    msg.vy = 0.104100325032;
    msg.vz = 0.28604861203;
    msg.course_error = 0.574713618998;
    msg.eta = 59289U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PathControlState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AllocatedControlTorques msg;
    msg.setTimeStamp(0.469423975912);
    msg.setSource(34531U);
    msg.setSourceEntity(79U);
    msg.setDestination(4030U);
    msg.setDestinationEntity(197U);
    msg.k = 0.557780871647;
    msg.m = 0.642853061113;
    msg.n = 0.00530554985207;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AllocatedControlTorques #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AllocatedControlTorques msg;
    msg.setTimeStamp(0.31009962484);
    msg.setSource(34555U);
    msg.setSourceEntity(204U);
    msg.setDestination(53742U);
    msg.setDestinationEntity(82U);
    msg.k = 0.644481990657;
    msg.m = 0.157353122076;
    msg.n = 0.394803238892;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AllocatedControlTorques #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AllocatedControlTorques msg;
    msg.setTimeStamp(0.712317143975);
    msg.setSource(6539U);
    msg.setSourceEntity(82U);
    msg.setDestination(11895U);
    msg.setDestinationEntity(155U);
    msg.k = 0.245010990531;
    msg.m = 0.899170621463;
    msg.n = 0.383920958666;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AllocatedControlTorques #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ControlParcel msg;
    msg.setTimeStamp(0.0235887048458);
    msg.setSource(46922U);
    msg.setSourceEntity(89U);
    msg.setDestination(59342U);
    msg.setDestinationEntity(66U);
    msg.p = 0.696940927466;
    msg.i = 0.53150752364;
    msg.d = 0.337301149188;
    msg.a = 0.993237361991;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ControlParcel #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ControlParcel msg;
    msg.setTimeStamp(0.586932288825);
    msg.setSource(59815U);
    msg.setSourceEntity(126U);
    msg.setDestination(16794U);
    msg.setDestinationEntity(32U);
    msg.p = 0.322712947989;
    msg.i = 0.669883357164;
    msg.d = 0.142816555709;
    msg.a = 0.464608753893;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ControlParcel #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ControlParcel msg;
    msg.setTimeStamp(0.00322478707393);
    msg.setSource(16304U);
    msg.setSourceEntity(42U);
    msg.setDestination(35170U);
    msg.setDestinationEntity(231U);
    msg.p = 0.980353632678;
    msg.i = 0.655900398229;
    msg.d = 0.294460185909;
    msg.a = 0.870183075851;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ControlParcel #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Brake msg;
    msg.setTimeStamp(0.915592793961);
    msg.setSource(32476U);
    msg.setSourceEntity(172U);
    msg.setDestination(4857U);
    msg.setDestinationEntity(16U);
    msg.op = 242U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Brake #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Brake msg;
    msg.setTimeStamp(0.796383311268);
    msg.setSource(12612U);
    msg.setSourceEntity(34U);
    msg.setDestination(26994U);
    msg.setDestinationEntity(30U);
    msg.op = 112U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Brake #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Brake msg;
    msg.setTimeStamp(0.247366280766);
    msg.setSource(61384U);
    msg.setSourceEntity(158U);
    msg.setDestination(15995U);
    msg.setDestinationEntity(198U);
    msg.op = 239U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Brake #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Goto msg;
    msg.setTimeStamp(0.169600366064);
    msg.setSource(195U);
    msg.setSourceEntity(193U);
    msg.setDestination(44301U);
    msg.setDestinationEntity(47U);
    msg.timeout = 28531U;
    msg.lat = 0.533475867127;
    msg.lon = 0.705249045183;
    msg.z = 0.904796307638;
    msg.z_units = 60U;
    msg.speed = 0.188034409925;
    msg.speed_units = 55U;
    msg.roll = 0.6237146989;
    msg.pitch = 0.596197675352;
    msg.yaw = 0.682708023644;
    msg.custom.assign("IZKXHQLVPPWSLCDZYSNMPOJRHEPBUEYTLIZVGXOYHRIJBOADGNRFWPTAUKWODXKELHINBYGCYQUAGCWQTWTMVICFOBQCSOCJAKFXTJKXRMEXDZNUUHDCAGWPBJTXBOANAVUKRLUPEWNOSSBOQZCQRLFFIOLZHSFHATJSKGHVYHMZYVLMVWUZDVNEYXIFKTAXEIDZJRSRMBNDMNWWFDBTZJIKUQQLFCMTYIMEGLPQJGNGJPS");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Goto #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Goto msg;
    msg.setTimeStamp(0.836146942427);
    msg.setSource(51705U);
    msg.setSourceEntity(64U);
    msg.setDestination(20199U);
    msg.setDestinationEntity(25U);
    msg.timeout = 27438U;
    msg.lat = 0.526975871525;
    msg.lon = 0.999263183126;
    msg.z = 0.975312227462;
    msg.z_units = 75U;
    msg.speed = 0.804034957085;
    msg.speed_units = 237U;
    msg.roll = 0.022091746563;
    msg.pitch = 0.486239787639;
    msg.yaw = 0.136905453431;
    msg.custom.assign("JMMXEMAZSXJXARBENSFQATMTUCLHHHLQULKYOPSEEOBZHDKBPIBTMKXAPXHLESVNWRTJYYUZDUVDKFCRCCHYISAWFYOJITPNSVGWTCHMWJCOYQBNOHZDSVUSXVVEALTQFDGMGFTJJMJCPGLIAGLXWUNOKHZNYVFQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Goto #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Goto msg;
    msg.setTimeStamp(0.408705833863);
    msg.setSource(55485U);
    msg.setSourceEntity(251U);
    msg.setDestination(52691U);
    msg.setDestinationEntity(175U);
    msg.timeout = 16929U;
    msg.lat = 0.66299761024;
    msg.lon = 0.872692190943;
    msg.z = 0.817536006681;
    msg.z_units = 36U;
    msg.speed = 0.677325226422;
    msg.speed_units = 224U;
    msg.roll = 0.885819294772;
    msg.pitch = 0.685617553604;
    msg.yaw = 0.909762906973;
    msg.custom.assign("WKOWZVOSIJFLVEMMFNCHZYDLYXBNRWLJHFASZDOYNDZKHQQPSIXRLNIYLRZCDUGQZVEQHVVWIRADTMXFEOSCYGSZNKKDLDRWPECBFZUFBPEOCISFGUJNOQOPELJPKAQWBUATTBRHJGABUJGLMTETTTPBGHCUXWHTKCNBYNZIXAUKBGXHVIFIYHJGWBOIMMSPJQAMFCXEZSMCQQXJEKXIQKDRPDE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Goto #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PopUp msg;
    msg.setTimeStamp(0.833241057106);
    msg.setSource(61815U);
    msg.setSourceEntity(49U);
    msg.setDestination(10655U);
    msg.setDestinationEntity(104U);
    msg.timeout = 11711U;
    msg.lat = 0.770093335109;
    msg.lon = 0.555950535245;
    msg.z = 0.564878860255;
    msg.z_units = 105U;
    msg.speed = 0.271202246911;
    msg.speed_units = 78U;
    msg.duration = 41596U;
    msg.radius = 0.622513816611;
    msg.flags = 226U;
    msg.custom.assign("KNSTSRQTDTKT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PopUp #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PopUp msg;
    msg.setTimeStamp(0.469831201646);
    msg.setSource(51951U);
    msg.setSourceEntity(161U);
    msg.setDestination(60160U);
    msg.setDestinationEntity(142U);
    msg.timeout = 32422U;
    msg.lat = 0.880480900364;
    msg.lon = 0.465481337345;
    msg.z = 0.301370145941;
    msg.z_units = 64U;
    msg.speed = 0.94932183119;
    msg.speed_units = 22U;
    msg.duration = 42118U;
    msg.radius = 0.265263118348;
    msg.flags = 153U;
    msg.custom.assign("ZSBRGHINWITCQXTOMQHECPABWNG");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PopUp #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PopUp msg;
    msg.setTimeStamp(0.352805702165);
    msg.setSource(22716U);
    msg.setSourceEntity(94U);
    msg.setDestination(37892U);
    msg.setDestinationEntity(104U);
    msg.timeout = 54127U;
    msg.lat = 0.21592919067;
    msg.lon = 0.037713252758;
    msg.z = 0.709451802525;
    msg.z_units = 207U;
    msg.speed = 0.237737289428;
    msg.speed_units = 233U;
    msg.duration = 35348U;
    msg.radius = 0.756152795702;
    msg.flags = 155U;
    msg.custom.assign("EKPPOGXAYPCYQAOXFMJUGVIZMKGZCEFSNEJBUIQQZMYXRORNIMLKWFEQSHCJCIOGOEFCFJPSNBQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PopUp #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Teleoperation msg;
    msg.setTimeStamp(0.641616044252);
    msg.setSource(40412U);
    msg.setSourceEntity(36U);
    msg.setDestination(39438U);
    msg.setDestinationEntity(121U);
    msg.custom.assign("LDUYFRADKEZJDEQNSJVCCLUVPYHGAWIPIFKEBFSBPCGHWVPWDOKLDMSNLZUSRXMPEBYKALSGQZJCMQHXXIPZRFSXZFHBNQNPPQFEKGSZSNCXGRGIQMYTOMUTEULMXOEQVETWVVJNLMRLATMTAUWJJRXGDEYOCYVSDTAIMRVVWMIQFUXYCFJATZOGBOVPNTLBIBINJYFKBPIIHKGHYKHUZOUTWKNAEJUZXRSCBFYBOADCRQCRWWQKD");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Teleoperation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Teleoperation msg;
    msg.setTimeStamp(0.748886938997);
    msg.setSource(28620U);
    msg.setSourceEntity(65U);
    msg.setDestination(60094U);
    msg.setDestinationEntity(246U);
    msg.custom.assign("RSNABJXHKYYLZYUQSSPDQNVHMRTYPKOCXDDXCJFEEMEAIOKOVIQYDYELDAEBFWTHDMTFKGXUZELIARGFICZUWMTEOJUXPRVXCWVQDYWLUPTUUPSMGETVJODNBWALQOTVGWJJFGPZQRJBJBTHLROQNCHAIZTJUDASYNPDVNIWZWUBGRHHPBKHBRVIHXERACKFFQOLGPYZAMGVUYLZGXZSMNFFIXKQLAKMWFMTVQOROCNPSGSCIXEBJCKCIZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Teleoperation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Teleoperation msg;
    msg.setTimeStamp(0.284472775228);
    msg.setSource(30955U);
    msg.setSourceEntity(103U);
    msg.setDestination(22605U);
    msg.setDestinationEntity(95U);
    msg.custom.assign("FCBAVGWRRLYDNDEMOYVPSQPHQFPCMJVFOAVSMYYCFACYLKGXRNBGLDKWAPHSQWUKSUJLGTPBRXRDYTJDHIAPBJKQBLIAMMOHENFVUHNLGCYUVSBIIOJOJWORQXQRLNKKZTRXCKEG");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Teleoperation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Loiter msg;
    msg.setTimeStamp(0.518499568562);
    msg.setSource(60017U);
    msg.setSourceEntity(143U);
    msg.setDestination(38327U);
    msg.setDestinationEntity(154U);
    msg.timeout = 65519U;
    msg.lat = 0.232386704207;
    msg.lon = 0.576439845223;
    msg.z = 0.301302134277;
    msg.z_units = 58U;
    msg.duration = 2639U;
    msg.speed = 0.608982931166;
    msg.speed_units = 109U;
    msg.type = 198U;
    msg.radius = 0.00735475630226;
    msg.length = 0.410891920404;
    msg.bearing = 0.124869315694;
    msg.direction = 88U;
    msg.custom.assign("IQINJJNQKJIVPWOBTKGAEHLOUTBTVXPCUCDCKHURHVFVYZXDLXQBWZZLWAMCFDZTLRBLFSROUBYYPZTNNVQNPWQKWKDRGKFQTAMMXJYLWMXUHYSKRTIDAUIKVCHAMUCHJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Loiter #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Loiter msg;
    msg.setTimeStamp(0.0685714944082);
    msg.setSource(32964U);
    msg.setSourceEntity(249U);
    msg.setDestination(54548U);
    msg.setDestinationEntity(208U);
    msg.timeout = 12629U;
    msg.lat = 0.138471860533;
    msg.lon = 0.14921815055;
    msg.z = 0.526479777311;
    msg.z_units = 170U;
    msg.duration = 33279U;
    msg.speed = 0.0196010268858;
    msg.speed_units = 121U;
    msg.type = 152U;
    msg.radius = 0.285717871929;
    msg.length = 0.79740162452;
    msg.bearing = 0.24595676743;
    msg.direction = 191U;
    msg.custom.assign("ZLXHFEAUJQDXGQFDCBDCJQAEFGPDEGRHKVOZEFKYZVOFCOIGWTEUABCWKBEWJZLVVFDRJLCNSPBQHOIITFMYXMVBSTPDDVNQPURRKRZYKOSDQSEFHIWTJGWQUCKFZAGWNOWFI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Loiter #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Loiter msg;
    msg.setTimeStamp(0.864935953573);
    msg.setSource(47638U);
    msg.setSourceEntity(163U);
    msg.setDestination(61782U);
    msg.setDestinationEntity(184U);
    msg.timeout = 8719U;
    msg.lat = 0.725272284251;
    msg.lon = 0.639196450371;
    msg.z = 0.428997350167;
    msg.z_units = 52U;
    msg.duration = 989U;
    msg.speed = 0.562148606144;
    msg.speed_units = 212U;
    msg.type = 193U;
    msg.radius = 0.337736810644;
    msg.length = 0.0529907695705;
    msg.bearing = 0.8125559749;
    msg.direction = 227U;
    msg.custom.assign("JDZWPGQLYWGIYSLFEYMAPRAQNQNUKANGMPKODTRTUQLTENJHPKLZJBGYGPZKQLVNXJYEHGGRYNXSCIXNOUUIOODBUDOMWBSVCCOTQMXZDXUHIKXNMPASYXMDSYCVTWQSIFJCRVTCTKIOAZZGEUAQORUCJJFAZZBAOVHIFCHWDIBBRLHKCHUWMJAFLFHTDBPBVXCMWRRYHETEM");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Loiter #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IdleManeuver msg;
    msg.setTimeStamp(0.0901893319455);
    msg.setSource(63549U);
    msg.setSourceEntity(193U);
    msg.setDestination(47776U);
    msg.setDestinationEntity(63U);
    msg.duration = 21361U;
    msg.custom.assign("SATRXSBJXSGJLLWYONULCOZJOPGXYNBWVUKCXPDGUPAVYCWEPOEMYKNJTZWWMNXZVJSTHTFDIAQXNYONRMOCBBMVERMIQHQFDQVFEAIITODBERLQFIDJBYWGQIDAWJIHKKGZCIFTKZVZHWGPFRKIOXUXVRLQGASYDHCPOM");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IdleManeuver #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IdleManeuver msg;
    msg.setTimeStamp(0.618160891165);
    msg.setSource(37214U);
    msg.setSourceEntity(237U);
    msg.setDestination(45888U);
    msg.setDestinationEntity(123U);
    msg.duration = 46595U;
    msg.custom.assign("WFVZOBUHPZAIHKNHCFHEVAWSXXMYAFDYPQZMIWYJIPOYESBJLCCXF");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IdleManeuver #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IdleManeuver msg;
    msg.setTimeStamp(0.504041227843);
    msg.setSource(105U);
    msg.setSourceEntity(168U);
    msg.setDestination(44239U);
    msg.setDestinationEntity(196U);
    msg.duration = 36736U;
    msg.custom.assign("NKIHHZMPPULTXZWKIAVUCYCLEKROJOALPGZNUCDABSWCTYBTUKLVSYQBWTTNRKRAYRVTOCGJZDEYLKPTHEBCJXHROBGZUGVBZAGEMFVFQNLKTFKBMIDMQSSEISCKOQOBQEJIOXWODDLMDFTSDFPOIKMSWYJZQXUZGPQSIVHCJMXPAAJAFMAYRWZEUWTRNHYDPAISWFMBLVHLUXLGMPGNXSHYRHFGEHNXQVNRNUUVJWXNZXJRCBIFQGVCIJEFDE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IdleManeuver #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LowLevelControl msg;
    msg.setTimeStamp(0.751656015514);
    msg.setSource(7442U);
    msg.setSourceEntity(192U);
    msg.setDestination(30405U);
    msg.setDestinationEntity(39U);
    IMC::DesiredHeading tmp_msg_0;
    tmp_msg_0.value = 0.127825326466;
    msg.control.set(tmp_msg_0);
    msg.duration = 65164U;
    msg.custom.assign("WJGRTLCXUQHQESZOSUYNJQHRNOVPCXPDHDNJUNAQPRAKYYJHOQVKPLZPPCEFADXZEXAKPAWDRHKZKGTTYGSCPSTBKFXIBNDMNXMKFSFEQFSIGBUNTVRAIEEVFMZAMMQT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LowLevelControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LowLevelControl msg;
    msg.setTimeStamp(0.297288808754);
    msg.setSource(44175U);
    msg.setSourceEntity(135U);
    msg.setDestination(15398U);
    msg.setDestinationEntity(87U);
    IMC::DesiredPitch tmp_msg_0;
    tmp_msg_0.value = 0.300306590496;
    msg.control.set(tmp_msg_0);
    msg.duration = 53693U;
    msg.custom.assign("WSQVHAQGRMRKCECZHPVSGNDWKIUYRHJRPKZZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LowLevelControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LowLevelControl msg;
    msg.setTimeStamp(0.225053961894);
    msg.setSource(36154U);
    msg.setSourceEntity(80U);
    msg.setDestination(44201U);
    msg.setDestinationEntity(138U);
    IMC::DesiredSpeed tmp_msg_0;
    tmp_msg_0.value = 0.161949081637;
    tmp_msg_0.speed_units = 121U;
    msg.control.set(tmp_msg_0);
    msg.duration = 40859U;
    msg.custom.assign("SDMCAHOGTJXEBDDEIIYFEULDXCEYKWCZYTBWYBSIVEOEAYAHBLMFPICSQRYPFSQKRAELEXLVWKXRDGFTMTNDPJMZFPGPZOZBJIXRSIFQNSWKJOVUCKNCDZIIENMSBTGQZZSNFFQBMGVUOPLWTYLXNSYHWSOMXGRVQAXLHHNRQZZUAHHKUENVJZHN");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LowLevelControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Rows msg;
    msg.setTimeStamp(0.81180246321);
    msg.setSource(49362U);
    msg.setSourceEntity(121U);
    msg.setDestination(47050U);
    msg.setDestinationEntity(8U);
    msg.timeout = 35268U;
    msg.lat = 0.282616737422;
    msg.lon = 0.705684678797;
    msg.z = 0.868985465308;
    msg.z_units = 5U;
    msg.speed = 0.41580151069;
    msg.speed_units = 155U;
    msg.bearing = 0.593288981037;
    msg.cross_angle = 0.0921157072773;
    msg.width = 0.985753289993;
    msg.length = 0.690514798762;
    msg.hstep = 0.511450142866;
    msg.coff = 212U;
    msg.alternation = 182U;
    msg.flags = 3U;
    msg.custom.assign("OTNZCZWQDHXDLHWVZDEQBDQTFESRHBWFGFSBMWCAZIWUSSRHULSKNUIKCEOAYTMINVYMPRPLOCPOVBMKXNXKVZQYOYEJOTGWGBLVTCYHKGBBRJLWLSJHXVF");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Rows #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Rows msg;
    msg.setTimeStamp(0.659203762952);
    msg.setSource(5746U);
    msg.setSourceEntity(240U);
    msg.setDestination(54645U);
    msg.setDestinationEntity(235U);
    msg.timeout = 33576U;
    msg.lat = 0.590474553814;
    msg.lon = 0.00166778785722;
    msg.z = 0.595678343568;
    msg.z_units = 138U;
    msg.speed = 0.647061924812;
    msg.speed_units = 15U;
    msg.bearing = 0.0258628022221;
    msg.cross_angle = 0.843437441594;
    msg.width = 0.466393247985;
    msg.length = 0.962060879423;
    msg.hstep = 0.633050332341;
    msg.coff = 241U;
    msg.alternation = 76U;
    msg.flags = 187U;
    msg.custom.assign("ADIHFWTSKBSZRXHITFRSGEMXYGUVKELNPLPJZAOYNIVDPITJUALNQLRCWEEJACZZMOYCKDRCBSLHWUZQLWGCRQSTRJQECOHVIFATXUUTAUMQUFSVSAPTGMPHBROCPTHLGCJOYLDYNAIGQJLXEXBLXVZXYTHXXSGZDYUINEGKPBPFIDMVNPDZNWQMUWMIWYMJOUFRJBAZVCESRGEIVJAZNKBBWWNKMKQNRDJWHKOOOKSHYCHTFYBP");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Rows #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Rows msg;
    msg.setTimeStamp(0.743723077102);
    msg.setSource(10025U);
    msg.setSourceEntity(17U);
    msg.setDestination(30999U);
    msg.setDestinationEntity(222U);
    msg.timeout = 61616U;
    msg.lat = 0.0083235148982;
    msg.lon = 0.851222752835;
    msg.z = 0.166170239257;
    msg.z_units = 14U;
    msg.speed = 0.901010500209;
    msg.speed_units = 6U;
    msg.bearing = 0.138375654951;
    msg.cross_angle = 0.142476761659;
    msg.width = 0.947245902786;
    msg.length = 0.691975582464;
    msg.hstep = 0.864957358597;
    msg.coff = 235U;
    msg.alternation = 233U;
    msg.flags = 24U;
    msg.custom.assign("VINEUTEOBTEZOOGEVODOKWPZUKLCDCYLZQGNJNBFWUDXBRKRGCRPYHYXWYTQSEUKXJNZDDFTSTXQIQWICCEQDCUUUVUKMZAMHNJJFIGXBROWYSYVHVWNAEBGKGHAODAGZIINUEHFBXPVLT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Rows #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowPath msg;
    msg.setTimeStamp(0.570591159527);
    msg.setSource(65301U);
    msg.setSourceEntity(153U);
    msg.setDestination(43915U);
    msg.setDestinationEntity(31U);
    msg.timeout = 63791U;
    msg.lat = 0.237912436176;
    msg.lon = 0.967626225118;
    msg.z = 0.0946346068343;
    msg.z_units = 107U;
    msg.speed = 0.23164680836;
    msg.speed_units = 136U;
    msg.custom.assign("PXTHPIMVGSIVTODTWBOTUNQUUBYNEEIVCNFAPCNJKAZKVSZHJPKSWCMISIXQKPFZPODRZANCYRJVUCDGKMGEUMGGFMUOQRHKNXAZADPAMSNGOEBCWKFVWEBMFSICGWELLERARIVMCTVDQSSHRFMLPJYERKYYZQCGUBJOPDHOJFZRXABIVLNVHTJZOYMJKTCEAUXTPXQFJLWELLYWHZRNDRHYFLIWTKWNSQTYGQYGQLDZHADBXFXWULQBBJI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowPath #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowPath msg;
    msg.setTimeStamp(0.0968344125055);
    msg.setSource(16209U);
    msg.setSourceEntity(200U);
    msg.setDestination(30399U);
    msg.setDestinationEntity(32U);
    msg.timeout = 8469U;
    msg.lat = 0.00508885789744;
    msg.lon = 0.901959090184;
    msg.z = 0.510854532676;
    msg.z_units = 2U;
    msg.speed = 0.896703758338;
    msg.speed_units = 137U;
    IMC::PathPoint tmp_msg_0;
    tmp_msg_0.x = 0.523402938651;
    tmp_msg_0.y = 0.521179245602;
    tmp_msg_0.z = 0.71961260417;
    msg.points.push_back(tmp_msg_0);
    msg.custom.assign("EVEZSTARYJNYPQCTYEHYFKPKIPLVTFCQUWMRAJCNJBHZRUTMKKXUGUGJIXGZKTFBCWBTSXZIZFLQPYORAQOBRDJOJJNELZFDTDBKSSYSVLANMNHIWVVHBZXPSPYPXIP");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowPath #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowPath msg;
    msg.setTimeStamp(0.0532189228621);
    msg.setSource(43697U);
    msg.setSourceEntity(154U);
    msg.setDestination(55143U);
    msg.setDestinationEntity(214U);
    msg.timeout = 46593U;
    msg.lat = 0.940743901745;
    msg.lon = 0.747660966395;
    msg.z = 0.510037172052;
    msg.z_units = 208U;
    msg.speed = 0.137311672124;
    msg.speed_units = 134U;
    IMC::PathPoint tmp_msg_0;
    tmp_msg_0.x = 0.797171674766;
    tmp_msg_0.y = 0.165580855875;
    tmp_msg_0.z = 0.230181824508;
    msg.points.push_back(tmp_msg_0);
    msg.custom.assign("QJMVMGAZBVZEJMAOPQZDDTKYMROQBHLBJWTFXWPXBWKNYPLEMKLFVIPJSNADNWDMGQBITQSWUSAHILHDYZCYXDMA");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowPath #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PathPoint msg;
    msg.setTimeStamp(0.419881871698);
    msg.setSource(1446U);
    msg.setSourceEntity(121U);
    msg.setDestination(42791U);
    msg.setDestinationEntity(50U);
    msg.x = 0.869635751551;
    msg.y = 0.522520717848;
    msg.z = 0.0968630384958;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PathPoint #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PathPoint msg;
    msg.setTimeStamp(0.405122394861);
    msg.setSource(36173U);
    msg.setSourceEntity(229U);
    msg.setDestination(12859U);
    msg.setDestinationEntity(194U);
    msg.x = 0.713347312502;
    msg.y = 0.166863755722;
    msg.z = 0.108166011572;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PathPoint #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PathPoint msg;
    msg.setTimeStamp(0.645002129714);
    msg.setSource(29295U);
    msg.setSourceEntity(3U);
    msg.setDestination(56739U);
    msg.setDestinationEntity(168U);
    msg.x = 0.866772374205;
    msg.y = 0.452264867392;
    msg.z = 0.445042778796;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PathPoint #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::YoYo msg;
    msg.setTimeStamp(0.185549629166);
    msg.setSource(56995U);
    msg.setSourceEntity(122U);
    msg.setDestination(31650U);
    msg.setDestinationEntity(194U);
    msg.timeout = 7350U;
    msg.lat = 0.644456395236;
    msg.lon = 0.122069250886;
    msg.z = 0.951584978219;
    msg.z_units = 171U;
    msg.amplitude = 0.511101520953;
    msg.pitch = 0.790621723262;
    msg.speed = 0.704411837783;
    msg.speed_units = 131U;
    msg.custom.assign("HXMVNORJOJDRTXRGMPTDWOYAYKIAUFVUJKWNQQBJSRUFGWDWFQRDEHFLUAJVBPFTANYMPZBTHBMOYFIUKQYLHREKCUXYGJCLLMZWLHHSKDZODIRGIDPVEBYLYXRIMZSCNAGIPZVUTEKZJUPSQICNSCTALBSUAFFGGQHJXNAUHVSXAWDDTNESZOSEVTYNKDGCJLW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("YoYo #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::YoYo msg;
    msg.setTimeStamp(0.853049949976);
    msg.setSource(59463U);
    msg.setSourceEntity(71U);
    msg.setDestination(26823U);
    msg.setDestinationEntity(95U);
    msg.timeout = 63011U;
    msg.lat = 0.938455317118;
    msg.lon = 0.988306485343;
    msg.z = 0.356672077914;
    msg.z_units = 164U;
    msg.amplitude = 0.551569928054;
    msg.pitch = 0.417653007961;
    msg.speed = 0.361289202564;
    msg.speed_units = 202U;
    msg.custom.assign("IGOJBAJKQVPCHVYGSWFGSCWQNBLKZPHOKDVMDURKHNOMOPFIFTWWHURYKTFHAJQXEZQMZSFPJPVGYRWXRNEISTFNULLROWLDK");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("YoYo #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::YoYo msg;
    msg.setTimeStamp(0.263637765995);
    msg.setSource(44563U);
    msg.setSourceEntity(58U);
    msg.setDestination(36873U);
    msg.setDestinationEntity(198U);
    msg.timeout = 55764U;
    msg.lat = 0.420417628207;
    msg.lon = 0.841166240637;
    msg.z = 0.433928682748;
    msg.z_units = 130U;
    msg.amplitude = 0.747595662816;
    msg.pitch = 0.112049748706;
    msg.speed = 0.408383076425;
    msg.speed_units = 24U;
    msg.custom.assign("LIHBVEFECBFSDPHJOQCNWFANWAGGDDVYYSQNDCRITSQUULUBIZDHAZDGYIZUANRZHORKYHVWIKPOSWRPTN");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("YoYo #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TeleoperationDone msg;
    msg.setTimeStamp(0.277189291332);
    msg.setSource(33953U);
    msg.setSourceEntity(173U);
    msg.setDestination(8566U);
    msg.setDestinationEntity(26U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TeleoperationDone #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TeleoperationDone msg;
    msg.setTimeStamp(0.960191422654);
    msg.setSource(7865U);
    msg.setSourceEntity(32U);
    msg.setDestination(58868U);
    msg.setDestinationEntity(5U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TeleoperationDone #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TeleoperationDone msg;
    msg.setTimeStamp(0.862247034924);
    msg.setSource(1563U);
    msg.setSourceEntity(1U);
    msg.setDestination(63501U);
    msg.setDestinationEntity(164U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TeleoperationDone #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StationKeeping msg;
    msg.setTimeStamp(0.377467755601);
    msg.setSource(5445U);
    msg.setSourceEntity(149U);
    msg.setDestination(25075U);
    msg.setDestinationEntity(44U);
    msg.lat = 0.429845056722;
    msg.lon = 0.469933110854;
    msg.z = 0.669120822699;
    msg.z_units = 3U;
    msg.radius = 0.146786753701;
    msg.duration = 3656U;
    msg.speed = 0.699810913362;
    msg.speed_units = 33U;
    msg.custom.assign("OLFNGCZUXEWVZEAXFNZRQHSFNSPJIGSLTRAWDRIYLBRXWTFPRJMUIHQMTTZGQWIHGWVWVNDRMURSWOYYREHPBBWJUKVKUXFTCGKDJFQZMMHDLKZNOKXUQIDSQIFJSSXFYNYNUIEVTLCFGZZYPKDYJBAMRDACHT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StationKeeping #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StationKeeping msg;
    msg.setTimeStamp(0.806127323808);
    msg.setSource(58550U);
    msg.setSourceEntity(126U);
    msg.setDestination(12592U);
    msg.setDestinationEntity(172U);
    msg.lat = 0.284773440849;
    msg.lon = 0.990984592021;
    msg.z = 0.914178065223;
    msg.z_units = 134U;
    msg.radius = 0.882976744462;
    msg.duration = 49255U;
    msg.speed = 0.434280973492;
    msg.speed_units = 169U;
    msg.custom.assign("IOISDSKAYAVAVLSOMXAENKKYZMAYXIRCYOJVJFEHFLMQMNPECWCTRUYJWNZRSSOJQNTZCLIOISKGMUHOUQSQPHLNLRIYNSGWXELUFJBUDFBJRVLHTNKNGPDWBJGRLIIHPVBQDCWNEKAOQR");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StationKeeping #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StationKeeping msg;
    msg.setTimeStamp(0.891220398302);
    msg.setSource(31367U);
    msg.setSourceEntity(248U);
    msg.setDestination(59343U);
    msg.setDestinationEntity(167U);
    msg.lat = 0.793205411396;
    msg.lon = 0.723215982816;
    msg.z = 0.900708233266;
    msg.z_units = 245U;
    msg.radius = 0.468084134002;
    msg.duration = 65127U;
    msg.speed = 0.117174504801;
    msg.speed_units = 142U;
    msg.custom.assign("KHRRDMYFCWPETBMHCFZUCERCRUUVSQDGQIETYIMVNECJLTXANADHYYHYUUXKUHPPVKJQSQVDFJBEGCNTQZTOZWIBQUNADSIXOCISSUSZALREGTVGXGLRXQZVPKGBZLRLACXPWNXFGYNBZNYJMFIPPEBYOMTIVDFFMQDOVFEIHLTPT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StationKeeping #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Elevator msg;
    msg.setTimeStamp(0.503309607172);
    msg.setSource(48052U);
    msg.setSourceEntity(118U);
    msg.setDestination(63869U);
    msg.setDestinationEntity(6U);
    msg.timeout = 9678U;
    msg.flags = 197U;
    msg.lat = 0.485516452924;
    msg.lon = 0.060481653227;
    msg.start_z = 0.109345874154;
    msg.start_z_units = 72U;
    msg.end_z = 0.0229492155929;
    msg.end_z_units = 132U;
    msg.radius = 0.286912978788;
    msg.speed = 0.372347482659;
    msg.speed_units = 179U;
    msg.custom.assign("HVHDHJNOUNPJQZZLJPCISBLPQQNHORSQJVTOVZBACHNRRXKMZFMXKZMDSFIRGPKSMBYKQSXYWVZDRAUCXVKDUVFTEYXDNTSUCVNMIYCJDSFBOLCFKFYUQAOXOINWEUAZWVJPTCRRNIOJGTGWDFYJGHOHSEWQMVKBWARCLZWBGLXTKDBKWLZQPWEBTEULMSEIMGTCYGGXTJAINOLMHAPDYQEU");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Elevator #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Elevator msg;
    msg.setTimeStamp(0.860373105557);
    msg.setSource(3827U);
    msg.setSourceEntity(12U);
    msg.setDestination(58163U);
    msg.setDestinationEntity(165U);
    msg.timeout = 55914U;
    msg.flags = 232U;
    msg.lat = 0.9688889612;
    msg.lon = 0.594308037995;
    msg.start_z = 0.999838028966;
    msg.start_z_units = 142U;
    msg.end_z = 0.662525578014;
    msg.end_z_units = 225U;
    msg.radius = 0.626616369416;
    msg.speed = 0.994845460372;
    msg.speed_units = 52U;
    msg.custom.assign("ENLXITLWKLOMWUTCQITJIFEAOPJPWREYQZNHGKJVWTZPLBBHNRZXPPTIGBBEUFVUXYSVIUSRTADVEBLMLDSQWJLKQHGDMGOYPNYGAWQZNDCNRUISEUNOBMDQZSWSTWKMEXEMOKGJYPTVUNCRCJCXSHZOERGDCS");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Elevator #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Elevator msg;
    msg.setTimeStamp(0.4463035572);
    msg.setSource(3191U);
    msg.setSourceEntity(239U);
    msg.setDestination(22832U);
    msg.setDestinationEntity(47U);
    msg.timeout = 60146U;
    msg.flags = 151U;
    msg.lat = 0.296686823227;
    msg.lon = 0.845329119661;
    msg.start_z = 0.124271145965;
    msg.start_z_units = 71U;
    msg.end_z = 0.00753847753373;
    msg.end_z_units = 177U;
    msg.radius = 0.718744075413;
    msg.speed = 0.0843872228535;
    msg.speed_units = 45U;
    msg.custom.assign("FEKGLLBKNDCRPQGSDQWJUBEXDEPLVMSISTLRSQSXUXBJPMLAUTCNMYQAASDDNOFNJAFXIWOURSZZTUSROULWUAWPT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Elevator #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowTrajectory msg;
    msg.setTimeStamp(0.521128183998);
    msg.setSource(58360U);
    msg.setSourceEntity(74U);
    msg.setDestination(41244U);
    msg.setDestinationEntity(82U);
    msg.timeout = 27313U;
    msg.lat = 0.73655759927;
    msg.lon = 0.161440333858;
    msg.z = 0.483131926526;
    msg.z_units = 136U;
    msg.speed = 0.462213527854;
    msg.speed_units = 227U;
    msg.custom.assign("KOSEYAEUXXMPTNYKWBZGHPOCSYBGGNLLQNFEHUOBEIKNIBHGAISENNEWPCNYKCYKSJFIFQLUTRTRRZDZJVWXQLNVODWZAYSTLIZVZHAJMCGEFLHGRZQDJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowTrajectory #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowTrajectory msg;
    msg.setTimeStamp(0.792782808343);
    msg.setSource(9671U);
    msg.setSourceEntity(238U);
    msg.setDestination(25699U);
    msg.setDestinationEntity(151U);
    msg.timeout = 19588U;
    msg.lat = 0.206364383626;
    msg.lon = 0.93317563105;
    msg.z = 0.30939159632;
    msg.z_units = 185U;
    msg.speed = 0.980304312407;
    msg.speed_units = 198U;
    msg.custom.assign("AIOVFKEAEIGCBQMZFCYBNCTBSUFORDAVJDHSGLRXOJQFJGTMHUNESYSSLXZADNNYUXTSWOIKPHFWJSI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowTrajectory #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowTrajectory msg;
    msg.setTimeStamp(0.000994988725314);
    msg.setSource(27002U);
    msg.setSourceEntity(216U);
    msg.setDestination(57566U);
    msg.setDestinationEntity(247U);
    msg.timeout = 52596U;
    msg.lat = 0.376294723797;
    msg.lon = 0.178122033663;
    msg.z = 0.454588501014;
    msg.z_units = 69U;
    msg.speed = 0.824200387739;
    msg.speed_units = 79U;
    IMC::TrajectoryPoint tmp_msg_0;
    tmp_msg_0.x = 0.78728961999;
    tmp_msg_0.y = 0.38293278439;
    tmp_msg_0.z = 0.669896562123;
    tmp_msg_0.t = 0.490973866328;
    msg.points.push_back(tmp_msg_0);
    msg.custom.assign("UKPGGCOEFKBPMBIGDGJVNBUAVHJKBVTILWMMYCFUKJQBVOQNKSWLKTABULIEEZTHMYWJOCGJTGXANNVUFFEWXOZYWQFEAASKMWHQDPORMXGACIRDNEEKRQRRABHPHFQUYGYZNPOOXCHDLPUISVSSCLPYWYSCPTABDLDHOHNT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowTrajectory #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrajectoryPoint msg;
    msg.setTimeStamp(0.832465605627);
    msg.setSource(65204U);
    msg.setSourceEntity(113U);
    msg.setDestination(7265U);
    msg.setDestinationEntity(110U);
    msg.x = 0.779182627689;
    msg.y = 0.993291057115;
    msg.z = 0.313253257416;
    msg.t = 0.51056428893;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrajectoryPoint #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrajectoryPoint msg;
    msg.setTimeStamp(0.526537972098);
    msg.setSource(41911U);
    msg.setSourceEntity(31U);
    msg.setDestination(29060U);
    msg.setDestinationEntity(17U);
    msg.x = 0.905065988854;
    msg.y = 0.0888046913393;
    msg.z = 0.017267646504;
    msg.t = 0.670213025875;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrajectoryPoint #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrajectoryPoint msg;
    msg.setTimeStamp(0.692779671599);
    msg.setSource(47938U);
    msg.setSourceEntity(87U);
    msg.setDestination(40757U);
    msg.setDestinationEntity(136U);
    msg.x = 0.521344137026;
    msg.y = 0.789601575859;
    msg.z = 0.553748642218;
    msg.t = 0.770198278287;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrajectoryPoint #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CustomManeuver msg;
    msg.setTimeStamp(0.747592076677);
    msg.setSource(64702U);
    msg.setSourceEntity(199U);
    msg.setDestination(9107U);
    msg.setDestinationEntity(243U);
    msg.timeout = 59618U;
    msg.name.assign("NAJVBAUEEHMCXCSTFXZSMGWVKNNTGFQZWRYSQDWBFAFUTQDAZPBWEKAPCPZIFWCRYPFWMPELGLDJIYHZCLXJFMHEBRJRHAHLQGOKPLBWIMSQLCBTO");
    msg.custom.assign("FAEAKBSIMITUCAEQKGDXCJKMDIMUIWZKLVYTHOMCUHBJEJSNRJZZPYRDEDPUNFTLNJEAFZWRTOOTVNRZDOZZUVAMORUDPHUYSPHNTBQZYHRGVMTQCTTCBJBJGKMCKBUMUHFNOYDGXYESGJOACXHKF");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CustomManeuver #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CustomManeuver msg;
    msg.setTimeStamp(0.0614333660617);
    msg.setSource(13511U);
    msg.setSourceEntity(29U);
    msg.setDestination(15291U);
    msg.setDestinationEntity(53U);
    msg.timeout = 2217U;
    msg.name.assign("DFCTLNIEUZPKJGOFLAPOZELWUGIZSMHFBSFHEOGOWSTGOYPBDOSMLAGWEWVQWWRIJUHCVIQDQWASXJUANYEYTILK");
    msg.custom.assign("SOEJKQAUUKIEHMKLOFCRNJCXCGZVJSYLEWMBRITVRZDTFRHSKVBRPNCXLGTLKJDXONPWVYHFLJCQTJTXFTPMZQEJOMHODLVZFUDHMOLAANEETZMWKPJGGMURHSAWBYCDDQXGZQLVFMEZYXUFVVKEJWQQTGYXNBWPARWYMRCYGURBQDHAWIRPZFIBNDHOWHNANGBIB");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CustomManeuver #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CustomManeuver msg;
    msg.setTimeStamp(0.852355124994);
    msg.setSource(7707U);
    msg.setSourceEntity(107U);
    msg.setDestination(40165U);
    msg.setDestinationEntity(130U);
    msg.timeout = 53153U;
    msg.name.assign("SMMIPFJSPYFRILOMVRJYNPTGQHEPSQYYVCEBMKEPWNVIWMFLJJHPRWLGNKYXZTAEVZXQXYSLDQKLJRFRZGSRQOJDWFCIVYUXSUAGGCVZIBKDJCAQPKMKAYQABLDITKQRSKBDZVUZHVHBDTGHDWDWUITCCNGDTXCRHNGZYOXMUAGWUDXOUUOOOUAZLMFKEBNNPQXJWYCLWLIBOJMFHSBRBTWGATVIJXZFN");
    msg.custom.assign("UOKMODDKQVIYDGSOBARWUANUPJREAOZABFQSSKSIIIKJOYFUVJKLVJVUPVXHQNLHMDLNDTLRBQDIIRNDSUWLWWZXANZPWBLZSOMNAEMTCTGLGJYKPZSLPCRSHPNXGBGVVQMYMSQBJUQRTMI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CustomManeuver #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleFormation msg;
    msg.setTimeStamp(0.756707629193);
    msg.setSource(34707U);
    msg.setSourceEntity(43U);
    msg.setDestination(65097U);
    msg.setDestinationEntity(116U);
    msg.lat = 0.685228059983;
    msg.lon = 0.390933674643;
    msg.z = 0.898532243735;
    msg.z_units = 104U;
    msg.speed = 0.348513547972;
    msg.speed_units = 48U;
    msg.start_time = 0.811400858665;
    msg.custom.assign("DTYFVGETJANESEXQEFPSPJMOSYOUCYYTCRQHUVHAPVGEDVZXMNWIJEWAHGGHZASTWZMQKAEUUFRDINCFHSNQXZTYPPHBRPUJOUTKZYLABAXSLTDWGFBSXJFUFQMWSBDZXFKVBMZIUHEZSVNHKBWPKRBKGPMMGFLODCZJAEERLCCYVJCJVLOPXOGDHIIQNINNNWQYB");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleFormation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleFormation msg;
    msg.setTimeStamp(0.309453089733);
    msg.setSource(61549U);
    msg.setSourceEntity(163U);
    msg.setDestination(36720U);
    msg.setDestinationEntity(223U);
    msg.lat = 0.574726985586;
    msg.lon = 0.928512145614;
    msg.z = 0.15304751375;
    msg.z_units = 201U;
    msg.speed = 0.992224567311;
    msg.speed_units = 212U;
    IMC::TrajectoryPoint tmp_msg_0;
    tmp_msg_0.x = 0.439093130651;
    tmp_msg_0.y = 0.536550100337;
    tmp_msg_0.z = 0.791283222832;
    tmp_msg_0.t = 0.432089661774;
    msg.points.push_back(tmp_msg_0);
    IMC::VehicleFormationParticipant tmp_msg_1;
    tmp_msg_1.vid = 32062U;
    tmp_msg_1.off_x = 0.296303319733;
    tmp_msg_1.off_y = 0.990992977729;
    tmp_msg_1.off_z = 0.602735432913;
    msg.participants.push_back(tmp_msg_1);
    msg.start_time = 0.683469174255;
    msg.custom.assign("EKHAASUXXRXPYYRDXMJELZXWTTLEFHYIPNUDXATZDGNFZQTTBHCYFLVKGBPPRUGRLRWKQISIFUKFLEODCEJIVAOMSCVVQLZZQYCLSBYMPAOHTUJZLEVXVGFUREGAGBJMQCOEBSZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleFormation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleFormation msg;
    msg.setTimeStamp(0.259279286751);
    msg.setSource(41635U);
    msg.setSourceEntity(9U);
    msg.setDestination(42600U);
    msg.setDestinationEntity(111U);
    msg.lat = 0.0593485517124;
    msg.lon = 0.653950076508;
    msg.z = 0.85036961926;
    msg.z_units = 22U;
    msg.speed = 0.531545942085;
    msg.speed_units = 67U;
    IMC::TrajectoryPoint tmp_msg_0;
    tmp_msg_0.x = 0.407996867712;
    tmp_msg_0.y = 0.111993178399;
    tmp_msg_0.z = 0.282204748712;
    tmp_msg_0.t = 0.22558145121;
    msg.points.push_back(tmp_msg_0);
    IMC::VehicleFormationParticipant tmp_msg_1;
    tmp_msg_1.vid = 5372U;
    tmp_msg_1.off_x = 0.154846892984;
    tmp_msg_1.off_y = 0.964129496026;
    tmp_msg_1.off_z = 0.188216335544;
    msg.participants.push_back(tmp_msg_1);
    msg.start_time = 0.713784208701;
    msg.custom.assign("GCVSAWLLGEQZULECUZOJAMWQZXEHVTHYONRBFBHGEGJKAORTFLKQWEEORGUPEVDZBFNQGWQHZRNPSPHVRSJIFOAXPAIMBLFGAIKNWUIVWDCYDCXICRJWXDUSFSMLFODPITLPAIVDENCQONYABXUYOHRGXSMSHJAPDFCBHJDTIIKGMMQHVZOQUMBIYCUTPBJHSMLWYWOCVKZFYQNMAYSKSEPZMCXFPDNJNTLYVTNZUUVTKWXDTLKKQZRXRGKXYB");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleFormation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleFormationParticipant msg;
    msg.setTimeStamp(0.786820422528);
    msg.setSource(18509U);
    msg.setSourceEntity(61U);
    msg.setDestination(13462U);
    msg.setDestinationEntity(202U);
    msg.vid = 12089U;
    msg.off_x = 0.522508230999;
    msg.off_y = 0.110365043647;
    msg.off_z = 0.208249870963;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleFormationParticipant #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleFormationParticipant msg;
    msg.setTimeStamp(0.704786697551);
    msg.setSource(23683U);
    msg.setSourceEntity(237U);
    msg.setDestination(15419U);
    msg.setDestinationEntity(108U);
    msg.vid = 42706U;
    msg.off_x = 0.709520658535;
    msg.off_y = 0.742214830185;
    msg.off_z = 0.691322665599;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleFormationParticipant #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleFormationParticipant msg;
    msg.setTimeStamp(0.0515635611233);
    msg.setSource(17870U);
    msg.setSourceEntity(62U);
    msg.setDestination(57968U);
    msg.setDestinationEntity(5U);
    msg.vid = 9505U;
    msg.off_x = 0.384098751706;
    msg.off_y = 0.563514631843;
    msg.off_z = 0.139910997961;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleFormationParticipant #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StopManeuver msg;
    msg.setTimeStamp(0.539699057247);
    msg.setSource(28774U);
    msg.setSourceEntity(197U);
    msg.setDestination(16726U);
    msg.setDestinationEntity(36U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StopManeuver #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StopManeuver msg;
    msg.setTimeStamp(0.437720129703);
    msg.setSource(51307U);
    msg.setSourceEntity(82U);
    msg.setDestination(18099U);
    msg.setDestinationEntity(146U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StopManeuver #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::StopManeuver msg;
    msg.setTimeStamp(0.579246421975);
    msg.setSource(65382U);
    msg.setSourceEntity(128U);
    msg.setDestination(47994U);
    msg.setDestinationEntity(243U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("StopManeuver #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RegisterManeuver msg;
    msg.setTimeStamp(0.169488998965);
    msg.setSource(26333U);
    msg.setSourceEntity(204U);
    msg.setDestination(48120U);
    msg.setDestinationEntity(253U);
    msg.mid = 31943U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RegisterManeuver #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RegisterManeuver msg;
    msg.setTimeStamp(0.676974396198);
    msg.setSource(47082U);
    msg.setSourceEntity(31U);
    msg.setDestination(28998U);
    msg.setDestinationEntity(197U);
    msg.mid = 23053U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RegisterManeuver #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RegisterManeuver msg;
    msg.setTimeStamp(0.501821505177);
    msg.setSource(5467U);
    msg.setSourceEntity(47U);
    msg.setDestination(44387U);
    msg.setDestinationEntity(190U);
    msg.mid = 43856U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RegisterManeuver #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ManeuverControlState msg;
    msg.setTimeStamp(0.366800075695);
    msg.setSource(38245U);
    msg.setSourceEntity(252U);
    msg.setDestination(32744U);
    msg.setDestinationEntity(245U);
    msg.state = 6U;
    msg.eta = 36154U;
    msg.info.assign("PILACHSJEYUEUCPYRNXCZGXPQLPIIJTYLOWTIZNORDKWARNRDZRHJDWFLDFDSXSXUBFBKSKLVNBFJUGWNEYMMGMWOVVQUTQCZGMVLYEKXCAHOJNAVZEVOSQENUPDVXXGRJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ManeuverControlState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ManeuverControlState msg;
    msg.setTimeStamp(0.705721445088);
    msg.setSource(63507U);
    msg.setSourceEntity(179U);
    msg.setDestination(34891U);
    msg.setDestinationEntity(74U);
    msg.state = 251U;
    msg.eta = 23328U;
    msg.info.assign("PRNWHMFFZHWYPWQYCLIGOGQQUMJUSUDHAUQKXWXCLZBTSKNIDKHNNYLBHBDBVSTELVUYQJNRBUZYJFSEPROEFPAGCGRGJQHOAMKVVUBGGHPLFUZACEMZTOIYYQP");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ManeuverControlState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ManeuverControlState msg;
    msg.setTimeStamp(0.766916376302);
    msg.setSource(16697U);
    msg.setSourceEntity(103U);
    msg.setDestination(20367U);
    msg.setDestinationEntity(159U);
    msg.state = 184U;
    msg.eta = 8503U;
    msg.info.assign("PHOAIWWYXPQYZGVFVQXXYFQNDRTCLUIXNSNEJLTWQAOVBLXFFEDONOASTLMKYJHWSGJSJCYPKZBKRQHIPEDQHDEABEURAGKYSDUXAJSMDPGUGIIHMLESSXJFUMPLGMKUMIRGVBAGAWZFNMLMSWCKZYMZPXIZDE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ManeuverControlState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowSystem msg;
    msg.setTimeStamp(0.166467453666);
    msg.setSource(19613U);
    msg.setSourceEntity(100U);
    msg.setDestination(12001U);
    msg.setDestinationEntity(74U);
    msg.system = 34259U;
    msg.duration = 12342U;
    msg.speed = 0.559436840316;
    msg.speed_units = 170U;
    msg.x = 0.792694577143;
    msg.y = 0.53918918363;
    msg.z = 0.227188556552;
    msg.z_units = 72U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowSystem #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowSystem msg;
    msg.setTimeStamp(0.853698511296);
    msg.setSource(42583U);
    msg.setSourceEntity(112U);
    msg.setDestination(20841U);
    msg.setDestinationEntity(201U);
    msg.system = 43351U;
    msg.duration = 14510U;
    msg.speed = 0.794521887997;
    msg.speed_units = 103U;
    msg.x = 0.410124798504;
    msg.y = 0.0750489244862;
    msg.z = 0.246836630164;
    msg.z_units = 147U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowSystem #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowSystem msg;
    msg.setTimeStamp(0.357762408002);
    msg.setSource(43883U);
    msg.setSourceEntity(122U);
    msg.setDestination(32683U);
    msg.setDestinationEntity(221U);
    msg.system = 8586U;
    msg.duration = 4885U;
    msg.speed = 0.899218572359;
    msg.speed_units = 198U;
    msg.x = 0.725568691169;
    msg.y = 0.951127344354;
    msg.z = 0.107814119518;
    msg.z_units = 157U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowSystem #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CommsRelay msg;
    msg.setTimeStamp(0.731339039443);
    msg.setSource(57584U);
    msg.setSourceEntity(187U);
    msg.setDestination(63621U);
    msg.setDestinationEntity(228U);
    msg.lat = 0.377898858409;
    msg.lon = 0.347423783134;
    msg.speed = 0.589713144108;
    msg.speed_units = 136U;
    msg.duration = 62786U;
    msg.sys_a = 54047U;
    msg.sys_b = 9461U;
    msg.move_threshold = 0.795444532499;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CommsRelay #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CommsRelay msg;
    msg.setTimeStamp(0.721304405526);
    msg.setSource(21291U);
    msg.setSourceEntity(173U);
    msg.setDestination(49076U);
    msg.setDestinationEntity(31U);
    msg.lat = 0.312299459714;
    msg.lon = 0.923431948888;
    msg.speed = 0.519742070359;
    msg.speed_units = 15U;
    msg.duration = 10252U;
    msg.sys_a = 3542U;
    msg.sys_b = 30362U;
    msg.move_threshold = 0.00991524868052;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CommsRelay #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CommsRelay msg;
    msg.setTimeStamp(0.671789673974);
    msg.setSource(31632U);
    msg.setSourceEntity(109U);
    msg.setDestination(11801U);
    msg.setDestinationEntity(102U);
    msg.lat = 0.466244321219;
    msg.lon = 0.0431874446454;
    msg.speed = 0.395794873175;
    msg.speed_units = 47U;
    msg.duration = 58102U;
    msg.sys_a = 21372U;
    msg.sys_b = 32448U;
    msg.move_threshold = 0.204371628254;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CommsRelay #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CoverArea msg;
    msg.setTimeStamp(0.371429225368);
    msg.setSource(19460U);
    msg.setSourceEntity(132U);
    msg.setDestination(25386U);
    msg.setDestinationEntity(128U);
    msg.lat = 0.102091404262;
    msg.lon = 0.3864771847;
    msg.z = 0.898239861445;
    msg.z_units = 159U;
    msg.speed = 0.859445390063;
    msg.speed_units = 143U;
    IMC::PolygonVertex tmp_msg_0;
    tmp_msg_0.lat = 0.884308415471;
    tmp_msg_0.lon = 0.958447306282;
    msg.polygon.push_back(tmp_msg_0);
    msg.custom.assign("IIVCRGEKEYGQSIGKCXTTVAAILZQSTOTYFNMSFCFXLYFMHPAVEZHOAJDBQCIBHPCNOOBPXFOUHWSGOQBRSMKNNNANYGQYWAEOSEGNHHZDZITUGMPKZKDBWWLFLEPEUPPTLIAGLXJNMPTZYUOTOMXWWMZKGSUJRWJJUKTULHIDDNPBLLRTWKDVVZBVNCZRGQREWYFEZCPURCQVVRAXJSXDIMFADJYWMVKU");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CoverArea #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CoverArea msg;
    msg.setTimeStamp(0.443181226306);
    msg.setSource(42005U);
    msg.setSourceEntity(68U);
    msg.setDestination(33884U);
    msg.setDestinationEntity(129U);
    msg.lat = 0.0145044733418;
    msg.lon = 0.328062414904;
    msg.z = 0.0789417624748;
    msg.z_units = 18U;
    msg.speed = 0.484040641597;
    msg.speed_units = 195U;
    msg.custom.assign("YSNDBPRYOWMTZLVHALZARPDHIETEOKIUUKJXAQQRXKCVWYNKCPQWJXUSWNTBOXUPPPFMRKJOGAFIZGARQJMNLFKHMQVGMR");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CoverArea #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CoverArea msg;
    msg.setTimeStamp(0.735560596058);
    msg.setSource(58988U);
    msg.setSourceEntity(202U);
    msg.setDestination(28970U);
    msg.setDestinationEntity(143U);
    msg.lat = 0.636762962413;
    msg.lon = 0.111018462839;
    msg.z = 0.605372811455;
    msg.z_units = 209U;
    msg.speed = 0.970303376376;
    msg.speed_units = 58U;
    msg.custom.assign("XXCMYFVOZOZVQWHECWMICCHGIHHZJPUGQFJHPTASIEGXJGLUPVBERHWIKYLSHYYPRZMXFYNTQSGUFLBFOSCOLQDJYNJMDRALWMUAMEVSGLDOVKMSSEOHFBVIDUXDGRQYGRUNKBLWNKSFZTTJFKPUNCAMKDJMBNKXGWAWMZXTKRYIRYEVJXHDTECDXCTPZRALNUZTJOWRRCPKYE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CoverArea #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PolygonVertex msg;
    msg.setTimeStamp(0.236603282849);
    msg.setSource(2435U);
    msg.setSourceEntity(114U);
    msg.setDestination(57542U);
    msg.setDestinationEntity(30U);
    msg.lat = 0.74584293788;
    msg.lon = 0.590655970998;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PolygonVertex #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PolygonVertex msg;
    msg.setTimeStamp(0.760409695083);
    msg.setSource(39125U);
    msg.setSourceEntity(87U);
    msg.setDestination(64079U);
    msg.setDestinationEntity(55U);
    msg.lat = 0.799295488546;
    msg.lon = 0.929482842762;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PolygonVertex #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PolygonVertex msg;
    msg.setTimeStamp(0.405452788756);
    msg.setSource(29307U);
    msg.setSourceEntity(241U);
    msg.setDestination(30654U);
    msg.setDestinationEntity(142U);
    msg.lat = 0.0622092121548;
    msg.lon = 0.966145495401;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PolygonVertex #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CompassCalibration msg;
    msg.setTimeStamp(0.958663946691);
    msg.setSource(28375U);
    msg.setSourceEntity(132U);
    msg.setDestination(41898U);
    msg.setDestinationEntity(222U);
    msg.timeout = 25601U;
    msg.lat = 0.407380385233;
    msg.lon = 0.238146491488;
    msg.z = 0.699126385961;
    msg.z_units = 170U;
    msg.pitch = 0.399277066495;
    msg.amplitude = 0.162792963747;
    msg.duration = 1261U;
    msg.speed = 0.374402205118;
    msg.speed_units = 129U;
    msg.radius = 0.820421129406;
    msg.direction = 147U;
    msg.custom.assign("XOJMIEQBFWQVCTPAHENGIMOLTXHPVOIKRYVWKWASTQXYULLKPHMMFAZJVPNTOAZTRIIUIYMXHNXOMJZHJOBGQCWSRXWUFEXJG");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CompassCalibration #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CompassCalibration msg;
    msg.setTimeStamp(0.426375428388);
    msg.setSource(5450U);
    msg.setSourceEntity(86U);
    msg.setDestination(40612U);
    msg.setDestinationEntity(246U);
    msg.timeout = 27453U;
    msg.lat = 0.529414760107;
    msg.lon = 0.749409886485;
    msg.z = 0.557986549717;
    msg.z_units = 151U;
    msg.pitch = 0.487424346081;
    msg.amplitude = 0.844689429426;
    msg.duration = 33697U;
    msg.speed = 0.0307389827961;
    msg.speed_units = 83U;
    msg.radius = 0.373906954512;
    msg.direction = 214U;
    msg.custom.assign("NGEFHRQLNWNEXFWASJZRFJRNHEAZXRTIBQRAXQOWRIQXPSLOHASCCLJWEZCOMPHPXVTJSULNDUGPCGATDMGTONIDFJLDLMMXKSSUQIFXOUWJHZXTWFMNUFBHPOYKVREKVNKHZTWMTMCZXOCCHLQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CompassCalibration #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CompassCalibration msg;
    msg.setTimeStamp(0.27227325512);
    msg.setSource(33387U);
    msg.setSourceEntity(127U);
    msg.setDestination(48571U);
    msg.setDestinationEntity(55U);
    msg.timeout = 1011U;
    msg.lat = 0.767274287012;
    msg.lon = 0.898585555879;
    msg.z = 0.587481771209;
    msg.z_units = 238U;
    msg.pitch = 0.982064373921;
    msg.amplitude = 0.64175349284;
    msg.duration = 39473U;
    msg.speed = 0.143334884352;
    msg.speed_units = 101U;
    msg.radius = 0.0456811314611;
    msg.direction = 38U;
    msg.custom.assign("OKEJMFHZQJPSZILUZQBTCMQPMRQUUPFRPHLHFDUNLQECLZSTBWDGSWHPFDCUJPBJIZIVMWPLNFNGYMVKYXSMZKYXVYROTSRNOADJJSOYHJFKICAONREVXLNTEOJSVBLCOXEFGDVAECCMVZGGAIWTUWBMQJKBMSNPZEAHREGYDXXYKBXQCOXHITXFXCBKRVYFKI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CompassCalibration #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationParameters msg;
    msg.setTimeStamp(0.672856351746);
    msg.setSource(53469U);
    msg.setSourceEntity(154U);
    msg.setDestination(25133U);
    msg.setDestinationEntity(221U);
    msg.formation_name.assign("LGAUPBPFMASPYTTFTKGTOQFSEWHGISEBLIFHBVSQVGXHJZXZAYMANYIQYCGWJPWUWUPEVRVUTJCAP");
    msg.reference_frame = 184U;
    msg.custom.assign("JTLAPTUAVKHARXWPYRRCRHMYZASJOLVZHVNHYFFBPDNIZIMWNWKLXAXXCWUGRDOPRELCTWIWULAG");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationParameters #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationParameters msg;
    msg.setTimeStamp(0.638469406915);
    msg.setSource(23749U);
    msg.setSourceEntity(3U);
    msg.setDestination(26227U);
    msg.setDestinationEntity(167U);
    msg.formation_name.assign("RDBJIKLVPTQYJZMTACPMMNIXHVEWJBBYSTOUPBFCMFZEQQNTSSZTNCHNWTYZFEGUZPKSNKNQPMNGVXJTGYGPYNCDWFKCBTRZWIVORD");
    msg.reference_frame = 224U;
    msg.custom.assign("XAGJHFLYXOKJNIZIAJPLOGASSRARGTETLOJCIZKDNNBVIXOGRQATWFYDZTLEYDMNUQCPUUCBFOIHRGGDPVXYKHQMHAZOFNGEDLTETQQONSCMXFETTFMMQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationParameters #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationParameters msg;
    msg.setTimeStamp(0.429331223758);
    msg.setSource(51689U);
    msg.setSourceEntity(8U);
    msg.setDestination(61531U);
    msg.setDestinationEntity(106U);
    msg.formation_name.assign("VTBADROFKSKVKECFEDMLGRMBCCBIKJOOOENJPZUJABXYAUGXUNAESVWVRQMPSOVVQHFHSGDCUNFKMFBNUDLPAXMIDIDVDXVGXYCOXGQMDSFJURBJOKBQ");
    msg.reference_frame = 172U;
    IMC::VehicleFormationParticipant tmp_msg_0;
    tmp_msg_0.vid = 45477U;
    tmp_msg_0.off_x = 0.457292356419;
    tmp_msg_0.off_y = 0.705617765629;
    tmp_msg_0.off_z = 0.0458273050758;
    msg.participants.push_back(tmp_msg_0);
    msg.custom.assign("MIGTWCAVHWTPOOZWDKEVHKBSMKHNRDOISBCYCNMOWPFCRRQFRMELBGSOLWDIZKFMSKLXBITELJJDNYAUJILVBJPAMFFABUHBYMCUSWQDLHQTTNSVRZGJSEHARQGEVSZIXAMDZXRGQCWBDNFAQOAKXPNXLUHFZZXSYCXADHBYUIPBZLLJOUOPJCDWSTFJEKREKVYPEKYNTNYDCRNXWVPTFUVNJYGAYIIGHZHOIMVP");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationParameters #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationPlanExecution msg;
    msg.setTimeStamp(0.975989649134);
    msg.setSource(60735U);
    msg.setSourceEntity(122U);
    msg.setDestination(22636U);
    msg.setDestinationEntity(176U);
    msg.group_name.assign("OBZTBHDXQXWZPMETZMGZWJFMQQHASCPYMYKJAIQDNISCXWKPTVOAJKYBINYSFMRBYYSTSVYZCLOEVEAFPANTVXTLPIRARKPJ");
    msg.formation_name.assign("OLTVHXRPPKJQZLLKRTEQMCEGKZWRYJXMCCYGBECLQDUSZZSVCNANJWGVYZSJTCAHANNOJMLOVUYEXZANMGGYFNVKLKKAWLTDCFDTRMDPBFOANJJXFUBSHJRWQVBOFMBIWITDVBDFYPQRYPPOBHXDHKL");
    msg.plan_id.assign("TDWNOLSXJSZVRDUKCNRUMWEGYVAEBMPHYKJQYOXVQLZDJUSWRURWQX");
    msg.description.assign("CDOVQYUPJWTSHBCSLBCLNYMNAHMUAOABDPCJEPWZNNKCYBJEMOGTYSUGZIRWIBUZULRHUPKEGQWQOMAFIALDXGNPFLYVCMKKCNTYIZCFVKEHBVVMXUDFDAEBBXBZFEDKOSIQIJGCRNNHPKGGUGKRXMCXZTWJYWXYLDSOVSNTW");
    msg.leader_speed = 0.697648122351;
    msg.leader_bank_lim = 0.243055592274;
    msg.pos_sim_err_lim = 0.508814851034;
    msg.pos_sim_err_wrn = 0.23310935777;
    msg.pos_sim_err_timeout = 40631U;
    msg.converg_max = 0.0333162892358;
    msg.converg_timeout = 29289U;
    msg.comms_timeout = 9380U;
    msg.turb_lim = 0.0670159149589;
    msg.custom.assign("LLWSLCLVSZVVVFXIQHWQXBUENNJKHRNFBNEPEXBDLYOBHSUJCXIVAYOCIRBSMZJZPBOGMAORGUWKYXZDYEUXCCIUSPTSAKKIQATYQFRASMEVBOHPGZJYGCNLPKQFQWHPJCXTMVKETXQJSHNFEDIXEHCDTKFERWCSGPUNOHGOMDUZMWWRKGAAJLOAAJSMILQFUNROPMQYLMKT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationPlanExecution #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationPlanExecution msg;
    msg.setTimeStamp(0.634203738606);
    msg.setSource(33252U);
    msg.setSourceEntity(119U);
    msg.setDestination(52733U);
    msg.setDestinationEntity(69U);
    msg.group_name.assign("DRCPDJBSVBTIVLREHXKGRAMYHNIPWYNUYMZUHGNOMEDBDKWVQHBCBEGYZUAAQJAXQEZRSTVSQVAWERZQKUGFABYTWPOIOZDRGSYKJZYMIIBAJDVPWFFJOLMSNDCSUEDHMSLFXMTXLUAGILAIVNTBEKBEHGLOFMVITVFLCLHNHZCCFKIKNWPGEJNZHYQXXTJMDCUKRSTPJYQ");
    msg.formation_name.assign("MAUKSACVSFBUSIRESDMUJLMNDMREAFGFYBCSPINTCLNRMDRALHRGAXEBGZWHROJZJYBUVBMXOAWYQHEVCLRHOMBYLOIJZVXHXDJFZXYLWDPZNHJWUPWTQXG");
    msg.plan_id.assign("ERAARSNAJAGDZYOQPCTDJIUTUDLXVYHPCGPRPMMOVAXFZMCQMIQZPSWWUNLDCMYNDJROPSXKOCYJFMUXLYBBVGLSKHGEMDSNBIJSBXUZOUYQ");
    msg.description.assign("RWQXQEQFLVEGLCZEDKSHDPYWEANGTDICHQWVNZSPSPOCBKAPAJRQFEXTFOEIPJISLMRQVUPMINARUIBKVTWKDRLYOHGBJJWYWWUEKMASGGVXCFNDVASOXIXMKICTKHNTZRJVXOMHMUBHQXQLJBUMJRXAVFFAZCGLMYDDSBZOGSWKSJPKTZCGDXUTUYFEYBIYBOBTFNZNPQELYUG");
    msg.leader_speed = 0.272377878988;
    msg.leader_bank_lim = 0.852315938655;
    msg.pos_sim_err_lim = 0.477453041715;
    msg.pos_sim_err_wrn = 0.159795019167;
    msg.pos_sim_err_timeout = 3934U;
    msg.converg_max = 0.659814464051;
    msg.converg_timeout = 17158U;
    msg.comms_timeout = 41141U;
    msg.turb_lim = 0.170688772715;
    msg.custom.assign("GABGJQBIVFIRGTKUHEOZPWPRKENYIPDUF");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationPlanExecution #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationPlanExecution msg;
    msg.setTimeStamp(0.25960294595);
    msg.setSource(16733U);
    msg.setSourceEntity(222U);
    msg.setDestination(22801U);
    msg.setDestinationEntity(94U);
    msg.group_name.assign("DNZAGQLLAU");
    msg.formation_name.assign("XVALOQIEZSAKMXRVGDNAZFCEMPATAVIPOTXKEWBMLWYUGJCHSPTKQABIHULWFWBELVHSFDOXETBMIORVDYRNFOPZUZXHXAGKRHOJIBJZCFR");
    msg.plan_id.assign("QJFFBEPNTLWKICPZYCPWBGUAUKKRPLAQAGHJZYHKNVGWJCYFMHGN");
    msg.description.assign("UIMRFRQWMDBJACRZXZLKWCVGBNJCXVFUFSONEDZLLYHQVNFATMYJOMLOYR");
    msg.leader_speed = 0.287633297142;
    msg.leader_bank_lim = 0.89786378281;
    msg.pos_sim_err_lim = 0.982042351891;
    msg.pos_sim_err_wrn = 0.638980039718;
    msg.pos_sim_err_timeout = 61319U;
    msg.converg_max = 0.907560579322;
    msg.converg_timeout = 16686U;
    msg.comms_timeout = 26322U;
    msg.turb_lim = 0.749859906441;
    msg.custom.assign("HOUXEJGMZVDMWMSLJTIEKOZEPEGWPVFSKAAENPDKXTLEVOHHZMKUIMMGTASNRXLRYRICBODDQJACVYOCLQKHTLUAYFAINBVBVUSPBZNGKNGTUOZBQFPKEICIFISYGNPCKVMUESUWRWPXLYXVIMSZFSZNDCDSKUFQLGRHTDRXI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationPlanExecution #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowReference msg;
    msg.setTimeStamp(0.394436684617);
    msg.setSource(10214U);
    msg.setSourceEntity(21U);
    msg.setDestination(10223U);
    msg.setDestinationEntity(73U);
    msg.control_src = 8090U;
    msg.control_ent = 188U;
    msg.timeout = 0.627969310737;
    msg.loiter_radius = 0.640218417933;
    msg.altitude_interval = 0.448503639286;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowReference #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowReference msg;
    msg.setTimeStamp(0.242513443909);
    msg.setSource(46220U);
    msg.setSourceEntity(81U);
    msg.setDestination(60793U);
    msg.setDestinationEntity(24U);
    msg.control_src = 7967U;
    msg.control_ent = 131U;
    msg.timeout = 0.337568274324;
    msg.loiter_radius = 0.360298034182;
    msg.altitude_interval = 0.64294539667;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowReference #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowReference msg;
    msg.setTimeStamp(0.144820450613);
    msg.setSource(38229U);
    msg.setSourceEntity(75U);
    msg.setDestination(14385U);
    msg.setDestinationEntity(112U);
    msg.control_src = 17210U;
    msg.control_ent = 2U;
    msg.timeout = 0.877603180119;
    msg.loiter_radius = 0.0592939482813;
    msg.altitude_interval = 0.431349424061;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowReference #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Reference msg;
    msg.setTimeStamp(0.985744540875);
    msg.setSource(21463U);
    msg.setSourceEntity(20U);
    msg.setDestination(13652U);
    msg.setDestinationEntity(218U);
    msg.flags = 204U;
    IMC::DesiredSpeed tmp_msg_0;
    tmp_msg_0.value = 0.150390711645;
    tmp_msg_0.speed_units = 76U;
    msg.speed.set(tmp_msg_0);
    IMC::DesiredZ tmp_msg_1;
    tmp_msg_1.value = 0.860259209462;
    tmp_msg_1.z_units = 175U;
    msg.z.set(tmp_msg_1);
    msg.lat = 0.767064780118;
    msg.lon = 0.153081323525;
    msg.radius = 0.211783281766;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Reference #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Reference msg;
    msg.setTimeStamp(0.103703579832);
    msg.setSource(19927U);
    msg.setSourceEntity(52U);
    msg.setDestination(55464U);
    msg.setDestinationEntity(219U);
    msg.flags = 101U;
    IMC::DesiredSpeed tmp_msg_0;
    tmp_msg_0.value = 0.553814987106;
    tmp_msg_0.speed_units = 223U;
    msg.speed.set(tmp_msg_0);
    IMC::DesiredZ tmp_msg_1;
    tmp_msg_1.value = 0.974952179353;
    tmp_msg_1.z_units = 214U;
    msg.z.set(tmp_msg_1);
    msg.lat = 0.51473748621;
    msg.lon = 0.303512119991;
    msg.radius = 0.0660141311131;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Reference #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Reference msg;
    msg.setTimeStamp(0.943136605921);
    msg.setSource(26789U);
    msg.setSourceEntity(179U);
    msg.setDestination(19474U);
    msg.setDestinationEntity(103U);
    msg.flags = 229U;
    IMC::DesiredSpeed tmp_msg_0;
    tmp_msg_0.value = 0.408778359473;
    tmp_msg_0.speed_units = 27U;
    msg.speed.set(tmp_msg_0);
    IMC::DesiredZ tmp_msg_1;
    tmp_msg_1.value = 0.194780500329;
    tmp_msg_1.z_units = 89U;
    msg.z.set(tmp_msg_1);
    msg.lat = 0.583708374022;
    msg.lon = 0.510922082971;
    msg.radius = 0.4047429451;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Reference #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowRefState msg;
    msg.setTimeStamp(0.806556471625);
    msg.setSource(17746U);
    msg.setSourceEntity(142U);
    msg.setDestination(13409U);
    msg.setDestinationEntity(150U);
    msg.control_src = 32683U;
    msg.control_ent = 88U;
    IMC::Reference tmp_msg_0;
    tmp_msg_0.flags = 162U;
    IMC::DesiredSpeed tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.value = 0.897793426322;
    tmp_tmp_msg_0_0.speed_units = 104U;
    tmp_msg_0.speed.set(tmp_tmp_msg_0_0);
    IMC::DesiredZ tmp_tmp_msg_0_1;
    tmp_tmp_msg_0_1.value = 0.186494742921;
    tmp_tmp_msg_0_1.z_units = 250U;
    tmp_msg_0.z.set(tmp_tmp_msg_0_1);
    tmp_msg_0.lat = 0.766647784111;
    tmp_msg_0.lon = 0.844460301667;
    tmp_msg_0.radius = 0.920832885332;
    msg.reference.set(tmp_msg_0);
    msg.state = 61U;
    msg.proximity = 140U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowRefState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowRefState msg;
    msg.setTimeStamp(0.851317681187);
    msg.setSource(19810U);
    msg.setSourceEntity(56U);
    msg.setDestination(63131U);
    msg.setDestinationEntity(207U);
    msg.control_src = 20321U;
    msg.control_ent = 129U;
    IMC::Reference tmp_msg_0;
    tmp_msg_0.flags = 83U;
    IMC::DesiredSpeed tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.value = 0.431671362315;
    tmp_tmp_msg_0_0.speed_units = 198U;
    tmp_msg_0.speed.set(tmp_tmp_msg_0_0);
    IMC::DesiredZ tmp_tmp_msg_0_1;
    tmp_tmp_msg_0_1.value = 0.98234673289;
    tmp_tmp_msg_0_1.z_units = 78U;
    tmp_msg_0.z.set(tmp_tmp_msg_0_1);
    tmp_msg_0.lat = 0.630139788646;
    tmp_msg_0.lon = 0.801280636739;
    tmp_msg_0.radius = 0.954792394629;
    msg.reference.set(tmp_msg_0);
    msg.state = 49U;
    msg.proximity = 92U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowRefState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FollowRefState msg;
    msg.setTimeStamp(0.950876642628);
    msg.setSource(10935U);
    msg.setSourceEntity(119U);
    msg.setDestination(62403U);
    msg.setDestinationEntity(23U);
    msg.control_src = 40030U;
    msg.control_ent = 145U;
    IMC::Reference tmp_msg_0;
    tmp_msg_0.flags = 2U;
    IMC::DesiredSpeed tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.value = 0.283390627604;
    tmp_tmp_msg_0_0.speed_units = 230U;
    tmp_msg_0.speed.set(tmp_tmp_msg_0_0);
    IMC::DesiredZ tmp_tmp_msg_0_1;
    tmp_tmp_msg_0_1.value = 0.238157297658;
    tmp_tmp_msg_0_1.z_units = 18U;
    tmp_msg_0.z.set(tmp_tmp_msg_0_1);
    tmp_msg_0.lat = 0.162779082758;
    tmp_msg_0.lon = 0.872003839531;
    tmp_msg_0.radius = 0.71259459407;
    msg.reference.set(tmp_msg_0);
    msg.state = 175U;
    msg.proximity = 248U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FollowRefState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationMonitor msg;
    msg.setTimeStamp(0.638049245043);
    msg.setSource(21242U);
    msg.setSourceEntity(42U);
    msg.setDestination(60245U);
    msg.setDestinationEntity(88U);
    msg.ax_cmd = 0.583211000832;
    msg.ay_cmd = 0.974697568356;
    msg.az_cmd = 0.369341814624;
    msg.ax_des = 0.265852812862;
    msg.ay_des = 0.894443200648;
    msg.az_des = 0.77504803652;
    msg.virt_err_x = 0.703947915817;
    msg.virt_err_y = 0.659743839357;
    msg.virt_err_z = 0.306728408417;
    msg.surf_fdbk_x = 0.490069490431;
    msg.surf_fdbk_y = 0.575051650336;
    msg.surf_fdbk_z = 0.0579584890367;
    msg.surf_unkn_x = 0.11355517334;
    msg.surf_unkn_y = 0.494032078326;
    msg.surf_unkn_z = 0.316063375218;
    msg.ss_x = 0.641431231558;
    msg.ss_y = 0.806712275264;
    msg.ss_z = 0.336847293196;
    IMC::RelativeState tmp_msg_0;
    tmp_msg_0.s_id.assign("ACCZHWXUXQRJXDDWQFUBGHEQLBSDRJAPIHLJBLANBTQJPVAPOTBFVUVSCOEMFTZIAOFKCILUNYEIKWETQTWKGKZYGUMMAUCLKXZALQPXVGUBRTJBAXRVMSWYZSMFVFFRYSWUMBPKHDDLZOOVODOEYRHGCKIYIMRYNB");
    tmp_msg_0.dist = 0.905097408545;
    tmp_msg_0.err = 0.854632366056;
    tmp_msg_0.ctrl_imp = 0.970817229228;
    tmp_msg_0.rel_dir_x = 0.918734971294;
    tmp_msg_0.rel_dir_y = 0.676282141593;
    tmp_msg_0.rel_dir_z = 0.0404727300588;
    tmp_msg_0.err_x = 0.149071460269;
    tmp_msg_0.err_y = 0.143273011942;
    tmp_msg_0.err_z = 0.79858126155;
    tmp_msg_0.rf_err_x = 0.523470756719;
    tmp_msg_0.rf_err_y = 0.356742489252;
    tmp_msg_0.rf_err_z = 0.651196121771;
    tmp_msg_0.rf_err_vx = 0.0889218516628;
    tmp_msg_0.rf_err_vy = 0.294351149264;
    tmp_msg_0.rf_err_vz = 0.776864313285;
    tmp_msg_0.ss_x = 0.442931346573;
    tmp_msg_0.ss_y = 0.9072027419;
    tmp_msg_0.ss_z = 0.93618890389;
    tmp_msg_0.virt_err_x = 0.976341538499;
    tmp_msg_0.virt_err_y = 0.355692083284;
    tmp_msg_0.virt_err_z = 0.607125731494;
    msg.rel_state.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationMonitor #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationMonitor msg;
    msg.setTimeStamp(0.711538537298);
    msg.setSource(37979U);
    msg.setSourceEntity(154U);
    msg.setDestination(19909U);
    msg.setDestinationEntity(104U);
    msg.ax_cmd = 0.510190435664;
    msg.ay_cmd = 0.323726613155;
    msg.az_cmd = 0.851563971118;
    msg.ax_des = 0.287651790286;
    msg.ay_des = 0.552850197526;
    msg.az_des = 0.532810067013;
    msg.virt_err_x = 0.42454449144;
    msg.virt_err_y = 0.27360090677;
    msg.virt_err_z = 0.654612873508;
    msg.surf_fdbk_x = 0.069912078316;
    msg.surf_fdbk_y = 0.150826090403;
    msg.surf_fdbk_z = 0.259901427769;
    msg.surf_unkn_x = 0.80093058605;
    msg.surf_unkn_y = 0.0758502689752;
    msg.surf_unkn_z = 0.121641916705;
    msg.ss_x = 0.753025008199;
    msg.ss_y = 0.189885210168;
    msg.ss_z = 0.941570034174;
    IMC::RelativeState tmp_msg_0;
    tmp_msg_0.s_id.assign("RKJGSVYMIWVVBXWMCWWQOERKMQHQZGVFDVKAGTKOUEEGUFLOXXCLRZDFHTWSRJLEBVYWHBTXLPZLDBSTIKGLYDCZMJQTUPZFVDLJEHPUOZGLIBREDCFEHEBHXHMYNUYZSHINOTARDMXTQWXOKWMNEDJIGSXKSCJUIAYPR");
    tmp_msg_0.dist = 0.569542662862;
    tmp_msg_0.err = 0.437390235584;
    tmp_msg_0.ctrl_imp = 0.746318528562;
    tmp_msg_0.rel_dir_x = 0.000769628533211;
    tmp_msg_0.rel_dir_y = 0.301959906406;
    tmp_msg_0.rel_dir_z = 0.430350787976;
    tmp_msg_0.err_x = 0.743948554195;
    tmp_msg_0.err_y = 0.619068908754;
    tmp_msg_0.err_z = 0.65859470315;
    tmp_msg_0.rf_err_x = 0.38365581645;
    tmp_msg_0.rf_err_y = 0.146909345835;
    tmp_msg_0.rf_err_z = 0.269584682389;
    tmp_msg_0.rf_err_vx = 0.162502638226;
    tmp_msg_0.rf_err_vy = 0.069959300464;
    tmp_msg_0.rf_err_vz = 0.62122537452;
    tmp_msg_0.ss_x = 0.679001950073;
    tmp_msg_0.ss_y = 0.947074430204;
    tmp_msg_0.ss_z = 0.0224182601902;
    tmp_msg_0.virt_err_x = 0.0231014108817;
    tmp_msg_0.virt_err_y = 0.360793233108;
    tmp_msg_0.virt_err_z = 0.815211689109;
    msg.rel_state.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationMonitor #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationMonitor msg;
    msg.setTimeStamp(0.0772727738373);
    msg.setSource(418U);
    msg.setSourceEntity(225U);
    msg.setDestination(59236U);
    msg.setDestinationEntity(234U);
    msg.ax_cmd = 0.178126517068;
    msg.ay_cmd = 0.802071346345;
    msg.az_cmd = 0.0898931340108;
    msg.ax_des = 0.741070822128;
    msg.ay_des = 0.747683861532;
    msg.az_des = 0.536946906511;
    msg.virt_err_x = 0.55861563534;
    msg.virt_err_y = 0.7325007343;
    msg.virt_err_z = 0.0305770817757;
    msg.surf_fdbk_x = 0.741759187337;
    msg.surf_fdbk_y = 0.112385807249;
    msg.surf_fdbk_z = 0.469630791057;
    msg.surf_unkn_x = 0.652030926135;
    msg.surf_unkn_y = 0.848736956829;
    msg.surf_unkn_z = 0.509559824153;
    msg.ss_x = 0.751486770959;
    msg.ss_y = 0.00133300344095;
    msg.ss_z = 0.262057273028;
    IMC::RelativeState tmp_msg_0;
    tmp_msg_0.s_id.assign("JVEAVAFNQKDQNTVIXESHSMMBKKCYYDVHTOUOJTVEHCQZGAWQYZCNHQCRQAKJPBC");
    tmp_msg_0.dist = 0.357068284051;
    tmp_msg_0.err = 0.981942164981;
    tmp_msg_0.ctrl_imp = 0.481662796719;
    tmp_msg_0.rel_dir_x = 0.375435837993;
    tmp_msg_0.rel_dir_y = 0.694876913239;
    tmp_msg_0.rel_dir_z = 0.970923339427;
    tmp_msg_0.err_x = 0.89149655087;
    tmp_msg_0.err_y = 0.939442995941;
    tmp_msg_0.err_z = 0.867544697155;
    tmp_msg_0.rf_err_x = 0.216660743411;
    tmp_msg_0.rf_err_y = 0.0478866057651;
    tmp_msg_0.rf_err_z = 0.684242254307;
    tmp_msg_0.rf_err_vx = 0.0187202383125;
    tmp_msg_0.rf_err_vy = 0.927560669234;
    tmp_msg_0.rf_err_vz = 0.531846835571;
    tmp_msg_0.ss_x = 0.372566766973;
    tmp_msg_0.ss_y = 0.969651701693;
    tmp_msg_0.ss_z = 0.576290512503;
    tmp_msg_0.virt_err_x = 0.141920935587;
    tmp_msg_0.virt_err_y = 0.00190630025093;
    tmp_msg_0.virt_err_z = 0.579467524677;
    msg.rel_state.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationMonitor #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RelativeState msg;
    msg.setTimeStamp(0.200832008215);
    msg.setSource(55653U);
    msg.setSourceEntity(199U);
    msg.setDestination(61924U);
    msg.setDestinationEntity(202U);
    msg.s_id.assign("LWFACTNFQOARZGMZPCULXSZKJSSWXOUJZGGZELXUEXEH");
    msg.dist = 0.589686455162;
    msg.err = 0.214375609671;
    msg.ctrl_imp = 0.744285251096;
    msg.rel_dir_x = 0.874412166912;
    msg.rel_dir_y = 0.523020422019;
    msg.rel_dir_z = 0.727621612454;
    msg.err_x = 0.699058303987;
    msg.err_y = 0.388787253709;
    msg.err_z = 0.12335442996;
    msg.rf_err_x = 0.324268290963;
    msg.rf_err_y = 0.499220692465;
    msg.rf_err_z = 0.169898728543;
    msg.rf_err_vx = 0.332323187812;
    msg.rf_err_vy = 0.183313170322;
    msg.rf_err_vz = 0.655976265295;
    msg.ss_x = 0.00155226957355;
    msg.ss_y = 0.157926772519;
    msg.ss_z = 0.578815242804;
    msg.virt_err_x = 0.102543651749;
    msg.virt_err_y = 0.509092589758;
    msg.virt_err_z = 0.153632134396;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RelativeState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RelativeState msg;
    msg.setTimeStamp(0.737044003997);
    msg.setSource(2255U);
    msg.setSourceEntity(133U);
    msg.setDestination(12495U);
    msg.setDestinationEntity(28U);
    msg.s_id.assign("QMTAGTPXXRFQFHZMVNFMOLJKYNPPHBZCXBVRACRUMOVYTAZEUNAADHQKWVTOLNBZBVRHBSZCZDRJPKSBRJGISENSEGDSYEPOFTUOIYCFLDWLWDGW");
    msg.dist = 0.653575861457;
    msg.err = 0.899006653016;
    msg.ctrl_imp = 0.745072458846;
    msg.rel_dir_x = 0.205851138703;
    msg.rel_dir_y = 0.987696774862;
    msg.rel_dir_z = 0.285466770071;
    msg.err_x = 0.550067693715;
    msg.err_y = 0.688802407022;
    msg.err_z = 0.133961903378;
    msg.rf_err_x = 0.376430820336;
    msg.rf_err_y = 0.447436846505;
    msg.rf_err_z = 0.370989394578;
    msg.rf_err_vx = 0.357426001475;
    msg.rf_err_vy = 0.370938760237;
    msg.rf_err_vz = 0.640515712918;
    msg.ss_x = 0.0508018906304;
    msg.ss_y = 0.768951467676;
    msg.ss_z = 0.304344913732;
    msg.virt_err_x = 0.804952072802;
    msg.virt_err_y = 0.751735857044;
    msg.virt_err_z = 0.466335600381;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RelativeState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RelativeState msg;
    msg.setTimeStamp(0.469325961422);
    msg.setSource(45789U);
    msg.setSourceEntity(89U);
    msg.setDestination(38867U);
    msg.setDestinationEntity(92U);
    msg.s_id.assign("WSRMVPOXEZXMKXMULSEBWICGYIURVGVLYGRURTYAGXLKKIWWZAAPXPNZLHOKTKLTAQZGFQSA");
    msg.dist = 0.567133859001;
    msg.err = 0.06882393114;
    msg.ctrl_imp = 0.387063016796;
    msg.rel_dir_x = 0.841186345566;
    msg.rel_dir_y = 0.98024690807;
    msg.rel_dir_z = 0.858500629296;
    msg.err_x = 0.210108077004;
    msg.err_y = 0.46538056426;
    msg.err_z = 0.398075198037;
    msg.rf_err_x = 0.00600384595101;
    msg.rf_err_y = 0.498500563329;
    msg.rf_err_z = 0.541710943058;
    msg.rf_err_vx = 0.670501113405;
    msg.rf_err_vy = 0.486369953988;
    msg.rf_err_vz = 0.754028628981;
    msg.ss_x = 0.555062349312;
    msg.ss_y = 0.334090859919;
    msg.ss_z = 0.0302923755669;
    msg.virt_err_x = 0.303823141825;
    msg.virt_err_y = 0.84868711023;
    msg.virt_err_z = 0.743239930194;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RelativeState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Dislodge msg;
    msg.setTimeStamp(0.72200338585);
    msg.setSource(56820U);
    msg.setSourceEntity(185U);
    msg.setDestination(59376U);
    msg.setDestinationEntity(203U);
    msg.timeout = 21721U;
    msg.rpm = 0.504098256029;
    msg.direction = 138U;
    msg.custom.assign("UIEAFGRUOKEYYRJELXVQHHWNOBYNEHEKYWPNGGISIQIVHZAHBKSQTFTM");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Dislodge #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Dislodge msg;
    msg.setTimeStamp(0.947410788169);
    msg.setSource(14333U);
    msg.setSourceEntity(171U);
    msg.setDestination(2062U);
    msg.setDestinationEntity(144U);
    msg.timeout = 60400U;
    msg.rpm = 0.820384976815;
    msg.direction = 97U;
    msg.custom.assign("EJCNBDDZZLRIBYCDTUVXRWSRHSXWIISAWQXVTPHGLBXNTAIQVJFQZPWOSICGMNNSOVAYJUSRFHPVYFTUIFQUEMFIBYTKGKLDRPUMRGKAULBFGXWOPFJCOAHDWPLPRTXNLACYBZOLMGMAINHVXC");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Dislodge #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Dislodge msg;
    msg.setTimeStamp(0.968782465132);
    msg.setSource(48647U);
    msg.setSourceEntity(207U);
    msg.setDestination(49455U);
    msg.setDestinationEntity(41U);
    msg.timeout = 43279U;
    msg.rpm = 0.957945282575;
    msg.direction = 51U;
    msg.custom.assign("ABTJKROUTKBUTMRUCPDRTANVVHOBGCZFELFHMBNSNTXLGQTSBQWHIUIPXSWYMJEPDQDVYMFWNYQQYQVKIDYVMHJXRJQSYV");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Dislodge #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleState msg;
    msg.setTimeStamp(0.606616845551);
    msg.setSource(7615U);
    msg.setSourceEntity(147U);
    msg.setDestination(39346U);
    msg.setDestinationEntity(73U);
    msg.op_mode = 209U;
    msg.error_count = 165U;
    msg.error_ents.assign("JXVRZTIWJITISEZKHKUASFTJMYYHDYMTKEAFFBPPIERNOTYGWBHUQZJNEMPOCBOAZTCLYWCCGPDPTDRNOESMSMMDTAVXPBPAYXGLCLEYLWLQASVQZMGUMGPSYUQAJWGONKJXLICWZYOZLOSNPVKQRKOWMIHHACTVUBPRFGJWUFHLZQJXDNCRXRUOYDFVGZATLHLIDGUKDSINDUWEVXICSQRFOJXBNVBEZFVJKUDMSHBGQXANKHINQKBF");
    msg.maneuver_type = 54072U;
    msg.maneuver_stime = 0.562840472707;
    msg.maneuver_eta = 25730U;
    msg.control_loops = 4245482900U;
    msg.flags = 11U;
    msg.last_error.assign("NUYODIWFUETMVBIQGRDULJWEQQTTWJPWJIHZKDCMPIZVSMFAPAAJEUEUVIGCNRHKWDGJRFTFWRZVPXQDQZOYYCRMZRVAHTZQYKXXCXBQCOQFVYHSBSSLFSPOHCQLUJHDYESFBZFXIWLBBRUIBXSGRNOXNURKKMSUGJZAYOAPVKWPBRJZOGGVIHVLATCPSYNWXMWEAIQDFHVJACBTSPOANMDJBNZNGDUXKPOMELEKKDLTTLHGMLHL");
    msg.last_error_time = 0.279331909499;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleState msg;
    msg.setTimeStamp(0.60537123941);
    msg.setSource(5029U);
    msg.setSourceEntity(188U);
    msg.setDestination(14780U);
    msg.setDestinationEntity(230U);
    msg.op_mode = 136U;
    msg.error_count = 103U;
    msg.error_ents.assign("UBWLRTXPVQQCAAJFWUSDZSEYCBDFKJFWHGZLNVPCNHGEAVRPEPSXDQDLGKFVXEOAQMCSFNMXYPFCNNCFZABMJRHUFGHTSWUHEJDLAZDZDXXPYVJDWOKVHYMCIKBZSJHILWOTJIMUQFUEJZPSRJSKVAOQNSTIHMNDOBZLTIERMPLIYRRMGBWFGWKHOLGOUAOTGYCUZTKLBUWYKXIIOQXEXABQPPQKQCLDT");
    msg.maneuver_type = 31248U;
    msg.maneuver_stime = 0.972744118113;
    msg.maneuver_eta = 62267U;
    msg.control_loops = 202517592U;
    msg.flags = 174U;
    msg.last_error.assign("LUBECSGHNPWFDOIOKARYYXHZEUHNHBVWCRRIYYONJIVMPJFPEWYGTNLLJRLBQCLPDY");
    msg.last_error_time = 0.703124476563;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleState msg;
    msg.setTimeStamp(0.589847567171);
    msg.setSource(34150U);
    msg.setSourceEntity(153U);
    msg.setDestination(23075U);
    msg.setDestinationEntity(41U);
    msg.op_mode = 32U;
    msg.error_count = 125U;
    msg.error_ents.assign("SCUEMBYDRVVKZKQPUKZENSGHSODCTGXJZBUIZOYZMZUSMQHNNNXYLTQHWFAWXNAJFPJDLXAMAQSDNLIEVICJAEYKTDUXP");
    msg.maneuver_type = 50226U;
    msg.maneuver_stime = 0.906734854549;
    msg.maneuver_eta = 5284U;
    msg.control_loops = 3629189265U;
    msg.flags = 55U;
    msg.last_error.assign("TDHAAIYBUUNO");
    msg.last_error_time = 0.220491552498;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleCommand msg;
    msg.setTimeStamp(0.799744801546);
    msg.setSource(38916U);
    msg.setSourceEntity(14U);
    msg.setDestination(1699U);
    msg.setDestinationEntity(110U);
    msg.type = 145U;
    msg.request_id = 35918U;
    msg.command = 93U;
    IMC::FormationPlanExecution tmp_msg_0;
    tmp_msg_0.group_name.assign("OYNMCSQCOHOTXWQQJEUDXJCZYBVTLNPGKFDAMAXFUPLQMMKRROPPFEKNSTVAVXWNEGAZCYDRTHKYERMGMLVBXPXLLSYNAWLNFPKFJGJAQCFHVEVPDEZYHKZNAQWDWNXOWYRVUYBOOHIOZPSJVECCGRHSFBYIRSYSALCXMRIKROENHOTDATHGIBDGISTQZIFIBZZBDPLGGXLJJAJUMIKHQUB");
    tmp_msg_0.formation_name.assign("PGXHPWFHDMBRKFMCJGLGINRTZJVEXUMUDQOVKEOETSBIRGDYPKUHBUYFQWLIQTTLVABJSEGWZYCCDSSDLLBXIFKYEHORENVGYVYGORPFBNGCWPDQCMJGKOWVUBJXOLLNEXAILNIQORWMGBMTJAQARXZMJC");
    tmp_msg_0.plan_id.assign("NXYJSQLMSPBAGMWNXUEGSCCNNRTQSHEXGBUSMRCFZWTPCUYXUIS");
    tmp_msg_0.description.assign("BHIWRBVHFLETQGAGYNZFLHPZQTHBTGWERDGVQAZZOMMZYKPDYXEHMLYJJBOOXJVUSUQQEBQHXCVYR");
    tmp_msg_0.leader_speed = 0.016799753145;
    tmp_msg_0.leader_bank_lim = 0.727802822889;
    tmp_msg_0.pos_sim_err_lim = 0.768255806695;
    tmp_msg_0.pos_sim_err_wrn = 0.262877788836;
    tmp_msg_0.pos_sim_err_timeout = 23180U;
    tmp_msg_0.converg_max = 0.333064926831;
    tmp_msg_0.converg_timeout = 17362U;
    tmp_msg_0.comms_timeout = 41143U;
    tmp_msg_0.turb_lim = 0.0203634932818;
    tmp_msg_0.custom.assign("OZFTALHSLIRZEMUZAKTBPROPGVISEGAZHWDLIXDFUPLOMHJQC");
    msg.maneuver.set(tmp_msg_0);
    msg.calib_time = 2959U;
    msg.info.assign("VJUUDZCGEDGMBCZAVCLGHZWOGTLZKYLRITKZQRHTBHBFWJEXNTFAJLBISUCP");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleCommand #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleCommand msg;
    msg.setTimeStamp(0.826028481077);
    msg.setSource(65055U);
    msg.setSourceEntity(3U);
    msg.setDestination(35974U);
    msg.setDestinationEntity(2U);
    msg.type = 248U;
    msg.request_id = 22018U;
    msg.command = 102U;
    IMC::IdleManeuver tmp_msg_0;
    tmp_msg_0.duration = 20586U;
    tmp_msg_0.custom.assign("LBVUTWHFQPEDEQPFSZCAOIOQRVQPYKQCONSFBJIKBXZAUUXSOEKAONNRGRPMMRDOLLFRYBURDNWFLPHVZULHNSKUJMHGPMRZTUSJNGNGXLWIDCSXMOEXIAL");
    msg.maneuver.set(tmp_msg_0);
    msg.calib_time = 32801U;
    msg.info.assign("PGMXTPJDMBCXFIXMJIPOVWZORZOXWSVURCXUTMLJQFLKVDKWBHODFWTU");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleCommand #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleCommand msg;
    msg.setTimeStamp(0.563679939722);
    msg.setSource(48636U);
    msg.setSourceEntity(164U);
    msg.setDestination(13085U);
    msg.setDestinationEntity(138U);
    msg.type = 15U;
    msg.request_id = 38077U;
    msg.command = 193U;
    IMC::CoverArea tmp_msg_0;
    tmp_msg_0.lat = 0.165838402228;
    tmp_msg_0.lon = 0.123653863804;
    tmp_msg_0.z = 0.41835747411;
    tmp_msg_0.z_units = 229U;
    tmp_msg_0.speed = 0.953708251143;
    tmp_msg_0.speed_units = 70U;
    IMC::PolygonVertex tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.lat = 0.323263264772;
    tmp_tmp_msg_0_0.lon = 0.765252846187;
    tmp_msg_0.polygon.push_back(tmp_tmp_msg_0_0);
    tmp_msg_0.custom.assign("YTSQRAPPCGWEEXYZDDUQKUMOGAJDCADJLFEQFEXIIPKLDKTIMQAQJYKYWHRRTGMKQROV");
    msg.maneuver.set(tmp_msg_0);
    msg.calib_time = 42558U;
    msg.info.assign("COYAJLIAMFXXXDBQUNIZYWFZHIGMGCHJXPSYWRRPZJDZCMPBTQORULUKVRLIVNEWGIMYWYEJZHWZCNQEYVNOOVQJBTKHHETKQTEG");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleCommand #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MonitorEntityState msg;
    msg.setTimeStamp(0.715153191555);
    msg.setSource(47583U);
    msg.setSourceEntity(129U);
    msg.setDestination(26287U);
    msg.setDestinationEntity(26U);
    msg.command = 91U;
    msg.entities.assign("HZRLCOBWFVAKKGMIBQUDUXTNTYMWMBRYZDWJOQVGDXHFCBEQDGEHDBSIQXUAGPHVMNUIKNQDCWVFTXHLLOCAGOEXLZUZKYOLKJCEOFFDBCNKDREJAUO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MonitorEntityState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MonitorEntityState msg;
    msg.setTimeStamp(0.488069588171);
    msg.setSource(10184U);
    msg.setSourceEntity(122U);
    msg.setDestination(48667U);
    msg.setDestinationEntity(109U);
    msg.command = 58U;
    msg.entities.assign("KYGEUOBNYHTTWBVXVQLNRIIOJYSSMAWQRCKZNEPXKYJXRDRMCEHDKPQKWPLIFIXGBEVAUSUHDERNLSXOQKVTATFSMDJZEPASPOUCODMQEAPAUNWVOFPIBJSWVHTBFKRPMXLFMYXGLHZRUYBZZHPFDQQKJEQVKQGFIJTIMBZHBIVOGWWGYZXGLNDCCECOULCMKNAYBUDSCYLXNRIMOPTJHRULXCTGZVWSF");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MonitorEntityState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MonitorEntityState msg;
    msg.setTimeStamp(0.239148122331);
    msg.setSource(23554U);
    msg.setSourceEntity(83U);
    msg.setDestination(35039U);
    msg.setDestinationEntity(78U);
    msg.command = 182U;
    msg.entities.assign("WYGRASRZIPFYETDCNJOQCBUOQZZZATNYMXWIVVYYPAXOYQCJUXSGRNBRXKIGXLOKSNHPNRMVMELEFESRUMXGSJGAJKEMEEJYLIBUAJATFLBSNNNHAOZKOAHOFPLDQWTEMNDGZIBXFQHXBHMITDQVQWKCSRCWVCHCWPDDUVMUCQDLLTBIJVIRINILRXFQSBAPG");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MonitorEntityState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityMonitoringState msg;
    msg.setTimeStamp(0.34634510836);
    msg.setSource(23208U);
    msg.setSourceEntity(242U);
    msg.setDestination(56270U);
    msg.setDestinationEntity(152U);
    msg.mcount = 254U;
    msg.mnames.assign("VXZVTCIBGHCUERMDBOGPKKSEGWLYOJDGRVTJAQOZQZFRWYIFKUGHZIVFKVQPJCUNHJLWVYL");
    msg.ecount = 94U;
    msg.enames.assign("HVPUSGFDBLCYYHRUVRPEOMQDFKBDWSDZQTDMASTWZJVMIHMSUZUZXMARXARIVAWBUJUDQSINGRDCMHGJXTBKIOMCXBRNKMBLPYENWFSQPUEYR");
    msg.ccount = 155U;
    msg.cnames.assign("UWZPJOIQBQPJPIISAJJMPRXCKZKPZBMZRWVDUSKJXXMNFATQKHCGMRIFNZTNGOUYLUBDLFINHIULTZMCDJTFFLKPYNXEVY");
    msg.last_error.assign("PNEKSQFBOZXQRHIEIWOVECNYYVUXOAKNLGOYBHMCRDFVLMXNYJMZCDPBRNFDQLAAICXXJMSWTHKWMGJUBLJXZJZUJOSPOTOXTYQUSKRE");
    msg.last_error_time = 0.463640119397;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityMonitoringState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityMonitoringState msg;
    msg.setTimeStamp(0.260704972828);
    msg.setSource(44609U);
    msg.setSourceEntity(124U);
    msg.setDestination(34279U);
    msg.setDestinationEntity(123U);
    msg.mcount = 188U;
    msg.mnames.assign("QZTTWEAEUQSVSGRFTMIKIBVEIGHHPBUFBTLKZWHNRIUWOIXDULEWRTOTABYGJRBYCBSPMVAJPVQCJEMSGXHGWROWQYFHMHIZPZNJEBXGAOJKZVCEPPIKFXNFQVCEURLDDFNLZGYXEDQTWHXPYDOPULXWCJSVDNNNLQEAQDRCIXKOPJBVYCGAHKJFYBSZFKMDGOFSMGAHULUMCPTCOXNVRHOCXJRSYSWLYL");
    msg.ecount = 62U;
    msg.enames.assign("RHEMBIZTRVWRST");
    msg.ccount = 15U;
    msg.cnames.assign("JNTJRYZCJSYKVRVYIFCLOYZFDKCXUQMOWHPTGQTGPAOREJLLDNEININTOKQDVKYYGWKUQFZGXZEKPVGEKTMHVWBNPICCPAHHYPUBNHJPBNNRFBDVTODFEQSBJRWIGPZDMAMRMVJSPDVSGMGGLSECDBZUOEIWMULQFZQWTLXBAKINXTFIPRMZEXNUTVQUSXQVZKIH");
    msg.last_error.assign("SCAURJRBOYZEWJRWVKCCMNKCOCYMMQRXDYFZXHNWAIQEVBIGJMFGCZNCVRYVFUUFJAVLIJWPNAREMFUMMFJUSRQDPOLIWQVRBADHKIQJHLISYSKSDHZJJBIFXEBZBOTBGXSBZHTKZYKADZGSSWVPUNNLRXNYKOHKHGDNFOUBOYXCTPJHHUIZFCEAGSQLKCXGIQPOPGWNWMDLQIAQPMDEYALWXLEOWUVETXMDQ");
    msg.last_error_time = 0.913495215732;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityMonitoringState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityMonitoringState msg;
    msg.setTimeStamp(0.212716327042);
    msg.setSource(46799U);
    msg.setSourceEntity(184U);
    msg.setDestination(1430U);
    msg.setDestinationEntity(82U);
    msg.mcount = 12U;
    msg.mnames.assign("JXZELVUAPZQENWAUQNZWSNHBJWPETSYHPDTZLLEUIJKOJAQKJMRRYMAIBXGLAGWMHIQKADKVGXSSYMOHTCITSMUNNOZFSHOSTKLUCDZRWTUJMUUNARMHWMFGZVVYSVICNDERQODOXFIIWKFEIHZJZYDKNBPHPEPRBKUBRXLNTRUDSEQJVONHFAYFGXCOXPWLYJCFLYBFCRVPAPGXKLHBEATVWFXTKYMZCVDODXCRBJDGQGPQVCGMOQEYCIQIG");
    msg.ecount = 31U;
    msg.enames.assign("LWVZZQVBNBHPVPODZOWEAAPSJVMLBMOIJNNYSCWMVEXMPHVJQBDKKJOFTVXFTCDDYIAQUHBUEUCBNAGEHYBLJSYGAKS");
    msg.ccount = 137U;
    msg.cnames.assign("VRSIOEATEOKVXSUKGEHHEUCXSWPWVDDRAIAGPASMROYDJVQREPJVUYZRVHLXFCTXFGNSJRTBMQDGXO");
    msg.last_error.assign("BSKKUJTFOIXNSDQWSNSMDNEPFIKDTUWQVYPELZQSLIMGFQMJADXHIXZCXWOAYZCLZFXHNGHAJQYLBZMRAHKGRQOUUIFPDAMOSAZVIGHOVZVCSE");
    msg.last_error_time = 0.353038482743;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityMonitoringState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::OperationalLimits msg;
    msg.setTimeStamp(0.454301897055);
    msg.setSource(35626U);
    msg.setSourceEntity(82U);
    msg.setDestination(14559U);
    msg.setDestinationEntity(35U);
    msg.mask = 110U;
    msg.max_depth = 0.0438947606858;
    msg.min_altitude = 0.969441549561;
    msg.max_altitude = 0.624710188851;
    msg.min_speed = 0.50389990127;
    msg.max_speed = 0.384080504766;
    msg.max_vrate = 0.574909321517;
    msg.lat = 0.862925854853;
    msg.lon = 0.0431129989449;
    msg.orientation = 0.257460503162;
    msg.width = 0.877724434495;
    msg.length = 0.662415390156;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("OperationalLimits #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::OperationalLimits msg;
    msg.setTimeStamp(0.64708315773);
    msg.setSource(63030U);
    msg.setSourceEntity(49U);
    msg.setDestination(21447U);
    msg.setDestinationEntity(238U);
    msg.mask = 225U;
    msg.max_depth = 0.587922907796;
    msg.min_altitude = 0.759608694299;
    msg.max_altitude = 0.17291456942;
    msg.min_speed = 0.7649646267;
    msg.max_speed = 0.86638088393;
    msg.max_vrate = 0.669859255939;
    msg.lat = 0.98065098712;
    msg.lon = 0.393674869208;
    msg.orientation = 0.399108699328;
    msg.width = 0.760781111022;
    msg.length = 0.385944125389;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("OperationalLimits #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::OperationalLimits msg;
    msg.setTimeStamp(0.817829237319);
    msg.setSource(7600U);
    msg.setSourceEntity(246U);
    msg.setDestination(32234U);
    msg.setDestinationEntity(91U);
    msg.mask = 129U;
    msg.max_depth = 0.247773463726;
    msg.min_altitude = 0.398219494504;
    msg.max_altitude = 0.447990287314;
    msg.min_speed = 0.666648865304;
    msg.max_speed = 0.522210996149;
    msg.max_vrate = 0.627401801898;
    msg.lat = 0.408659369544;
    msg.lon = 0.927647270974;
    msg.orientation = 0.273665861418;
    msg.width = 0.410277156355;
    msg.length = 0.920016147195;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("OperationalLimits #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GetOperationalLimits msg;
    msg.setTimeStamp(0.0636718189447);
    msg.setSource(1156U);
    msg.setSourceEntity(111U);
    msg.setDestination(58294U);
    msg.setDestinationEntity(250U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GetOperationalLimits #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GetOperationalLimits msg;
    msg.setTimeStamp(0.0847342561967);
    msg.setSource(3299U);
    msg.setSourceEntity(135U);
    msg.setDestination(35289U);
    msg.setDestinationEntity(71U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GetOperationalLimits #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::GetOperationalLimits msg;
    msg.setTimeStamp(0.510478262665);
    msg.setSource(41019U);
    msg.setSourceEntity(152U);
    msg.setDestination(25649U);
    msg.setDestinationEntity(222U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("GetOperationalLimits #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Calibration msg;
    msg.setTimeStamp(0.994817777228);
    msg.setSource(64249U);
    msg.setSourceEntity(96U);
    msg.setDestination(12909U);
    msg.setDestinationEntity(142U);
    msg.duration = 48734U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Calibration #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Calibration msg;
    msg.setTimeStamp(0.945272810648);
    msg.setSource(56479U);
    msg.setSourceEntity(64U);
    msg.setDestination(10517U);
    msg.setDestinationEntity(13U);
    msg.duration = 62876U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Calibration #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Calibration msg;
    msg.setTimeStamp(0.493870449325);
    msg.setSource(11261U);
    msg.setSourceEntity(95U);
    msg.setDestination(42620U);
    msg.setDestinationEntity(123U);
    msg.duration = 37218U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Calibration #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ControlLoops msg;
    msg.setTimeStamp(0.535663312355);
    msg.setSource(41652U);
    msg.setSourceEntity(241U);
    msg.setDestination(23450U);
    msg.setDestinationEntity(204U);
    msg.enable = 244U;
    msg.mask = 1550079932U;
    msg.scope_ref = 1295577540U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ControlLoops #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ControlLoops msg;
    msg.setTimeStamp(0.830877639699);
    msg.setSource(14372U);
    msg.setSourceEntity(205U);
    msg.setDestination(9300U);
    msg.setDestinationEntity(219U);
    msg.enable = 181U;
    msg.mask = 2421672460U;
    msg.scope_ref = 3001324316U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ControlLoops #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ControlLoops msg;
    msg.setTimeStamp(0.461935450932);
    msg.setSource(56799U);
    msg.setSourceEntity(155U);
    msg.setDestination(24765U);
    msg.setDestinationEntity(128U);
    msg.enable = 188U;
    msg.mask = 1939455066U;
    msg.scope_ref = 2676809810U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ControlLoops #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleMedium msg;
    msg.setTimeStamp(0.107278511591);
    msg.setSource(38960U);
    msg.setSourceEntity(34U);
    msg.setDestination(13676U);
    msg.setDestinationEntity(199U);
    msg.medium = 243U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleMedium #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleMedium msg;
    msg.setTimeStamp(0.670752200569);
    msg.setSource(61016U);
    msg.setSourceEntity(94U);
    msg.setDestination(42610U);
    msg.setDestinationEntity(207U);
    msg.medium = 24U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleMedium #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleMedium msg;
    msg.setTimeStamp(0.4973211685);
    msg.setSource(51010U);
    msg.setSourceEntity(186U);
    msg.setDestination(1086U);
    msg.setDestinationEntity(119U);
    msg.medium = 128U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleMedium #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Collision msg;
    msg.setTimeStamp(0.514447345248);
    msg.setSource(33910U);
    msg.setSourceEntity(68U);
    msg.setDestination(55070U);
    msg.setDestinationEntity(252U);
    msg.value = 0.113445696603;
    msg.type = 243U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Collision #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Collision msg;
    msg.setTimeStamp(0.635558616289);
    msg.setSource(61931U);
    msg.setSourceEntity(184U);
    msg.setDestination(35130U);
    msg.setDestinationEntity(119U);
    msg.value = 0.869998480592;
    msg.type = 206U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Collision #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Collision msg;
    msg.setTimeStamp(0.498979360391);
    msg.setSource(34460U);
    msg.setSourceEntity(76U);
    msg.setDestination(6109U);
    msg.setDestinationEntity(16U);
    msg.value = 0.161873674823;
    msg.type = 43U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Collision #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormState msg;
    msg.setTimeStamp(0.592217356213);
    msg.setSource(20925U);
    msg.setSourceEntity(120U);
    msg.setDestination(45255U);
    msg.setDestinationEntity(124U);
    msg.possimerr = 0.303977408801;
    msg.converg = 0.727993852257;
    msg.turbulence = 0.546532080252;
    msg.possimmon = 151U;
    msg.commmon = 150U;
    msg.convergmon = 3U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormState msg;
    msg.setTimeStamp(0.128856059541);
    msg.setSource(13495U);
    msg.setSourceEntity(210U);
    msg.setDestination(59780U);
    msg.setDestinationEntity(155U);
    msg.possimerr = 0.106164827668;
    msg.converg = 0.851957425922;
    msg.turbulence = 0.981771275472;
    msg.possimmon = 36U;
    msg.commmon = 167U;
    msg.convergmon = 14U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormState msg;
    msg.setTimeStamp(0.0913506415067);
    msg.setSource(9788U);
    msg.setSourceEntity(23U);
    msg.setDestination(43205U);
    msg.setDestinationEntity(230U);
    msg.possimerr = 0.698018499397;
    msg.converg = 0.243452745087;
    msg.turbulence = 0.270545996516;
    msg.possimmon = 172U;
    msg.commmon = 199U;
    msg.convergmon = 1U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AutopilotMode msg;
    msg.setTimeStamp(0.602748682244);
    msg.setSource(51058U);
    msg.setSourceEntity(221U);
    msg.setDestination(56736U);
    msg.setDestinationEntity(95U);
    msg.autonomy = 16U;
    msg.mode.assign("XKCMDJBFTWTVEHLAFRCLFQHPTESDEXHOCZPNAAKYZURIPVGCDYNZYSLRHXICXSZGXZPUNBRJBWOJDCRPAQRRADKYGYZLWOTSKUJYDROQVSFMTVQGKPYDBHMYGXCLXAJJNJULBXCUEKFKINQMMILUEFAWQPH");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AutopilotMode #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AutopilotMode msg;
    msg.setTimeStamp(0.374083038698);
    msg.setSource(37432U);
    msg.setSourceEntity(133U);
    msg.setDestination(20894U);
    msg.setDestinationEntity(168U);
    msg.autonomy = 12U;
    msg.mode.assign("IMEZGZEANCICRHFJMWFTYXKRLJXYBOWWYAPLCPSLKTSVBOUTHPHPDGOFBQUEKECXKOIRANNSETABMAWIDLSXIBQEVFTUXDVIDRCMTMEYPLNVURQPZXHIRFLRQOBWJZWJSWXOIKUCDWZLUYHXYFEHQGMZKNORKLFJMAUFYOCYHBVANXJYGQVCMWLUITNTOJTHVHZVBQVQKSHDDGPGTFBJPKNFJLRROMY");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AutopilotMode #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::AutopilotMode msg;
    msg.setTimeStamp(0.253358050046);
    msg.setSource(26425U);
    msg.setSourceEntity(211U);
    msg.setDestination(57630U);
    msg.setDestinationEntity(149U);
    msg.autonomy = 249U;
    msg.mode.assign("RTYRESCKOKLJHOFGHTQNDEUNSFMUEERDPOXGIQPJYRXACBKWQIJJRIKTEZHFASOWPQHYQGDEVKPWRXSUISLKHOMZILNJPJZWGHVVMECONCPKBSJXPQTAQYUXIEVTZTNWGXZQVTLNURKMOOVCHFSIWFDDDSBYRUZLADTIJCMYIBLFNINGVWSFMDKGWAUUFKBHSA");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("AutopilotMode #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Abort msg;
    msg.setTimeStamp(0.00519411592657);
    msg.setSource(9361U);
    msg.setSourceEntity(180U);
    msg.setDestination(57866U);
    msg.setDestinationEntity(176U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Abort #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Abort msg;
    msg.setTimeStamp(0.0451480581827);
    msg.setSource(23474U);
    msg.setSourceEntity(253U);
    msg.setDestination(46723U);
    msg.setDestinationEntity(178U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Abort #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Abort msg;
    msg.setTimeStamp(0.312509837194);
    msg.setSource(10182U);
    msg.setSourceEntity(26U);
    msg.setDestination(649U);
    msg.setDestinationEntity(29U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Abort #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanSpecification msg;
    msg.setTimeStamp(0.305065751681);
    msg.setSource(61464U);
    msg.setSourceEntity(66U);
    msg.setDestination(11489U);
    msg.setDestinationEntity(115U);
    msg.plan_id.assign("QUCXEDZAFOSXOWYBJNCERLHYRMDBYHEWIADVHGBTSEPPBKYOSZYFPWDMUIIQJHZOGREKWXSXMKGLYJDNCHGULKLJNCREDQPPATGUHKEFNEBHSUPTNJMGPI");
    msg.description.assign("JWJWFRRNDYHRGICOQOFGYQDTILGHRVADVTLTOGHRZEVYLJUVLMPIPWJJKEBTHLBKHJERADYXKYGGSFVGEVGOAMWVZZNNTZCQKQTLZNHIOTHPXFHISINFQWYPDFWCXDJRCBADEEJKKSLQRNYUULZCSXFX");
    msg.vnamespace.assign("YNSQHLMGBIEZZXQXXZAAEPPLJBIXWDOLSEDMRTKASSTAXWCLSCOHKRYSXNSPVMHZGRBYXLOKBLRDXQHQWMATUNDMLHTVMFJQJNUFUCFBNCFUFYTWWVVEDYKZWZMBMLJPYQYGIFAPRRBUKITUCNGQPVRAFQEHJEHNUVOUVJBCIRGGVMGHKVDZZHOLENDDAFJEIOK");
    msg.start_man_id.assign("MVPHKYCTVNANBZIJHEZUGWXXWNVXSAPWPLDQCHLOBBDEPUUEWYCOJROSRTYJCDTONDZVDWDFKLGQIFWMMKAUH");
    IMC::PlanTransition tmp_msg_0;
    tmp_msg_0.source_man.assign("WOZTEBKVIFZKSRVAPDZNWHBDHMJQCVIAHEHMBWLJMYBXUQYIKDGAOAMRNUEVILGPKCLYRCJNZJGFVNVYHEQIMKIXQYHOWWRTYFEGZATUUUYXXCMNICPCPDWLQQIVSTSZXRJBGORNPBXMNVCBDDMWPUUELQJGKJIRNETPFSDWOOOBQGFEPPLRZS");
    tmp_msg_0.dest_man.assign("FNFBSJOPVPUMHEIOCHNLKACGISTWAHWUZZTQJMSDVUAWOVZYYSKYMGCGNOUBZLAKID");
    tmp_msg_0.conditions.assign("HITLUOARGLCGONHWYIJDMOLFFSPCKNKKDLKPBKWNNLOECJXSXMIOTZQXXQAHHBCFTLGHSYJZRRXZWIDEWKOEHGZBUPSBREMNVFOYTBXTCBBPLOF");
    IMC::FuelLevel tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.value = 0.330326942435;
    tmp_tmp_msg_0_0.confidence = 0.683421477878;
    tmp_tmp_msg_0_0.opmodes.assign("IBHVYDFMJKGLJMHXAKYEXSTACKIKNBCVWQNNMSYUFZDCPDHTGDCHPJZEBGWQIRYIWOHLULCUHQASPVEXMNEQTNQROMWXSOYKSCRLCYZPBGKENCYWRIYEBTUVOKLONKQGSEFVBJKQRD");
    tmp_msg_0.actions.push_back(tmp_tmp_msg_0_0);
    msg.transitions.push_back(tmp_msg_0);
    IMC::FormationPlanExecution tmp_msg_1;
    tmp_msg_1.group_name.assign("AGRCHEXLQNKNZEDOFGVIADJRORLXFLCYFEMNOYRMDZQVBMLPREURPGZXVWKHGDNIYPUBQUSVVXPDVYEOWUGGHBVQQACMXIEZJEMCZTFXCISRMKFFKBUJAPSZFHHLTTJUDJTQIZPZBXJMODQTWMJHUWXQIOHMBLUPBGBNFTILSUWPAITYOGH");
    tmp_msg_1.formation_name.assign("DTLXOMTHZHKPNWDLFBKEPCSZFGLSPNZTHAKCFQJXPHMTKSBJTZZBXXRJIU");
    tmp_msg_1.plan_id.assign("CRHYTLGYFCOSWFCKGZWNYTPZJNHUJURQTKADUJXGJKBRSYDVBAFOMRBMZHPLMUQLQENGWZS");
    tmp_msg_1.description.assign("DSSJDIUFWYHAPQLRLUHAOMX");
    tmp_msg_1.leader_speed = 0.563115174483;
    tmp_msg_1.leader_bank_lim = 0.743253830158;
    tmp_msg_1.pos_sim_err_lim = 0.734873480442;
    tmp_msg_1.pos_sim_err_wrn = 0.672142152274;
    tmp_msg_1.pos_sim_err_timeout = 26487U;
    tmp_msg_1.converg_max = 0.955557040877;
    tmp_msg_1.converg_timeout = 21519U;
    tmp_msg_1.comms_timeout = 14361U;
    tmp_msg_1.turb_lim = 0.0749778243494;
    tmp_msg_1.custom.assign("GBDXOZNKQGLRFZFZCPXFXANDTZEXJCVBDZURQWALMATCTKYWJPCUKDENOQCXINWZZOSMGBFYTYDPUQNOBTIFNKNEVVHQVUYYIZYPKVWPKHAWZJLJQRWGIYD");
    msg.start_actions.push_back(tmp_msg_1);
    IMC::NeptusBlob tmp_msg_2;
    tmp_msg_2.content_type.assign("CMSJLGZJLRSLMHZATRHAZMKBFYAXEPWOBJCQNWWOPRXANBHXIVLSQOAHUTGMECVKDRIANWBCY");
    const char tmp_tmp_msg_2_0[] = {-128, 68, 22, -126, 70, 83, -105, -48, 58, -89, -105, -7, 79, 85, 98, 29, -104, 13, 56, 3, 24, 126, 121, -23, 94, 13, 104, -86, -7, 25, 73, -126, -31, -97, 114, 82, 7, -69, 121, -42, -30, 25, 19, 18, 115, -2, 91, 9, -22, 111, -55, 125, 17, -104, -59, -78, -15, 111, 117, -80, 8, -39, 80, 89, -125, 125, -87, -55, -79, 4, 0, -91, -49, 95, -35, 31, -43, 8, -115, 29};
    tmp_msg_2.content.assign(tmp_tmp_msg_2_0, tmp_tmp_msg_2_0 + sizeof(tmp_tmp_msg_2_0));
    msg.end_actions.push_back(tmp_msg_2);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanSpecification #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanSpecification msg;
    msg.setTimeStamp(0.944455847101);
    msg.setSource(1956U);
    msg.setSourceEntity(16U);
    msg.setDestination(53459U);
    msg.setDestinationEntity(158U);
    msg.plan_id.assign("YWXODPNUZWTYMGEWSWHKKDGHVMBLNXZYOKJJEQUZMTIYKQPBVFPVSBGBAKEFNNYYMSPRVZSQLVIKLVGFUZG");
    msg.description.assign("RNYZLMMVTLSGPGCNJGVTDCDAFUKEENUVHTQJAPDFUFILBOJKGFQYVRSLZMABPXEGNCTOOPPQARDJIJJIHGDQ");
    msg.vnamespace.assign("CNJUYBVMGVVJFWHCCJPWUGXMIRZLGQWHAQSLEPAEDNVCYZLLOVYATEMEKKRYBFSBGVAZWHXDGFIGBZUUSTMZQLPROHVRWCXPSDTJFNFFNBXYPZIWDKHURLQLCZMOYJCLBWYSDEQNTDUMKQDFELKIZIWTSRTXFSYANQSIDHNYSGQENBUGXURFANVTMXHLYGJNXQAEHTKJKDPRBBJOOJOWXIOPRKRMVGTEMDUSIOCCUIOWBEAP");
    msg.start_man_id.assign("UYBDRNOWQSZGKQWGQDODTPYISELLETPBVNSOVPTHRJAXDIHRMBKKQTCNUIYFWDTSCMNABPLVRONEHAIHCQDWKYULXBORNHUOVFMYTMKZQSXKOEWLOEBBLJJTWVMGHCPBSGREZAPUVSZAAUCESKDIXON");
    IMC::Heartbeat tmp_msg_0;
    msg.end_actions.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanSpecification #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanSpecification msg;
    msg.setTimeStamp(0.147408257533);
    msg.setSource(53306U);
    msg.setSourceEntity(34U);
    msg.setDestination(14883U);
    msg.setDestinationEntity(174U);
    msg.plan_id.assign("GGFJZNUIOCZIPBWUVIUQHITEKDAOKSDXBVHWSGDIGZUMUFQSIAYTEMFHZYBBLLBXCBYDSVWRUTRXTSVVVXSEPONGHYESDGJCKUAILHAFBKOPINNWUPQJARIZLXJLCWUXFXWHAKLCKHDPPYSZBGDPQAKIYYMCNSPYJKVVAFQRJTJCNRLOMJOZCHGBYRYQDTWWMEMOPZGFFHZSXTNQCNONFEVFQRO");
    msg.description.assign("VMEBYLPBXTLFKQHYDHRCAFDGUUHNKYWAEEOVUSYEWAZDRIWGOCZBRQQZQKPPTKESFYOGVLAWMSEUHTGQEAOXKYIZHCIPBVRUAXVBFFEOFMHRFCADXBGCMUJBCANNZJNNOSHVBVXSXVQJQMNKRQJMSBDJFGGYEVJIBIOMJOHDUTKXJLLZUHCNCRZGPSLLTUYTDZCXLJWGWZ");
    msg.vnamespace.assign("QGJUHESPKUMCGACVYATQFXIXVEQBUEFZBVWESSUKXDBWCJGULBRMZNIIHSTLRISVYKONBSPXHENLJDRRGOZAPMKLTRYNHWDYUNJNBZDPFCGOLQECDRSZMDG");
    IMC::PlanVariable tmp_msg_0;
    tmp_msg_0.name.assign("MYXVYKXIVKYKBLNMRHDABOHIYLAVOSEICZFDHTWXAZJUHDUQTRKECGXOGMRIMBXRERYGEGFAXEISURMWCFKNTEDZOJWBLWAYHZWYFZGJSNQCEONCNGPPJTPBTWFCOSQRQTEKIULKFQUNHNTMGDVAIARUWNHFCZRJSVZSOXPIAFZBCTKHQQBQUIPSYLFEMLXCYPOUPPOGCUAKAJZ");
    tmp_msg_0.value.assign("OQQVPNJYRDPKOTVEIBZDXFGMBHHPHUXGHKGOMCSTAJBURLSBXVFIWCUUWCSFATJXKXQRWLQID");
    tmp_msg_0.type = 72U;
    tmp_msg_0.access = 109U;
    msg.variables.push_back(tmp_msg_0);
    msg.start_man_id.assign("WCPHLHJVRDNZXCXZQOIKRDAOSZSPZYCIKDOBDOWQXHPKBPQEDDMNGHUZCKRANJQSAALYTFLJOJHUAUXKTESYMLVNURHRWNRLYMQSEBLFSUIMGBMZCTFVGBIZVYURTDWGTERXOIDZWJBTOQFAGRAGVYJYVLEIHDFAXNHOPEQVWUTRUHYSZUKTMLYWMKKEGLOCVUBAVVBJLEYQBWXWEXSSZPJFXFEMCPNCTDIGFSNMPNNAKPCWQIFJC");
    IMC::PlanTransition tmp_msg_1;
    tmp_msg_1.source_man.assign("RPGBGNQIOYTPDBAAHCNKMMRATELWXZDBLFEYTKQVUVFJWRGOXJNUSGQEZPWYVQVDSBQYIIPDXABESIYLWSMKXTBVUXLISCQIXEUJQHFJBMODOYUETYKKOEUZLXA");
    tmp_msg_1.dest_man.assign("XQQJLHOIKLPFQHGJASIGUZAHLFTVEMCMIMSBAEVJETGVNUAEQTOHSRGWOXWYWJHIMHRBENFTYAVZDFINULCJMUIVPGRPWLCNFRSNCXHFEXTEQANSLVZFEYMVRMNQGDVIVZFRIYUTOBXJUCUBWLAOMJWPXGYKQBTFQDURDYIOHMJKTAKKXPSKNDCWQGFWYSHKJBPNUG");
    tmp_msg_1.conditions.assign("UPBLCVSNLVYXADXBRUMWUTEQP");
    IMC::CcuEvent tmp_tmp_msg_1_0;
    tmp_tmp_msg_1_0.type = 87U;
    tmp_tmp_msg_1_0.id.assign("VIARQBIWKMWVEBWHBDUCDKFQNIZULPAKYSWZEIJKVUNGJUPZNPQZNYNOEACLBDSGKAYAGFJXIOKHTLDSXRETGAZXQNMTVGFVXKDMBJNPSBSRUYEXOVDULHGRFJMYQDIXRFYHUPGLTMCYJFRHFBVJXPZTZGSPQQWUXRQTFCVARUHJKMDTSTSHQEWYGPZIBCT");
    IMC::RemoteSensorInfo tmp_tmp_tmp_msg_1_0_0;
    tmp_tmp_tmp_msg_1_0_0.id.assign("SNPOQHBCBWMNMJMLOMVTWCLQUTRLCQLHKCXCFZDOZSAREYSSVSFITIDWHOEAFZUHMNPQFGQEOGYBTTNTZOJWKVKLKAENTTDAQYIFHGXHEIPNWKPYXQBUMXPEYPPDCLEMSVEEHVIHHWJRVQZPYIWUAXSWHOQXSGDLXRLQDJS");
    tmp_tmp_tmp_msg_1_0_0.sensor_class.assign("ZJCPNRFXLNKLLOUCMCWWQQOQONAIUHZNIGLTMYJBFQODEKWRIZYMMRATJPRNAPKCJFHYCLOODQRZRYGBSUDYBTKAMAGDDVEK");
    tmp_tmp_tmp_msg_1_0_0.lat = 0.356170008352;
    tmp_tmp_tmp_msg_1_0_0.lon = 0.501337910753;
    tmp_tmp_tmp_msg_1_0_0.alt = 0.00117113253893;
    tmp_tmp_tmp_msg_1_0_0.heading = 0.720888160914;
    tmp_tmp_tmp_msg_1_0_0.data.assign("ZFOVMXVWBRLRXXDQFTIIBVHRUCXULGWFMTMDKROUDGBQGEMSYCQJJBSZYJIPLDZINGBLOKBHPCYYDKFOSJALLKDESEDZJOPXRGMUPCANHMEBWNQMWONHRMHXZEPIAGNTGHDSHXYCKIYTDVVCWAVKIKTGKEZXQBLKXTIFXPUKMAYSBTCFPWNNLET");
    tmp_tmp_msg_1_0.arg.set(tmp_tmp_tmp_msg_1_0_0);
    tmp_msg_1.actions.push_back(tmp_tmp_msg_1_0);
    msg.transitions.push_back(tmp_msg_1);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanSpecification #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanManeuver msg;
    msg.setTimeStamp(0.432998016326);
    msg.setSource(23508U);
    msg.setSourceEntity(13U);
    msg.setDestination(39346U);
    msg.setDestinationEntity(33U);
    msg.maneuver_id.assign("MFXKEGDZZOHCACWDHINSXRDEPDROLGDPPQCTLUHPCZBZQBFVSVFKMUWWVJZPVCVTQYEX");
    IMC::CustomManeuver tmp_msg_0;
    tmp_msg_0.timeout = 54850U;
    tmp_msg_0.name.assign("XVSZYCBUPEZNSQVGOPHILTNPPIVJJIMDVWODJJQKMWKXMHYGZQFFEQUBNDKKCHMSUBFYDPAEMBXRCCTRZLYCFFMDAUTVZAHOCPPXWWDMYEGMHVVSHKIGLTVBITQYNLLJZWBWOVROEZLPDNB");
    tmp_msg_0.custom.assign("MPHNFBDXERPGOSPOIZCIULBNQAAFRSPOIQMTUWNOCPHIXYBRHMZAITAVMVSJJKYDAUZKTLKWSCHOQNZEZYZKXQIBHTKFAZGGUMFYLTOORJYJBDJEZNIVFNRLSLNAWFMWQPEDBYGCMASDLXAXPUITHEDMAJGUYBHVYREWQESMYUJFRKIGSDQCDBO");
    msg.data.set(tmp_msg_0);
    IMC::Temperature tmp_msg_1;
    tmp_msg_1.value = 0.09579623646;
    msg.start_actions.push_back(tmp_msg_1);
    IMC::ButtonEvent tmp_msg_2;
    tmp_msg_2.button = 115U;
    tmp_msg_2.value = 84U;
    msg.end_actions.push_back(tmp_msg_2);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanManeuver #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanManeuver msg;
    msg.setTimeStamp(0.348082077353);
    msg.setSource(43785U);
    msg.setSourceEntity(60U);
    msg.setDestination(19461U);
    msg.setDestinationEntity(27U);
    msg.maneuver_id.assign("KURARXZUJUJKTMYOXPFFSPXVWXKXPVGCPBVRLVEJSCGQOSMWHCVGHYDNMKQTZEBIHPLRDQQGWHPEQUINTAA");
    IMC::CompassCalibration tmp_msg_0;
    tmp_msg_0.timeout = 32444U;
    tmp_msg_0.lat = 0.0613741782562;
    tmp_msg_0.lon = 0.137191465453;
    tmp_msg_0.z = 0.276418611008;
    tmp_msg_0.z_units = 224U;
    tmp_msg_0.pitch = 0.0885466515468;
    tmp_msg_0.amplitude = 0.476467279005;
    tmp_msg_0.duration = 1565U;
    tmp_msg_0.speed = 0.744355907496;
    tmp_msg_0.speed_units = 53U;
    tmp_msg_0.radius = 0.192264665392;
    tmp_msg_0.direction = 110U;
    tmp_msg_0.custom.assign("FRTDRKZARBKPCXCAZUHJWZFRNRWSDGHUUKZXOEILPTYXLXYAHDDVTMYZKBXGYKSMLXNCSXIVMLPIHACBGUZNEPSCNPTPBEUBQVONYYIVZBQEAOHZAJASVGGBICSPAFSGJCJMPYFMQJKMLCDERMBXIVQKHQIJEFKCZRDLOWEOBYTYTRHNIGQQLTKRJLONUQWTFX");
    msg.data.set(tmp_msg_0);
    IMC::Brake tmp_msg_1;
    tmp_msg_1.op = 220U;
    msg.end_actions.push_back(tmp_msg_1);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanManeuver #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanManeuver msg;
    msg.setTimeStamp(0.696439320774);
    msg.setSource(9693U);
    msg.setSourceEntity(147U);
    msg.setDestination(52188U);
    msg.setDestinationEntity(146U);
    msg.maneuver_id.assign("PWUUWJTVGFDBXMFQSIWTJQRRLIZBNGQNRCKBRPPSPVAPYOBIOULCFKFQHDEXAYDCUJPIOVYEDJFSKUQMZVNAKMLJBJWLIRGPDCLEFIGRSTTSRQTZAXONYCXKAMLLAEDTLDSEFPCHNXNXFFCWDYBKWQMJZIGFTEEMMSYAGTHOGYXSSXAIZQXOOMJHYBZWSVPOYRIAETHBTUONHQLWAGLVQVCWKDHKYMUPHCDJVRRZZJNGV");
    IMC::StationKeeping tmp_msg_0;
    tmp_msg_0.lat = 0.968780983628;
    tmp_msg_0.lon = 0.726550508033;
    tmp_msg_0.z = 0.00584794300388;
    tmp_msg_0.z_units = 211U;
    tmp_msg_0.radius = 0.585865941491;
    tmp_msg_0.duration = 13228U;
    tmp_msg_0.speed = 0.451171899655;
    tmp_msg_0.speed_units = 79U;
    tmp_msg_0.custom.assign("VFJGMEHMCABGLZJYEV");
    msg.data.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanManeuver #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanTransition msg;
    msg.setTimeStamp(0.424359327096);
    msg.setSource(58190U);
    msg.setSourceEntity(160U);
    msg.setDestination(15126U);
    msg.setDestinationEntity(40U);
    msg.source_man.assign("RHLYKNONYSXVQLTQLMXCHRNRCRAYQXCJTVAKFZCPZBLGEXWCKGHOOXHGZPJGDEDEVBTWWOEYUKKIJOMLUZZUMNIXDJSIUBVCCRPMTDBFOGPKUYPIIKQJIPXOIDZBVAIXEPWEK");
    msg.dest_man.assign("YQUZQWQQCWDMMQJINUAWMBONCHJIMHVFUACWFZKDDFQZDORZSVTKPCLORYWUQRBVHPASXWSMJACHOAHCBWMLTSNNGVZYUUXSGYJTCLSLQHIEZJQJEPRJEZNPAALGVUZNYFODFXHSXZEREHYLGGCSOXNVFJEFXKVLAWTUKFBLRIIOUKAMBLXTTTBWDQNJYBWENIPOF");
    msg.conditions.assign("JADLZBURKKKVRI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanTransition #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanTransition msg;
    msg.setTimeStamp(0.422214482244);
    msg.setSource(63060U);
    msg.setSourceEntity(244U);
    msg.setDestination(50946U);
    msg.setDestinationEntity(46U);
    msg.source_man.assign("ZNVRVZHWXEEHETADRWTPHQXCCKCNECMGRQOUEPJCOBJMFKQWSPDJYSQZPUTVONJMGAUIOEQORHYZPSTITUKHEAAYWYCDKBQOJMGLFYKYIFLXRLSYMNNIDLHIRSIUYVRORBCGAZHJDLVHJWBGJZPSAOEMVGMDBLPLIAUHLVSBCIZLANRKEZXJXBIMUFSMKIXQNNWGASOUBXTKDWLPCMXTQFZGKFTF");
    msg.dest_man.assign("KHOZDCMUEJLWAKHVYMMSUWNCGYGNQJQMMEBGCFOVSSNJAQDBHDWAUUFPRBKNTLUHLBFIKFYMXD");
    msg.conditions.assign("HYQMFOHPKWHXUCWWGUEUVUOJOPZMZZYBMVTNKUZMNYJBSMQVKDSNIROAMCCG");
    IMC::Aborted tmp_msg_0;
    msg.actions.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanTransition #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanTransition msg;
    msg.setTimeStamp(0.650397497963);
    msg.setSource(64341U);
    msg.setSourceEntity(188U);
    msg.setDestination(23002U);
    msg.setDestinationEntity(238U);
    msg.source_man.assign("KMGNKMHBWBEHUOLTVWZOLRJLWPNAPFMEPZBOZKSLSMBKTIFDQXETUGYGPUIINNLVRSSYPE");
    msg.dest_man.assign("ERCLBMXFQCFUUSGKKDZPTCRUTDUXBVACRMZCKAWZTLJPAKXUQGEEYUHAISEXOPQGRGKTFJGPJOMTIUWHPPFJDKDSGWRMNPTRAYYUHLTFLNKBYXGPUBHZBJISBSKMOMDDQEAKJJRPWNVMCVGIANAYAOVEWBNIOXALYUZVTYOMSLCGHIQWCLHZ");
    msg.conditions.assign("CFEKJYZRMKDIJEHGSTELYPEHNWGRSGIKVGUPMVZLVGMORZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanTransition #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EmergencyControl msg;
    msg.setTimeStamp(0.110947790928);
    msg.setSource(31663U);
    msg.setSourceEntity(98U);
    msg.setDestination(1585U);
    msg.setDestinationEntity(4U);
    msg.command = 194U;
    IMC::PlanSpecification tmp_msg_0;
    tmp_msg_0.plan_id.assign("PJUMBLNHWWMXZDQOACGBIVBQYXCFXMRGVALOURJXCQYAISOVHZSVDLPUOYCICOHQENMTXIVHLJNIYRHTPTUGTNWNTXQBWWKREDOZDBAWSZCXYZKDKFNBVJHESONPCTBFSJWQRBJSUZSKJTREHGGAFTLKAPFFJZJDYGTMQWNSDJLFLVESMSERBKDWZFHKVLIXPEKAUQUIHRWGPLARXCYUZPKINQGYCLXYIEMRHVMZFAODIOQBOPUK");
    tmp_msg_0.description.assign("SJUUHLJZQBIYHRKZFKOCGRPAGPLUGXINJWVEMFYWOKRFWTLTYOMDECEBVNIXRUSQSERUWYKIJTPTGDXCSZGJZFSHDLIQTBORKPPCIGMJUTCYOSALXFKWOPPXIPOQSDLBDNSRZBCQNBUUZTGHTAS");
    tmp_msg_0.vnamespace.assign("CIIYZYOSKBZNVUTWREPWRGIQKMTNMMXGRHVSZKOBAPFYGAEMBPVDEWZSFOCTECJXMQOUTGRJIMLQSCDDXMRJCHHBKKOHUQYOIWMVGRZCDNLFXIQCNIQBDSRHVTGJKBJPEWUL");
    tmp_msg_0.start_man_id.assign("JMXCRJQMEVTQKI");
    IMC::SmsTx tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.seq = 1814283713U;
    tmp_tmp_msg_0_0.destination.assign("SXLYJIGPKQMFEUOQLPUMTBYGENPXXIOAOSJAYKTWFSOFEKZMPRQTUAELHRBECXGTBNUTFOZCNEIHSEDPWJWEGZXHALWDYJMTKVWITFDLRJMWJOGMHGJRV");
    tmp_tmp_msg_0_0.timeout = 12298U;
    const char tmp_tmp_tmp_msg_0_0_0[] = {-105, 55, -24, -5, -38, -67, -106, -6, 55, -39, 93, 21, -65, -77, -87, 12, -105, 44, -16, -84, -35, 87, 12, -9, -98, 92, 77, 52, 25, 67, -95, -27, 114, -38, -54, -81, 123, 15, -11, 92, -10, 103, 79, -58, -99, 117, -81, 54, 4, -79, 68, -4, -73, -23, 120, 119, -37, -48, 80, -84, 105, 8, 125, 123, 9, -111, -123, 45, -115, -105, 55, 24, 89, 112, -102, -45};
    tmp_tmp_msg_0_0.data.assign(tmp_tmp_tmp_msg_0_0_0, tmp_tmp_tmp_msg_0_0_0 + sizeof(tmp_tmp_tmp_msg_0_0_0));
    tmp_msg_0.end_actions.push_back(tmp_tmp_msg_0_0);
    msg.plan.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EmergencyControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EmergencyControl msg;
    msg.setTimeStamp(0.00447071047796);
    msg.setSource(45628U);
    msg.setSourceEntity(149U);
    msg.setDestination(31146U);
    msg.setDestinationEntity(153U);
    msg.command = 95U;
    IMC::PlanSpecification tmp_msg_0;
    tmp_msg_0.plan_id.assign("UKPUGWJEVYVXLYWDAEYPPZIHMXWUABPGSDTHNWDLPSCODIOVVJQRDILOSUGKWMLCNJUMTCLFCEJDKKHADJBWVRKBVENAUOMSRNOJNCY");
    tmp_msg_0.description.assign("EXLZGZHAHFAEAHVPQHJQZKCVSUODNNQNJTTMYRBVQSXVCTGUDLUKIYCYPJOYGDNTEOLCFVRGIENPBSQYEZYTBMSIIMDFFOBRIXPPCMGMWRV");
    tmp_msg_0.vnamespace.assign("VIVWIQZYZYUYOTGDHHQJAYDXJRHNWLFQTXLHNZGMM");
    IMC::PlanVariable tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.name.assign("JKHTRVSPWYZUYWBVPYQKEIOJPVXIGALQGHPXYZKODWQIFTRWBHTXJLDSFYRTGBSLBAADVCWHERYTIJIQPVKPGLHFMF");
    tmp_tmp_msg_0_0.value.assign("NJPBFJBHSJJPLUVMIJFSRIDGYWJAMXEHFUDFNBOAGVZLTKXRQNDZZRFUMEOZMHELCUNCBVTIHLAPYUCKPLCDYAGXWXDKEHGNHRDOYMLISTIWXRFSDQPOPUWDXQSAOFTGJIJLKWCKXCTHDQJKWZMQVYNRITFUZKSHOOVVWIBBTMGTWQZEEARZAXIMWKQPOACCNAOXHNFMBFVGVPUYZCSYROSGEDLVTRPWKGUZNTRYQEMILAYHUSQBGQKYCJ");
    tmp_tmp_msg_0_0.type = 154U;
    tmp_tmp_msg_0_0.access = 89U;
    tmp_msg_0.variables.push_back(tmp_tmp_msg_0_0);
    tmp_msg_0.start_man_id.assign("OPSMYLQQGMLLJFNPELNFEFMKDMSNISTCJZUXLSEHSYDWDNFXONOYZJCDBOBKADPURZKQHTJUOBCYPSRTSKKMVWUHEORPPZBIZXGVGBJSJVUXGYJWIZNFCKQIVRXCUQJHGUXUTYPIRBATLBDIAKEIDJMZVFNVLTRQZIKRJRGIALVULFQTPQZNMOSDWCYKVDXHETWKTMZXHPHCQHXMANVGHAFWNOAWWEHVDRFBBCM");
    IMC::PlanManeuver tmp_tmp_msg_0_1;
    tmp_tmp_msg_0_1.maneuver_id.assign("LLHAMYXHKGCNVHPNWDXHTGDDLTGPZNUXWCIBJPQYRRKAEPBYRKXBKYVIFRUVVIRAWOSCFFDVZPYSQAEHMUJDNPAEMBXGIKUIMSMHNPFKELHCNAHZYXOESUNZCWMLXDEZZCEEESXLQUSRYGPBDQZUOFEBQVYOIJOVAFYLPTJFZQHCKUKVCTJQQVMGLOBKCUKJUFXLMTZWRWLOGJJRWTWGDSBDRGQTSMYJQMTNTAAOTSXGOVRWIIJ");
    IMC::Dislodge tmp_tmp_tmp_msg_0_1_0;
    tmp_tmp_tmp_msg_0_1_0.timeout = 16803U;
    tmp_tmp_tmp_msg_0_1_0.rpm = 0.0856290364778;
    tmp_tmp_tmp_msg_0_1_0.direction = 67U;
    tmp_tmp_tmp_msg_0_1_0.custom.assign("ABJNSBTOMMBABEERFEBXCVZQUOCKLYZWYBMLWMXTZFVIRBSUHWTKAZRJCDAZBGCCKKEWUWHQANQPLSYQQKYUNHJPULINAHORJKYWVVCNSQKJWGXXCDHOTPKPFOHDFZGDFAGGPTWUSEZVOCZRJUAJOCYDGJRR");
    tmp_tmp_msg_0_1.data.set(tmp_tmp_tmp_msg_0_1_0);
    IMC::SessionKeepAlive tmp_tmp_tmp_msg_0_1_1;
    tmp_tmp_tmp_msg_0_1_1.sessid = 880536005U;
    tmp_tmp_msg_0_1.end_actions.push_back(tmp_tmp_tmp_msg_0_1_1);
    tmp_msg_0.maneuvers.push_back(tmp_tmp_msg_0_1);
    IMC::VehicleFormation tmp_tmp_msg_0_2;
    tmp_tmp_msg_0_2.lat = 0.0348296193321;
    tmp_tmp_msg_0_2.lon = 0.807347662401;
    tmp_tmp_msg_0_2.z = 0.124908563749;
    tmp_tmp_msg_0_2.z_units = 207U;
    tmp_tmp_msg_0_2.speed = 0.890050426126;
    tmp_tmp_msg_0_2.speed_units = 57U;
    tmp_tmp_msg_0_2.start_time = 0.242409190127;
    tmp_tmp_msg_0_2.custom.assign("SKKISTSKFIFRAZSNMUYCEZSWKZGMCOJGWRYFQTJRXDAIONRFQVDZVAVGYIQHGBDIVJOLWUXSXUQMEAQTRJBTHOJELYLXNBDAWCPNFJFQCLOMZFKBAXXVNULXAKCLNBDZRMHTRQONGPQTLZDWYI");
    tmp_msg_0.start_actions.push_back(tmp_tmp_msg_0_2);
    IMC::GpsFixRejection tmp_tmp_msg_0_3;
    tmp_tmp_msg_0_3.utc_time = 0.355469609042;
    tmp_tmp_msg_0_3.reason = 136U;
    tmp_msg_0.end_actions.push_back(tmp_tmp_msg_0_3);
    msg.plan.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EmergencyControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EmergencyControl msg;
    msg.setTimeStamp(0.653354873865);
    msg.setSource(30826U);
    msg.setSourceEntity(34U);
    msg.setDestination(43688U);
    msg.setDestinationEntity(235U);
    msg.command = 27U;
    IMC::PlanSpecification tmp_msg_0;
    tmp_msg_0.plan_id.assign("KDPAVGYUCOLDW");
    tmp_msg_0.description.assign("JTJLUFHBRIFXAKRLWAGKKESKLZJAHSRNOSNMVXDCYCANJTAUBXVDAZSQMHIHDVGTFBMNQCRJRAXLKHAMPGSPXBYNOVTIVVILODIQTGBCGONIWPWHVCQYWNIPVTVQTRHYMUZBLOFWXHBIGJLZLJZXPXKRNPCZMFEYPWGCIZMYYEHOEMFBMFQWOIZDSDPZNBHANTKWUWSSAWRYGDGXFSOTFQETDCZUREFSXKRUBQYQKKDEVPY");
    tmp_msg_0.vnamespace.assign("OLRHZTUSALDKTIINPKIDJQZXVPMTWCYIDKCRMVDMCEBWTHNNRSDHFEENZXP");
    IMC::PlanVariable tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.name.assign("BGWRQFNJEQXIYFHGJURPFSBWJLILVDNBPIBBGJJXDFQZVTXQOGXXOKGMTXWAWPUENGZMDNORTOEUSBDEHNPXIKEYRGHHCZOIUCLKTWVEADXYADOWUGALXOLVVFSUCHJMBYSRLBFRLYPQIVZCROPPITCHPKRQNHTSUKYYZZSTKCYAKJOMPDIVQRMWAUPMFSFFHWZMNW");
    tmp_tmp_msg_0_0.value.assign("WNVFMWAOULYQFKNIYEXA");
    tmp_tmp_msg_0_0.type = 219U;
    tmp_tmp_msg_0_0.access = 140U;
    tmp_msg_0.variables.push_back(tmp_tmp_msg_0_0);
    tmp_msg_0.start_man_id.assign("YTDCECXCWRCXRUYADKXUOVBWVWEIEYYCXQZHAJAZINXHLCQPGFHGJBYPOLQDOFTYUT");
    IMC::PlanManeuver tmp_tmp_msg_0_1;
    tmp_tmp_msg_0_1.maneuver_id.assign("VYUOTLLNERXBHLVQMBTDNPAKUMQKQAHFEZLAYSCWZCPNDVIACIMNQBTZIYUOJQUUYFRQAZUWRXMSWBLUHPTGDAEZSSPWSNCCIOHTGGWVLJWXMHIOZEWYEDOMHGZUTBRHIDKWGDQEYXKKRGIESOMYRBDTXGJPSJXJAXIYPJVAVNOFFSWLCIEOKFBDJEJMXZLVARBXOCPNPHBIKYFRVMFEPGRGDHAZZQYKVDBOCJFKCQM");
    IMC::PopUp tmp_tmp_tmp_msg_0_1_0;
    tmp_tmp_tmp_msg_0_1_0.timeout = 35449U;
    tmp_tmp_tmp_msg_0_1_0.lat = 0.212906931893;
    tmp_tmp_tmp_msg_0_1_0.lon = 0.523247125885;
    tmp_tmp_tmp_msg_0_1_0.z = 0.3297772414;
    tmp_tmp_tmp_msg_0_1_0.z_units = 7U;
    tmp_tmp_tmp_msg_0_1_0.speed = 0.359576806013;
    tmp_tmp_tmp_msg_0_1_0.speed_units = 7U;
    tmp_tmp_tmp_msg_0_1_0.duration = 39470U;
    tmp_tmp_tmp_msg_0_1_0.radius = 0.684512597744;
    tmp_tmp_tmp_msg_0_1_0.flags = 47U;
    tmp_tmp_tmp_msg_0_1_0.custom.assign("CZZUKITQWRWIJZBJFSISZPJTSETHQQZMDEZPFDPAGNRAYYDKXVLINECAWSXIGNIOJXKXUTPJCCPNOTZRHEDHKYYVQVAJNVIJFXHAGRBJAHGGI");
    tmp_tmp_msg_0_1.data.set(tmp_tmp_tmp_msg_0_1_0);
    tmp_msg_0.maneuvers.push_back(tmp_tmp_msg_0_1);
    IMC::PowerChannelState tmp_tmp_msg_0_2;
    tmp_tmp_msg_0_2.name.assign("UJKKSTMYDDCZQPLUIEORVRJLAQXYZDTRMNCOAXLPZCWKEWWZYADTPVQXIUNRCPIKFYQYQOTURSQGPPENCLZIUNNDLEJDPMAMYLBGXCSQEESGVJLGBZYJW");
    tmp_tmp_msg_0_2.state = 225U;
    tmp_msg_0.start_actions.push_back(tmp_tmp_msg_0_2);
    IMC::EntityParameter tmp_tmp_msg_0_3;
    tmp_tmp_msg_0_3.name.assign("OLNDPEKLKJGAHQSVPGTNMJXGJNZHCEXBOOZBAUWWTNMFUPPTCDYZSOKJGNWSVYFXVAWMCIWKGDKSZEFHORQNBDYUHSNQLJPTGRRJQIMIKDCGWFEFDIMPBLJXQIUAOXGJHMKFZCXOOAQNDTSKZLGVAMJYUECSBFDEYKSHLJXIYTEBZIUCRPGSXPCAIMVHIOKQUTLPLBENBFUQHXOXFZUDYVC");
    tmp_tmp_msg_0_3.value.assign("NOHCTGGVQKDZKKSOWTBPZEFNMUDXNTQEMRXZZNJGYKPJKQEYBYXIHCTXGLZUWAIASBIHMSSUISXOETCLXYWUZPVLJYVLJWMHCTGABXNPNGGBIDKRQCQIUHFDFXZTIMDFPWRGFNKBUQHZUAOWWZACIMPBVFJKDLOA");
    tmp_msg_0.end_actions.push_back(tmp_tmp_msg_0_3);
    msg.plan.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EmergencyControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EmergencyControlState msg;
    msg.setTimeStamp(0.907112133473);
    msg.setSource(59444U);
    msg.setSourceEntity(215U);
    msg.setDestination(16010U);
    msg.setDestinationEntity(240U);
    msg.state = 239U;
    msg.plan_id.assign("PSKTWJDUKYRZBMXQWQOCZTHVGRGEZFOQNXHLWUHYBLTSMAZWNNWIVDNPZZQLBEMXMRCACPJGNPWTAOBOGEIJDFGIHOXECORIEVFVLPDXFKXFKZRATGRCKYRBNRBCVPUSXNLPFKDQZDNMCSHFFIBUVTHVSATSARCANEZYBLYHGEQCDOESGAPMMDXBJYXMMQBKVIFYSOIUIJIJIMKKLJXJWLTJPASNJUFOUWQDHLUGUZWKAYHPSQEVDQCUWYHYRG");
    msg.comm_level = 164U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EmergencyControlState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EmergencyControlState msg;
    msg.setTimeStamp(0.933267259927);
    msg.setSource(55443U);
    msg.setSourceEntity(223U);
    msg.setDestination(25456U);
    msg.setDestinationEntity(156U);
    msg.state = 157U;
    msg.plan_id.assign("VDOTRNMLHRMMBHCPSIDBAWFWNCNOOBVXEHKBCDSYGLWTRLUITURFYFHHPEXSUYWCOCVWIBUUBEJQKZQDEXGK");
    msg.comm_level = 61U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EmergencyControlState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EmergencyControlState msg;
    msg.setTimeStamp(0.965734021602);
    msg.setSource(4552U);
    msg.setSourceEntity(208U);
    msg.setDestination(35751U);
    msg.setDestinationEntity(127U);
    msg.state = 251U;
    msg.plan_id.assign("JHCFLEKDXAGZZBKCCUSKBYTCQPMOLWYLFNSNXSZEUHTJOQVCDQAPDWALYJITCSGQHHTMAGNXIVMAW");
    msg.comm_level = 124U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EmergencyControlState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDB msg;
    msg.setTimeStamp(0.869747002095);
    msg.setSource(57696U);
    msg.setSourceEntity(76U);
    msg.setDestination(64127U);
    msg.setDestinationEntity(155U);
    msg.type = 50U;
    msg.op = 39U;
    msg.request_id = 11294U;
    msg.plan_id.assign("KDGWABXCXDVLQTYMEKOHMFHJRZIMMPPICCYSUXEWMPARMF");
    IMC::IdleManeuver tmp_msg_0;
    tmp_msg_0.duration = 12629U;
    tmp_msg_0.custom.assign("ZXDLIFZYTCOKUDUBGLNMFXEDUCDHASYGIHOBZMPUIPMLVLWCIKSHGSVRSXEWYJSWPHCPFSVCNOGMYYRXTQRIDKVXTVEMBYVQFZXGHCTBDVOEBYVUDRDWAJENMOERBGALOGUQYBJKSLCPSKYAQAOAFQVOW");
    msg.arg.set(tmp_msg_0);
    msg.info.assign("RFHBVYWRWHMNVGKPIBCIXNPBWGSQVKMGCPMQPNAOOQQAYEEXXOODFXCPCLWTORJMQRGSEHYRKJTHTQXDUWXJFUJIOGUIUSFCISVLPWJKMCQLEKHFUDNYAZRKTYLBMNABVJFCIYAEUMIYVFTRMCLXHPJQDBFSFRLSQAYXZPBIUXLEDZNEEZEXAZDYKJIAFTRJMBGVOCBHQBEVZNCVODJZNKZSRTZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDB #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDB msg;
    msg.setTimeStamp(0.968220845692);
    msg.setSource(26052U);
    msg.setSourceEntity(247U);
    msg.setDestination(34146U);
    msg.setDestinationEntity(246U);
    msg.type = 120U;
    msg.op = 20U;
    msg.request_id = 41647U;
    msg.plan_id.assign("WXVGHNJAFUYPOCAOFSWQJGEIYMHPMBIWIGGUQFOKGNMKBQEXHIXBZXQMZJSZCAHNOQYRVFTVWUNTSSFLVLRTMW");
    IMC::PlanStatistics tmp_msg_0;
    tmp_msg_0.plan_id.assign("SILUKEDSJUMTMWHPUKSXCIXTRVVZODCFQBTXMYHYDAOWQJOBJNXMORNMWWMEFESJGKPYPVLYSYZUTARAWTWRCLGOEGHOHKJVRJXHKUSQPPDKIYZHYZDPMNNUDIPZKTFWUQLBEQOIZLZHLHABBFGOVEQLDRSAGEXNTNXVIVJGQGKWMAIRTVYBCDWQAQIKLKGJNXHCAFGICHCUCNRXQFCTMLYFPSNZUYLPDSJ");
    tmp_msg_0.type = 232U;
    tmp_msg_0.properties = 70U;
    tmp_msg_0.durations.assign("ALWPETWYAKTNSZQSBJZBTKW");
    tmp_msg_0.distances.assign("YXHFXCTHZAPGDOWEQUERTASKWWULGILYKJZRKUISDRBIUMWCBLYK");
    tmp_msg_0.actions.assign("SDFFSZYLJTITKFTKRAGXZODXFNBYEOYFWUFMPCHUNABDSLEGQAIFLYLIXGEOWBKYQVOAW");
    tmp_msg_0.fuel.assign("WNCIPUHIEEFHYPMWEHXESMVLMYCFVNPXSNDQZTOHZSOUALYWNADEDPGZURYNOJUUTGAAITUGBHQTJMFRJCYBQHXBRWYRUQFG");
    msg.arg.set(tmp_msg_0);
    msg.info.assign("DNPNROSPDNCKHUTZFVZKQGNPBBWZMVJEHCBEOONXRMPXHZTOXEEYWZUYFDXIGOTGXXZZKRJJXSHIMPOIGFIACEYLAAIMECFMXWVGZBUNAJJILYTQURDKMCISFUCLVPNSVQJZGAQENTYLLVMRFCJVQKDOOXIFIBNWRDCPLABBYOQTNHTKUYJOYE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDB #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDB msg;
    msg.setTimeStamp(0.430496853952);
    msg.setSource(19334U);
    msg.setSourceEntity(214U);
    msg.setDestination(27229U);
    msg.setDestinationEntity(47U);
    msg.type = 182U;
    msg.op = 228U;
    msg.request_id = 61686U;
    msg.plan_id.assign("RRPUWEOHAKDPEH");
    IMC::FormationMonitor tmp_msg_0;
    tmp_msg_0.ax_cmd = 0.34529153899;
    tmp_msg_0.ay_cmd = 0.753139396607;
    tmp_msg_0.az_cmd = 0.761273562395;
    tmp_msg_0.ax_des = 0.491967498757;
    tmp_msg_0.ay_des = 0.54615182218;
    tmp_msg_0.az_des = 0.0483075364588;
    tmp_msg_0.virt_err_x = 0.345582038114;
    tmp_msg_0.virt_err_y = 0.536694906786;
    tmp_msg_0.virt_err_z = 0.706196046627;
    tmp_msg_0.surf_fdbk_x = 0.72986111168;
    tmp_msg_0.surf_fdbk_y = 0.397835564697;
    tmp_msg_0.surf_fdbk_z = 0.800028111865;
    tmp_msg_0.surf_unkn_x = 0.432530125288;
    tmp_msg_0.surf_unkn_y = 0.491864113702;
    tmp_msg_0.surf_unkn_z = 0.0922833021899;
    tmp_msg_0.ss_x = 0.276224546092;
    tmp_msg_0.ss_y = 0.935724979834;
    tmp_msg_0.ss_z = 0.482148667985;
    msg.arg.set(tmp_msg_0);
    msg.info.assign("BQXMNMKXFEGDTYFOEESIQIVYUKXZBIYSVFSXTIUWFRHRWFGUROKFYWBZMUJTLGDSGZOOUPAIKSYKURXYLDWQBPMBEGWJXZPOADVDMHWVWTCTRCNGDHYISAHIQY");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDB #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDBState msg;
    msg.setTimeStamp(0.606075120857);
    msg.setSource(64281U);
    msg.setSourceEntity(145U);
    msg.setDestination(25580U);
    msg.setDestinationEntity(204U);
    msg.plan_count = 739U;
    msg.plan_size = 4055241545U;
    msg.change_time = 0.51102121447;
    msg.change_sid = 25108U;
    msg.change_sname.assign("RZZESQNEQHODIBDXYAWQGMLTRVDDAXWJGWZDEYMKWBWBGZGSHJUPFVRFHIJHTTPPOEZLLPEVSHQKROOZFSECWSJZLHTFJBGYFVMNDFNATYKWIEIVPXPPAJUUYDEGPKMBJUJCHVMCKKIHZSQMPQAWDETAWHNKAXSNGTJLBORITUCXUZDHNYNXOAFRPQLRYCMNSGV");
    const char tmp_msg_0[] = {54, 93, -23, -59, 24, -37, 117, -84, -27, -29, 26, 85, -74, -25, -60, -58, 47, -107, 94, -69, -73, 40, 92, -107, 27, 69, 5, 20, -96, -97, -103, 1, 20, 51, -85, 46, 28, -72, 23, 90, 119, 75, -62, -100, -47, -51, 38, -44, 28, -106, 18, 59, 62, -92, -50, -18, 0, -128, -98, -90, 6, 81};
    msg.md5.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));
    IMC::PlanDBInformation tmp_msg_1;
    tmp_msg_1.plan_id.assign("LDZGCDOJAPWUWFHTGRATZWTISMHXLRRVTLBHFPDBVQKZSWQJMPFDWSMDHAXOWJYQKVTFQYHLONLEGAUEXRODMSHKVTRILOAQPIOBTTDYDHCNENYVRKYMAAGURRKGIIRQGXOKUVPISZJFFJKNOJFYBBICQQLNCFUZJLCVIUNZXCMEQPUTAJKXSEJNPKX");
    tmp_msg_1.plan_size = 9830U;
    tmp_msg_1.change_time = 0.248391109142;
    tmp_msg_1.change_sid = 13593U;
    tmp_msg_1.change_sname.assign("JKIFFIKLPXBSPDXYOBWCBFDKFFNDRWYHOXCZQNSXBZNHCHOFZTPVITKLRTOCNVQKPMKWJRJLTVFDFXYXJNOPITHHGACJWMGUZLLGEDMMOGJRAEEIKVNWHQRZDBYDHAUZYQSAQLBWCUUVTSMTZEEDOASTUQDSJGLGASESHNROYHIJPNGABMBJWLVXRICQPPGUGIWTUKEOAZTJUXXRWPKEDYYEWMKRONAQFXBQMY");
    const char tmp_tmp_msg_1_0[] = {-38, -45, -57, -32, 47, -87, 114, 19, 15, -21, -45, -42, -57, -110, -10, -43, 34, 42, -60, 0, 124, 41, -61, 105, -92, 72, 114, 83, -47, 40, -15, -41, -110, -22, -40, -63, -64, -27, -75, 57, -3, -97, -105, -43, 9, 74, 90, -87, 72, -123, -25, -125, -56, 4, -49, 66, -45, 60, -13, 54, -68, 53, -119, -9, -113, -116, 97, 102, 56, 33, 84, -72, 12, 109, 24, 22, 68, 6, -105, -110, 32, 33, -49, 14, 62, -120, 66, 8, 75, 16, 118, -44, 74, -98, -99, 61, 119, -10, 27, 34, -92, -4, -48, -44, -61, -96, -106, -114, -11, -101, -125, 36, 13, 120};
    tmp_msg_1.md5.assign(tmp_tmp_msg_1_0, tmp_tmp_msg_1_0 + sizeof(tmp_tmp_msg_1_0));
    msg.plans_info.push_back(tmp_msg_1);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDBState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDBState msg;
    msg.setTimeStamp(0.901093117167);
    msg.setSource(7693U);
    msg.setSourceEntity(1U);
    msg.setDestination(40170U);
    msg.setDestinationEntity(228U);
    msg.plan_count = 58291U;
    msg.plan_size = 1608982810U;
    msg.change_time = 0.56664558154;
    msg.change_sid = 26731U;
    msg.change_sname.assign("OZVSDCZWIBHYWFDAKTTOJGBKIHDSJMWABDTXDLPPLLSWHFAMKWELQWPOLRITJCUPEYRSOBWBBKRZRRXTPSTXAVIEBSMVZNNMEUORBNCFMHKRILIUUIYFYLVZNRQJQEDCAYMVSSQHGGPNCGCHXCJDWVTXVMNBOZFOZCXYKGVPHZFAGEYDHFGPAOZNJIJDCQYLHGKAUQEQGWWNQTJYBUILKJYOETRXEMKMQT");
    const char tmp_msg_0[] = {5, 93, -125, -70, 64, -69, -80, 70, -9, 38, 34, 83, -76, -101, 45, 112, 114, 37, -86, -100, -116, -1, -11, -90, 65, -124, 100, -100, -23, 119, -63, 2, -125, -40, 48, -18, 124, -114, -44, -56, 122, 33, 28, -68, 97, -52, -57, 65, 51, 105, -32, -67, 68, 100, 74, 83, 60, -98, 49, 119, 35, -52, -31, -22, -93, -110, 94, -111, 95, 59, -95, -39, 71, 95, -43, -71, -103, -84, 57, 125, 80, -42, 70, -76, 85, -121, 7, 19, -47, 5, -17, 77, -126, -111, 15, 105, -15, -43, 80, -66, 125, 43, 93, 59, -79, 17, 90, -108, -59, 21, 40, -100, -21, 110, 3, 84, 6, 102, -125, 94, 35, 112, 112, 44, -3, 40, 6, -67, 50, 71, -32, -64, 54, -87, 41, 84, 54, -67, 58, 4, -87, 40, -6, 9, 13, 67, 7, -51, -22, -10, -14, -53, 122, -79, 27, 109, 106, 75, 116, -97, -128, 65, 122, 62, 116, -39, 117, -88, 82, 49, -40, 74, -62, -13, -115, 122, 124, -126, -113, 110, -113, -26, 112, -25, 99, 61, 121, 64, 18, -103, -49, 116, -26, 34, -83, -18, -24, 11, -71, -120, 57, -93, 106, -84, 58, -6, -20, -76, 16, -101, 126, -81, -108, 61, -46, 91, 84, -59, -70, 124, 2, 28, -11, -25, -111, 46};
    msg.md5.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));
    IMC::PlanDBInformation tmp_msg_1;
    tmp_msg_1.plan_id.assign("DGJMSICYVMGJVPZFLMHPCYWSLIVBPZQCKJXEKLRIUZTRVMALZYRNGTHPCLQIFGECYOWKKEXUW");
    tmp_msg_1.plan_size = 35679U;
    tmp_msg_1.change_time = 0.268058144105;
    tmp_msg_1.change_sid = 28995U;
    tmp_msg_1.change_sname.assign("VUOHGFLNOPVNSQUVKJJBERMXLDYGHTFWANYIBYGTRABRXOQFKHZDBWQZTJRNRBGTOTYHFDLCJUCAMXYGV");
    const char tmp_tmp_msg_1_0[] = {-65, 6, 3, -115, 97, -110, -11, -6, 27, -87, 70, 67, -86, -20, 112, -124, -57, -52, -43, -52, -89, -24, 2, -127, -11, 85, 44, -46, -29, 97, 85, -36, -43, 65, -89, -32, -95, 61, -9, -37, -8, -73, -18, -96, 62, 70, 35, -88, 74, -18, -15, -73, 42, 63, 42, 108, 58, -48, -30, 57, 55, 34, -19, -115, 58, -13, -63, -14, 16, 36, 28, -117, -114, -8, -91, 105, 21, 124, -56, -58, 27, -70, 6, -86, 1, -20, -9, -12, -10, -14, 71, -71, -98, -52, -112, -102, -123, -91, -127, -86, 126, -74, 45, 109, 86, 103, -76, -45, -98, -22, 121, -100, 122, 67, 79, 29, -24, -37, -113, -79, 70, -114, 21, -102, 112, -38, -15, 13, -63, -100, -41, -123, -60, -35, 72, 21, 10, 26, -74, 56, 57, -66, -73, -47, -68, -62, -55, 109, 87, -69, -17, -90, 104, 70, -42, 89, -74, 49, -92, 121, 42, -22, -108, -95, -85, -34, -39, 114, 30, 66, 58, 108, -82, 93, 42, -117, -13, 93, -43, -106, -96, 94, -103, 46, -27};
    tmp_msg_1.md5.assign(tmp_tmp_msg_1_0, tmp_tmp_msg_1_0 + sizeof(tmp_tmp_msg_1_0));
    msg.plans_info.push_back(tmp_msg_1);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDBState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDBState msg;
    msg.setTimeStamp(0.716938587288);
    msg.setSource(8193U);
    msg.setSourceEntity(103U);
    msg.setDestination(12752U);
    msg.setDestinationEntity(53U);
    msg.plan_count = 29446U;
    msg.plan_size = 1197682169U;
    msg.change_time = 0.989551065896;
    msg.change_sid = 24981U;
    msg.change_sname.assign("IONQXBJIHESFFARDWTFGQVVARXSJKOWLPMNNOACFJSLBZCZCGSUQYXSLKTPUKCUQCRGBGHWEVKGCJYDBFQNFMIMLWZMOOXKNTYFHTPVETEZRHKJRYPERKYVNZNDSMEDGWYKHBIEDIEHXAIJPPUBPFHYIXAUBWDJJEDNWTUHXSKUZYEUDQATAMBQKZLLLIWISTSZVJ");
    const char tmp_msg_0[] = {125, -46, 86, -8, -109, 64, -10, 8, -25, 89, -85, -28, 101, -108, -80, 113, -75, 92, -44, -70, 0, 31, 78, -18, 93, 123, -90, 19, 43, -91, 80, 8, -4, -113, 3, -29, 48, -122, 79, 2, 96, -111, 6, -36, 22, 63, 82, 13, 76, 31, -83, 60, 78, -6, -60, -4, 59, 63, -49, -10, 25, 112, 13, -33, 75, 29, -60, 47, 27, -101, -65, -72, 6, 37, -113, -89, 49, -50, 43, 40, -87, -5, 5, -42, -44, -6, -57, -111, -62, -89, 43, -32, -15, -93, 64, -45, -55, 101, 101, 126, -86, -37, 98, -128, -41, 13, 69, 56, 105, -77, 11, -16, 108, -76, 21, 107, -120, 51, -37, -104, 17, -7, 106, -22, 114, -63, -92, -96, -48, 107, -53, 39, -73, -85, -67, -76, 66, 114, 2, 19, 52, -86, -95, -67, 1, -14, -54, -72, 81, -98, -7, -111, 29, -98, -4, -16, -25, -105, 34, -12};
    msg.md5.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));
    IMC::PlanDBInformation tmp_msg_1;
    tmp_msg_1.plan_id.assign("OTSWSEXCCXOGRHZQYDKTEFHVTFRMHMSGUYOMUPVRPHOXRLBIYJWRZLCSVHBGWAWSPCZKUDEKULFWZQAIPNGYNXDWEMTPUDWWICIUJVALZRGAKBKCSTSUYDAIDINJOXJYOBHJJKYLNHZQQZUQFCQDMFASCNMMFZZQNFLMNOVIBUTVFHLNJPBGJRTUFNSRXAVBIXE");
    tmp_msg_1.plan_size = 20656U;
    tmp_msg_1.change_time = 0.945615816649;
    tmp_msg_1.change_sid = 16974U;
    tmp_msg_1.change_sname.assign("WCAUYZTPMSMFRVLJGXYXPZIHLHYZBBAFHVPHTIDRULCUCAOETXQGNNYOBNOVEQTESVMZQZLMRAZDBFADYECBYYGSNSWQNKNWBMFCJUFOVUGRDOSJQTDKQEKXFFEPYERDGKSKDFOOKMWFISSIQTSIAAXZRAZWWTYDXQHTXHFLKLNJKEHZVZCLGCUWIXEHOMWVSWPJELIKJTDNUNCAHBLGUVDQKOXBPRJVGJGIHRXBN");
    const char tmp_tmp_msg_1_0[] = {-22, 55, 71, -100, 72, 7, 96, -4, 36, 43, 109, -75, 62, 96, -112, 10, 67, -15, -5, 28, 126, -46, 12, 25, 29, 47, 45, -128, -126, -49, -40, 61, 101, 116, 87, -97, -26, 61, 50, -66, 37, -83, -124, 24, -71, 34, 83, 19, 67, -118, -118, -116, 75, 107, 93, 51, 112, -102, -31, 16, 67, -124, 106, -75, -3, -12, 45, -70, -61, -49, -8, -88, -120, -1};
    tmp_msg_1.md5.assign(tmp_tmp_msg_1_0, tmp_tmp_msg_1_0 + sizeof(tmp_tmp_msg_1_0));
    msg.plans_info.push_back(tmp_msg_1);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDBState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDBInformation msg;
    msg.setTimeStamp(0.655725017121);
    msg.setSource(4417U);
    msg.setSourceEntity(43U);
    msg.setDestination(5515U);
    msg.setDestinationEntity(24U);
    msg.plan_id.assign("JRRVUSKOCRBTFICZOJBKGKVHRNMEJIIZUZPNQOGLFTXTCQLTBZHSVZOASIQENYPBWJHTXMSPENMWRKKGFJSNPSOGLILEMCJQPWCNJBSWDVEXJUVKLSZGSUQHRFPHEJYDAFADGQDKWDXQUWZFVOYWRYHOEONLDZRKHTXZMTYNWZFYAWBAFLGIMODPNJCDULRGLWQHCXSMVABNIPKYTIBYKQPALQUEYXM");
    msg.plan_size = 64515U;
    msg.change_time = 0.488076218605;
    msg.change_sid = 43055U;
    msg.change_sname.assign("YZOBXPNFOONNNFAOVWCWHNGEUSWIGDKKJQBEQFEDXAIRXAJZQBQGADRREUHVUTVQKGMFIDKPXYIRWPJFATBZEMBTTSMHUFLBKSCQJBAPEEIVVYXWWYOOHZDYLRFFGPICYMBATWLSOYGUQMVLGLJNNARXHOQCAYSOBSBLGPZKYUOMKWMNIVIXCZZPKLSEHXGMHDCUALVSPHCNEUNHCHEGP");
    const char tmp_msg_0[] = {-103, -7, -95, -112, -3, -44, 87, 61, -64, 77, 1, 16, -109, 103, -2, -37, -58, -80, -114, -66, 26, -45, 11, -7, -63, 95, 82, 26, 49, 113, -81, -49, 16, 76, -33, -5, -16, 85, 102, -69, -65, 124, 111, 80, -64, -113, -40, -84, 70, -34, 18, 38, -76, -107, -14, -60, 116, 119, 93, -100, 33, -37, -41, 112, 80, -90, -33, 84, 51, -108, 101, 86, -123, -113, 68, 48, 102, 18, 44, 108, 59, -24, 122, -59, -85, 115, 86, 22, -21, 119, 64, -8, -60, 62, -116, -2, 79, -122, 6, 122, 94, 50, 84, 52, -84, 18, -101, -120, -1, 38, -61, -70, -61, 104, -112, 89, 47, 107, -100, 108, 37, 53, -44, 114, 126, 108, -27, -67, 106, 60, 27, -95, -20, -29, 52, 52, -51, -32, 2, -123, 78, -90, 28, 35, 62, 28, 117, 116, -28, 46, 52, 40, 3, -38, 77, -40, -65, -22, 55, 3, -93, 125, 38, -63, 94, 120, -6, 125, 66, 17, -4, 13, 53, -78, 99, -81, -115, 102, 77, -14};
    msg.md5.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDBInformation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDBInformation msg;
    msg.setTimeStamp(0.772852672305);
    msg.setSource(20250U);
    msg.setSourceEntity(138U);
    msg.setDestination(22743U);
    msg.setDestinationEntity(109U);
    msg.plan_id.assign("MQORABYWETDDGLTPEKVFRQJGFRMQXZSICCWNAIUWQWTLNJTLZGOOLICKNJMFSYRLQZUISXHYVEEDKPFRZXWCUUMXQZEMUJUHEFBKRGPOGOUFWPYCAQOIXZSTYGUNAFVISPFEVJDFYQCEVQRMPILWCALZJMHORKHJDBOEZDXVVKDLB");
    msg.plan_size = 37919U;
    msg.change_time = 0.454856902935;
    msg.change_sid = 41030U;
    msg.change_sname.assign("ITCSQFZKTULHDEOWOKHLKTUNMSRNMRHT");
    const char tmp_msg_0[] = {-117, -3, -110, 22, -57, -33, -74, 123, 31, -100, 18, -81, 34, 57, -67, 124, 44, -50, 23, -61, -81, -74, 49, 60, 87, -72, -75, -51, 48, 29, 55, 27, 107, 84, -9, -114, -42, -100, -77, 13, -123, 80, -10, -85, 3, -24, 8, -93};
    msg.md5.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDBInformation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanDBInformation msg;
    msg.setTimeStamp(0.563880160649);
    msg.setSource(36866U);
    msg.setSourceEntity(216U);
    msg.setDestination(4052U);
    msg.setDestinationEntity(39U);
    msg.plan_id.assign("CVKAIVBKLMELMZWDIIHZPZFQONSYDVUJTYBEGSSWVXBOTVGAQDYLFYHLYUDLWCUUEATTJPSLXDTNQWIPLLPQNBXQCXRWRHDGXGLKGKMRUNKZPANFJXEQRFVQHGKOJEIRCCPTUPEMFISKQUNXVKDOOOHJVWGIQNMEBCEWUJGHMVHKBDSODXMZSGPHIENCWBRKOBFUUAXHYTFOYSAJFCOQXZWGZI");
    msg.plan_size = 49644U;
    msg.change_time = 0.710716561806;
    msg.change_sid = 13898U;
    msg.change_sname.assign("RUHUWWTQPQJSXWYVYELMVTKZLYDHYSLLQSNQKKCDCICIBYZPARAESXLSVMACMJHJGJFVICGQRWEMVUJCLCURGENSFKFONXUXOJAFWNHZIDOGMSPRNIYBBYMWROUUJLZREZVZBXEFQZSESMZZCAYKIPU");
    const char tmp_msg_0[] = {22, 84, 54, -55, -10, 101, 61, 60, 122, 58, -105, 63, -94, 118, -109, 122, -37, 37, -53, -125, 63, -114, 120, -52, -63, -67, 65, -18, 59, 74, -40, -17, 110, -18, 14, -46, -64, -106, -26, -59, 56, -35, -61, 93, -1, 14, -64, 95, 54, 94, 47, -70, -78, 9, -20, 86, 75, -103, 92, -28, -82, -23, 20, 52, -95, 58, -66, -29, 112, 90, 31, 16, -22, -56, 123, -8, 13, 71, -116, 113, -48, 78, -5, -65, 40, 87, -61, 122, -28, 68, -56, -89, 16, -11, -15, 2, 126, 10, -104, -79, -86, 118, -1, 113, 8, -68, -118, 117, -85, -21, 12, 78, 103, 15, 112, -103, -11, 63, 107, -110, -54, -27, -10, 40, -35, -70, -28, 74, -48, 38, 107, 43, 49, 51, 62, -59, 37, -30, -10, -115, 54, -79, 66, 12, 33, -51, -42, 50};
    msg.md5.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanDBInformation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanControl msg;
    msg.setTimeStamp(0.42681369249);
    msg.setSource(19000U);
    msg.setSourceEntity(21U);
    msg.setDestination(34578U);
    msg.setDestinationEntity(222U);
    msg.type = 161U;
    msg.op = 63U;
    msg.request_id = 18928U;
    msg.plan_id.assign("LTIEMQZWKIQCEVNPUIVYRQEJFHRIVCCDLDQMBFFZNPNCLVNENOPAYFLWDYSWSQFDKMJTPBBZEJT");
    msg.flags = 61453U;
    IMC::GpsFix tmp_msg_0;
    tmp_msg_0.validity = 32508U;
    tmp_msg_0.type = 157U;
    tmp_msg_0.utc_year = 210U;
    tmp_msg_0.utc_month = 165U;
    tmp_msg_0.utc_day = 196U;
    tmp_msg_0.utc_time = 0.718927082334;
    tmp_msg_0.lat = 0.512947940848;
    tmp_msg_0.lon = 0.603918773226;
    tmp_msg_0.height = 0.459493242479;
    tmp_msg_0.satellites = 194U;
    tmp_msg_0.cog = 0.0843386427117;
    tmp_msg_0.sog = 0.589172553657;
    tmp_msg_0.hdop = 0.110428196727;
    tmp_msg_0.vdop = 0.304033291161;
    tmp_msg_0.hacc = 0.844151728369;
    tmp_msg_0.vacc = 0.433267098766;
    msg.arg.set(tmp_msg_0);
    msg.info.assign("RNTZOTYIXGDZLRWOUFGCWHQJKXOQXQNZUOTHCVTDHLYEPZZXWSVDUOMHQGVXWINHURTMRXFGEPBHFYOBIBCOXWOLYMZHQBALSHMSLKPCHACDGKIBVFXRQWIFJUFSNPVTJIEYQAEACCNJJNBYVIMR");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanControl #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanControl msg;
    msg.setTimeStamp(0.597708804432);
    msg.setSource(1749U);
    msg.setSourceEntity(85U);
    msg.setDestination(2455U);
    msg.setDestinationEntity(249U);
    msg.type = 178U;
    msg.op = 158U;
    msg.request_id = 56636U;
    msg.plan_id.assign("EIILVFBEACWHTUDPKIEGHCOQADVMZSFSGYDEPJDREBDJOMZSYSTCKEJZZPPBBSRCOQNPNGXQXJNGLVLQJONCUUZVGBEIDNJVKNKUZBWHFIHXLTYEJVOIKYDMJVFXCM");
    msg.flags = 36514U;
    IMC::TeleoperationDone tmp_msg_0;
    msg.arg.set(tmp_msg_0);
    msg.info.assign("FCREMXPPWZLCBSPZOJKHAWRFBLRUNFKAYIFBKQWHWVSLKROSUPMELDNRSEPDAGYNIIZYVPXIUXHSQCKRCASZXYSZZYWHONLKTUAUDMJX");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanControl #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanControl msg;
    msg.setTimeStamp(0.318439520107);
    msg.setSource(59375U);
    msg.setSourceEntity(178U);
    msg.setDestination(32550U);
    msg.setDestinationEntity(200U);
    msg.type = 226U;
    msg.op = 228U;
    msg.request_id = 64667U;
    msg.plan_id.assign("TRHOKUJDYDJCWKLOTGCXVTVKLCCOZJZJGNDRZVMNOYQJRWFNQHTGCLHRDUOYWKBHSQCC");
    msg.flags = 21490U;
    IMC::PlanGeneration tmp_msg_0;
    tmp_msg_0.cmd = 206U;
    tmp_msg_0.op = 74U;
    tmp_msg_0.plan_id.assign("VWAGPJVJONKUEHIVJHVZYQWWCIZMIPAUUNCMGSKDTZMWEGTHRQYLPSNMFEZWIYQIPAJXJZSWYRWYQGFCLBOIGLNRFFWDFCGOVRFJXUUXLMPSQBZTDCVBXERUOBTMSBCXSOHHHDPBNYORDCQAATLIOLBKNMEOZVUZEQVQXOGFKLXZGTHUJSMHVOQWYXNLBFAZDQSCPATDTDTFWVISULPJKK");
    tmp_msg_0.params.assign("OPPGIYGVWHYGIGTMOPVORDCBDCUQJZRJTEUFUXLMFSTGZNALUBCFRKZCCAXKZSJVIUAKRFRRQLJZTYYBANNZJOONNXAHKLPXZEZAXVJFMEOKKTFIPHOUMSCPBZWUWFODJPVNAQETMKMEUAXPVWKRN");
    msg.arg.set(tmp_msg_0);
    msg.info.assign("UZOBQHFOQORADKLNVJFNSKMHTPRXRPZZCNVQQWZXGPPHJOOVQHSDUZFHSNTYRFMUSTWWUZXBQUKJUTHYAARKDRWINDJZVFYDBIPHFLVCGIPCVRXBUKIGEBYOYTPWEZGSJKKJHITGMO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanControl #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanControlState msg;
    msg.setTimeStamp(0.475782387986);
    msg.setSource(26587U);
    msg.setSourceEntity(71U);
    msg.setDestination(33962U);
    msg.setDestinationEntity(186U);
    msg.state = 53U;
    msg.plan_id.assign("DCMIDGGYDXGFSJWNXJWNJKPIIVHSDNCRYPKRDHRATBFXCOJWMVSCBLSWCEOTMJRTIQMXBABOKUEQQUOZFYWIYQYNUKZBACEVXLZGAQYLAYSLIFXRCVBLXWWCC");
    msg.plan_eta = 1156521869;
    msg.plan_progress = 0.318795145004;
    msg.man_id.assign("CYGQAEMCFNIRAODYFAVIHZTJVUDQVMUIPYZIEXMZLFEUHSMXTLCSUSSRSPKBRFZNQBREBUCTBZACJCOIQLYJNWYXQTZKDIWQVGWYSNSGVIFOAIZWVMZBOOFRWXHOJDKZLG");
    msg.man_type = 45401U;
    msg.man_eta = -873160891;
    msg.last_outcome = 224U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanControlState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanControlState msg;
    msg.setTimeStamp(0.0799215741451);
    msg.setSource(18900U);
    msg.setSourceEntity(106U);
    msg.setDestination(65276U);
    msg.setDestinationEntity(14U);
    msg.state = 102U;
    msg.plan_id.assign("PKHWBQVKCGGFHGGBPUBAJSQPPUAUCUAIGLCTEXMXIVCVHDCRTAWYOWIFNOLKWSSKPOEHXBVKSWQNRXXJXUSQKUFHOSNHZYMMTNNXWGQFPLU");
    msg.plan_eta = 488606928;
    msg.plan_progress = 0.873859073084;
    msg.man_id.assign("FMFLHDEINFVSSZNJFIERNHOELXCFEHRFKPBXSQANWLOPRUSIGOLCNHOLQADMADMDZGKFKUPTW");
    msg.man_type = 396U;
    msg.man_eta = -1665995637;
    msg.last_outcome = 194U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanControlState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanControlState msg;
    msg.setTimeStamp(0.773747313277);
    msg.setSource(53547U);
    msg.setSourceEntity(25U);
    msg.setDestination(11727U);
    msg.setDestinationEntity(130U);
    msg.state = 197U;
    msg.plan_id.assign("EWIOCDSSRSYODFZIEXXAGMNPMOUPALJLWXKMTUOBOTSGEUAFZWENINBPNJEKDJZVDPKJZCMRRPXWPICUYXLYTPFYXUIFASKYDVTQSMERSQLRLCTTREHHGDNRBEYJVBZGFQFKHACMMUMVHVQYTFDHPQXKVZQKORFWOLCGUVBONEBBDAOAAIYZXHUFQHIKTUDQHWNSVQWPHJGIGKLFCSLQCCXNZBYGMZWADLAVUXRJZTGJKJPIEYSHWTJVLR");
    msg.plan_eta = -637095882;
    msg.plan_progress = 0.755497777797;
    msg.man_id.assign("YVJMRCPQRHFSPCCTGFOAWBLAKMZFQOCCKFXEPUHRGOOAPMMQFMGCLEPSZNBSSYHGJPTGIWFSLFHHOPNUHXMEYWMXTTGYRGASBYVHPDUVJXQIZDIESDLUTUIZDLQHOMVDKYEIUODVJWKXRVKTVEDRFBNXKWSRWLUAKQQMNTXHJGZNDQCDRINAEGEVPONEUPQXBCKJBLRRLZAKS");
    msg.man_type = 51746U;
    msg.man_eta = -959675167;
    msg.last_outcome = 156U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanControlState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanVariable msg;
    msg.setTimeStamp(0.939577493051);
    msg.setSource(60235U);
    msg.setSourceEntity(54U);
    msg.setDestination(52411U);
    msg.setDestinationEntity(246U);
    msg.name.assign("RACBPUIKLZRPDTBNBSPDIFYIQKAFQEFGJVDGFERFXXSSNBIMZGQWZQWHICLSCNVMRXUDRORMDEFVIUKLTYYYEYCUZPKANMGPJKMEDHAGYAJJTOVBMQXVOBEXIDSJECIYHAZCLLOKNDUUHYVVCHBHWGQASKQRCNUCFNCPMOJQOXMZFUZSEYJMJSSZWPVWFGXEDQOQTLAFHOHKWWWXBUPIDNAOR");
    msg.value.assign("EUWJFNMRVUQSMALJEYFSZRTCMTCBXMXIUTXLZRCKDPAIWFFKKNTSRAMRTQLYPFAYEAXCBCPEUITHHEYSKODPVYSMPJFDEESPXODNW");
    msg.type = 89U;
    msg.access = 50U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanVariable #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanVariable msg;
    msg.setTimeStamp(0.58668777597);
    msg.setSource(34491U);
    msg.setSourceEntity(71U);
    msg.setDestination(26183U);
    msg.setDestinationEntity(130U);
    msg.name.assign("ZYSNAFXCOSQQVYYYGDRQOJVPKFQUTXVNGIPYYYDSPTCMAPWHUGMREHZWZKHLOF");
    msg.value.assign("VIDZJPYXHQPTTXIHUFKFHJLOYHHNNCJWYW");
    msg.type = 123U;
    msg.access = 168U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanVariable #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanVariable msg;
    msg.setTimeStamp(0.418409961828);
    msg.setSource(52252U);
    msg.setSourceEntity(171U);
    msg.setDestination(22718U);
    msg.setDestinationEntity(164U);
    msg.name.assign("CDMFLIWHVEVTIATCOCQYADZSBWZCHMVHTYFCUZALEOXYJHC");
    msg.value.assign("YCPYMEOUSPXIESWIHSJHLBIVOLRJXQILMZQFDGEUKAIXYWDDFPJLJWVVBEAKSJUNUYUAYVHFOXUCYTHKJYVUEASDTRWOANAOPMYRJMAPGZSZFIUBFKVPOTVBSFMIVYZNVXRXKBDLRQWKZAIYQUHLUZTZNACDFASHOXLRTMBXLFKQKCWJHJWCCQPJDDCPKHIRGTDVXNLETZNNMSGRXCGQZENQGWHRTO");
    msg.type = 82U;
    msg.access = 55U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanVariable #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanGeneration msg;
    msg.setTimeStamp(0.216194009058);
    msg.setSource(4355U);
    msg.setSourceEntity(130U);
    msg.setDestination(52980U);
    msg.setDestinationEntity(19U);
    msg.cmd = 63U;
    msg.op = 90U;
    msg.plan_id.assign("GQEVYZCHOGZLWXEODDOJFUSUNHLTKAAIL");
    msg.params.assign("MNJOAYAIZAQINCYNXRVRJCBEQBETXCMYWTLOSOPFLJLEZQCGVYDQCIFWTRWZGIOWZXKGDXQOFPFXTCDCNAEDQYLUVBRAISAJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanGeneration #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanGeneration msg;
    msg.setTimeStamp(0.742079287924);
    msg.setSource(65204U);
    msg.setSourceEntity(157U);
    msg.setDestination(47617U);
    msg.setDestinationEntity(43U);
    msg.cmd = 52U;
    msg.op = 176U;
    msg.plan_id.assign("DCKIZSHAYWFENTHNJTPABJNEYGXXBWJUWOXRAQESVQLMRFZINLAONZVMICLTIXMPWQYOVXICKBNPKJNDKSYFSHJTFWGUMDHUOVMTGUSEBLRQSPSSEBTWWJHLDFCTZPBXAAEIRUCYEYKDZFBOKZCMXFOZAQVKDFQOCGAZXDUEMKVGLYUSAPJMPZVTULDRTQWIRVHAPGWCRLJHFLHRQUKICQHPEYBYGNQDOJBOVZBJIHYLRFTD");
    msg.params.assign("LATYCAZBIWIMXGYBUUKVNLVJBYGYWORJVQKZHZNMPHYKONFGDMOERENFMWHDYTPKKBBSAJZSNQJIGATGJFMZOLXMLNTYWUFDXKTOMAYLFBJPSOHGLOIRDSKJKRIEUPWVFCDIZSOYICWERXUDNCBSAEQVYJURSHWTLKUXDNHNPZJJEPDCAVUQGXVIXTGOFPMQHRZLQRLXQVPEBBPESHDFVLTQPCXCEUH");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanGeneration #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanGeneration msg;
    msg.setTimeStamp(0.200870924577);
    msg.setSource(52858U);
    msg.setSourceEntity(188U);
    msg.setDestination(50902U);
    msg.setDestinationEntity(224U);
    msg.cmd = 240U;
    msg.op = 161U;
    msg.plan_id.assign("NQFIARBNLTLNIEMCUCRHVONVNYTDDCPHQFJZBQPPOMBAKLSSEMWRWOXVJAARMJOUFIGLIHVKOSJTWOKSGEXKFSGTWIZGVFHBGZCWXXHAXVWEIAIAHLLRDVUUVFDLISRHYCBFJBZERMOZYIUECGGCNYOKKUYLYTXHBLCZEEKPXJKPBYORPSXA");
    msg.params.assign("TOXIGTGCGISDBQOINHJUALBZLLWPSNAXZCTBFLPMEDKKOOOCBSEYPJNIETW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanGeneration #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LeaderState msg;
    msg.setTimeStamp(0.488604023446);
    msg.setSource(20807U);
    msg.setSourceEntity(224U);
    msg.setDestination(61118U);
    msg.setDestinationEntity(20U);
    msg.group_name.assign("IYUECUNHWKSHQIYYCLTAZNIDXHNDSESNRJVQZGNTIJZBDBJBVVUXQOAVNTZSYALLCEVBFGKCJMJHLOXFPEDKTLCRBLAHKGQORDMPRJXVDNATIPLPX");
    msg.op = 52U;
    msg.lat = 0.524362139954;
    msg.lon = 0.180985848268;
    msg.height = 0.417257019591;
    msg.x = 0.0146306014061;
    msg.y = 0.880412914155;
    msg.z = 0.629182787083;
    msg.phi = 0.526185470433;
    msg.theta = 0.645876739042;
    msg.psi = 0.302815848686;
    msg.vx = 0.949854567876;
    msg.vy = 0.63234526613;
    msg.vz = 0.809866172461;
    msg.p = 0.249130083368;
    msg.q = 0.414329577027;
    msg.r = 0.76154171829;
    msg.svx = 0.215756357077;
    msg.svy = 0.289072498333;
    msg.svz = 0.387063772895;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LeaderState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LeaderState msg;
    msg.setTimeStamp(0.258652628641);
    msg.setSource(35362U);
    msg.setSourceEntity(174U);
    msg.setDestination(18584U);
    msg.setDestinationEntity(175U);
    msg.group_name.assign("QVNWRJYDAKGOUPYFLNJMHKDQDLGTDCSZAJMMLEK");
    msg.op = 92U;
    msg.lat = 0.53841684036;
    msg.lon = 0.752313385211;
    msg.height = 0.749237964245;
    msg.x = 0.438148425319;
    msg.y = 0.453928184094;
    msg.z = 0.416222956304;
    msg.phi = 0.257474680226;
    msg.theta = 0.0530113516598;
    msg.psi = 0.422036376002;
    msg.vx = 0.569651171489;
    msg.vy = 0.625774680955;
    msg.vz = 0.0925700538418;
    msg.p = 0.997570534242;
    msg.q = 0.248774421355;
    msg.r = 0.205187535995;
    msg.svx = 0.254101855015;
    msg.svy = 0.847575823693;
    msg.svz = 0.293336346389;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LeaderState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::LeaderState msg;
    msg.setTimeStamp(0.427852907188);
    msg.setSource(55582U);
    msg.setSourceEntity(93U);
    msg.setDestination(23331U);
    msg.setDestinationEntity(188U);
    msg.group_name.assign("RCUESITPSLQUCDSFWOGTNMRBFBZODRLILHYAGXHOOGAUDYWBWBYUTQKOKXFKGZUBAETGN");
    msg.op = 26U;
    msg.lat = 0.621616844199;
    msg.lon = 0.457259852893;
    msg.height = 0.258910026798;
    msg.x = 0.0137149305082;
    msg.y = 0.936113858363;
    msg.z = 0.0594398114143;
    msg.phi = 0.805349188466;
    msg.theta = 0.768664212246;
    msg.psi = 0.777140884548;
    msg.vx = 0.390820628725;
    msg.vy = 0.425195494851;
    msg.vz = 0.708472548571;
    msg.p = 0.164396448169;
    msg.q = 0.622473115911;
    msg.r = 0.715804927324;
    msg.svx = 0.487269283903;
    msg.svy = 0.852871737316;
    msg.svz = 0.784420730075;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("LeaderState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanStatistics msg;
    msg.setTimeStamp(0.766294109718);
    msg.setSource(17100U);
    msg.setSourceEntity(71U);
    msg.setDestination(26866U);
    msg.setDestinationEntity(181U);
    msg.plan_id.assign("PPIMNTANEORSOUFHSXRGVHSYVDBVITSIFCNOJKEWTGPTLJECHXEBAVVZRQEWQXYYZCDWOWXQKNWTBLTZFXZQYYKPCAZQQCOTVCMZZLEWXOGPQKVEMBXORAYZROACIEDBMCLYJTGMEUBMYUGWXUQFISFLMQRRHSNKNNRLOHISIPLFAJFGNUJHMVQIFTGBPJZNMYDRTNCDEUJJKHSDODWHLHWDMG");
    msg.type = 61U;
    msg.properties = 60U;
    msg.durations.assign("FKCANFWVIQCEBAYFDBIJVGYHNFXDQQRXEHOQDYTTYJKKOYLEVVWVIMCXWGXCYSRSHTXRYMHUQEAPZWTHHJPKMMGZNRZRANLNAPMHGLZZWAGNUNVPXGCVQRDCQGZJIKHBUWLOAZNDKSTMMJ");
    msg.distances.assign("HSQKXFSMYHAYODLZAVQUVLKFDPTGFZQUTBG");
    msg.actions.assign("ZYIUYXXVZKPKFOQBSDABLVYMKEMPNDQHJSQIRPPNFWFWPFSONFGFTHHTQAJCMKCQOXXWVHUAEFVXRRIWBGQJLDL");
    msg.fuel.assign("GHPHUYMZFTBRBUYFUANWMQQWLZVBK");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanStatistics #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanStatistics msg;
    msg.setTimeStamp(0.983047324254);
    msg.setSource(8709U);
    msg.setSourceEntity(10U);
    msg.setDestination(32610U);
    msg.setDestinationEntity(102U);
    msg.plan_id.assign("WBCLVJLWMFXHWMGGWSNHOBUGRTTUKEEBZRCTMYXNZFONQWOFXPHZQZRNAIPJTCRXGDKDUFAYBURSXRLQHPIOBBWKHFMLESJDAZBRMMUPYJSZOEIHBQOMOYGDBKAHSGKIXCNAUAVJWUTZWVAFDTUHVLPNTNCEEZVBOEKYXVFJAISPFIKTAQQRYEVLSPCITNEXQFGJEXPOASDHDSUVIMDJCRGLMDCYPCFIPGLMNLQOSGITZJKJCVZWKQYKX");
    msg.type = 200U;
    msg.properties = 123U;
    msg.durations.assign("BPUITKIXSUVOBYSVXQSZKLNGJYKXNWIYHRADNAWMIPDDARWNHSPIUGMLMLZRCCLQMEYYZRFKTZFTDEMWFOFRJYAZQHBNOEIMNGKPGZAGFVMKKTOOIKHRXIVYMDDWGHLHTLNVXHJSNUPBFBCGMCWCJWSOTUUJRJHGPPJCZSLBFHJXIJSUOBVRWADCLXKVCGBEDQMGAVYDWUQVFLVPZCTEEAUDPXP");
    msg.distances.assign("XXYLUTHBKZKATAORGPQUCCCYMHERVDLLUTTIVPQDBEVF");
    msg.actions.assign("MEOPFPCCSXOTDWROYPKJBQGLRAMDKWYMRQUFZTGTYVTZVILKBGWQJLALVUKXMZYIROCGDJPRMYSKECJOQOLWBRLHJVCZXZNKEVYAZTMGCNSTZMVMSEILSWINHQOAZWZFXBQLHUHKOEIJAFZDCDUPUMBDLTPPFEINOBCQXTKRWGGJVHSHVXOVNUNKTFIEPGHSMGUAPBNQBFEHXRJUCIXDJWFNFCX");
    msg.fuel.assign("BXPXGGOEQUCACOLXGPSLFRIKMVBJWPFSUIJGTZAUHTPXLLKNRNPSFDBMDPKVNZWNVQKRYNGUQSPBFJWTFFMVWENYYUQDVOLSVFXHQOUGMZZBHISTCIZHDAZYOBYBALTEMUJDVZNRGOPTLEHQTS");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanStatistics #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PlanStatistics msg;
    msg.setTimeStamp(0.148989117851);
    msg.setSource(8181U);
    msg.setSourceEntity(218U);
    msg.setDestination(17603U);
    msg.setDestinationEntity(227U);
    msg.plan_id.assign("BDGURMTYGHAARVJCFZJSFLALXYMHEEUSGXXUWOIYLHESXYMAWSIIZGJXQTULWAFEMTMPOZMIHGRVCRFOSYDTFPGLXPCEVQAYYKZCOGINJQABVDEPSWHSBNTVBIMMVFQRUANYWKHONHFTJCGHVKUUDOOQFEPBLICRELDVJDBKLJJANOKQWTCXNRCRPUKZUDKRCENCFPEOQZHDMNZBBVKZWBQDFTYWUZADVTSZOSJGPSX");
    msg.type = 185U;
    msg.properties = 38U;
    msg.durations.assign("BKILVZAKFREBMYPLCZXVVUAJTPHLWKXQGKJJDGKIWUELRDTYRVGGCSVFJZHXVZERXLNZMSXSNOOOFUDQCCRJTJJSANWTDREITFZXIAZVYPNPYPEXMBDSEGNZUMDPHLYUVMIMZ");
    msg.distances.assign("INJUALAOCSHYTIJLALGVSBGQZWDGQCSFRVNXRYWPURAGDTAGLDOTUIKWBCEAYKKVUCXJFUDHLIXGZMFJHFNTWDOVEYKRAHYZZNCZHEQLJUMZUNGKQXFYQBENWGBYGIZLFXSCVPYTMDOWXVOWKRBUJTIMEEPLXXPCVQRTYZXB");
    msg.actions.assign("YIUBNZTMBWMNVNOLASGNTAEOFRFOSTVIXVLZTTGVWFVDPABTSCPXQNZCBZCCGEPCQDFBPRAMOOHJUTEQZSZHIPSIBXYDEGGKQUMGEZESJXLRRSMKVWLCXHUCVFPASUOLQDBEEBHYKVFMIDOKQRRJXYYHVJDJXKUIINJUUWDJLGWEVWIPAAFNYZFGDLCILRDNOUJOQKNMXBQWTKWU");
    msg.fuel.assign("BKNIYZTIYQEWNPFUZVUIW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PlanStatistics #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ReportedState msg;
    msg.setTimeStamp(0.127120045766);
    msg.setSource(15547U);
    msg.setSourceEntity(145U);
    msg.setDestination(29702U);
    msg.setDestinationEntity(66U);
    msg.lat = 0.736791506441;
    msg.lon = 0.429369584655;
    msg.depth = 0.248469038971;
    msg.roll = 0.512766497254;
    msg.pitch = 0.60457397083;
    msg.yaw = 0.709027437091;
    msg.rcp_time = 0.992971947404;
    msg.sid.assign("IBMJXJXSRRYAGDSUFHHSJAXVBWNGQHPTYGFENAZROECMADGZKUILXPQOGBGHTRHUZYISJSICOMTYFSGJNLMJPLRBUZKULKLGIQOPKQEOFEFXOCMBRJGEFTRXSHHJDCACGBNKCCWVNMTDAUPAWVAFWVNJBTTLEIBYDODLIUTDXVZYTARWBSVYYEQARWXVZFWNQUVROQIPNDJMVWMKVCQMHKLXKZYYBWEZHHPLZLPUIFCXKNUZWQCPFMTEQPO");
    msg.s_type = 32U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ReportedState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ReportedState msg;
    msg.setTimeStamp(0.884396231439);
    msg.setSource(17946U);
    msg.setSourceEntity(151U);
    msg.setDestination(8815U);
    msg.setDestinationEntity(253U);
    msg.lat = 0.385994352912;
    msg.lon = 0.32857705599;
    msg.depth = 0.851759610085;
    msg.roll = 0.645510912064;
    msg.pitch = 0.252875824783;
    msg.yaw = 0.554048557125;
    msg.rcp_time = 0.998705047738;
    msg.sid.assign("YVMREZAGCRCVHWAAPUHOYHHGAYVYXJDFFHLZTECXYIVJUKCJKDOYGXRSVUZQLEWTIVSIOXNNKPURKIFEBPXXLSUNTGVAIGTRWRNQCJNPAKQIRHQCIJMFZCYPZJFRGMJZQHKLKCMTXOXPDVSDFLLTXKUZSZJGDTE");
    msg.s_type = 137U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ReportedState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ReportedState msg;
    msg.setTimeStamp(0.593569717743);
    msg.setSource(27801U);
    msg.setSourceEntity(228U);
    msg.setDestination(42092U);
    msg.setDestinationEntity(38U);
    msg.lat = 0.977134293465;
    msg.lon = 0.436401091179;
    msg.depth = 0.734753529201;
    msg.roll = 0.209782251632;
    msg.pitch = 0.210580343868;
    msg.yaw = 0.394961006141;
    msg.rcp_time = 0.895826491367;
    msg.sid.assign("AGEWTANRPLKBQXCWSYILVOMRTZIBDAFBGUPXGWJQRICVDNSYQXHXZSVTPUJCCOJMXDWFAJHNYVLHPUFKRWPVLEPFJPBKNGESUYJCDOHXQWWZSOMFIO");
    msg.s_type = 118U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ReportedState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteSensorInfo msg;
    msg.setTimeStamp(0.537892820884);
    msg.setSource(9263U);
    msg.setSourceEntity(164U);
    msg.setDestination(15788U);
    msg.setDestinationEntity(8U);
    msg.id.assign("DCJVTKNGAUBCKVCGALDUGLSANNPBSONNKOQCRGAVEPZNZFLVIYZGTKIBMWFTFJIHLFWWOJZUVOLHGJPERMDDJVWZDBDIXIYFYTNYPEDYYRFNZFPOIMXGSCYOSKMXEEVCLMRWTXTRPNPHEHBFFRUTMSJDUWQXESUP");
    msg.sensor_class.assign("SPVMDZNTEQKCHRKAADRYFQPNXJQGOMVHBZJILCYCOWADUPJQAIWNBCSFTAOKXZJKEZMHVWLZFWQNYMRXPVFXMKZATWZJUTRJLDDGKMCDMDZRERWMOFXIIFXEDBRIEOUIUIMILOGXYNGEGLAFSHCOVLQUTAFPTUHFPIRLLVCYADXVNFGBQYNSOQAYBKBHYTBWNNQ");
    msg.lat = 0.0920566075855;
    msg.lon = 0.569365948207;
    msg.alt = 0.884437382484;
    msg.heading = 0.301222356701;
    msg.data.assign("NBNLTOSFCQWUMHGTGYNWOY");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteSensorInfo #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteSensorInfo msg;
    msg.setTimeStamp(0.328010548356);
    msg.setSource(45031U);
    msg.setSourceEntity(50U);
    msg.setDestination(30219U);
    msg.setDestinationEntity(181U);
    msg.id.assign("ZDTNFVKTZNTREXXSUAVJTIKRNZSWNAKDHESRSFLGYYBLHQSPQFDZCVQXCKTYPWPUNAUEBENGKBRVXLVCOZJXRBXIDJGJDQEYGAXZSMAOQIVYLGKJZFODSKOHUHVCYCJHVUTAIEILEWERPCCUFFMGLRTSOHXJBDUBWZRHTPWQKR");
    msg.sensor_class.assign("GVTUUMVAVNKHJMZWEH");
    msg.lat = 0.0567030686524;
    msg.lon = 0.931112918948;
    msg.alt = 0.209495479807;
    msg.heading = 0.542811471924;
    msg.data.assign("LSMSIZIAKPYNTBMYTNJOFPUPRFYSPPXLKNDKRGHMJETAXRDFXESZPVHXAQYIPXWOJUWPKWRVCCDTKVTLLVUYRETNKO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteSensorInfo #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteSensorInfo msg;
    msg.setTimeStamp(0.649636777711);
    msg.setSource(46140U);
    msg.setSourceEntity(142U);
    msg.setDestination(61979U);
    msg.setDestinationEntity(66U);
    msg.id.assign("YAAHZCMABWGAPHDVURDYOASPYFAVILCTXBDXJNOVJLMCREVAOBSBISGGGQPNLCLLXRZYXKQODYAPPDUHZIKCKZPZHWV");
    msg.sensor_class.assign("CSRFYHSCQJQONBFLYNRDEAJQXJMAZLADMUOUSKSPMYAJLODZOUYBAVKDKDVGOCANQLQNFRXJMBUNTJHVHEITQJESQNBKAXFVEKWTTMOXBZCUKMQXZHIVTZEGTEPUXGKRHYVJDOZWCHBDNOWMCSLXINFPSURMYWZVOZZNNTRAWLWKXPDRDXEUCQHPIZITIGSRYWGSBKQLODRHH");
    msg.lat = 0.466163142882;
    msg.lon = 0.100034548248;
    msg.alt = 0.179440816727;
    msg.heading = 0.221619005484;
    msg.data.assign("AKDRNLZAZNDZKTUKEBEUBHKYIILMJBIQRPWZOLTJLZAYCMXLGHOLCWPCDNQNQNLIXYMYV");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteSensorInfo #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Map msg;
    msg.setTimeStamp(0.174891577854);
    msg.setSource(54922U);
    msg.setSourceEntity(124U);
    msg.setDestination(37348U);
    msg.setDestinationEntity(205U);
    msg.id.assign("NYCCLXBOGJVPPJXLOAQMWLWKJLQAUBOZCVSBWNBKOETWKZJXGENUIEWAMDANESAPOZGNTILUNMLRWDQURITUSRFSDDOUEPXRXBQGQCIVYRDXVCWGKZATGLDNVGREEKYZPGFYXHHRSMBPPCHAGGJMHDQJLRCYCSXHYQIZRTYVXPFRPHHIHDZXCMFKTQJWYFUBNAVITOFFJM");
    IMC::MapFeature tmp_msg_0;
    tmp_msg_0.id.assign("JITZUALCKTIWEDPCGWVDSTKXLSZYESNUSJTPIREHKNENIGCDMRQTDGBANFWEJLNQXBANQOGPWAFYKLXEODVQKLXZJWCBBNQSGCIVAOZQRHYWRHRVKESBLQIUMOOEMXCHHPUMTFBZUBUOJYLFDZYDSSNRMVDKSAKMPORCHJPLRGMXIQZPPHHCUIAYONXB");
    tmp_msg_0.feature_type = 187U;
    tmp_msg_0.rgb_red = 70U;
    tmp_msg_0.rgb_green = 54U;
    tmp_msg_0.rgb_blue = 235U;
    msg.features.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Map #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Map msg;
    msg.setTimeStamp(0.0478744760712);
    msg.setSource(50500U);
    msg.setSourceEntity(46U);
    msg.setDestination(61328U);
    msg.setDestinationEntity(219U);
    msg.id.assign("NNWCEKBQJPPKEPKHVJRVGYWSSNXUWYILPYMXBDZRQFQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Map #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Map msg;
    msg.setTimeStamp(0.197551335375);
    msg.setSource(47255U);
    msg.setSourceEntity(52U);
    msg.setDestination(43556U);
    msg.setDestinationEntity(224U);
    msg.id.assign("FLWBXJEKTFWAQMXPEZMPDLRSULOGUWIHRPIRKHZHDPCPVSUUFIYKDQTSPJRFLSYVHQYVCMVNIOMADURVQNEXGGECRYHGCWQZT");
    IMC::MapFeature tmp_msg_0;
    tmp_msg_0.id.assign("CZPNEVGEYTMJAZCNZPRUYPKCMJQQKGMXBTORMSNWEZMAEBCLUYSSDGHXLPHIWJBDJWLUQOROISHHFNEGWNPQMIBLTQLJMIXJZXGMWCSXXZJHYEDEEVYXNPIWTRGKAHZEBNCDKAGGRFSVTVOIMKBBKGTPNAUSKFVFQFDWCUITSAKDNAUKZIXOAJMVZUVJQTOIFSADBGXFYLWVWRUTL");
    tmp_msg_0.feature_type = 248U;
    tmp_msg_0.rgb_red = 238U;
    tmp_msg_0.rgb_green = 54U;
    tmp_msg_0.rgb_blue = 206U;
    msg.features.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Map #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MapFeature msg;
    msg.setTimeStamp(0.428280621737);
    msg.setSource(22247U);
    msg.setSourceEntity(159U);
    msg.setDestination(11821U);
    msg.setDestinationEntity(87U);
    msg.id.assign("JWHHEELQMIHOYYLYKKNSMHXXWBKFBTJORFPIUDFDIAKUBFRUMVSUZXGSHGJVRXPAFUXMGCXNHBOAAGUENHGVEDCOWMYGHOLKWGTOQILFNTVCIKQGVJQASDC");
    msg.feature_type = 26U;
    msg.rgb_red = 209U;
    msg.rgb_green = 206U;
    msg.rgb_blue = 54U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MapFeature #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MapFeature msg;
    msg.setTimeStamp(0.817349121304);
    msg.setSource(25884U);
    msg.setSourceEntity(246U);
    msg.setDestination(41821U);
    msg.setDestinationEntity(67U);
    msg.id.assign("XZLBZVVNFEYPUAQMMNMTMWAJQFHRMOLCCSTWJVUETCPKGTXYQLOEHCGTUVZHKQXMKZCBMCBEAURHRTALYDOFFHALVSFNAPLWUIEOBAXIQQZNZGIUDUJYWXLGRJLWIN");
    msg.feature_type = 92U;
    msg.rgb_red = 115U;
    msg.rgb_green = 213U;
    msg.rgb_blue = 53U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MapFeature #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MapFeature msg;
    msg.setTimeStamp(0.820589729754);
    msg.setSource(43209U);
    msg.setSourceEntity(188U);
    msg.setDestination(38195U);
    msg.setDestinationEntity(18U);
    msg.id.assign("ZTVGYNFWRYHNHLKEIRYLVFLAXCJOHCGGWNITPSUDQUGXVMNAUCIGFOPCQBVHCMIOJNAEEHUMMKQSCBADQUELZDSNBPPVABFUDOFLZRBHYCIIPXYZKBMJCWOYDXTSPQWVSMWKQFUXOHEFB");
    msg.feature_type = 176U;
    msg.rgb_red = 150U;
    msg.rgb_green = 202U;
    msg.rgb_blue = 164U;
    IMC::MapPoint tmp_msg_0;
    tmp_msg_0.lat = 0.079898385895;
    tmp_msg_0.lon = 0.16837310513;
    tmp_msg_0.alt = 0.704944838759;
    msg.feature.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MapFeature #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MapPoint msg;
    msg.setTimeStamp(0.831967266769);
    msg.setSource(43198U);
    msg.setSourceEntity(142U);
    msg.setDestination(15117U);
    msg.setDestinationEntity(191U);
    msg.lat = 0.66626934781;
    msg.lon = 0.127990209906;
    msg.alt = 0.988051201825;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MapPoint #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MapPoint msg;
    msg.setTimeStamp(0.596353044874);
    msg.setSource(59792U);
    msg.setSourceEntity(16U);
    msg.setDestination(1697U);
    msg.setDestinationEntity(239U);
    msg.lat = 0.309782870417;
    msg.lon = 0.815912548981;
    msg.alt = 0.353400598791;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MapPoint #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MapPoint msg;
    msg.setTimeStamp(0.852324744782);
    msg.setSource(33362U);
    msg.setSourceEntity(167U);
    msg.setDestination(48572U);
    msg.setDestinationEntity(9U);
    msg.lat = 0.593345946774;
    msg.lon = 0.78793398513;
    msg.alt = 0.359682879103;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MapPoint #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CcuEvent msg;
    msg.setTimeStamp(0.684959783846);
    msg.setSource(6807U);
    msg.setSourceEntity(165U);
    msg.setDestination(48061U);
    msg.setDestinationEntity(75U);
    msg.type = 139U;
    msg.id.assign("WASCRYYMOVUUBBRDCASFBPZEJGSMLJLLXGLRFXRIXEGZTONKBIKPZOFHDUGDYQIVOMUNMYBRZIEREQKITEZCZXUECBSATKAWJYJLHZELVBQXQNVCEPYKORFGPKGGRLFDCJVWZQZWMCAQEDYSVPSRMDPOCFSBJMIPQNKOASTFOZINNLCHVDRJWUYATPSDUFOTJQTQMNIUJTTBINMMWVYFOASKHGKUYHXQXWGVHIWTHCEVWXGXKDFNPB");
    IMC::UamRxFrame tmp_msg_0;
    tmp_msg_0.sys_src.assign("WAYDKFTHXQXGABAHIMYLOEOREIWNHLTXYISWMJBFJQCJPUPTVOUVELJLWVRLRDXRKVNM");
    tmp_msg_0.sys_dst.assign("DSRYPRIOMKZVJTCEPQJPBJGJKVHGKOJKRFNYZPMXISETMPGZYKNJCBUSOADSLLCPDERQFOEYLGZRFBNTHRW");
    tmp_msg_0.flags = 169U;
    const char tmp_tmp_msg_0_0[] = {26, -33, -51, 98, -64, 123, 111, 121, 107, -91, -47, 58, 1, -111, -120, -43, 55, -103, 56, 51, -97, -17, 85, 24, -70, -35, 126, -110, 22, -35, -88, -103, -55, 119, 40, 31, -100, -81, 63, 76, 23, 14, -6, -122, -116, 118, -18, -98, -51, 15, 34, -128, 23, -24, 66, -36, -29, -126, -80, 55, 109, 87, 123, -21, 81, 42, 88, -111, 58, -40, -123, 100, -36, -15, 51, -41, -115, -34, 39, 13, -105, -74, -106, -63, 46, -96, 46, -107, 114, -120, -45, 66, -86, 58, 24, 27, -116, 76, 114, -61, -22, 66, 75, 8, -123, -20, 11};
    tmp_msg_0.data.assign(tmp_tmp_msg_0_0, tmp_tmp_msg_0_0 + sizeof(tmp_tmp_msg_0_0));
    msg.arg.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CcuEvent #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CcuEvent msg;
    msg.setTimeStamp(0.779770893832);
    msg.setSource(61876U);
    msg.setSourceEntity(150U);
    msg.setDestination(53281U);
    msg.setDestinationEntity(166U);
    msg.type = 216U;
    msg.id.assign("EAPGVHDHNCFCMLACJHIZEXWNZFLASQHLVJILYQNMYFMGQYYGSWWQNPZSUUOKIDGCKYJURHVGVZVDPTBYWTPXDDACKF");
    IMC::Current tmp_msg_0;
    tmp_msg_0.value = 0.29862174737;
    msg.arg.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CcuEvent #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CcuEvent msg;
    msg.setTimeStamp(0.350907903769);
    msg.setSource(8522U);
    msg.setSourceEntity(232U);
    msg.setDestination(62420U);
    msg.setDestinationEntity(67U);
    msg.type = 241U;
    msg.id.assign("XJYSCERKLORLGNZEIMPWXTPQMMCRWEVSDAXEBWSCIDBBSFCKFMGJARTBALXQUVZTUTDXJARNZOMITKUZPPLOMWPTYQWVANGJRCWCQKITEHJFNEWOJUXNPALLEFWHGVJQXHYQILUEXEVQQRZGHFFXZQSWUFCDKVDYTDSSJKDBNOJXSZUMKIEONUNFGVGZ");
    IMC::LblConfig tmp_msg_0;
    tmp_msg_0.op = 91U;
    msg.arg.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CcuEvent #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleLinks msg;
    msg.setTimeStamp(0.761543903374);
    msg.setSource(37953U);
    msg.setSourceEntity(27U);
    msg.setDestination(4775U);
    msg.setDestinationEntity(176U);
    msg.localname.assign("XVADWAFXZQFWTZTDFKEGAXCGSCIFYWKKHCNABHQFJBPUIKGQJUBLZFSQPKWLUOWRCZPNDTXJYTOSVIZTXLGCRUSILNPRRNHESNJCQBPOGGLIBMKRCQRSYMOFDIVENK");
    IMC::Announce tmp_msg_0;
    tmp_msg_0.sys_name.assign("HZYSZCCDLMDYJVMDZEDZAUX");
    tmp_msg_0.sys_type = 76U;
    tmp_msg_0.owner = 44567U;
    tmp_msg_0.lat = 0.141353956638;
    tmp_msg_0.lon = 0.977629866164;
    tmp_msg_0.height = 0.0629372560264;
    tmp_msg_0.services.assign("YEHSFMYWEEUFWMIGJZCFRKJYDASBWTXZQRALGATNTGWCHOMBJRGISWDCDCSJPBKQOVGVQECQADTFMVUIOWLPQKHOUKJKYFBLAHRBHOQZLETABBICUTKBZOWICQXFNLQMMUOYZAMQJVHPHIVDSFBZXUYOFURSYBYOEJMPLGARZKNWNJIPJNMKLVVCXNGVXIPUASDDYGEGTXZVJMNVOXYURSADRLLPPUZDGPCXSNIXHEEQLRFTKWTIEHZC");
    msg.links.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleLinks #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleLinks msg;
    msg.setTimeStamp(0.068549264268);
    msg.setSource(28583U);
    msg.setSourceEntity(182U);
    msg.setDestination(48289U);
    msg.setDestinationEntity(159U);
    msg.localname.assign("NTUWRRTCKKNZIMWQHSTZZONCKOCLSQBZQTCDCYLXGXUGPDIRXOWQQUWYPRLRMWSNBQUGJZHLYAIJJEQHPJTMSOZDTVYIURJZTOPINFQLEKJUGPALJEEBJMFOHMWSVVCCIGFYYMEVMIIMHFDNGDHNUIRYGXAKYZVMNXXRKFBEBHANUXOBDH");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleLinks #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::VehicleLinks msg;
    msg.setTimeStamp(0.387146681141);
    msg.setSource(1276U);
    msg.setSourceEntity(153U);
    msg.setDestination(42826U);
    msg.setDestinationEntity(128U);
    msg.localname.assign("KXCGKNWQDZKXQMTZUWETOVOEPNDBPNFVWXKGXMVNNCZYLMJOBSCCRXQNUFEZGVHGSPYYBBGXFDRYDIOJSURMCTZSODOHHJTHKR");
    IMC::Announce tmp_msg_0;
    tmp_msg_0.sys_name.assign("KHRHGTCBKPEOFJGACCNDLPHDLSLQWHFYNEHQNMTYKXCVYMRHRDFABOMVBTTUUQPVNIXTTOOSXKORIPYBZJKOJWSAIPXKMRWNLDXZWJSMTCQZQZNKKWEAJGXJXUDIDVXFLQPGIKVUIVJWWSAGAPYSFCYDFUSOGAGWOXEFRCZYHFZKJFRPEIEGYHBEOBLUGGLVDIMBLMVZJVXAUMIHWZSPQNDQTRMZSILZYUDOEAQTCNNBAREFB");
    tmp_msg_0.sys_type = 96U;
    tmp_msg_0.owner = 15144U;
    tmp_msg_0.lat = 0.903773470232;
    tmp_msg_0.lon = 0.171480398445;
    tmp_msg_0.height = 0.770576957379;
    tmp_msg_0.services.assign("TQGMRLBIQAJQQGONLVZFIVBEJPKOUITGHLISOHIGKYURZBRJUPBCOWCAEUXTKWKNFUAUQNTOFQAPHGNBSJTWPDQWZOGDRKFGYYZATSURDMDFXHEQSRI");
    msg.links.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("VehicleLinks #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexObservation msg;
    msg.setTimeStamp(0.161048174653);
    msg.setSource(17316U);
    msg.setSourceEntity(4U);
    msg.setDestination(19752U);
    msg.setDestinationEntity(193U);
    msg.timeline.assign("MODBVQNTIKEWAN");
    msg.predicate.assign("JHUWKBIDRQCCMXHXGALDEAWHYZLGUOVJJVIPAMRANAWSZRIPTNBCSNOOVEFYLXVRCMDEHALBJJMDMKAZAQUDUXGVFQPKXIVGIITFPRHPMSAEFMNJEWMRPERHOCPUHDUXQUFMFERNIOPLWWZXGKBOQTOXHBTSVWRIUZDCKGSSVFKYEFZQTZTCGVEHZWPONKPIBZXSLYJYJSSYDNBGTDAJV");
    msg.attributes.assign("KVVZVQZDKIGHHDHRXTDPWAZCQAJDKZVGRNMGDCKUVPYELCONBFAQWZKCMGWZINHIYCEFPRLXHEWHLMKXFWTHEBDTGJIQKRWAPEXRRVYGUNTCKWAOYHMQUOTAAYMFEIFBURALUMZXBJSBBRBOZISUJMNJTYFJKKNNAFQVNISGGXSBLQHYXLFHLVCISFPQSYJNBTIUZRWPXSPCUYUOWLN");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexObservation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexObservation msg;
    msg.setTimeStamp(0.457013062134);
    msg.setSource(52069U);
    msg.setSourceEntity(188U);
    msg.setDestination(47124U);
    msg.setDestinationEntity(82U);
    msg.timeline.assign("ECDOOCUBURULAZWHWELMZKNURGXJWOJMFMWHMCJPFAYXTXSNBYSYGEMNNSTORBLIACIJNDKGEWSXEPKRMSQCLCNELRVMWHYTCVQFPOBNYLZBLCZOQXBUGGJIWGZDPJVRPGBJVQNSHZDPKHYRLZFJLHAOTFVEUNBTAWRVJXPIVRFBICAQWDZTXLAVMDOMEEICUMPQQYZFZHKKOADIYDVXXQHUBNGYYTUEAHWO");
    msg.predicate.assign("HBWWERZDODTPFCKCDWUIAOJNYXCJVGOYIECMTGJLLBKPFZTSIZWLBBBRQPAENBKFIARSZWZAVFCYPUXYECVJGZQYLVMUQJHSMEBVBXDEERICJMFYJJKDNMDRNDPHZHLQROGNQSQIDHWHULFXWKST");
    msg.attributes.assign("ZUDDZYZDFFTKVWPHQIPNSZNIDLAYHJYSRRNHKEQMTWJMFEDOJOBAGQBXFREHXTIAZQBMUSZHTOOMDJGXRQKGIXQVLVTVNEIXOBWKVKPDFFLFCLWHHNKAMSLEOCKAWCCTCCRYNUAMEGOBSWRECAZLXWHNZTEZBTFPGOVI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexObservation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexObservation msg;
    msg.setTimeStamp(0.257402269729);
    msg.setSource(14765U);
    msg.setSourceEntity(185U);
    msg.setDestination(9574U);
    msg.setDestinationEntity(38U);
    msg.timeline.assign("JZAZOXXPFUORRDOTBHIPUMLKHMFNWLBZWHHMETBEDZNJTBCCSIGTGIONLWHRLQKXBMEDAJHIPYRUUJQBUARCDDXCGONHSWZARGAVJBFQADNYMYOYIESXCXKPNECWEVEWDLLGISYQVWRSJHLTECLKECUOBMPHAOURIAQPLSJQCWBTURYVKVQMTQIUODZVSZQGVBPXX");
    msg.predicate.assign("HVQSCEHZDPLYMTZCYWUARXAXHALWNBZRBBVULNTYIKQVIBJKKLEGYXYYBWQXRSKGOAZCMWCHKUP");
    msg.attributes.assign("UEKIBZBGXVFLSHLCUHENELTCCGNKQRSTJBWVJPMIPNLKTQCFXMGNKU");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexObservation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexCommand msg;
    msg.setTimeStamp(0.810029643349);
    msg.setSource(58553U);
    msg.setSourceEntity(217U);
    msg.setDestination(64226U);
    msg.setDestinationEntity(141U);
    msg.command = 177U;
    msg.goal_id.assign("QWTVOKEMSLXABXPDBWULJYRSRRMJAMWIYZZILVBDSJBYEZVXRNMQCIZRDVCCSGHCKPKJCAKVFHZIDEKPGDBOEQZLKJHEPFRFFOYSPTP");
    msg.goal_xml.assign("ZBUYLKYFGJWOPNYYAEOWXQLJPSSBGTNKMHDHJMSETIZJZBELPDRAJGOFTMLKVUCNMCDZTMCURCPVVGW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexCommand #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexCommand msg;
    msg.setTimeStamp(0.57316063968);
    msg.setSource(52211U);
    msg.setSourceEntity(187U);
    msg.setDestination(32497U);
    msg.setDestinationEntity(44U);
    msg.command = 141U;
    msg.goal_id.assign("BEOGWPPNRIKRACHBNCLGTBQVCXSGHQROUXBVUMQWDMZWBQASHAXZPTDHMMMGZVOSQZJUHEXFKVONFPEGMFJXXIYFOSYULZZXCYZNWDRAGWEUDIMZPETJBMBXUBIMOLROKJFYYGWAVOYCCQBKIESLLHTJANKWEZJATNVNUKOSGNQRHTAJTLCUHTRGYCDLFSKVDVMIZGQDWDKSSJAYXVERITDFCLQUPXPLIHKOWHPRJPSBTIQYJPFANCDIFLVUE");
    msg.goal_xml.assign("SVGSUBMLUSPLEKXRPCIHLINDQNXABLLHFUAFYNWKTQGLTHMRWFDMDRHXMFAPJCQYAEPQCESACTDYDLMQRHBBIWZZJFSDEZYYMBLUUDGYZDRVWLQARYWWNQPRTCSYJMOPHFCCTNIVPLZVQAOVKMPMVSIDNYRETGIEKNBOKQZOWSVCVSEKGTJKI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexCommand #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexCommand msg;
    msg.setTimeStamp(0.7824789506);
    msg.setSource(11050U);
    msg.setSourceEntity(61U);
    msg.setDestination(20681U);
    msg.setDestinationEntity(134U);
    msg.command = 122U;
    msg.goal_id.assign("PLDBNLOIPYVJTFDKFMSSRZLCBJJBLGWEVEHQNQJVSFFGYCJVNGIQKQWPKWYVDXHCDDBVVARHHITAJXBYNSEXOGHYFPIIGPO");
    msg.goal_xml.assign("PVJGHUEQZMUQYSJVDYOSNCEICMLGTOFICAHVAJCHUEBWUUKWXYHIMZMNIDAELTEXXLSTWTYRDCHUKSIPYO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexCommand #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexOperation msg;
    msg.setTimeStamp(0.101189602597);
    msg.setSource(57008U);
    msg.setSourceEntity(27U);
    msg.setDestination(14826U);
    msg.setDestinationEntity(133U);
    msg.op = 28U;
    msg.goal_id.assign("RCNOHCXSWVZFDBQDTZOQOEPEEUSJZBHQIWPXTLBALPHNYHTWJQKVRVPYEFBDJAWRIGFBGEBQGNCAJNMAIDKXNZYROGKRYAIACKMLKVAUQRNEC");
    IMC::TrexToken tmp_msg_0;
    tmp_msg_0.timeline.assign("UKJIBFERKPVKUWLHHBGSNDXJEQUFEARSFTOHMZCHJJALBFSNZDJNBCDZWCOXXKDBLDDNUEGYUFRMKVVYCTPQDBXPMANRBYMRTYINZQLOHFGOLOIEOSAOSJVOXVIGTXYVHZPPAKIBIHSATWCLXJQZISVRMRGMHTHDUNCKYHNYQJWAGUMZOPVQVMSWZOLDSAEUJIQREPEPCCKMATFXGGT");
    tmp_msg_0.predicate.assign("KXPEWLWSRUHQRSOTXCJGEPJUYMTWMFNQVODCKSCBSRZPGJXWNOGEPXYHKOEDXERZLPCIGZYDOUMPSRFSULCLNOIGVPINFVWNMDKXIQQDUGTDUGQKBQJXMWMFZVCWVMFYLTKANEGLHIKNOHLALVVHNWEHLZTKUYZAHYTFQXBCRRQADNBSAYUOYFJAZAIPPQAJBKCJIGQBAXUBIJKBEJOOITRTSTBDJSIYGEDFVHZRMRANZPWVHZFMC");
    msg.token.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexOperation #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexOperation msg;
    msg.setTimeStamp(0.254378840443);
    msg.setSource(33236U);
    msg.setSourceEntity(172U);
    msg.setDestination(39693U);
    msg.setDestinationEntity(195U);
    msg.op = 116U;
    msg.goal_id.assign("NORKSIPDCOMCFXJQFKVYORDBLDNQYPQWTIQZQGDLBKXYMGSAJMFCYWJXHTQNRVLBYFEJHMP");
    IMC::TrexToken tmp_msg_0;
    tmp_msg_0.timeline.assign("RLVKMEOOZKWFZCJQNSEBVUETAKCXZDPIDEBGHPJYORWIMQPLUFJXQTLLEWRWPRIJNFMVNJPNIZBOXBCRAIFZCTFUNLXQWIBBSYSWSIWUQCBTSPHLANMLTDPJYKSUVWDXVGVYQDYGZMHCGSINMATBDAKNGBHEZVFP");
    tmp_msg_0.predicate.assign("NKSPHGGCOALSOMXNGIQCLYEJVFYHGTAXMHTPEZBSJAFDIBOQDGVXKZZHSVTYHHNARKWJYNPANIJOPCHYUEWHUTUTFPCXNZAYPZDVNQPOWMYUQXMTRNADUJ");
    msg.token.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexOperation #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexOperation msg;
    msg.setTimeStamp(0.930571772201);
    msg.setSource(8920U);
    msg.setSourceEntity(87U);
    msg.setDestination(38289U);
    msg.setDestinationEntity(18U);
    msg.op = 15U;
    msg.goal_id.assign("MSBYKPQQUXEIBPGTLOZOSGTHQPDAYSCZVYNBUFVKUVFNNAHFGMGERDHENRZCJLPPKALDIBIXZTBZLWDLBDMPNWCJRMWWEJKOPMVFBFZ");
    IMC::TrexToken tmp_msg_0;
    tmp_msg_0.timeline.assign("IGRDXMAVXOBUWVIZNYRAUPYFAXWNRHZDJQOKR");
    tmp_msg_0.predicate.assign("IOWAVTDYQCXRDBGIQACYDNFKOQITXLADCXPQAMDGBSZCTYKPAXUOVUMPYJULKEFZJYVROKEFVIVUPSPWWQFPLXFEDIGIJSLHCVXDINFQBWAEKHTZUOLGRSUUPSHNKFMICAYLCXDRWSUY");
    IMC::TrexAttribute tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.name.assign("XILLKVCBTFQTFWUWQVRQSFKOTYDATUEWOUWDXWTVEXKNMUNNUFZEEENZIPCITEPHMNADMSPG");
    tmp_tmp_msg_0_0.attr_type = 164U;
    tmp_tmp_msg_0_0.min.assign("KWWPLRIUNSNVGQYQIFSVUEDBHKSHWRIOPDMEBJOXTTQONVQSPLAYTFWBBMIJAUMXATDJSEABXETLSYLWFSNZKUCXFOQALXIVKEIWZVBKVUBPNZDJYHUPHVZLMVJRJIVRTWPFVWDQRMFCQXSNQUXGTZRHRXJCFMUJPRGGMBYKEGYUCXBBIJZLWKHPTCGFIOSLXYRTUIMODELFNAECNQYKGCECPZMDZFYQHZHDHRJPNGTOEADOANKHGMOYWLS");
    tmp_tmp_msg_0_0.max.assign("ORRWZBZQBSGEBCQSKJXLQMWWAFBCFP");
    tmp_msg_0.attributes.push_back(tmp_tmp_msg_0_0);
    msg.token.set(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexOperation #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexAttribute msg;
    msg.setTimeStamp(0.492137118592);
    msg.setSource(29485U);
    msg.setSourceEntity(254U);
    msg.setDestination(10818U);
    msg.setDestinationEntity(0U);
    msg.name.assign("RBGAHTPMLHICXJXYVVKSVKJUFLSRDQXLBOCKFGEEUMBKDGMOOTHPACSIVNBDVBLDQTWQYMZUZDTNXB");
    msg.attr_type = 87U;
    msg.min.assign("RYPDUDHMXDPKCBLATBKWQPGBIUJLXREINSIAOQMVLZFXEXCZFETQBHMDNSEIFWYACSEVUVMWIOEPBAKQDNMOKDFLVNAHRLEEGOHCJFNYXNWKGWAHBXVPHCJBMYDQJVSIXZIZZQQEGPRUKVDFIYQTUYRCRBJSAFTWYXLONPWSQWTOLSIGUKJAJGGEOIHHWRYVZXPFGLCPTRNUNAYOLZZSUMRFWQAYDVTCKCUBGZMBOTMTFLJUVSKZRHDGOHSMPC");
    msg.max.assign("AAFHAZLVFYFQYLEPLSRLLQPESIFDHNYRLTVARYKVCBJZKIDNMPDHMKUQVWCTGNDREYEIJXRQFOBUMUDLCEUWJAJPTYZZZZZBGXFACDEXPAHHSQMRAWMZLSNQDCHRIUUHKFBXOXNIKAKGUO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexAttribute #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexAttribute msg;
    msg.setTimeStamp(0.755118327001);
    msg.setSource(29990U);
    msg.setSourceEntity(107U);
    msg.setDestination(35451U);
    msg.setDestinationEntity(250U);
    msg.name.assign("MQXSHXFYOMTNMTQCAIAMFSUBWRMUEWAYJGIXZKVBCZOFKPTILXUCOCFREIYIOQBIJSUQTRGSDZKYKTQRUDEHQPPIJLRPAVBOTEZQNBHPTAMVVYTURL");
    msg.attr_type = 88U;
    msg.min.assign("LEVRSYOOODBISGMPXJQKOOFNMXYQRAUILIFLSBLTKIUCXNZRGOJURLCERONWEUUFZHAXJCGVHJPFMYBIQAXHCVZQJMQPHGEBEJKZERTVPRYVRXNVSLRPGSKHFFHDLTEDWAFHBGAJWEXXAFNQTTLZGQEFMANIZBRNCUBKMMJDCCSALTUGOTYANXPTBQZSN");
    msg.max.assign("YSGMZENOVDIVRFAGUFMOEHBTLCTWJPVRQCGKEDFFOBVISSNUMZANEQSAODTKIQYNHXDQLXOOLQQBUHCJUEPXMABCSYJIRVZJFKRXPINFTAQMRZCMITHGGBEMZNCPOUUCSKHAVNHORTLZHTGCYIKYYBHCSRGYCJKOXZBNPBWDGOWMFRKRZWEDYJDEJPDFSXEPLSAUNEPVDXQWKHQWA");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexAttribute #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexAttribute msg;
    msg.setTimeStamp(0.37812771128);
    msg.setSource(28514U);
    msg.setSourceEntity(17U);
    msg.setDestination(51369U);
    msg.setDestinationEntity(169U);
    msg.name.assign("HIFTASYENVJMCBVIOHJZNPRJLJXCHLHPCKGWZFBKADAUGBWUNEIVKEKDJEOOLFFJXTVNZZL");
    msg.attr_type = 198U;
    msg.min.assign("RIPLNQXHUTFPPFMEZIKZGHCIIHBLYGYQMOZBKEROSKLSRUHCCDEHUGNURREZOTKGUHAYJKXTDDIEFOGQBFXGJFVVPNREWLQSDDJIVVRNYXCCBINYWNVVZWSCSLUNZKHCBTVMWIXNSJFFZDKFLUMUJAABXEICXLDOMTAWPEPIAURBMQCWBPPKWHTZSHSWVAXQOMMOLDUCPEWQAGQJHJRLTARQOYGNZBVXPZYK");
    msg.max.assign("TNUEWYYYTUHQVAQXJLRXJROAZUMUHOGQVNBDMTNNBRNXMLBJOACYAUSQTFHVVQNURKABIGBGJHCTGXOCWLYZZQTUIVTNKPVXMRVSWPSZDZEIPCOIXCEFAMUOLZDDPBRGXZPJCIZJRFJWECDPAUKOEZPBNGSPFSSRFXGVQYOAWEGMEFCIDKJPYHDMVJCOUFBBELIIMSEKTLSYKTLNWRFWXLXWNQYHGIEMRFAKCJHSVIWDFYDOQD");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexAttribute #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexToken msg;
    msg.setTimeStamp(0.50153447955);
    msg.setSource(44615U);
    msg.setSourceEntity(77U);
    msg.setDestination(21470U);
    msg.setDestinationEntity(36U);
    msg.timeline.assign("EEPQJTOWYBRTPSDIDFIZQBGPNEVNBQXYUOHZQIFYGYJQBXSCKFRCMBJPJGHMGWAQPKVURNRFMATSMFDBYUUKJV");
    msg.predicate.assign("HYAGMDTVSYEKCZOIATMTYRTTXPOUMLFPTIKQZGKORCLSKUHXAFEUGSKKNACTTYBIRUUIMCJGBBDCLBEWETXWBVYUICQILNHDFZZNPJYIKDPAEHO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexToken #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexToken msg;
    msg.setTimeStamp(0.381207627715);
    msg.setSource(55612U);
    msg.setSourceEntity(47U);
    msg.setDestination(42651U);
    msg.setDestinationEntity(247U);
    msg.timeline.assign("LQAOPXEXUJYKDMVSWEQDAFHGTBOHGRKLBPLKCJXZSICARYJBTLENQDLJGYTXRGOQGNOLTZAARIYZ");
    msg.predicate.assign("FCICNJBONLLURNHEVXFHPJUETNSEPGSVLVSVPKEICOZXSQHHYLRMDDZKOPAJHABLGQHCGGSQFXIGKRUTOPNPRCJDWVAYJYPZSYFMOIYJBEBHDTOBMZZAXKFAEIGKDTIWRWOVLCURMPZYQRTOFVBELPKTJACAXWUEWUKNFYXQGIVW");
    IMC::TrexAttribute tmp_msg_0;
    tmp_msg_0.name.assign("JYMMSTPHNRCTGLHGRAKKACGSYATWZETAHPIQRXROGOHUWWPZINOLEEBMOXZIIFQRWZAFWVEWL");
    tmp_msg_0.attr_type = 216U;
    tmp_msg_0.min.assign("UNRIFCCYKZKEUIQTZJOPKYPKPVJGXVESDJZYBYNVPCMIGOFMLXAGCTBDEKUSVMOXKKWDJAQLTDSGRZHFXHSZIMLFNJGLBTTIGFPDCQQWQXRPUVSJPNNPRRSFXENBDFFTEBWCIIKZBGNQELXAWSMTVWJRPQHLWQFUHWEEUEQBQTODDGBHHOGHRIKCUCIAMHUNOMYUFAIKAWDXOWJZSEBBDAYAZJJMSYVMCPZHLLOROVOSHCRNRYWVGTMLV");
    tmp_msg_0.max.assign("XVWTBOKURXJYFERFEDNTXHGH");
    msg.attributes.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexToken #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexToken msg;
    msg.setTimeStamp(0.0353379814393);
    msg.setSource(23601U);
    msg.setSourceEntity(64U);
    msg.setDestination(23562U);
    msg.setDestinationEntity(173U);
    msg.timeline.assign("VFSYCCNJFYHHFZEUKSGIKQUPDHAVDTKDBMWQTLMHVFRGGZQNCWQUACRIJILZHLIXQEKBPUBTEZEVTKEUDQELBFUWOOVHYSMUWPUZMCYNMDDSJDWLCEIEGCFLDOMYANXLV");
    msg.predicate.assign("HDBLGPBRWJZVAVLESSOEKPJYYQKPYIJLBRBGTZZ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexToken #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexPlan msg;
    msg.setTimeStamp(0.440822352388);
    msg.setSource(64363U);
    msg.setSourceEntity(96U);
    msg.setDestination(3469U);
    msg.setDestinationEntity(177U);
    msg.reactor.assign("KSFEYRSWSJEHDGMRXBGOIJNZPHLJRFICTRBQYUDWLTBWHEXGEDDAOFKHCM");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexPlan #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexPlan msg;
    msg.setTimeStamp(0.186255759405);
    msg.setSource(56178U);
    msg.setSourceEntity(210U);
    msg.setDestination(17362U);
    msg.setDestinationEntity(252U);
    msg.reactor.assign("LKZBMYNMQJIVBYHFTKSZNGAPEXQCCZEPHOOUOSQRERCHCUQVTMWDVPOTFANVOUIZXEATFHKISSMWMJXZMFQDERTUAZOBPERADBEHPBFWATPWCVVHUKXBEOKVQLSNGMCNETHMYRVDCLY");
    IMC::TrexToken tmp_msg_0;
    tmp_msg_0.timeline.assign("MGKYJOPTFXHBLIPFBUQVIFXBQVSSPZTPTEANXXMGIZWHLTNGNRKJHOOECFPZDZAAXWJLTSGKBSEOMTUYCZCWWKPGVLEYBUZPYREXVORIHRIRRACFNTHUOQ");
    tmp_msg_0.predicate.assign("NBVCRVELHQKQCMIYUCWCAAGIPBOTCHPIJJMLIKDEJSZERWVDFRLVBHBF");
    msg.tokens.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexPlan #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::TrexPlan msg;
    msg.setTimeStamp(0.0976938692324);
    msg.setSource(23414U);
    msg.setSourceEntity(20U);
    msg.setDestination(7992U);
    msg.setDestinationEntity(108U);
    msg.reactor.assign("IKKLQHMAXIRQLDZSWUKAPRNHMGVQRIPKIRYUCJPSDQNKTJUXPXXIYSHESFPAXNKOOOWJRTBEFZWAYPZGNAUYBZMKDMOGIQZVDVVOFWTSTNXVIIELMXBQVGBOVJC");
    IMC::TrexToken tmp_msg_0;
    tmp_msg_0.timeline.assign("IOFIRJRCXLLHCRFJOLWNFDMSARPWCYDZIHKVYDIAHHWAAUCCUNESTCAKXXAZKUWYNRUAONPEWRMJUTYSGGMWXLXVPESKDGZZOJKMPEYJRBQQEFSHTDURPYJNLTGJDZPTGESDVQKEWZMZNFPGMJHMSBGPVAOLBZYABQSDIFMOELWQVBSRLNKNFVJXBNB");
    tmp_msg_0.predicate.assign("CGZLNDAYXLJPMEZILJIHTZDWCPCPEGBSYNQENCZWLLBOPXWYKOGPUGWUHXMVSNCDQMIWEK");
    IMC::TrexAttribute tmp_tmp_msg_0_0;
    tmp_tmp_msg_0_0.name.assign("VQQZMVERSLEWCNUTKPCHSYKNGCWMYOLRWZDFMXMNUBROBGHTBSOFSNTKLIZZHMGBAXTVRKGUPDIFBOAGEXQEQYLBCNLOCSCXJXYGDDOXVZHWCKDBYOFOUJUNYATMMYSLAFEALPWTREJINTPWZVWJUTJQXVIUYHQQHXKJIUHZABWPDDCBQSAHUNNIOEPRIASZGVYMWNRERFJUAKPKXHDEQLRADFJKGTEVTYPLZVXVMPSCKPISRDOLJIMWGBJFI");
    tmp_tmp_msg_0_0.attr_type = 188U;
    tmp_tmp_msg_0_0.min.assign("WRRKVHZDQCUJUJPJMHFEZNUMBSXTILSOMNUICQKBYFJTCUIPTIOAVGQICQYYSCNFMUQODAMNOKVRVTYZKRCPSEVJBEAVOEAFFBIXDJLNEZQYVCRDMRZJGLWBCOGWJBBBTYWAPOCKGDOPHWDML");
    tmp_tmp_msg_0_0.max.assign("CINIVVYOHHVMRMLQWSHEJCBEHOXTALZGQCHSIUPOKUAEXLWPYWCZFEZOKRMWJNECXTYCPSTBTVXSBTRFNGTLKPKIMWNXIRDQOQYFSBJLCQUDQDUUVFODPEPRQHIPYZKWGZJHIMUURYGVHIPCLPBL");
    tmp_msg_0.attributes.push_back(tmp_tmp_msg_0_0);
    msg.tokens.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("TrexPlan #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Event msg;
    msg.setTimeStamp(0.107896277127);
    msg.setSource(49976U);
    msg.setSourceEntity(76U);
    msg.setDestination(31305U);
    msg.setDestinationEntity(163U);
    msg.topic.assign("MITXJLUODTRNJJRDJAHMUTYGHCJLUBMPBBVLQTCQTWLSIGVRKSEDQBWJPONRYFAXYNCTOWLIIHXOMAMQVCHTDHFVCV");
    msg.data.assign("VSGPBXVAQEFIAUBPDNNKRTMXZWOAMDLPKTBCGVUQUCYPFBSHUAVKFINKFLYJOEVDCCIFIWGRXKXLHSCXMUT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Event #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Event msg;
    msg.setTimeStamp(0.0111763853908);
    msg.setSource(9641U);
    msg.setSourceEntity(174U);
    msg.setDestination(9976U);
    msg.setDestinationEntity(175U);
    msg.topic.assign("IFJJPLJTUVONUFFCUJTZNVNIHBAVHYLGKFAWNMNREELHSXTKKYBWYELLRZJADSSZXMAQIDCBCZYQISEPQAQHNHMQWAOSEZVYGXKFCBKOTUXHFDGYLLHB");
    msg.data.assign("EBVLOCZQWPQO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Event #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Event msg;
    msg.setTimeStamp(0.601911282701);
    msg.setSource(43094U);
    msg.setSourceEntity(136U);
    msg.setDestination(22989U);
    msg.setDestinationEntity(36U);
    msg.topic.assign("JTXPDHTRXXMQHDOIDLHQJTJVSEWSURQKPQBGNEKYLNFLMVIPEDPHOUAWLAMYSYMIJXSXHMBCLZGYTCSFCWKIFUCYEFYWKOGDRTIJJSFMBBVBVBADOZGCYRQNZVINGWRBUYBQFTGTRIDSWDHVUMQRFLSEAZLPFYUSPWBXCAQKEUZCGHCATKZDNMQPZTEVPJTEZKSJVKNPOGGWHAXNNJGBUOCIRZUXARJ");
    msg.data.assign("CVLKOCIMKFTHSJVRBSMULQRNWDQVNXYLZMXKUFNWKJQJQTGIBVDEYXHTFXFTRGWQZPDCLKGAWGMHMSALAPOCFJGCXTJVXKHSMPALFQUOHQCPSDEDYERKBNTCZHHRXIDXPAYUFYTVBOSYLWKZEETXVHHQDUPWMBZZJABYNTBJSUPOYLLFDGWKY");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Event #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CompressedImage msg;
    msg.setTimeStamp(0.581266647533);
    msg.setSource(64665U);
    msg.setSourceEntity(169U);
    msg.setDestination(2882U);
    msg.setDestinationEntity(25U);
    msg.frameid = 233U;
    const char tmp_msg_0[] = {92, -39, 110, -4, -111, 24, -96, -38, -9, 2, -50, 32, -115, 122, 41, -36, 123, -112, -19, 22, -38, 98, -95, -66, -4, -20, -58, 45, -62, -73, 0, -20, 95, 123, -48, 14, 25, -82, -60, 81, 56, -102, 74, -120, -75, -102, 37, 8, -15, 6, -122, 117, 113, -12, -31, -59, -92, 91, 1, -20, 45, 108, -38, -67, 17, -56, 61, -121, -17, -124, 68, -6, -19, 73, -90, 47, -58, 98, -53, -30, -102, 26, -109, -72, -33, 119, 90, 63, 71, 124, 16, -63, -64, -114, -115, 67, 8, -40, 73, 28, -103, 6, -70, -36, -37, 3, 92, -93, 84, 68, -74, 43, -49, -88, 60, -26, 52, -89, 122, 105, -68, -21, -94, 91, -60, -82, -2, 99, -69, 26, 52, 15, 19, 97, -102, 34, 38, 53, -106, -21, 114, -126, -86, -14, -96, -6, -63, 64, 61, 27, -23, -74, -64, 13, 68, 72, 21, 8, 10, -27, 111, -61, 11, -7, 111, 104, 44, -109, 54, -56, -91, -42, 121, -37, -92, 5, -122, -115, 123, -51, 68, 8, 88, 7, 19, 1, -41, 27, -4, -9, -5, 60, -97, -69, 56, 56, 21, 122, 115, 109, 35, 48, -92, 5, 110, -116, -98, 94, -41, -4, -78, 46, -92, -87, -52, 55, 58, -18, -80, 57, -17, 121, -53, -6, 48, 29, 103, 76, 66, -59, 49, 2, -113, 21, -9, 53, 52, -104, -123, 26, -122, 39, -103, -3, 84, 38, -26, -11, 37};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CompressedImage #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CompressedImage msg;
    msg.setTimeStamp(0.362693153111);
    msg.setSource(56533U);
    msg.setSourceEntity(14U);
    msg.setDestination(39494U);
    msg.setDestinationEntity(36U);
    msg.frameid = 83U;
    const char tmp_msg_0[] = {-4, -84, 39, -1, 68, -45, -49, -5, -99, -55, 3, -3, -54, 88, 33, -115, 99, 39, 111, -3, -116, 63, 14, -35, -50, -30, -22, 23, -70, -17, -7, -78, 90, 78, -55, -28, 13, -71, 20, 59, -94, -55, 62, 15, -120, -85, -45, -20, 118, -47, -23, -10, 35, -93, -24, 62, -4, -104, 76, -112, 31, 81, -28, -68, 1, 77, -122, -125, 32, 51, -119, 42, -109, -18, -62, -44, 3, 42, 117, -74, 76, 34, -77, 125, 115, -108, -82, 120, 13, 64, 124, 105, 97, -33, -49, 124, -77, 74, 12, -31, 50, -86, 59, 62, 76, -57, 123, 102, 45, -55, -123, -1, -19, 101, -1, 85, 75, -13, -16, 90, -43, -51, 69, -78, 76, -55, -91, 102, -28, -83, -101, 111, -12, 38, -4, -45, -15, 32, 90, -74, 17, 6, 103, -42, -88, 118, -71, -31, 73, -105, 15, 17, -27, -18, -103, -24, 108, 94, -92, -124, 27, -128, -22};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CompressedImage #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CompressedImage msg;
    msg.setTimeStamp(0.930079942464);
    msg.setSource(60155U);
    msg.setSourceEntity(21U);
    msg.setDestination(14903U);
    msg.setDestinationEntity(204U);
    msg.frameid = 52U;
    const char tmp_msg_0[] = {88, 37, -98, -56, -55, -74, 35, 98, 116, 23, -80, 78, 53, 45, -73, 100, -40, -17, -3, 125, 28, -31, 101, 82, -83, -17, -81, 25, 42, 41, 24, 19, -31, 39, 10, 33, -59, 77, -86, -3, 39, -16, 49, -45, -100, -94, 29, 69, -97, -27, 22, -114, -128, 98, -47, 15, 14, -2, 106, 115, 22, 103, 113, -101, 85, 40, -38, 119, -30, -127, -97, -115, -7, 6, -118, -117, 3, 26, -103, 43, 110, 88, 108, 80, -61, -95, -8, 7, 72, -8, 100, -82, 78, -46, -57, -3, -13, -80, -110, 67, -51, 40, 96, 42, -12, -72, -48, -70, -78, -93, -86, -65, 94, 75, 100, -78, -84};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CompressedImage #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ImageTxSettings msg;
    msg.setTimeStamp(0.320635951433);
    msg.setSource(12184U);
    msg.setSourceEntity(59U);
    msg.setDestination(10509U);
    msg.setDestinationEntity(105U);
    msg.fps = 31U;
    msg.quality = 223U;
    msg.reps = 221U;
    msg.tsize = 70U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ImageTxSettings #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ImageTxSettings msg;
    msg.setTimeStamp(0.0698969445677);
    msg.setSource(12536U);
    msg.setSourceEntity(59U);
    msg.setDestination(15083U);
    msg.setDestinationEntity(67U);
    msg.fps = 99U;
    msg.quality = 155U;
    msg.reps = 21U;
    msg.tsize = 108U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ImageTxSettings #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::ImageTxSettings msg;
    msg.setTimeStamp(0.57640954238);
    msg.setSource(10550U);
    msg.setSourceEntity(217U);
    msg.setDestination(21050U);
    msg.setDestinationEntity(167U);
    msg.fps = 29U;
    msg.quality = 147U;
    msg.reps = 77U;
    msg.tsize = 199U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("ImageTxSettings #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteState msg;
    msg.setTimeStamp(0.158497515522);
    msg.setSource(47097U);
    msg.setSourceEntity(210U);
    msg.setDestination(18237U);
    msg.setDestinationEntity(153U);
    msg.lat = 0.405375726066;
    msg.lon = 0.914599015276;
    msg.depth = 30U;
    msg.speed = 0.829698533376;
    msg.psi = 0.319067252811;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteState #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteState msg;
    msg.setTimeStamp(0.940791818467);
    msg.setSource(52027U);
    msg.setSourceEntity(162U);
    msg.setDestination(38955U);
    msg.setDestinationEntity(223U);
    msg.lat = 0.468253918884;
    msg.lon = 0.680175344268;
    msg.depth = 64U;
    msg.speed = 0.274174782289;
    msg.psi = 0.540783631477;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteState #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::RemoteState msg;
    msg.setTimeStamp(0.477306468997);
    msg.setSource(60863U);
    msg.setSourceEntity(195U);
    msg.setDestination(49934U);
    msg.setDestinationEntity(103U);
    msg.lat = 0.735359632741;
    msg.lon = 0.0747249581562;
    msg.depth = 230U;
    msg.speed = 0.0258766974767;
    msg.psi = 0.344681820121;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("RemoteState #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Target msg;
    msg.setTimeStamp(0.0334628629274);
    msg.setSource(36673U);
    msg.setSourceEntity(156U);
    msg.setDestination(61672U);
    msg.setDestinationEntity(196U);
    msg.label.assign("ZRMGAKPHTQPTMINMUSILHBRVUVJPOZFSSXBGLWVYABORSUFGLFTEJEVSLRAWF");
    msg.lat = 0.8061492449;
    msg.lon = 0.395505273104;
    msg.z = 0.280017234146;
    msg.z_units = 133U;
    msg.cog = 0.932897058924;
    msg.sog = 0.492126452643;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Target #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Target msg;
    msg.setTimeStamp(0.328887267021);
    msg.setSource(20041U);
    msg.setSourceEntity(163U);
    msg.setDestination(32477U);
    msg.setDestinationEntity(204U);
    msg.label.assign("DWJNHHDEVQXMFPLXQQKKAAAOXZJ");
    msg.lat = 0.354225141173;
    msg.lon = 0.658330691151;
    msg.z = 0.950568109852;
    msg.z_units = 90U;
    msg.cog = 0.534796958695;
    msg.sog = 0.435235448227;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Target #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Target msg;
    msg.setTimeStamp(0.95205572916);
    msg.setSource(28852U);
    msg.setSourceEntity(236U);
    msg.setDestination(31469U);
    msg.setDestinationEntity(26U);
    msg.label.assign("SAKCVFLMBEAIMOKVHXMVNUJAXHBGQNRCPMKYOYUJRXVWVWFWRJDEAAWWPZLTXZRFBBGVUQERZZYOBWUNGLJXOIQSQDR");
    msg.lat = 0.546056103733;
    msg.lon = 0.0362336656402;
    msg.z = 0.628974158094;
    msg.z_units = 56U;
    msg.cog = 0.713849202442;
    msg.sog = 0.692025339589;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Target #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityParameter msg;
    msg.setTimeStamp(0.0243837549474);
    msg.setSource(44940U);
    msg.setSourceEntity(88U);
    msg.setDestination(10111U);
    msg.setDestinationEntity(58U);
    msg.name.assign("HTGQCVBUHOMSGYSHJDDNUYDJXWBWCRQUJQNWQGRCPEEVRFDJKOKJELABXXXQLWJGYNTDFCZZICHZVZORAYKBOVJAUZXFFIYUOWVNHAAXRMUNJFEOGWEMMFXRJYQCQTLUVKSSTPPBVEOIOFCPPLGDXMK");
    msg.value.assign("KYFUOAUVNTVEGMCQCUIOBKHNSOLRYQGLNIQQPUQEPZLYMSLJRQLVHBKPXMFNAQHQHEPMFGUXFJUHHRXYUHGZWSJGJZYCDBTCOVTRMWWNRTKMKJCBBPYNMWRQIRUUXMJAPLTOCDXENLREOAQPYZUOCSPDIWWCKNMFOXFDNAIESEJOBPFVIHGBIZTKWTCOVAZITEDSMZKIYGTLBLXGBNJY");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityParameter #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityParameter msg;
    msg.setTimeStamp(0.285804965242);
    msg.setSource(61572U);
    msg.setSourceEntity(108U);
    msg.setDestination(231U);
    msg.setDestinationEntity(80U);
    msg.name.assign("MBNGENOWURIGMXOMXFJZRWSRRCPNKMSZSPIZEWBUXEWAUJIWBYTPTUGDQQTIUQDSBKFWEVZRBFTLNLIQAYJIBZBDWLPVZKYAEOYGJQHDHCHUHCUYIZUFDWNGPRGSKCNVBXSWBLCYEAAXERKJDFLVINUQTY");
    msg.value.assign("SPJUSRYUOIEIRGAVHSBJSZRZCOTJOBLSBAEKVYUJMJGZVNFZIVXRXYAMFDHSQBBRMPMXOGHYLPJCROQQGKFCBZCPCHTFTKKDXMZHHY");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityParameter #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityParameter msg;
    msg.setTimeStamp(0.460082136425);
    msg.setSource(23976U);
    msg.setSourceEntity(230U);
    msg.setDestination(30554U);
    msg.setDestinationEntity(104U);
    msg.name.assign("LEDNQOKYEXMTSJJIDMLLPACGFGSXABUJGSFQMHFKRJXWEKNLAYQUHZEZFTVICKGMTOVVCDUXAZJIPWWNTZYRHZOBWGNJMSAGYQNBCHAQCDWSSHBCWJVSIYQODLRVOKRPRHVWKHAW");
    msg.value.assign("WGJERUVBGHVQAXARFCSIXXKZDWBLWPBNQEJNOJIVLTWECPYDNMGGSPQFHGOICNYHJIQHJBUTSVLSSKOEXVMZUBVETJVQHUMAVXLRMRIIQORXT");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityParameter #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityParameters msg;
    msg.setTimeStamp(0.979848228288);
    msg.setSource(9431U);
    msg.setSourceEntity(52U);
    msg.setDestination(34964U);
    msg.setDestinationEntity(137U);
    msg.name.assign("GIYPTMZYVJLZDMISYOVPEBYNEADGMSNVMZUCLEHTGKFGEPOUUTKWEXXJPSNNHJJTGXLVXRHKYDHKQIUFUQNKQDPIMYGCHFISVQWEI");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityParameters #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityParameters msg;
    msg.setTimeStamp(0.695455131924);
    msg.setSource(65430U);
    msg.setSourceEntity(147U);
    msg.setDestination(22055U);
    msg.setDestinationEntity(206U);
    msg.name.assign("BMJLPGSKURSNPECVGZFNGURLFRJZFQXMAQWIBIBNPSMFGOXSCKJPVPRLCHTTOCNNLBEGCKEANAMGEXJOUDMMAWPSWG");
    IMC::EntityParameter tmp_msg_0;
    tmp_msg_0.name.assign("EXWLAIRGOYSHOAEOZOESMTRGBLKDTTGIPXOZYWZNMEDNUGFMZPMQHM");
    tmp_msg_0.value.assign("MAOTIKIIYGXSAUIWIVZSRICTVQADYFHIHUTCSMKLTFQVFKGERAFNQXJPNNHOMXSBXHQYHMROLVZLLQPRAGYUMJ");
    msg.params.push_back(tmp_msg_0);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityParameters #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::EntityParameters msg;
    msg.setTimeStamp(0.808377268295);
    msg.setSource(29019U);
    msg.setSourceEntity(29U);
    msg.setDestination(34716U);
    msg.setDestinationEntity(63U);
    msg.name.assign("CKIKQYBTKUJESTDEDHGEHZTENFACSGBRWWEEBQMHYZNCHRJVOXEIVOCWJQKLPYIBLNIJJITYQYARURU");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("EntityParameters #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityParameters msg;
    msg.setTimeStamp(0.15335077879);
    msg.setSource(58269U);
    msg.setSourceEntity(69U);
    msg.setDestination(39772U);
    msg.setDestinationEntity(217U);
    msg.name.assign("MOVDSTTZIBFAEXXCVKAUHFPGGAAWPFHHFAYGXOBLOVMVYLENRFCYYLWAGM");
    msg.visibility.assign("XYJGEJSRHSVFULXVDXOSZFDWQEOANWIBBQXIKVCHVTDZXYYNNPDUPKEWKISUGXHFKCDXAUQHWUELUEXYPZUQETFOBPHTLGOQAWWNRSBKJMOJOPFRHMYWMVAMYTLAJICNDKDKLIJFZGPHGRWSPDYORUVCN");
    msg.scope.assign("KJDGLMSGLPPNQJFUWRUONHUMTTMQSRZFGKSJLMJUBKYLHGVEDIJNIBAQFERNCARDBWFSAGVKUXHTIRDORPSWNWDXXPFBHIFBTBOEIYFNWSATZOCZQZWBOPLGTPYCRFOMEPDIZAGHVDRFMAUZSEKJGDLJRECWQXEGYOQJQMISVZWIHXUCITWBYTXVHKGXBIVXRDUYAQKKHPVYLQCEHZWMQLNNXK");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityParameters #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityParameters msg;
    msg.setTimeStamp(0.407993147891);
    msg.setSource(59413U);
    msg.setSourceEntity(120U);
    msg.setDestination(30039U);
    msg.setDestinationEntity(232U);
    msg.name.assign("XRPMLXITHZOULZDFCNWQOEGLRFTQVCFPEVCTQYHJWSGETDYNNKPPPPWEJGNZRMONEUIMLWFRCOFREUYDKJOKCWXBGBQRAZRGHAVTHMNNAYVOXGBJAMISPZZKSVYDSLHQMMSWLZTZTUQHRZSENKGTHGMSCVCQFQBEIJJXBKDAWROCDWBWUTNQXYFVEPAUAFJVLIIDBBREFXDNBKDYTBJCPQVSPXOUIAKIO");
    msg.visibility.assign("HLCEBYJOXAMKYZYSDOBUCWLOPESSXLNWEKZDFAZGRVTNXFGKZEVOX");
    msg.scope.assign("XHCTTHENAHFRSUGEQZCGTSMAXQDEYAMPVITVIYRNOWZYUKACFNPXMWIEMMZPJNMEXFJQXKOACKPESNRXPUFEDVAVAKYZOCLTOZKKHGBBNHRQOPMWSLDBIJJTLQQDPACLJBUTLUGYQQFWWPRLIPNALKUCEROCDWDTSVUSKHJMGRZUJTMVRHIDFSEHPUXIZMLYFLOFHGGBKAGSFZNFWDJVVITBWBQSQEGXWBHOYGJXVD");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityParameters #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::QueryEntityParameters msg;
    msg.setTimeStamp(0.814201344314);
    msg.setSource(65223U);
    msg.setSourceEntity(25U);
    msg.setDestination(1946U);
    msg.setDestinationEntity(160U);
    msg.name.assign("SPLALGGZDHJWPEFGRBUXUPVDZOJRSFEBPNKNHKCUBUAQTIZNNDBMXSLLZUIZWIEOBFGFZCMARDKKTQLFALWBXKEIIBPCIMO");
    msg.visibility.assign("VBNTSKVWJSNQZYPMDJATYHQSJKGOTAVHYUPMVNFIILLCEMOZWQGXLOIREMYOHKWEMGORLHSPNTXEGGWNUYRRUFZMYUXSUQEGPZAPVAUPRGFHVHDRYNGGLZTJBXSJEBXMITBNDAVTIHIBPLDQLKUQFJAHBEPHCTNHSKCJXR");
    msg.scope.assign("ASRTGITRXOLXNZYNLUPZLIFYEHGWRGCOFSCWGDQYXPWGQLKBSPTOOCMQVAYFTKJEGKNGMTZKEBMDHEEJXCIPSRKONUVMXCEJUCUQYPZZVJRMDSOAJHBQVBMYGLBKDSOJJERTWLQYYNZFINXDYAHXFH");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("QueryEntityParameters #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetEntityParameters msg;
    msg.setTimeStamp(0.127239082286);
    msg.setSource(52324U);
    msg.setSourceEntity(166U);
    msg.setDestination(36026U);
    msg.setDestinationEntity(0U);
    msg.name.assign("ZCFGIJRMJCNGROXZMKURTWTPDKTCYUVHIVKTTUBBQLFCMEBOWNGKADSOOPITFLHNZVMTVAAOPSHBEYIGNVCYHOCGGNASVDIQKEQUXWBRNMLBIXFHYNELQKKORYP");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetEntityParameters #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetEntityParameters msg;
    msg.setTimeStamp(0.699272420008);
    msg.setSource(57921U);
    msg.setSourceEntity(165U);
    msg.setDestination(2056U);
    msg.setDestinationEntity(33U);
    msg.name.assign("SLBPIWOUXHTOEKJZOICCNJLYWIJPKRUEBIJGFDDMBWYVYYRRDIKAFMVBMLFXAZTZKFTATQYHHKNPPHHXMWDYFSVZQWLUXRLVTGGZGNQCQJGNRUNEOUSXAGPGCCFGTJNFCPCNFEODPVACIBAJWZTXXTCRHQMLDFHWMDKDTRPYUXUAVBUINESVTMBKHUAGGJZMSEFBHCAWIVEOZPQSQWDH");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetEntityParameters #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SetEntityParameters msg;
    msg.setTimeStamp(0.752498109702);
    msg.setSource(43055U);
    msg.setSourceEntity(7U);
    msg.setDestination(30968U);
    msg.setDestinationEntity(9U);
    msg.name.assign("GVZBXXUQRNDQOBXPFVXVYCLXQJJDLDCNSZYFZPWBILLAFJTKTEOUWLWSBFNZVUVBSPMKSCPRSCQIEEZAHFGZEGTALLOXHTGARGLSNXIHYAESUQIILFQGYTJIYBDTAKOSEWNGHTJFYZROSMKWBYKZOHAFKMVCSDYWVFKYCIQJR");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SetEntityParameters #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SaveEntityParameters msg;
    msg.setTimeStamp(0.627858556393);
    msg.setSource(21140U);
    msg.setSourceEntity(186U);
    msg.setDestination(54606U);
    msg.setDestinationEntity(111U);
    msg.name.assign("DAOAWFDBPVKEFMCONZCLUKMMQHXGFAVUEUDQIIKCMNWLOAEARODNIEGRMDQYCHLSIJXXEDKDIJBEDXRYKPTRUNYWPXGZLBPWBNURHFVLUAIEUGUGJWPNIYWXLJZFFYSXKFWELJTZBOIQEPRVSQUZYPFGKJJQPHGYMXSZSBZQRMBDFBRKITZATKLSCIBAJRCHOHAOYHHGAWURCYQVMHELKJMVNPWTCNTCXTOQ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SaveEntityParameters #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SaveEntityParameters msg;
    msg.setTimeStamp(0.601064284202);
    msg.setSource(22445U);
    msg.setSourceEntity(188U);
    msg.setDestination(5581U);
    msg.setDestinationEntity(11U);
    msg.name.assign("FDILXWWWJDRHUOHTPYSDPZUIBZZRYMYVYKKLCKSBYMIGYDFQKUNKMLAAEE");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SaveEntityParameters #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SaveEntityParameters msg;
    msg.setTimeStamp(0.306118211364);
    msg.setSource(8011U);
    msg.setSourceEntity(121U);
    msg.setDestination(10810U);
    msg.setDestinationEntity(175U);
    msg.name.assign("GYDTOKKYWZCNEIROV");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SaveEntityParameters #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CreateSession msg;
    msg.setTimeStamp(0.851580734241);
    msg.setSource(62769U);
    msg.setSourceEntity(39U);
    msg.setDestination(1315U);
    msg.setDestinationEntity(13U);
    msg.timeout = 1078544266U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CreateSession #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CreateSession msg;
    msg.setTimeStamp(0.105333547715);
    msg.setSource(58615U);
    msg.setSourceEntity(152U);
    msg.setDestination(50160U);
    msg.setDestinationEntity(91U);
    msg.timeout = 598978320U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CreateSession #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CreateSession msg;
    msg.setTimeStamp(0.936364804274);
    msg.setSource(45154U);
    msg.setSourceEntity(163U);
    msg.setDestination(42835U);
    msg.setDestinationEntity(202U);
    msg.timeout = 837563320U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CreateSession #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CloseSession msg;
    msg.setTimeStamp(0.994312884849);
    msg.setSource(447U);
    msg.setSourceEntity(153U);
    msg.setDestination(4301U);
    msg.setDestinationEntity(209U);
    msg.sessid = 940418064U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CloseSession #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CloseSession msg;
    msg.setTimeStamp(0.0572572259641);
    msg.setSource(18640U);
    msg.setSourceEntity(104U);
    msg.setDestination(32023U);
    msg.setDestinationEntity(18U);
    msg.sessid = 1342274313U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CloseSession #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::CloseSession msg;
    msg.setTimeStamp(0.140444925845);
    msg.setSource(40266U);
    msg.setSourceEntity(38U);
    msg.setDestination(57108U);
    msg.setDestinationEntity(254U);
    msg.sessid = 3029126632U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("CloseSession #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionSubscription msg;
    msg.setTimeStamp(0.0106402158141);
    msg.setSource(36777U);
    msg.setSourceEntity(159U);
    msg.setDestination(30641U);
    msg.setDestinationEntity(22U);
    msg.sessid = 1937634249U;
    msg.messages.assign("DUYXRFBSLNSBQBDXWLVIHGBBOWXSYOCENTRMXCFYAQFNREUHUFIEJGCXXDKOMFHRWNAXKQJKVQMEWUKCJMPOYSIWJGEAWEGLXGTTNMKCSPS");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionSubscription #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionSubscription msg;
    msg.setTimeStamp(0.308018667668);
    msg.setSource(51146U);
    msg.setSourceEntity(200U);
    msg.setDestination(60002U);
    msg.setDestinationEntity(136U);
    msg.sessid = 114229027U;
    msg.messages.assign("QBQRRZHCFBKHCQBYTXMWJUIMPOEWLAOGYSSICEPOXMOMKQKGXXVWUSLMIXWJYLQRUZPDKTFIHVNTJGGYGWPJUSENGABCJZDENKURTZDFRAEQDXLMUMABRJONVOKXYHRPTISCOPOHHSNKKCCJPGLVXEMIFFVATBVVJJXLWCQATBHDZTERWLVFMGVSPIFOZHFAILJTZLXQSAIDDENALDCUQBVZUYMYZNG");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionSubscription #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionSubscription msg;
    msg.setTimeStamp(0.91447381436);
    msg.setSource(11689U);
    msg.setSourceEntity(16U);
    msg.setDestination(4894U);
    msg.setDestinationEntity(132U);
    msg.sessid = 2947416764U;
    msg.messages.assign("LFINMYINPYNWQDDEIAKGMRKKBMWLUHCLMAPKOFOBZTNGZQSQMDNNVVOEKEUFMVYEHZUVAYPZLIVJGHHTQFLZSLDHULFXDAIZPKJEMBWRAVRKDRGRLYHCQHZCNSJKBZWIGWKBFTXARUFTIQPGXSBQNSPRWDUSVCCPDYXNMBEXSXCYAEOQVMVXGCWEOBZGTLIUFOCZUOHHTNYODTFWJDTRTWRKPWJBEFVJYO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionSubscription #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionKeepAlive msg;
    msg.setTimeStamp(0.272526229805);
    msg.setSource(57004U);
    msg.setSourceEntity(30U);
    msg.setDestination(2506U);
    msg.setDestinationEntity(49U);
    msg.sessid = 4251862380U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionKeepAlive #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionKeepAlive msg;
    msg.setTimeStamp(0.655185629144);
    msg.setSource(43611U);
    msg.setSourceEntity(71U);
    msg.setDestination(47150U);
    msg.setDestinationEntity(67U);
    msg.sessid = 370001539U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionKeepAlive #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionKeepAlive msg;
    msg.setTimeStamp(0.249036932119);
    msg.setSource(46710U);
    msg.setSourceEntity(16U);
    msg.setDestination(40963U);
    msg.setDestinationEntity(76U);
    msg.sessid = 2746776210U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionKeepAlive #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionStatus msg;
    msg.setTimeStamp(0.676008591945);
    msg.setSource(20060U);
    msg.setSourceEntity(62U);
    msg.setDestination(17719U);
    msg.setDestinationEntity(234U);
    msg.sessid = 3706185619U;
    msg.status = 35U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionStatus #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionStatus msg;
    msg.setTimeStamp(0.515221674434);
    msg.setSource(30360U);
    msg.setSourceEntity(170U);
    msg.setDestination(61740U);
    msg.setDestinationEntity(101U);
    msg.sessid = 966642492U;
    msg.status = 143U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionStatus #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::SessionStatus msg;
    msg.setTimeStamp(0.368376838764);
    msg.setSource(26151U);
    msg.setSourceEntity(82U);
    msg.setDestination(36161U);
    msg.setDestinationEntity(35U);
    msg.sessid = 2019958176U;
    msg.status = 161U;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("SessionStatus #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PushEntityParameters msg;
    msg.setTimeStamp(0.0487630888406);
    msg.setSource(35567U);
    msg.setSourceEntity(248U);
    msg.setDestination(13065U);
    msg.setDestinationEntity(126U);
    msg.name.assign("XQTDTNKNFBNFEVGBXWSDBPTUOVMZJDHGGZGOAMNCQPQLEKRWJSERWYZJMUXGRFHGCSNKANSQIGZPSYYOKMTSIOAAYMNKECETMIJTWZRPUXLJRIZYLLQRHEOFOIPTUTWVIMOOKDUHMWHXADJYBWVLEXCVQBHZIJGGYANPWSZHLMSKVCBHFQFYYUJRQOC");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PushEntityParameters #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PushEntityParameters msg;
    msg.setTimeStamp(0.472190174141);
    msg.setSource(18103U);
    msg.setSourceEntity(92U);
    msg.setDestination(64297U);
    msg.setDestinationEntity(215U);
    msg.name.assign("NLAGPXCKSSDQSEPIYPVRWRZAKMXSRGIYURPDLVQHMCOKGFFIEJCKCPRVVVIVICSZMJCSCHWNLLCJAUTVJNAMORLRTTMNOHKJHBXMDBMOYABOTZHFFTVAQEQLGXDXVSIYWUZQINMKKJYOEYQPYDZONEGXNGUBAKGBSFBUTHEFRWYVDEOFAUQXZHWEAJHEBBFKXFOEHP");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PushEntityParameters #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PushEntityParameters msg;
    msg.setTimeStamp(0.667703581521);
    msg.setSource(9637U);
    msg.setSourceEntity(242U);
    msg.setDestination(25077U);
    msg.setDestinationEntity(124U);
    msg.name.assign("YHPOZNZROERVSWMDOIKLLWXUWINPGSHDMTOCXYLCHTSJGGDMOLGACRUYMSZFPKWUZIMCFPKZSZGASXTIXMQGPOBNMBCTEFVBJKQISOXYZBVXYBIXHLYKZJQEOWRNTUYARSKEWGDRNYIVTEAFHJDBMLRQDANUADECPJIQFHFZKHEJTOQDBPVAMFAVIJUTQVVWAGHUW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PushEntityParameters #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PopEntityParameters msg;
    msg.setTimeStamp(0.872150141911);
    msg.setSource(32522U);
    msg.setSourceEntity(169U);
    msg.setDestination(50272U);
    msg.setDestinationEntity(50U);
    msg.name.assign("QBJXFITNKPRNVIYQKDXLFLCEVMFZNTRGBKRVNVASPGCJVPHIXSYTUWYDZSCKLELZJLUCMZRQHHCORGYTXBWGJEJQVXSISTZNVFOJVIYCLKWYQTUAXDOOMPJARSHQQYQVIDNKCRRLWTHXWEOGPAKZTODBWCANRECMZLVEHUAUYUBEMZWEIDLBWQOTHYKEYABUPBPJPSJUXHFZTMFUODGMDPMMDSIEMZGAKNNGWOUFOFFICSNJ");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PopEntityParameters #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PopEntityParameters msg;
    msg.setTimeStamp(0.33516403219);
    msg.setSource(2610U);
    msg.setSourceEntity(72U);
    msg.setDestination(30954U);
    msg.setDestinationEntity(114U);
    msg.name.assign("JGQNXYMSUADWVFHEMQUGEORPSGSGITNQHYUELLJMACFKNGZJFWEAXHDMZRHHJPOSWPZHDKBTSQUVSRRYAKTBTGLILORQUAVTBJDVJLZQTFGNZPMONWBPCICSXRZJCSUBPYIFNFGYKBOETLBETIVWTMCNWFDXCELFCUINMMRRGBOTPZLVUFYXWZEHAHVKYUKXPOCJVQKBFLIQQVLYKOXRSOJD");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PopEntityParameters #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::PopEntityParameters msg;
    msg.setTimeStamp(0.469663417853);
    msg.setSource(30538U);
    msg.setSourceEntity(95U);
    msg.setDestination(56914U);
    msg.setDestinationEntity(3U);
    msg.name.assign("QPFNAQIPMPEJDKCAXIOJVJUAIMMFDBXNMMDVJDETZHSHTDAKFURTMWDFUWBOCPLPUGFCRRUCOWCHIAOZVVGFYYDSEKENJRXONAXRWBGHYLJCRXJNQHFVWYLRILXGBPIXZLGVKCTESBSBSBTNHASGXIQWSGQUDLXLYJKOHBZZETJYO");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("PopEntityParameters #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IoEvent msg;
    msg.setTimeStamp(0.083870023952);
    msg.setSource(33976U);
    msg.setSourceEntity(86U);
    msg.setDestination(4894U);
    msg.setDestinationEntity(188U);
    msg.type = 91U;
    msg.error.assign("HWIXQXDZZTRLTBYFNXLQMFXEGCUOLBVDDSWZSNAAJCPKRPWINYMVRIBEGIGHZVXDZQYJOKQUCHSCHJDPDRCAEZXEHKFMIPBUHEGKLFYCDCRJD");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IoEvent #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IoEvent msg;
    msg.setTimeStamp(0.734113373798);
    msg.setSource(50036U);
    msg.setSourceEntity(4U);
    msg.setDestination(4601U);
    msg.setDestinationEntity(162U);
    msg.type = 244U;
    msg.error.assign("UKBMMEFVAMXLQZETWMVHBKGFUFLJRPPMCEWWPXWWOZVYVZZQCYYZECKBCXDNACMPCLLTRQJBYOTJHPFWULLNKHULAUSJFSOERMYPHYGPAOQIRAZCHCJBOSWRGVAHVBRKDADYPSKLAMEEHHQJGMDZXJGDJYBTWGZUFIEAWXVCCBMTQXYGIFFDDUOSEQDJN");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IoEvent #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::IoEvent msg;
    msg.setTimeStamp(0.461634861577);
    msg.setSource(57362U);
    msg.setSourceEntity(116U);
    msg.setDestination(8373U);
    msg.setDestinationEntity(214U);
    msg.type = 116U;
    msg.error.assign("LQXJYJTVEZBXQBIBZQOGSYLCRMITSPLWVMLQGXGXQSYZANINCMWDUAJXMMNXSVJDCWFUTCMYHIDHUTDJJTHCGBTFRDPJBKMDNPZLMVYGUOOFROGZVQKWYOIFUNXWMDVASCAUIQOGNVIKRKNPFNEHBPSQCAFKCBEDESHAFXKUZZYHXTOAFECFZRWLHBIPUZIYKZBIW");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("IoEvent #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamTxFrame msg;
    msg.setTimeStamp(0.447889032518);
    msg.setSource(45125U);
    msg.setSourceEntity(128U);
    msg.setDestination(44989U);
    msg.setDestinationEntity(169U);
    msg.seq = 54579U;
    msg.sys_dst.assign("WCQIIMBPUALPMVOTUZRXBHYAKKXFZWDEGOAEDJZSWOPSITKVWDQIQFJGWKGLDYSCWGVKAENKLZQUABNJRLXVTGKWKNRNRJZAYSEJUCFEQBCIVZCIMHZTKNSROETQFUMLSTYLDDJHPDXNBMOHHPBMBWENXZPMJRYJCEGHFYXVFDMBHHQXMREFLSCKAYJNGDHTCGPROFTVUQBDETIINJXUUOWYPSQFBVPLVOX");
    msg.flags = 100U;
    const char tmp_msg_0[] = {-106, -52, -105, -107, 75, 59, -120, 126, 7, 108, -10};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamTxFrame #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamTxFrame msg;
    msg.setTimeStamp(0.270412742612);
    msg.setSource(38534U);
    msg.setSourceEntity(73U);
    msg.setDestination(42146U);
    msg.setDestinationEntity(43U);
    msg.seq = 59334U;
    msg.sys_dst.assign("RCMSMLJBVXWREPSYTMFPUWZRFDKALLYSWAVHXEKAGBQPOLGQUURBTEANCZVJEGEKJLFVWMKHIZQZKVMQIARUFQBFUWVCGBRVED");
    msg.flags = 201U;
    const char tmp_msg_0[] = {-18, 78, -35, 86, -128, 51, 85, 22, 108, -99, 4, -119, 105, 124, 34, -65, -49, 28, 74, 14, 62, -97, -9, 94, 109, 25, -92, 56, 86, 49, -120, -123, 122, 22, 68, 123, 63, 99, -106, -81, 108, 125, -8, -6, -109, -6, 86, -61, 22, 36, -65, 69, -64, 16, 24, -56, -16, 79, -108, 119, 59, -36, -97, 107, 47, 34, 25, -47, -70, -93, 12, 4, -36, -27, 99, -83, -36, 122, 18, 82, -60, -22, -15, 45, 97, 81, 16, -97, -25, -44, -39, -89, -108, 38, 120, 52, -14, -45, 38, 44, -39, 33, -22, 116, 1, -80, 25, 114, -93, 81, 18, -126, 109, -85, -33, 49, 107, -89, -15, 118, 3, 91, -22, -119, 24, 91, -39, -88, 58, -88, -44, -77, -127, 74, -6, -46, 101, 64, 31, 92, 83, 70, 82, 117, -114, -29, 83, 106, -11, 71, 65, -63, 106, -98, 77, -22, 8, 126, -4, -40, 103, 88, 49, 68, 46, -16, -16, 72, -72};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamTxFrame #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamTxFrame msg;
    msg.setTimeStamp(0.179191490117);
    msg.setSource(33438U);
    msg.setSourceEntity(93U);
    msg.setDestination(9695U);
    msg.setDestinationEntity(45U);
    msg.seq = 36327U;
    msg.sys_dst.assign("UQLVPGVQTFORLYOVJDSTCGZMXSETUOHYCELRSKAMDGUCIQIBALJJZKRIKYTOVBCQIFHJPPSZQBKNAODONGPHJUYMTPCSETSTJWLVBKWFYFOFPENLRWUYJCBHLDNSDHVKGGJNEFGAHSJXFXAYPNMGMRSOLAQWZFHWGVPKTBPSXJZXMWZIUTWCMUKCIMMRDRYDZABKBMXZYAR");
    msg.flags = 155U;
    const char tmp_msg_0[] = {-17, 52, -14, 25, -122, -82, 21, -34, -110, -53, -120, 5, -97, -116, -122, 118, 109, -106, -98, -86, -115, 55, -70, 65, -12, -46, -15, 60, 14, -93, 48, 111, -49, 94, -83, 78, -91, -71, -120, -32, -12, -126, 74, 28, -38, -80, -82, -14, 40, -49, -57, -42, 33, -74, 84, 6, -29, 3, -85, 91, 115, -64, 85, 77, 33, -89, 98, 102, 98, -103, 115, -86, 41, 3, 27, 34, -92, 5, 4, 81, -89, 50, 117, -51, 110, -47, -52, 7, -114, 94, -45, 40, -4, -39, 112, -110, -108, 45, -18};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamTxFrame #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamRxFrame msg;
    msg.setTimeStamp(0.607496187648);
    msg.setSource(31391U);
    msg.setSourceEntity(246U);
    msg.setDestination(32638U);
    msg.setDestinationEntity(107U);
    msg.sys_src.assign("FLKHDZWCRSIUAUIFIUGAEQCAWSJSBGHREQDRMWASOPSQBZSKKLREBJIQRDNQOUQTVVSJMJMVKTPACKVCYXGAKMOFEDEYPWLDDETNQPSEFBUAHDJXTBXGIMHMYYBBHYXRPQWFXZVJASOQSMPMBTGNDRKURELUNMTCPVZZVXCBPOHJONLWLXCZFXVLGTOLFGZTBVYXJYWWILLGXTJAPHHQNNWOINCHHKINF");
    msg.sys_dst.assign("QVRVMTBPBTLQRWVFIBNPTGSUJJIILIGRBZCTEZEEOHQUMKUDJTGZOEMOBQCHJSVYCGOKKXDMPOTLZUFJDNLXKAVHEYTGAFDABUBPIIGOUJEPQLQTFVOMWXYPDZRYNSRFGUZJWDUXNDOYIACEYKCAQLFFHFCFDN");
    msg.flags = 0U;
    const char tmp_msg_0[] = {-41, 40, 126, -101, 2, 83, 124, -128, 59, -96, 16, 33, -37, -14, -35, -80, -95, -107, 35, 109, -77, -94, 101, 58, 40, 47, -51, 74, 100, -42, -67, 55, -107, 29, 77, 107, 78, -111, 2, -50, -20, 80, 89, -97, 74, -67, 97, 25, 1, -120, -52, 38, -17, -67, -25, 4, -92, -122, -95, 80, -19, -64, 96, 24, -17, 102, 107, -21, -69, 75, 124, 48, 11, 88, 70, 118, 22, -20, -86, 85, 70, -100, 87, 9, 17, 48, 84, -102, 64, 10, 102, 126, -29, -124, -54, -85, -94, 84, -68, -98, 107, -49, -95, 93, 7, -56, 80, -83, 44, 79, -78, 62, 89, -96, -44, 58, -91, -77, -16, -69, -31};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamRxFrame #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamRxFrame msg;
    msg.setTimeStamp(0.582919089564);
    msg.setSource(46413U);
    msg.setSourceEntity(15U);
    msg.setDestination(27033U);
    msg.setDestinationEntity(137U);
    msg.sys_src.assign("VOENJMIYOBFYGLDXDKBRBHHNLPHYIKZGUQOOKDKPDKYBARESNBVHIBEKESXOXGVRGZJRXQWNHHPFZGRREPAXPZWWUTMAPLQUFLLGSAZLQBVNDUHCPEYQZLCAJHXILYYEVFTSSWCIJUWXFNJVMJDTJNRSNPZTJQCCUBNGOMVIQGCVFHKGAYWOLCKESOWOACRFIMKIONDVZMAQXMDHUWQVUQPW");
    msg.sys_dst.assign("KDSULDHXOLHVNRYTWNVZNIISZOIQBLYBPJXIBZFEKNET");
    msg.flags = 188U;
    const char tmp_msg_0[] = {-96, -38, -104, -11, 91, 80, -66, 124, -84, 9, -42, -57, -37, -81, -94, -84, -122, 106, 39, -31, -27, -64, 119, -126, -43, -21, -96, -19, 49, -127, -47, -19, -12, -82, 40, -67, -53, -32, -83, -92, -108, -57, 120, 126, 7, -30, -49, -43, -36, 114, -101, -31, -57, 86, -52, 76, 90, -78, 59, -104, 61, -66, -127, -67, -33, -71, 23, 82, -52, 111, 110, -76, -112, 31, 119, 13, -46, -124, -13, 96, -72, -84, 121, 48, 125, 96, -112, 67, -42, -17, 43, 15, 73, 105, -50, -21, 110, 12, -109, -123, 120, -42, 106, 118, -36, 84, -120, -79, -99, 88, 90, 20, -124, -94, -46, -119, -40, -4, -29, 32, 101, -18, -51, -67, 68, 112, -60, -25, -83, 18, 111, -55, 8, 122, -125, -105, -21, -31, -4, -22, 101, 20, 78, -40, 85, -30, -118, -121, 67, -88, 55, 28, -64, 52, -5, -111, -30, -124, -39, 18, 85, 5, 108, -110, -62, -16, 110, 76, 26, 54, -10, -52, 86, 19, 89, 33, 17, 95, -125, 19, -72, 106, 123, 41, 72, 1, -108, -16, -110, 60, 83, 87, 81, -3, -20, -113, 2, -126, -88, -36, -32, -35, 96, 62, 50, -107, 11, -109, -42, 61, 97, 55, 115, -62, 91, -41, -106, -4, 29};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamRxFrame #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamRxFrame msg;
    msg.setTimeStamp(0.448104756334);
    msg.setSource(22100U);
    msg.setSourceEntity(187U);
    msg.setDestination(50693U);
    msg.setDestinationEntity(96U);
    msg.sys_src.assign("NQATXHKMEERYYLFONUHLEFJWKFHRTJBXYSCADKCUZGVKSQMDJGGLNHVGMFV");
    msg.sys_dst.assign("QSPFYZBKQSPWQMFMBXVMCZYDFDLAAQKWLVVPKKUKZULNZUTIMTHZOOOEJOSAXDQLAVZSQOYNQTWQUXCCMKTEFBIUCKNJPTGNDUDPBFARVVERBDJOPLGEHNLBDCHRCJBJHQJGYGRDIJWWZEAGMID");
    msg.flags = 56U;
    const char tmp_msg_0[] = {-109, 117, 3, -70, 117, -16, 103, -106, 101, -93, -67, 21, 8, 117, -53, 59, -67, 95, -112, 86, 21, 74, -95, -21, 0, -11, -44};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamRxFrame #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamTxStatus msg;
    msg.setTimeStamp(0.652040966923);
    msg.setSource(57174U);
    msg.setSourceEntity(166U);
    msg.setDestination(34494U);
    msg.setDestinationEntity(160U);
    msg.seq = 46895U;
    msg.value = 101U;
    msg.error.assign("ZPUTUMYKLCTTKZXGQTOJSNZZCESPSXDXHEVPXNVUJMHEQHDVMKWXAGQFQVIWOHYFVHWGKRVISTJRGGJFS");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamTxStatus #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamTxStatus msg;
    msg.setTimeStamp(0.0150182882541);
    msg.setSource(24581U);
    msg.setSourceEntity(42U);
    msg.setDestination(56290U);
    msg.setDestinationEntity(122U);
    msg.seq = 26183U;
    msg.value = 163U;
    msg.error.assign("ZYPSHYFIMQWLC");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamTxStatus #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamTxStatus msg;
    msg.setTimeStamp(0.548582440179);
    msg.setSource(690U);
    msg.setSourceEntity(242U);
    msg.setDestination(1310U);
    msg.setDestinationEntity(85U);
    msg.seq = 52078U;
    msg.value = 187U;
    msg.error.assign("KBENGKSAHSHIGNKXBZADBKOLLMQBSUUPAPNCOYIHBCRDTRQJQKXXEQHFWTIILPDMBEXHUSOLUROLXOWPLM");

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamTxStatus #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamRxRange msg;
    msg.setTimeStamp(0.316640986696);
    msg.setSource(51517U);
    msg.setSourceEntity(186U);
    msg.setDestination(13618U);
    msg.setDestinationEntity(181U);
    msg.seq = 14310U;
    msg.sys.assign("XBAHOZPIDNHJBRGDPFVXKFEMFRXABMTFRQMYNJHIRVEORKJFKRPUSEZTXVPVGCJVQKNHWYPLUOZCQVDVZRYLWWLYUNPCOWGGEAZLLMGUYNHLEXRBYQPBXPAYUUQOEYOKUJQGBJMJDBZFMMHHTX");
    msg.value = 0.481223536169;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamRxRange #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamRxRange msg;
    msg.setTimeStamp(0.907765132156);
    msg.setSource(19306U);
    msg.setSourceEntity(9U);
    msg.setDestination(35243U);
    msg.setDestinationEntity(249U);
    msg.seq = 40301U;
    msg.sys.assign("ANLVDLJCXWGREWINHVHUQLRNOWGDBSPQPLMORRPOFVJJOSOUEPLARHZFNMJVGCZDHKZXGMNTVTBEWDNCWNGYUTUQQJNSPJKDXKLWRKHFACJHFVJHIYNAYTLBHDGI");
    msg.value = 0.661620066324;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamRxRange #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UamRxRange msg;
    msg.setTimeStamp(0.557909449304);
    msg.setSource(29036U);
    msg.setSourceEntity(119U);
    msg.setDestination(44523U);
    msg.setDestinationEntity(152U);
    msg.seq = 24349U;
    msg.sys.assign("VTWUZLIMPAUFFAQDUO");
    msg.value = 0.901945164224;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UamRxRange #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormCtrlParam msg;
    msg.setTimeStamp(0.860079757538);
    msg.setSource(5054U);
    msg.setSourceEntity(31U);
    msg.setDestination(16871U);
    msg.setDestinationEntity(201U);
    msg.action = 252U;
    msg.longain = 0.25389088376;
    msg.latgain = 0.397536774357;
    msg.bondthick = 1693077407U;
    msg.leadgain = 0.354470649499;
    msg.deconflgain = 0.855809268257;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormCtrlParam #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormCtrlParam msg;
    msg.setTimeStamp(0.265820128161);
    msg.setSource(65358U);
    msg.setSourceEntity(146U);
    msg.setDestination(29646U);
    msg.setDestinationEntity(144U);
    msg.action = 40U;
    msg.longain = 0.925149277933;
    msg.latgain = 0.251325648891;
    msg.bondthick = 2369504151U;
    msg.leadgain = 0.653557334024;
    msg.deconflgain = 0.124833695572;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormCtrlParam #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormCtrlParam msg;
    msg.setTimeStamp(0.252015632687);
    msg.setSource(12553U);
    msg.setSourceEntity(224U);
    msg.setDestination(2872U);
    msg.setDestinationEntity(88U);
    msg.action = 253U;
    msg.longain = 0.506499077046;
    msg.latgain = 0.293915374358;
    msg.bondthick = 706621583U;
    msg.leadgain = 0.185234291929;
    msg.deconflgain = 0.157612898169;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormCtrlParam #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationEval msg;
    msg.setTimeStamp(0.369893444843);
    msg.setSource(5371U);
    msg.setSourceEntity(50U);
    msg.setDestination(16170U);
    msg.setDestinationEntity(133U);
    msg.err_mean = 0.921249014899;
    msg.dist_min_abs = 0.898413703943;
    msg.dist_min_mean = 0.362287263533;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationEval #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationEval msg;
    msg.setTimeStamp(0.868646385758);
    msg.setSource(40584U);
    msg.setSourceEntity(231U);
    msg.setDestination(30985U);
    msg.setDestinationEntity(32U);
    msg.err_mean = 0.543319591348;
    msg.dist_min_abs = 0.550786563758;
    msg.dist_min_mean = 0.758958179144;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationEval #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::FormationEval msg;
    msg.setTimeStamp(0.627325349304);
    msg.setSource(43753U);
    msg.setSourceEntity(102U);
    msg.setDestination(62714U);
    msg.setDestinationEntity(122U);
    msg.err_mean = 0.106767376448;
    msg.dist_min_abs = 0.377039265792;
    msg.dist_min_mean = 0.91904343332;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("FormationEval #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MessagePart msg;
    msg.setTimeStamp(0.990824900121);
    msg.setSource(56202U);
    msg.setSourceEntity(58U);
    msg.setDestination(49552U);
    msg.setDestinationEntity(226U);
    msg.uid = 1U;
    msg.frag_number = 204U;
    msg.num_frags = 66U;
    const char tmp_msg_0[] = {91, 102, -64, -104, -56, 11, -7, 45, -68, 28, -59, 37, -77, 114, -93, -107, 75, 125, -13, -128, -36, -11, 72, 47, -39, 106, -34, 117, -45, -16, 66, -29, 97, 52, -16, 62, 68, 34, 28, 67, -8, -112, 60, -108, 34, 17, 100, 73, 75, 69, -92, 26, -61, -33, -55, -20, 9, 82, -10, 40, -69, -61, -112, 102, -114, 1, -119, 70, -35, 67, -46, 44, 67, -58, 48, -26, -60, -78, 105, -128, -123, 84, -11, 74, -61, 125, -35, 101, -36, -91, 12, 70, 96, -53, -32};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MessagePart #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MessagePart msg;
    msg.setTimeStamp(0.996687027047);
    msg.setSource(38813U);
    msg.setSourceEntity(78U);
    msg.setDestination(38495U);
    msg.setDestinationEntity(39U);
    msg.uid = 116U;
    msg.frag_number = 193U;
    msg.num_frags = 249U;
    const char tmp_msg_0[] = {-85, -8, 31, 13, 39, -8, 63, -78, -46, 1, 94, 95, -116, -11, 79, 39, -104, -101, -30, -15, -4, 45, 55, 90, -73, 74, 2, -101, 40, -114, 73, 5, 92, 12, 88, -96, -19, 110, -54, 42, 18, -66, 106, 21, 108, -117, 31, -14, -33, 15, 95, -99, 17, -30, 59, -18, -128, -22, -63, -12, 42, -57, -21, -27, 84, -68, 105, 30, -86, -54, 102, 116, 71, 34, -97, 78, -50, -27, -67, 109, 78, 42, -3, 19, 106, 93, -36, -22, 113, 103, 14, 12, -27, -75, 21, -7, 91, -41, -50, 105, -76, 22, -4, -56, -7, -39, 31, 105, -89, 35, 46, -67};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MessagePart #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::MessagePart msg;
    msg.setTimeStamp(0.232386966129);
    msg.setSource(41211U);
    msg.setSourceEntity(193U);
    msg.setDestination(40723U);
    msg.setDestinationEntity(4U);
    msg.uid = 70U;
    msg.frag_number = 173U;
    msg.num_frags = 60U;
    const char tmp_msg_0[] = {-101, -81, 4, -80, -67, -77, 64, -40, -113, 70, 70, 105, -21, -74, 108, 13, -78, -114, 13, 72, 102, -30, -4, 111, -10, -2, 37, 84, 14, -3, 79, 90, 120, 41, 32, -113, -126, 7, 84, 50, 14, -124, 37, -43, -20, 99, -90, -56, 15, 120, -23, -11, -122, 96, -34, 87, -126, -4, -60, -84, -11, -59, 29, -48, -85, -34, 97, -67, -49, 102, -53, -93, -29, 36, -58, 126, 72, 38, -16, -55, 5, 20, 63, 116, 123, -73, -74, 67, -3, -104, 4, 83, -114, -112, 95, 83, -33, -19, -83, -63, 3, 59, 68, 11, 75, 39, 59, -21, 108, -96, 17, 19, 112, 17, 107, -32, 96, 104, -60, -73, 105, 50, -123, -10, 104, 44, -95, -116, 69, -39, -66, 9, 84, -41, -32, 93, -13, 90, -95, 87, 6, 3, -49, -69, -73, -91, 80, -20, -48, 99, 2, 25, -72, -124, -79};
    msg.data.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("MessagePart #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NeptusBlob msg;
    msg.setTimeStamp(0.864605082339);
    msg.setSource(63824U);
    msg.setSourceEntity(16U);
    msg.setDestination(40693U);
    msg.setDestinationEntity(242U);
    msg.content_type.assign("SRTXXLPFZJXPAPBELEKLBTAPCVRZHFRWMYQRZNXTPUYJLGVTGSEGFGDASIDRCHJBPIGCSYLIWHOEQINWNZQSOKJXNIBKSTTSGFHZZEEGTX");
    const char tmp_msg_0[] = {124, 2, -16, -96, 40, -126, 57, -66, -37, -45, 72, 12, 33, 24, 80, 0, -33, 58, -60, -24, -94, -87, -3, -86, 29, 98, -35, 102, 4, -62, -40, -6, -91, -65, -83, -120, -103, 114, 120, -107, -32, -71, 116, 63, -19, -125, 71, -7, 122, 62, -75, 110, 39, 24, -3, 110, -117, -70, -118, -105, -122, 69, -1, 53, 45, 1, -61, 76, -10, -11, 117, 46, -94, 55, 19, 104, 38, -106, 47, -53, 92, -88, 83, 84, 76, 34, 25, 110, -97, 21, -11, -70, 88, -69, 77, 125, -25, -8, -25, -59, 93, 122, -101, 50, -36, 32, -24, -81, -86, -48, -125, 90, -1, -125, 115, -112, -113, 34, -125, 51, -72, -31, -101, -19, -39, -27, -7, 31, 52, 37, 85, -6, -117, -90, 5, 16, -113, 4, 47, -6, 84, 96, -73};
    msg.content.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NeptusBlob #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NeptusBlob msg;
    msg.setTimeStamp(0.755012489578);
    msg.setSource(38359U);
    msg.setSourceEntity(28U);
    msg.setDestination(39432U);
    msg.setDestinationEntity(174U);
    msg.content_type.assign("NKUOIERNVYPAHSOVAQFMUCEEZJFNOMEJCRAGESBVQBHAXCOYFTYTOINPLCWTK");
    const char tmp_msg_0[] = {-38, 93, 26, -75, -23, 34, 25, -115, 125, 73, -47, -77, -31, -65, -78, 77, -69, 123, -4, 8, 55, -127, -73, 71, -78, -33, 60, 101, -35, -114, -111, 116, -21, -54, 38, -13, 17, 95, 51, 106, 77, 63, -112, 52, -57, -83, -116, 32, -15, 19, 55, 2, 76, -34, -42, 122, 9, -36, -68, 112, -31, -48, 27, 57, -17, -29, 104, -71, 112, -59, 39, -70, -60, -119, -31, 59, -43, -66, 2, -6, 12, 25, 99, 118, -127, 100, 30, 105, -29, -94, -94, 60, 68, -13, 107, -79, 115, 73, -22, -120, 126, 73, 124, 106, -40, -101, -104, 70, 109, 77, -24, -104, -31, -121, -101, -107, 99, 109, -87, -9, 75, -17, -95, -49, -120};
    msg.content.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NeptusBlob #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::NeptusBlob msg;
    msg.setTimeStamp(0.370956851453);
    msg.setSource(49854U);
    msg.setSourceEntity(225U);
    msg.setDestination(8284U);
    msg.setDestinationEntity(107U);
    msg.content_type.assign("NPUHBCKXXUAGKRHTJACYNCBOSGKEKMVJEOXDJAVBSLPRPYVMSNNPBHBDIDW");
    const char tmp_msg_0[] = {18, -107, 120, 103, 44, -124, 26, 103, -93, 68, -101, 97, 38, -96, -73, 70, 66, 3};
    msg.content.assign(tmp_msg_0, tmp_msg_0 + sizeof(tmp_msg_0));

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("NeptusBlob #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Aborted msg;
    msg.setTimeStamp(0.633800668451);
    msg.setSource(60330U);
    msg.setSourceEntity(205U);
    msg.setDestination(24694U);
    msg.setDestinationEntity(121U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Aborted #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Aborted msg;
    msg.setTimeStamp(0.467322026262);
    msg.setSource(10947U);
    msg.setSourceEntity(144U);
    msg.setDestination(37074U);
    msg.setDestinationEntity(113U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Aborted #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::Aborted msg;
    msg.setTimeStamp(0.252214027587);
    msg.setSource(11810U);
    msg.setSourceEntity(120U);
    msg.setDestination(41528U);
    msg.setDestinationEntity(138U);

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("Aborted #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblAngles msg;
    msg.setTimeStamp(0.620026126745);
    msg.setSource(48207U);
    msg.setSourceEntity(199U);
    msg.setDestination(46625U);
    msg.setDestinationEntity(159U);
    msg.target = 50251U;
    msg.bearing = 0.631602901072;
    msg.elevation = 0.910163859656;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblAngles #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblAngles msg;
    msg.setTimeStamp(0.404489751697);
    msg.setSource(40729U);
    msg.setSourceEntity(235U);
    msg.setDestination(4585U);
    msg.setDestinationEntity(111U);
    msg.target = 26480U;
    msg.bearing = 0.799291980875;
    msg.elevation = 0.374143359184;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblAngles #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblAngles msg;
    msg.setTimeStamp(0.53028177184);
    msg.setSource(10570U);
    msg.setSourceEntity(251U);
    msg.setDestination(21114U);
    msg.setDestinationEntity(205U);
    msg.target = 38630U;
    msg.bearing = 0.61832972623;
    msg.elevation = 0.870823831562;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblAngles #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblPosition msg;
    msg.setTimeStamp(0.133424636138);
    msg.setSource(59238U);
    msg.setSourceEntity(217U);
    msg.setDestination(36209U);
    msg.setDestinationEntity(1U);
    msg.target = 48211U;
    msg.x = 0.496111632997;
    msg.y = 0.554702216516;
    msg.z = 0.471509509642;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblPosition #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblPosition msg;
    msg.setTimeStamp(0.618615364062);
    msg.setSource(22524U);
    msg.setSourceEntity(173U);
    msg.setDestination(9013U);
    msg.setDestinationEntity(185U);
    msg.target = 27112U;
    msg.x = 0.0576313198332;
    msg.y = 0.0239471110565;
    msg.z = 0.59585497077;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblPosition #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblPosition msg;
    msg.setTimeStamp(0.792551356678);
    msg.setSource(28762U);
    msg.setSourceEntity(231U);
    msg.setDestination(40155U);
    msg.setDestinationEntity(150U);
    msg.target = 3252U;
    msg.x = 0.312813915325;
    msg.y = 0.743087347412;
    msg.z = 0.277788482359;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblPosition #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblFix msg;
    msg.setTimeStamp(0.478355288434);
    msg.setSource(24726U);
    msg.setSourceEntity(48U);
    msg.setDestination(57029U);
    msg.setDestinationEntity(19U);
    msg.target = 57914U;
    msg.lat = 0.444345562039;
    msg.lon = 0.400622643726;
    msg.z_units = 201U;
    msg.z = 0.7359177139;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblFix #0", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #0", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblFix msg;
    msg.setTimeStamp(0.873684715697);
    msg.setSource(26053U);
    msg.setSourceEntity(74U);
    msg.setDestination(30387U);
    msg.setDestinationEntity(7U);
    msg.target = 8393U;
    msg.lat = 0.809918660713;
    msg.lon = 0.761851175275;
    msg.z_units = 234U;
    msg.z = 0.79913707597;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblFix #1", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #1", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  {
    IMC::UsblFix msg;
    msg.setTimeStamp(0.453292468583);
    msg.setSource(7199U);
    msg.setSourceEntity(13U);
    msg.setDestination(34452U);
    msg.setDestinationEntity(194U);
    msg.target = 8876U;
    msg.lat = 0.794096776013;
    msg.lon = 0.831316627105;
    msg.z_units = 224U;
    msg.z = 0.208931324327;

    try
    {
      Utils::ByteBuffer bfr;
      IMC::Packet::serialize(&msg, bfr);
      IMC::Message* msg_d = IMC::Packet::deserialize(bfr.getBuffer(), bfr.getSize());
      test.boolean("UsblFix #2", msg == *msg_d);
      delete msg_d;
    }
    catch (IMC::InvalidMessageSize& e)
    {
      (void)e;
      test.boolean("msg #2", msg.getSerializationSize() > DUNE_IMC_CONST_MAX_SIZE);
    }
  }

  return test.getReturnValue();
}
